// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QKeyframeAnimationWrapper_H
#define SBK_QKeyframeAnimationWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <Qt3DAnimation/qkeyframeanimation.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QKeyframeAnimationWrapper : public Qt3DAnimation::QKeyframeAnimation
{
public:
    QKeyframeAnimationWrapper(const QKeyframeAnimationWrapper &) = delete;
    QKeyframeAnimationWrapper& operator=(const QKeyframeAnimationWrapper &) = delete;
    QKeyframeAnimationWrapper(QKeyframeAnimationWrapper &&) = delete;
    QKeyframeAnimationWrapper& operator=(QKeyframeAnimationWrapper &&) = delete;

    QKeyframeAnimationWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QKeyframeAnimationWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7];
};

#endif // SBK_QKeyframeAnimationWrapper_H

