// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qt3dcore_python.h"

// main header
#include "qt3dcore_qnodeidtypepair_wrapper.h"

// Argument includes
#include <Qt3DCore/qnodeid.h>
#include <qobjectdefs.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_Qt3DCore_QNodeIdTypePair_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::Qt3DCore::QNodeIdTypePair >()))
        return -1;

    ::Qt3DCore::QNodeIdTypePair *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.Qt3DCore.Qt3DCore.QNodeIdTypePair.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QNodeIdTypePair", 0, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QNodeIdTypePair::QNodeIdTypePair()
    // 1: QNodeIdTypePair::QNodeIdTypePair(Qt3DCore::QNodeId,const QMetaObject*)
    // 2: QNodeIdTypePair::QNodeIdTypePair(Qt3DCore::QNodeIdTypePair)
    if (numArgs == 0) {
        overloadId = 0; // QNodeIdTypePair()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_Qt3DCoreTypeStructs[SBK_Qt3DCore_QNodeIdTypePair_IDX]), (pyArgs[0])))) {
        overloadId = 2; // QNodeIdTypePair(Qt3DCore::QNodeIdTypePair)
    } else if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_Qt3DCoreTypeStructs[SBK_Qt3DCore_QNodeId_IDX]), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QMetaObject_IDX]), (pyArgs[1])))) {
        overloadId = 1; // QNodeIdTypePair(Qt3DCore::QNodeId,const QMetaObject*)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QNodeIdTypePair()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QNodeIdTypePair()
                cptr = new ::Qt3DCore::QNodeIdTypePair();
            }
            break;
        }
        case 1: // QNodeIdTypePair(Qt3DCore::QNodeId _id, const QMetaObject * _type)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::Qt3DCore::QNodeId cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            if (!Shiboken::Object::isValid(pyArgs[1]))
                return -1;
            ::QMetaObject *cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QNodeIdTypePair(Qt3DCore::QNodeId,const QMetaObject*)
                cptr = new ::Qt3DCore::QNodeIdTypePair(cppArg0, cppArg1);
            }
            break;
        }
        case 2: // QNodeIdTypePair(const Qt3DCore::QNodeIdTypePair & QNodeIdTypePair)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::Qt3DCore::QNodeIdTypePair cppArg0_local;
            ::Qt3DCore::QNodeIdTypePair *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QNodeIdTypePair(Qt3DCore::QNodeIdTypePair)
                cptr = new ::Qt3DCore::QNodeIdTypePair(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::Qt3DCore::QNodeIdTypePair >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_Qt3DCore_QNodeIdTypePair__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::Qt3DCore::QNodeIdTypePair *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DCoreTypeStructs[SBK_Qt3DCore_QNodeIdTypePair_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_Qt3DCoreTypeStructs[SBK_Qt3DCore_QNodeIdTypePair_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_Qt3DCore_QNodeIdTypePair_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_Qt3DCore_QNodeIdTypePair_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_Qt3DCore_QNodeIdTypePair__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_Qt3DCore_QNodeIdTypePair_get_id(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DCore::QNodeIdTypePair *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DCoreTypeStructs[SBK_Qt3DCore_QNodeIdTypePair_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->id)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), Shiboken::Module::get(SbkPySide6_Qt3DCoreTypeStructs[SBK_Qt3DCore_QNodeId_IDX])));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->id))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->id)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(Shiboken::Module::get(SbkPySide6_Qt3DCoreTypeStructs[SBK_Qt3DCore_QNodeId_IDX]), &(cppSelf->id), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_Qt3DCore_QNodeIdTypePair_set_id(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::Qt3DCore::QNodeIdTypePair *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DCoreTypeStructs[SBK_Qt3DCore_QNodeIdTypePair_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("id");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_Qt3DCoreTypeStructs[SBK_Qt3DCore_QNodeId_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("id", "QNodeId");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->id;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_Qt3DCore_QNodeIdTypePair_get_type(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DCore::QNodeIdTypePair *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DCoreTypeStructs[SBK_Qt3DCore_QNodeIdTypePair_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QMetaObject_IDX]), cppSelf->type);
    return pyOut;
}
static int Sbk_Qt3DCore_QNodeIdTypePair_set_type(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::Qt3DCore::QNodeIdTypePair *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DCoreTypeStructs[SBK_Qt3DCore_QNodeIdTypePair_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("type");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QMetaObject_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("type", "QMetaObject");
        return -1;
    }

    const auto *&cppOut_ptr = cppSelf->type;
    pythonToCpp(pyIn, &cppOut_ptr);

    Shiboken::Object::keepReference(reinterpret_cast<SbkObject *>(self), "type", pyIn);
    return 0;
}

// Getters and Setters for QNodeIdTypePair
static PyGetSetDef Sbk_Qt3DCore_QNodeIdTypePair_getsetlist[] = {
    {const_cast<char *>("id"), Sbk_Qt3DCore_QNodeIdTypePair_get_id, Sbk_Qt3DCore_QNodeIdTypePair_set_id, nullptr, nullptr},
    {const_cast<char *>("type"), Sbk_Qt3DCore_QNodeIdTypePair_get_type, Sbk_Qt3DCore_QNodeIdTypePair_set_type, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_Qt3DCore_QNodeIdTypePair_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_Qt3DCore_QNodeIdTypePair_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_Qt3DCore_QNodeIdTypePair_Type = nullptr;
static PyTypeObject *Sbk_Qt3DCore_QNodeIdTypePair_TypeF(void)
{
    return _Sbk_Qt3DCore_QNodeIdTypePair_Type;
}

static PyType_Slot Sbk_Qt3DCore_QNodeIdTypePair_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_Qt3DCore_QNodeIdTypePair_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_Qt3DCore_QNodeIdTypePair_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_Qt3DCore_QNodeIdTypePair_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_Qt3DCore_QNodeIdTypePair_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_Qt3DCore_QNodeIdTypePair_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_Qt3DCore_QNodeIdTypePair_spec = {
    "2:PySide6.Qt3DCore.Qt3DCore.QNodeIdTypePair",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_Qt3DCore_QNodeIdTypePair_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QNodeIdTypePair_PythonToCpp_QNodeIdTypePair_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_Qt3DCore_QNodeIdTypePair_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QNodeIdTypePair_PythonToCpp_QNodeIdTypePair_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_Qt3DCore_QNodeIdTypePair_TypeF()))
        return QNodeIdTypePair_PythonToCpp_QNodeIdTypePair_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QNodeIdTypePair_PTR_CppToPython_QNodeIdTypePair(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::Qt3DCore::QNodeIdTypePair *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_Qt3DCore_QNodeIdTypePair_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *QNodeIdTypePair_COPY_CppToPython_QNodeIdTypePair(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::Qt3DCore::QNodeIdTypePair *>(cppIn);
    return Shiboken::Object::newObject(Sbk_Qt3DCore_QNodeIdTypePair_TypeF(), new ::Qt3DCore::QNodeIdTypePair(*source), true, true);
}

// Python to C++ copy conversion.
static void QNodeIdTypePair_PythonToCpp_QNodeIdTypePair_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::Qt3DCore::QNodeIdTypePair *>(cppOut) = *reinterpret_cast< ::Qt3DCore::QNodeIdTypePair *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DCoreTypeStructs[SBK_Qt3DCore_QNodeIdTypePair_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QNodeIdTypePair_PythonToCpp_QNodeIdTypePair_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_Qt3DCore_QNodeIdTypePair_TypeF()))
        return QNodeIdTypePair_PythonToCpp_QNodeIdTypePair_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *Qt3DCore_QNodeIdTypePair_SignatureStrings[] = {
    "2:PySide6.Qt3DCore.Qt3DCore.QNodeIdTypePair(self)",
    "1:PySide6.Qt3DCore.Qt3DCore.QNodeIdTypePair(self,_id:PySide6.Qt3DCore.Qt3DCore.QNodeId,_type:PySide6.QtCore.QMetaObject)",
    "0:PySide6.Qt3DCore.Qt3DCore.QNodeIdTypePair(self,QNodeIdTypePair:PySide6.Qt3DCore.Qt3DCore.QNodeIdTypePair)",
    "PySide6.Qt3DCore.Qt3DCore.QNodeIdTypePair.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_Qt3DCore_QNodeIdTypePair(PyObject *enclosingClass)
{
    _Sbk_Qt3DCore_QNodeIdTypePair_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "QNodeIdTypePair",
        "Qt3DCore::QNodeIdTypePair",
        &Sbk_Qt3DCore_QNodeIdTypePair_spec,
        &Shiboken::callCppDestructor< ::Qt3DCore::QNodeIdTypePair >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_Qt3DCore_QNodeIdTypePair_TypeF(); // references _Sbk_Qt3DCore_QNodeIdTypePair_Type
    InitSignatureStrings(pyType, Qt3DCore_QNodeIdTypePair_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_Qt3DCore_QNodeIdTypePair_PropertyStrings);
    SbkPySide6_Qt3DCoreTypeStructs[SBK_Qt3DCore_QNodeIdTypePair_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QNodeIdTypePair_PythonToCpp_QNodeIdTypePair_PTR,
        is_QNodeIdTypePair_PythonToCpp_QNodeIdTypePair_PTR_Convertible,
        QNodeIdTypePair_PTR_CppToPython_QNodeIdTypePair,
        QNodeIdTypePair_COPY_CppToPython_QNodeIdTypePair);

    Shiboken::Conversions::registerConverterName(converter, "Qt3DCore::QNodeIdTypePair");
    Shiboken::Conversions::registerConverterName(converter, "Qt3DCore::QNodeIdTypePair*");
    Shiboken::Conversions::registerConverterName(converter, "Qt3DCore::QNodeIdTypePair&");
    Shiboken::Conversions::registerConverterName(converter, "QNodeIdTypePair");
    Shiboken::Conversions::registerConverterName(converter, "QNodeIdTypePair*");
    Shiboken::Conversions::registerConverterName(converter, "QNodeIdTypePair&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::Qt3DCore::QNodeIdTypePair).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QNodeIdTypePair_PythonToCpp_QNodeIdTypePair_COPY,
        is_QNodeIdTypePair_PythonToCpp_QNodeIdTypePair_COPY_Convertible);

    qRegisterMetaType< ::Qt3DCore::QNodeIdTypePair >("QNodeIdTypePair");
    qRegisterMetaType< ::Qt3DCore::QNodeIdTypePair >("Qt3DCore::QNodeIdTypePair");

    return pyType;
}
