// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qt3dextras_python.h"

// main header
#include "qt3dextras_qabstractcameracontroller_inputstate_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>

using namespace Qt3DExtras;


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_Qt3DExtras_QAbstractCameraController_InputState_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::Qt3DExtras::QAbstractCameraController::InputState >()))
        return -1;

    ::Qt3DExtras::QAbstractCameraController::InputState *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.Qt3DExtras.Qt3DExtras.QAbstractCameraController.InputState.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "InputState", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: InputState::InputState()
    // 1: InputState::InputState(Qt3DExtras::QAbstractCameraController::InputState)
    if (numArgs == 0) {
        overloadId = 0; // InputState()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_Qt3DExtrasTypeStructs[SBK_Qt3DExtras_QAbstractCameraController_InputState_IDX]), (pyArgs[0])))) {
        overloadId = 1; // InputState(Qt3DExtras::QAbstractCameraController::InputState)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // InputState()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // InputState()
                cptr = new ::Qt3DExtras::QAbstractCameraController::InputState();
            }
            break;
        }
        case 1: // InputState(const Qt3DExtras::QAbstractCameraController::InputState & InputState)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::Qt3DExtras::QAbstractCameraController::InputState cppArg0_local;
            ::Qt3DExtras::QAbstractCameraController::InputState *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // InputState(Qt3DExtras::QAbstractCameraController::InputState)
                cptr = new ::Qt3DExtras::QAbstractCameraController::InputState(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::Qt3DExtras::QAbstractCameraController::InputState >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_Qt3DExtras_QAbstractCameraController_InputState__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::Qt3DExtras::QAbstractCameraController::InputState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DExtrasTypeStructs[SBK_Qt3DExtras_QAbstractCameraController_InputState_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_Qt3DExtrasTypeStructs[SBK_Qt3DExtras_QAbstractCameraController_InputState_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_Qt3DExtras_QAbstractCameraController_InputState_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_Qt3DExtras_QAbstractCameraController_InputState_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_Qt3DExtras_QAbstractCameraController_InputState__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_Qt3DExtras_QAbstractCameraController_InputState_get_rxAxisValue(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DExtras::QAbstractCameraController::InputState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DExtrasTypeStructs[SBK_Qt3DExtras_QAbstractCameraController_InputState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<float>(), &cppSelf->rxAxisValue);
    return pyOut;
}
static int Sbk_Qt3DExtras_QAbstractCameraController_InputState_set_rxAxisValue(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::Qt3DExtras::QAbstractCameraController::InputState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DExtrasTypeStructs[SBK_Qt3DExtras_QAbstractCameraController_InputState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("rxAxisValue");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<float>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("rxAxisValue", "float");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->rxAxisValue;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_Qt3DExtras_QAbstractCameraController_InputState_get_ryAxisValue(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DExtras::QAbstractCameraController::InputState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DExtrasTypeStructs[SBK_Qt3DExtras_QAbstractCameraController_InputState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<float>(), &cppSelf->ryAxisValue);
    return pyOut;
}
static int Sbk_Qt3DExtras_QAbstractCameraController_InputState_set_ryAxisValue(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::Qt3DExtras::QAbstractCameraController::InputState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DExtrasTypeStructs[SBK_Qt3DExtras_QAbstractCameraController_InputState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("ryAxisValue");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<float>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("ryAxisValue", "float");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->ryAxisValue;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_Qt3DExtras_QAbstractCameraController_InputState_get_txAxisValue(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DExtras::QAbstractCameraController::InputState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DExtrasTypeStructs[SBK_Qt3DExtras_QAbstractCameraController_InputState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<float>(), &cppSelf->txAxisValue);
    return pyOut;
}
static int Sbk_Qt3DExtras_QAbstractCameraController_InputState_set_txAxisValue(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::Qt3DExtras::QAbstractCameraController::InputState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DExtrasTypeStructs[SBK_Qt3DExtras_QAbstractCameraController_InputState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("txAxisValue");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<float>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("txAxisValue", "float");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->txAxisValue;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_Qt3DExtras_QAbstractCameraController_InputState_get_tyAxisValue(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DExtras::QAbstractCameraController::InputState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DExtrasTypeStructs[SBK_Qt3DExtras_QAbstractCameraController_InputState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<float>(), &cppSelf->tyAxisValue);
    return pyOut;
}
static int Sbk_Qt3DExtras_QAbstractCameraController_InputState_set_tyAxisValue(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::Qt3DExtras::QAbstractCameraController::InputState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DExtrasTypeStructs[SBK_Qt3DExtras_QAbstractCameraController_InputState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("tyAxisValue");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<float>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("tyAxisValue", "float");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->tyAxisValue;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_Qt3DExtras_QAbstractCameraController_InputState_get_tzAxisValue(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DExtras::QAbstractCameraController::InputState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DExtrasTypeStructs[SBK_Qt3DExtras_QAbstractCameraController_InputState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<float>(), &cppSelf->tzAxisValue);
    return pyOut;
}
static int Sbk_Qt3DExtras_QAbstractCameraController_InputState_set_tzAxisValue(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::Qt3DExtras::QAbstractCameraController::InputState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DExtrasTypeStructs[SBK_Qt3DExtras_QAbstractCameraController_InputState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("tzAxisValue");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<float>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("tzAxisValue", "float");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->tzAxisValue;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_Qt3DExtras_QAbstractCameraController_InputState_get_leftMouseButtonActive(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DExtras::QAbstractCameraController::InputState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DExtrasTypeStructs[SBK_Qt3DExtras_QAbstractCameraController_InputState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->leftMouseButtonActive;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_Qt3DExtras_QAbstractCameraController_InputState_set_leftMouseButtonActive(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::Qt3DExtras::QAbstractCameraController::InputState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DExtrasTypeStructs[SBK_Qt3DExtras_QAbstractCameraController_InputState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("leftMouseButtonActive");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("leftMouseButtonActive", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->leftMouseButtonActive;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->leftMouseButtonActive = cppOut_local;

    return 0;
}

static PyObject *Sbk_Qt3DExtras_QAbstractCameraController_InputState_get_middleMouseButtonActive(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DExtras::QAbstractCameraController::InputState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DExtrasTypeStructs[SBK_Qt3DExtras_QAbstractCameraController_InputState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->middleMouseButtonActive;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_Qt3DExtras_QAbstractCameraController_InputState_set_middleMouseButtonActive(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::Qt3DExtras::QAbstractCameraController::InputState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DExtrasTypeStructs[SBK_Qt3DExtras_QAbstractCameraController_InputState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("middleMouseButtonActive");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("middleMouseButtonActive", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->middleMouseButtonActive;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->middleMouseButtonActive = cppOut_local;

    return 0;
}

static PyObject *Sbk_Qt3DExtras_QAbstractCameraController_InputState_get_rightMouseButtonActive(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DExtras::QAbstractCameraController::InputState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DExtrasTypeStructs[SBK_Qt3DExtras_QAbstractCameraController_InputState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->rightMouseButtonActive;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_Qt3DExtras_QAbstractCameraController_InputState_set_rightMouseButtonActive(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::Qt3DExtras::QAbstractCameraController::InputState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DExtrasTypeStructs[SBK_Qt3DExtras_QAbstractCameraController_InputState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("rightMouseButtonActive");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("rightMouseButtonActive", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->rightMouseButtonActive;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->rightMouseButtonActive = cppOut_local;

    return 0;
}

static PyObject *Sbk_Qt3DExtras_QAbstractCameraController_InputState_get_altKeyActive(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DExtras::QAbstractCameraController::InputState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DExtrasTypeStructs[SBK_Qt3DExtras_QAbstractCameraController_InputState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->altKeyActive;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_Qt3DExtras_QAbstractCameraController_InputState_set_altKeyActive(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::Qt3DExtras::QAbstractCameraController::InputState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DExtrasTypeStructs[SBK_Qt3DExtras_QAbstractCameraController_InputState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("altKeyActive");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("altKeyActive", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->altKeyActive;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->altKeyActive = cppOut_local;

    return 0;
}

static PyObject *Sbk_Qt3DExtras_QAbstractCameraController_InputState_get_shiftKeyActive(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DExtras::QAbstractCameraController::InputState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DExtrasTypeStructs[SBK_Qt3DExtras_QAbstractCameraController_InputState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->shiftKeyActive;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_Qt3DExtras_QAbstractCameraController_InputState_set_shiftKeyActive(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::Qt3DExtras::QAbstractCameraController::InputState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DExtrasTypeStructs[SBK_Qt3DExtras_QAbstractCameraController_InputState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("shiftKeyActive");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("shiftKeyActive", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->shiftKeyActive;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->shiftKeyActive = cppOut_local;

    return 0;
}

// Getters and Setters for InputState
static PyGetSetDef Sbk_Qt3DExtras_QAbstractCameraController_InputState_getsetlist[] = {
    {const_cast<char *>("rxAxisValue"), Sbk_Qt3DExtras_QAbstractCameraController_InputState_get_rxAxisValue, Sbk_Qt3DExtras_QAbstractCameraController_InputState_set_rxAxisValue, nullptr, nullptr},
    {const_cast<char *>("ryAxisValue"), Sbk_Qt3DExtras_QAbstractCameraController_InputState_get_ryAxisValue, Sbk_Qt3DExtras_QAbstractCameraController_InputState_set_ryAxisValue, nullptr, nullptr},
    {const_cast<char *>("txAxisValue"), Sbk_Qt3DExtras_QAbstractCameraController_InputState_get_txAxisValue, Sbk_Qt3DExtras_QAbstractCameraController_InputState_set_txAxisValue, nullptr, nullptr},
    {const_cast<char *>("tyAxisValue"), Sbk_Qt3DExtras_QAbstractCameraController_InputState_get_tyAxisValue, Sbk_Qt3DExtras_QAbstractCameraController_InputState_set_tyAxisValue, nullptr, nullptr},
    {const_cast<char *>("tzAxisValue"), Sbk_Qt3DExtras_QAbstractCameraController_InputState_get_tzAxisValue, Sbk_Qt3DExtras_QAbstractCameraController_InputState_set_tzAxisValue, nullptr, nullptr},
    {const_cast<char *>("leftMouseButtonActive"), Sbk_Qt3DExtras_QAbstractCameraController_InputState_get_leftMouseButtonActive, Sbk_Qt3DExtras_QAbstractCameraController_InputState_set_leftMouseButtonActive, nullptr, nullptr},
    {const_cast<char *>("middleMouseButtonActive"), Sbk_Qt3DExtras_QAbstractCameraController_InputState_get_middleMouseButtonActive, Sbk_Qt3DExtras_QAbstractCameraController_InputState_set_middleMouseButtonActive, nullptr, nullptr},
    {const_cast<char *>("rightMouseButtonActive"), Sbk_Qt3DExtras_QAbstractCameraController_InputState_get_rightMouseButtonActive, Sbk_Qt3DExtras_QAbstractCameraController_InputState_set_rightMouseButtonActive, nullptr, nullptr},
    {const_cast<char *>("altKeyActive"), Sbk_Qt3DExtras_QAbstractCameraController_InputState_get_altKeyActive, Sbk_Qt3DExtras_QAbstractCameraController_InputState_set_altKeyActive, nullptr, nullptr},
    {const_cast<char *>("shiftKeyActive"), Sbk_Qt3DExtras_QAbstractCameraController_InputState_get_shiftKeyActive, Sbk_Qt3DExtras_QAbstractCameraController_InputState_set_shiftKeyActive, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_Qt3DExtras_QAbstractCameraController_InputState_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_Qt3DExtras_QAbstractCameraController_InputState_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_Qt3DExtras_QAbstractCameraController_InputState_Type = nullptr;
static PyTypeObject *Sbk_Qt3DExtras_QAbstractCameraController_InputState_TypeF(void)
{
    return _Sbk_Qt3DExtras_QAbstractCameraController_InputState_Type;
}

static PyType_Slot Sbk_Qt3DExtras_QAbstractCameraController_InputState_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_Qt3DExtras_QAbstractCameraController_InputState_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_Qt3DExtras_QAbstractCameraController_InputState_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_Qt3DExtras_QAbstractCameraController_InputState_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_Qt3DExtras_QAbstractCameraController_InputState_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_Qt3DExtras_QAbstractCameraController_InputState_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_Qt3DExtras_QAbstractCameraController_InputState_spec = {
    "2:PySide6.Qt3DExtras.Qt3DExtras.QAbstractCameraController.InputState",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_Qt3DExtras_QAbstractCameraController_InputState_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void InputState_PythonToCpp_InputState_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_Qt3DExtras_QAbstractCameraController_InputState_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_InputState_PythonToCpp_InputState_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_Qt3DExtras_QAbstractCameraController_InputState_TypeF()))
        return InputState_PythonToCpp_InputState_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *InputState_PTR_CppToPython_InputState(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::Qt3DExtras::QAbstractCameraController::InputState *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_Qt3DExtras_QAbstractCameraController_InputState_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *InputState_COPY_CppToPython_InputState(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::Qt3DExtras::QAbstractCameraController::InputState *>(cppIn);
    return Shiboken::Object::newObject(Sbk_Qt3DExtras_QAbstractCameraController_InputState_TypeF(), new ::Qt3DExtras::QAbstractCameraController::InputState(*source), true, true);
}

// Python to C++ copy conversion.
static void InputState_PythonToCpp_InputState_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::Qt3DExtras::QAbstractCameraController::InputState *>(cppOut) = *reinterpret_cast< ::Qt3DExtras::QAbstractCameraController::InputState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DExtrasTypeStructs[SBK_Qt3DExtras_QAbstractCameraController_InputState_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_InputState_PythonToCpp_InputState_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_Qt3DExtras_QAbstractCameraController_InputState_TypeF()))
        return InputState_PythonToCpp_InputState_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *Qt3DExtras_QAbstractCameraController_InputState_SignatureStrings[] = {
    "1:PySide6.Qt3DExtras.Qt3DExtras.QAbstractCameraController.InputState(self)",
    "0:PySide6.Qt3DExtras.Qt3DExtras.QAbstractCameraController.InputState(self,InputState:PySide6.Qt3DExtras.Qt3DExtras.QAbstractCameraController.InputState)",
    "PySide6.Qt3DExtras.Qt3DExtras.QAbstractCameraController.InputState.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_Qt3DExtras_QAbstractCameraController_InputState(PyObject *enclosingClass)
{
    _Sbk_Qt3DExtras_QAbstractCameraController_InputState_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "InputState",
        "Qt3DExtras::QAbstractCameraController::InputState",
        &Sbk_Qt3DExtras_QAbstractCameraController_InputState_spec,
        &Shiboken::callCppDestructor< ::Qt3DExtras::QAbstractCameraController::InputState >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_Qt3DExtras_QAbstractCameraController_InputState_TypeF(); // references _Sbk_Qt3DExtras_QAbstractCameraController_InputState_Type
    InitSignatureStrings(pyType, Qt3DExtras_QAbstractCameraController_InputState_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_Qt3DExtras_QAbstractCameraController_InputState_PropertyStrings);
    SbkPySide6_Qt3DExtrasTypeStructs[SBK_Qt3DExtras_QAbstractCameraController_InputState_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        InputState_PythonToCpp_InputState_PTR,
        is_InputState_PythonToCpp_InputState_PTR_Convertible,
        InputState_PTR_CppToPython_InputState,
        InputState_COPY_CppToPython_InputState);

    Shiboken::Conversions::registerConverterName(converter, "Qt3DExtras::QAbstractCameraController::InputState");
    Shiboken::Conversions::registerConverterName(converter, "Qt3DExtras::QAbstractCameraController::InputState*");
    Shiboken::Conversions::registerConverterName(converter, "Qt3DExtras::QAbstractCameraController::InputState&");
    Shiboken::Conversions::registerConverterName(converter, "QAbstractCameraController::InputState");
    Shiboken::Conversions::registerConverterName(converter, "QAbstractCameraController::InputState*");
    Shiboken::Conversions::registerConverterName(converter, "QAbstractCameraController::InputState&");
    Shiboken::Conversions::registerConverterName(converter, "InputState");
    Shiboken::Conversions::registerConverterName(converter, "InputState*");
    Shiboken::Conversions::registerConverterName(converter, "InputState&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::Qt3DExtras::QAbstractCameraController::InputState).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        InputState_PythonToCpp_InputState_COPY,
        is_InputState_PythonToCpp_InputState_COPY_Convertible);

    qRegisterMetaType< ::Qt3DExtras::QAbstractCameraController::InputState >("InputState");
    qRegisterMetaType< ::Qt3DExtras::QAbstractCameraController::InputState >("QAbstractCameraController::InputState");
    qRegisterMetaType< ::Qt3DExtras::QAbstractCameraController::InputState >("Qt3DExtras::QAbstractCameraController::InputState");

    return pyType;
}
