// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAbstractCameraControllerWrapper_H
#define SBK_QAbstractCameraControllerWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <Qt3DExtras/qabstractcameracontroller.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QAbstractCameraControllerWrapper : public Qt3DExtras::QAbstractCameraController
{
public:
    QAbstractCameraControllerWrapper(const QAbstractCameraControllerWrapper &) = delete;
    QAbstractCameraControllerWrapper& operator=(const QAbstractCameraControllerWrapper &) = delete;
    QAbstractCameraControllerWrapper(QAbstractCameraControllerWrapper &&) = delete;
    QAbstractCameraControllerWrapper& operator=(QAbstractCameraControllerWrapper &&) = delete;

    QAbstractCameraControllerWrapper(::Qt3DCore::QNode * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void moveCamera(const ::Qt3DExtras::QAbstractCameraController::InputState & state, float dt) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QAbstractCameraControllerWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8];
};

#endif // SBK_QAbstractCameraControllerWrapper_H

