// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

// module include
#include "pyside6_qt3drender_python.h"

// main header
#include "qsharedpointer_qtextureimagedatagenerator_wrapper.h"

// Extra includes
#include <Qt3DRender/qtextureimagedatagenerator.h>
#include <sbksmartpointer.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_Qt3DRender_QTextureImageDataGeneratorPtr_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QSharedPointer<Qt3DRender::QTextureImageDataGenerator> >()))
        return -1;

    ::QSharedPointer<Qt3DRender::QTextureImageDataGenerator> *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.Qt3DRender.Qt3DRender.QTextureImageDataGeneratorPtr.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QTextureImageDataGeneratorPtr", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QTextureImageDataGeneratorPtr::QTextureImageDataGeneratorPtr()
    // 1: QTextureImageDataGeneratorPtr::QTextureImageDataGeneratorPtr(Qt3DRender::QTextureImageDataGenerator*)
    if (numArgs == 0) {
        overloadId = 0; // QTextureImageDataGeneratorPtr()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureImageDataGenerator_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QTextureImageDataGeneratorPtr(Qt3DRender::QTextureImageDataGenerator*)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QTextureImageDataGeneratorPtr()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QTextureImageDataGeneratorPtr()
                cptr = new ::QSharedPointer<Qt3DRender::QTextureImageDataGenerator>();
            }
            break;
        }
        case 1: // QTextureImageDataGeneratorPtr(Qt3DRender::QTextureImageDataGenerator * pointee)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::Qt3DRender::QTextureImageDataGenerator *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QTextureImageDataGeneratorPtr(Qt3DRender::QTextureImageDataGenerator*)
                cptr = new ::QSharedPointer<Qt3DRender::QTextureImageDataGenerator>(cppArg0);

                // Ownership transferences.
                Shiboken::Object::releaseOwnership(pyArgs[0]);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QSharedPointer<Qt3DRender::QTextureImageDataGenerator> >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_Qt3DRender_QTextureImageDataGeneratorPtrFunc_reset(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSharedPointer<Qt3DRender::QTextureImageDataGenerator> *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_QSharedPointer_Qt3DRender_QTextureImageDataGenerator_IDX]), reinterpret_cast<SbkObject *>(self)));
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.Qt3DRender.Qt3DRender.QTextureImageDataGeneratorPtr.reset";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "reset", 0, 1, &(pyArgs[0])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QTextureImageDataGeneratorPtr::reset()
    // 1: QTextureImageDataGeneratorPtr::reset(Qt3DRender::QTextureImageDataGenerator*)
    if (numArgs == 0) {
        overloadId = 0; // reset()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureImageDataGenerator_IDX]), (pyArgs[0])))) {
        overloadId = 1; // reset(Qt3DRender::QTextureImageDataGenerator*)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    switch (overloadId) {
        case 0: // reset()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // reset()
                cppSelf->reset();
            }
            break;
        }
        case 1: // reset(Qt3DRender::QTextureImageDataGenerator * t)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return {};
            ::Qt3DRender::QTextureImageDataGenerator *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // reset(Qt3DRender::QTextureImageDataGenerator*)
                cppSelf->reset(cppArg0);

                // Ownership transferences.
                Shiboken::Object::releaseOwnership(pyArgs[0]);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_Qt3DRender_QTextureImageDataGeneratorPtrFunc_data(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSharedPointer<Qt3DRender::QTextureImageDataGenerator> *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_QSharedPointer_Qt3DRender_QTextureImageDataGenerator_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.Qt3DRender.Qt3DRender.QTextureImageDataGeneratorPtr.data";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // data()const
            Qt3DRender::QTextureImageDataGenerator * cppResult = const_cast<const ::QSharedPointer<Qt3DRender::QTextureImageDataGenerator> *>(cppSelf)->data();
            pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureImageDataGenerator_IDX]), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_Qt3DRender_QTextureImageDataGeneratorPtr__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QSharedPointer<Qt3DRender::QTextureImageDataGenerator> *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_QSharedPointer_Qt3DRender_QTextureImageDataGenerator_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_QSharedPointer_Qt3DRender_QTextureImageDataGenerator_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

extern "C"
{
static PyObject *Sbk_Qt3DRender_QTextureImageDataGeneratorPtr__dir__(PyObject *self)
{
    Shiboken::AutoDecRef pointee(PyObject_CallMethod(self, "data", 0));
    return Shiboken::SmartPointer::dir(self, pointee);
}
} // extern C

static PyMethodDef Sbk_Qt3DRender_QTextureImageDataGeneratorPtr_methods[] = {
    {"reset", reinterpret_cast<PyCFunction>(Sbk_Qt3DRender_QTextureImageDataGeneratorPtrFunc_reset), METH_VARARGS, nullptr},
    {"data", reinterpret_cast<PyCFunction>(Sbk_Qt3DRender_QTextureImageDataGeneratorPtrFunc_data), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_Qt3DRender_QTextureImageDataGeneratorPtr__copy__), METH_NOARGS, nullptr},
    {"__dir__", reinterpret_cast<PyCFunction>(Sbk_Qt3DRender_QTextureImageDataGeneratorPtr__dir__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_Qt3DRender_QTextureImageDataGeneratorPtr_getattro(PyObject *self, PyObject *name)
{
    PyObject *tmp = PyObject_GenericGetAttr(self, name);
    if (tmp)
        return tmp;
    if (PyErr_ExceptionMatches(PyExc_AttributeError) == 0)
        return nullptr;
    PyErr_Clear();
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSharedPointer<Qt3DRender::QTextureImageDataGenerator> *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_QSharedPointer_Qt3DRender_QTextureImageDataGenerator_IDX]), reinterpret_cast<SbkObject *>(self)));
    if (cppSelf->isNull()) {
        PyTypeObject *tp = Py_TYPE(self);
        PyErr_Format(PyExc_AttributeError, "Attempt to retrieve '%s' from null object '%s'.",
                     Shiboken::String::toCString(name), tp->tp_name);
        return nullptr;
    }
    // Try to find the 'name' attribute, by retrieving the PyObject for the corresponding C++ object held by the smart pointer.
    if (auto *rawObj = PyObject_CallMethod(self, "data", 0)) {
        if (auto *attribute = PyObject_GetAttr(rawObj, name))
            tmp = attribute;
        Py_DECREF(rawObj);
    }
    if (!tmp) {
        PyTypeObject *tp = Py_TYPE(self);
        PyErr_Format(PyExc_AttributeError,
                     "'%.50s' object has no attribute '%.400s'",
                     tp->tp_name, Shiboken::String::toCString(name));
    }
    return tmp;
}

static int Sbk_Qt3DRender_QTextureImageDataGeneratorPtr_setattro(PyObject *self, PyObject *name, PyObject *value)
{
    // Try to find the 'name' attribute, by retrieving the PyObject for the corresponding C++ object held by the smart pointer.
    if (auto *rawObj = PyObject_CallMethod(self, "data", 0)) {
        if (PyObject_HasAttr(rawObj, name) != 0)
            return PyObject_GenericSetAttr(rawObj, name, value);
        Py_DECREF(rawObj);
    }
    return PyObject_GenericSetAttr(self, name, value);
}

static int Sbk_Qt3DRender_QTextureImageDataGeneratorPtr___nb_bool(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return -1;
    auto *cppSelf = reinterpret_cast< ::QSharedPointer<Qt3DRender::QTextureImageDataGenerator> *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_QSharedPointer_Qt3DRender_QTextureImageDataGenerator_IDX]), reinterpret_cast<SbkObject *>(self)));
    return !cppSelf->isNull() ? 1 : 0;
}

static PyObject * Sbk_Qt3DRender_QTextureImageDataGeneratorPtr_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QSharedPointer<Qt3DRender::QTextureImageDataGenerator> *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_QSharedPointer_Qt3DRender_QTextureImageDataGenerator_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    if ((pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_QSharedPointer_Qt3DRender_QTextureImageDataGenerator_IDX]), (pyArg)))) {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QSharedPointer<Qt3DRender::QTextureImageDataGenerator> cppArg0;
        pythonToCpp(pyArg, &cppArg0);
        const auto *cppSelfPointee = cppSelf.data();
        const auto *cppArg0Pointee = cppArg0.data();
        if (cppSelfPointee == nullptr || cppArg0Pointee == nullptr) {
            PyErr_SetString(PyExc_NotImplementedError, "nullptr passed to comparison.");
            return {};

        }
        bool cppResult= false;
        switch (op) {
        case Py_EQ:
            cppResult = cppSelfPointee == cppArg0Pointee || *cppSelfPointee == *cppArg0Pointee;
            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
        }
        pyResult = cppResult ? Py_True : Py_False;
        Py_INCREF(pyResult);
    }
    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static int Sbk_Qt3DRender_QTextureImageDataGeneratorPtr_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_Qt3DRender_QTextureImageDataGeneratorPtr_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
extern "C"
{
static PyObject *Sbk_Qt3DRender_QTextureImageDataGeneratorPtr__repr__(PyObject *self)
{
    Shiboken::AutoDecRef pointee(PyObject_CallMethod(self, "data", 0));
    return Shiboken::SmartPointer::repr(self, pointee);
}
} // extern C

// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_Qt3DRender_QTextureImageDataGeneratorPtr_Type = nullptr;
static PyTypeObject *Sbk_Qt3DRender_QTextureImageDataGeneratorPtr_TypeF(void)
{
    return _Sbk_Qt3DRender_QTextureImageDataGeneratorPtr_Type;
}

static PyType_Slot Sbk_Qt3DRender_QTextureImageDataGeneratorPtr_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_repr,        reinterpret_cast<void *>(Sbk_Qt3DRender_QTextureImageDataGeneratorPtr__repr__)},
    {Py_tp_getattro,    reinterpret_cast<void *>(Sbk_Qt3DRender_QTextureImageDataGeneratorPtr_getattro)},
    {Py_tp_setattro,    reinterpret_cast<void *>(Sbk_Qt3DRender_QTextureImageDataGeneratorPtr_setattro)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_Qt3DRender_QTextureImageDataGeneratorPtr_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_Qt3DRender_QTextureImageDataGeneratorPtr_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_Qt3DRender_QTextureImageDataGeneratorPtr_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_Qt3DRender_QTextureImageDataGeneratorPtr_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_Qt3DRender_QTextureImageDataGeneratorPtr_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    // type supports number protocol
    {Py_nb_bool,        reinterpret_cast<void *>(Sbk_Qt3DRender_QTextureImageDataGeneratorPtr___nb_bool)},
    {0, nullptr}
};
static PyType_Spec Sbk_Qt3DRender_QTextureImageDataGeneratorPtr_spec = {
    "2:PySide6.Qt3DRender.Qt3DRender.QTextureImageDataGeneratorPtr",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_Qt3DRender_QTextureImageDataGeneratorPtr_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QTextureImageDataGeneratorPtr_PythonToCpp_QTextureImageDataGeneratorPtr_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_Qt3DRender_QTextureImageDataGeneratorPtr_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QTextureImageDataGeneratorPtr_PythonToCpp_QTextureImageDataGeneratorPtr_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_Qt3DRender_QTextureImageDataGeneratorPtr_TypeF()))
        return QTextureImageDataGeneratorPtr_PythonToCpp_QTextureImageDataGeneratorPtr_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QTextureImageDataGeneratorPtr_PTR_CppToPython_QTextureImageDataGeneratorPtr(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QSharedPointer<Qt3DRender::QTextureImageDataGenerator> *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_Qt3DRender_QTextureImageDataGeneratorPtr_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *QTextureImageDataGeneratorPtr_COPY_CppToPython_QTextureImageDataGeneratorPtr(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QSharedPointer<Qt3DRender::QTextureImageDataGenerator> *>(cppIn);
    return Shiboken::Object::newObject(Sbk_Qt3DRender_QTextureImageDataGeneratorPtr_TypeF(), new ::QSharedPointer<Qt3DRender::QTextureImageDataGenerator>(*source), true, true);
}

// Python to C++ copy conversion.
static void QTextureImageDataGeneratorPtr_PythonToCpp_QTextureImageDataGeneratorPtr_COPY(PyObject *pyIn, void *cppOut)
{
    auto *ptr = reinterpret_cast<::QSharedPointer<Qt3DRender::QTextureImageDataGenerator> *>(cppOut);
    if (pyIn == Py_None)
        ptr->reset();
    else
        *ptr = *reinterpret_cast< ::QSharedPointer<Qt3DRender::QTextureImageDataGenerator> *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_QSharedPointer_Qt3DRender_QTextureImageDataGenerator_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QTextureImageDataGeneratorPtr_PythonToCpp_QTextureImageDataGeneratorPtr_COPY_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None || PyObject_TypeCheck(pyIn, Sbk_Qt3DRender_QTextureImageDataGeneratorPtr_TypeF()))
        return QTextureImageDataGeneratorPtr_PythonToCpp_QTextureImageDataGeneratorPtr_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *Qt3DRender_QTextureImageDataGeneratorPtr_SignatureStrings[] = {
    "1:PySide6.Qt3DRender.Qt3DRender.QTextureImageDataGeneratorPtr(self)",
    "0:PySide6.Qt3DRender.Qt3DRender.QTextureImageDataGeneratorPtr(self,pointee:PySide6.Qt3DRender.Qt3DRender.QTextureImageDataGenerator)",
    "1:PySide6.Qt3DRender.Qt3DRender.QTextureImageDataGeneratorPtr.reset(self)",
    "0:PySide6.Qt3DRender.Qt3DRender.QTextureImageDataGeneratorPtr.reset(self,t:PySide6.Qt3DRender.Qt3DRender.QTextureImageDataGenerator)",
    "PySide6.Qt3DRender.Qt3DRender.QTextureImageDataGeneratorPtr.data(self)->PySide6.Qt3DRender.Qt3DRender.QTextureImageDataGenerator",
    "PySide6.Qt3DRender.Qt3DRender.QTextureImageDataGeneratorPtr.__copy__()",
    "PySide6.Qt3DRender.Qt3DRender.QTextureImageDataGeneratorPtr.__dir__()",
    nullptr}; // Sentinel

PyTypeObject *init_Qt3DRender_QTextureImageDataGeneratorPtr(PyObject *enclosingClass)
{
    _Sbk_Qt3DRender_QTextureImageDataGeneratorPtr_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "QTextureImageDataGeneratorPtr",
        "QSharedPointer<Qt3DRender::QTextureImageDataGenerator>",
        &Sbk_Qt3DRender_QTextureImageDataGeneratorPtr_spec,
        &Shiboken::callCppDestructor< ::QSharedPointer<Qt3DRender::QTextureImageDataGenerator> >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::InnerClass);
    auto *pyType = Sbk_Qt3DRender_QTextureImageDataGeneratorPtr_TypeF(); // references _Sbk_Qt3DRender_QTextureImageDataGeneratorPtr_Type
    InitSignatureStrings(pyType, Qt3DRender_QTextureImageDataGeneratorPtr_SignatureStrings);
    SbkPySide6_Qt3DRenderTypeStructs[SBK_QSharedPointer_Qt3DRender_QTextureImageDataGenerator_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QTextureImageDataGeneratorPtr_PythonToCpp_QTextureImageDataGeneratorPtr_PTR,
        is_QTextureImageDataGeneratorPtr_PythonToCpp_QTextureImageDataGeneratorPtr_PTR_Convertible,
        QTextureImageDataGeneratorPtr_PTR_CppToPython_QTextureImageDataGeneratorPtr,
        QTextureImageDataGeneratorPtr_COPY_CppToPython_QTextureImageDataGeneratorPtr);

    Shiboken::Conversions::registerConverterName(converter, "QSharedPointer<Qt3DRender::QTextureImageDataGenerator>");
    Shiboken::Conversions::registerConverterName(converter, "QSharedPointer<Qt3DRender::QTextureImageDataGenerator>*");
    Shiboken::Conversions::registerConverterName(converter, "QSharedPointer<Qt3DRender::QTextureImageDataGenerator>&");
    Shiboken::Conversions::registerConverterName(converter, "QSharedPointer<QTextureImageDataGenerator>");
    Shiboken::Conversions::registerConverterName(converter, "QSharedPointer<QTextureImageDataGenerator>*");
    Shiboken::Conversions::registerConverterName(converter, "QSharedPointer<QTextureImageDataGenerator>&");
    Shiboken::Conversions::registerConverterName(converter, "Qt3DRender::QTextureImageDataGenerator");
    Shiboken::Conversions::registerConverterName(converter, "Qt3DRender::QTextureImageDataGenerator*");
    Shiboken::Conversions::registerConverterName(converter, "Qt3DRender::QTextureImageDataGenerator&");
    Shiboken::Conversions::registerConverterName(converter, "QTextureImageDataGenerator");
    Shiboken::Conversions::registerConverterName(converter, "QTextureImageDataGenerator*");
    Shiboken::Conversions::registerConverterName(converter, "QTextureImageDataGenerator&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QSharedPointer<Qt3DRender::QTextureImageDataGenerator>).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QTextureImageDataGeneratorPtr_PythonToCpp_QTextureImageDataGeneratorPtr_COPY,
        is_QTextureImageDataGeneratorPtr_PythonToCpp_QTextureImageDataGeneratorPtr_COPY_Convertible);

    qRegisterMetaType< ::QSharedPointer<Qt3DRender::QTextureImageDataGenerator> >("QSharedPointer<Qt3DRender::QTextureImageDataGenerator>");
    qRegisterMetaType< ::QSharedPointer<Qt3DRender::QTextureImageDataGenerator> >("Qt3DRender::QSharedPointer<Qt3DRender::QTextureImageDataGenerator>");

    return pyType;
}
