// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qt3drender_python.h"

// main header
#include "qt3drender_qlevelofdetailboundingsphere_wrapper.h"

// Argument includes
#include <Qt3DRender/qlevelofdetailboundingsphere.h>
#include <QtGui/qvectornd.h>
#include <qobject.h>
#include <qobjectdefs.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>

using namespace Qt3DRender;


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_Qt3DRender_QLevelOfDetailBoundingSphere_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::Qt3DRender::QLevelOfDetailBoundingSphere >()))
        return -1;

    ::Qt3DRender::QLevelOfDetailBoundingSphere *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.Qt3DRender.Qt3DRender.QLevelOfDetailBoundingSphere.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 0, 2));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|OO:QLevelOfDetailBoundingSphere", &(pyArgs[0]), &(pyArgs[1])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QLevelOfDetailBoundingSphere::QLevelOfDetailBoundingSphere(QVector3D=,float=)
    // 1: QLevelOfDetailBoundingSphere::QLevelOfDetailBoundingSphere(Qt3DRender::QLevelOfDetailBoundingSphere)
    if (numArgs == 0) {
        overloadId = 0; // QLevelOfDetailBoundingSphere(QVector3D,float)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QLevelOfDetailBoundingSphere_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QLevelOfDetailBoundingSphere(Qt3DRender::QLevelOfDetailBoundingSphere)
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QVector3D_IDX]), (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 0; // QLevelOfDetailBoundingSphere(QVector3D,float)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<float>(), (pyArgs[1])))) {
            overloadId = 0; // QLevelOfDetailBoundingSphere(QVector3D,float)
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QLevelOfDetailBoundingSphere(QVector3D center, float radius)
        {
            if (kwds && PyDict_Size(kwds) > 0) {
                PyObject *value{};
                Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
                static PyObject *const key_center = Shiboken::String::createStaticString("center");
                if (PyDict_Contains(kwds, key_center) != 0) {
                    value = PyDict_GetItem(kwds, key_center);
                    if (value != nullptr && pyArgs[0] != nullptr ) {
                        errInfo.reset(key_center);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    if (value != nullptr) {
                        pyArgs[0] = value;
                        if (!(pythonToCpp[0] = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QVector3D_IDX]), (pyArgs[0]))))
                            return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    PyDict_DelItem(kwds_dup, key_center);
                }
                static PyObject *const key_radius = Shiboken::String::createStaticString("radius");
                if (PyDict_Contains(kwds, key_radius) != 0) {
                    value = PyDict_GetItem(kwds, key_radius);
                    if (value != nullptr && pyArgs[1] != nullptr ) {
                        errInfo.reset(key_radius);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    if (value != nullptr) {
                        pyArgs[1] = value;
                        if (!(pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<float>(), (pyArgs[1]))))
                            return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    PyDict_DelItem(kwds_dup, key_radius);
                }
                if (PyDict_Size(kwds_dup) > 0) {
                    errInfo.reset(kwds_dup.release());
                    return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                }
            }
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QVector3D cppArg0 = QVector3D();
            if (pythonToCpp[0])
                pythonToCpp[0](pyArgs[0], &cppArg0);
            float cppArg1 = 1.0f;
            if (pythonToCpp[1])
                pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QLevelOfDetailBoundingSphere(QVector3D,float)
                cptr = new ::Qt3DRender::QLevelOfDetailBoundingSphere(cppArg0, cppArg1);
            }
            break;
        }
        case 1: // QLevelOfDetailBoundingSphere(const Qt3DRender::QLevelOfDetailBoundingSphere & other)
        {
            if (kwds != nullptr && PyDict_Size(kwds) > 0) {
                errInfo.reset(kwds);
                Py_INCREF(errInfo.object());
                return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
            }
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::Qt3DRender::QLevelOfDetailBoundingSphere *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QLevelOfDetailBoundingSphere(Qt3DRender::QLevelOfDetailBoundingSphere)
                cptr = new ::Qt3DRender::QLevelOfDetailBoundingSphere(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::Qt3DRender::QLevelOfDetailBoundingSphere >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_Qt3DRender_QLevelOfDetailBoundingSphereFunc_center(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DRender::QLevelOfDetailBoundingSphere *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QLevelOfDetailBoundingSphere_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.Qt3DRender.Qt3DRender.QLevelOfDetailBoundingSphere.center";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // center()const
            QVector3D cppResult = const_cast<const ::Qt3DRender::QLevelOfDetailBoundingSphere *>(cppSelf)->center();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QVector3D_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_Qt3DRender_QLevelOfDetailBoundingSphereFunc_isEmpty(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DRender::QLevelOfDetailBoundingSphere *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QLevelOfDetailBoundingSphere_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.Qt3DRender.Qt3DRender.QLevelOfDetailBoundingSphere.isEmpty";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isEmpty()const
            bool cppResult = const_cast<const ::Qt3DRender::QLevelOfDetailBoundingSphere *>(cppSelf)->isEmpty();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_Qt3DRender_QLevelOfDetailBoundingSphereFunc_radius(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DRender::QLevelOfDetailBoundingSphere *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QLevelOfDetailBoundingSphere_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.Qt3DRender.Qt3DRender.QLevelOfDetailBoundingSphere.radius";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // radius()const
            float cppResult = const_cast<const ::Qt3DRender::QLevelOfDetailBoundingSphere *>(cppSelf)->radius();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<float>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_Qt3DRender_QLevelOfDetailBoundingSphere_PropertyStrings[] = {
    "center:",
    "radius:",
    nullptr // Sentinel
};

static PyMethodDef Sbk_Qt3DRender_QLevelOfDetailBoundingSphere_methods[] = {
    {"center", reinterpret_cast<PyCFunction>(Sbk_Qt3DRender_QLevelOfDetailBoundingSphereFunc_center), METH_NOARGS, nullptr},
    {"isEmpty", reinterpret_cast<PyCFunction>(Sbk_Qt3DRender_QLevelOfDetailBoundingSphereFunc_isEmpty), METH_NOARGS, nullptr},
    {"radius", reinterpret_cast<PyCFunction>(Sbk_Qt3DRender_QLevelOfDetailBoundingSphereFunc_radius), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_Qt3DRender_QLevelOfDetailBoundingSphere_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::Qt3DRender::QLevelOfDetailBoundingSphere *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QLevelOfDetailBoundingSphere_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QLevelOfDetailBoundingSphere_IDX]), (pyArg)))) {
                // operator!=(const Qt3DRender::QLevelOfDetailBoundingSphere & other) const
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::Qt3DRender::QLevelOfDetailBoundingSphere *cppArg0;
                pythonToCpp(pyArg, &cppArg0);
                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QLevelOfDetailBoundingSphere_IDX]), (pyArg)))) {
                // operator==(const Qt3DRender::QLevelOfDetailBoundingSphere & other) const
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::Qt3DRender::QLevelOfDetailBoundingSphere *cppArg0;
                pythonToCpp(pyArg, &cppArg0);
                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static int Sbk_Qt3DRender_QLevelOfDetailBoundingSphere_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_Qt3DRender_QLevelOfDetailBoundingSphere_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_Qt3DRender_QLevelOfDetailBoundingSphere_Type = nullptr;
static PyTypeObject *Sbk_Qt3DRender_QLevelOfDetailBoundingSphere_TypeF(void)
{
    return _Sbk_Qt3DRender_QLevelOfDetailBoundingSphere_Type;
}

static PyType_Slot Sbk_Qt3DRender_QLevelOfDetailBoundingSphere_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_Qt3DRender_QLevelOfDetailBoundingSphere_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_Qt3DRender_QLevelOfDetailBoundingSphere_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_Qt3DRender_QLevelOfDetailBoundingSphere_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_Qt3DRender_QLevelOfDetailBoundingSphere_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_Qt3DRender_QLevelOfDetailBoundingSphere_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_Qt3DRender_QLevelOfDetailBoundingSphere_spec = {
    "2:PySide6.Qt3DRender.Qt3DRender.QLevelOfDetailBoundingSphere",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_Qt3DRender_QLevelOfDetailBoundingSphere_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QLevelOfDetailBoundingSphere_PythonToCpp_QLevelOfDetailBoundingSphere_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_Qt3DRender_QLevelOfDetailBoundingSphere_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QLevelOfDetailBoundingSphere_PythonToCpp_QLevelOfDetailBoundingSphere_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_Qt3DRender_QLevelOfDetailBoundingSphere_TypeF()))
        return QLevelOfDetailBoundingSphere_PythonToCpp_QLevelOfDetailBoundingSphere_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QLevelOfDetailBoundingSphere_PTR_CppToPython_QLevelOfDetailBoundingSphere(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::Qt3DRender::QLevelOfDetailBoundingSphere *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_Qt3DRender_QLevelOfDetailBoundingSphere_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *Qt3DRender_QLevelOfDetailBoundingSphere_SignatureStrings[] = {
    "1:PySide6.Qt3DRender.Qt3DRender.QLevelOfDetailBoundingSphere(self,center:PySide6.QtGui.QVector3D=QVector3D(),radius:float=1.0f)",
    "0:PySide6.Qt3DRender.Qt3DRender.QLevelOfDetailBoundingSphere(self,other:PySide6.Qt3DRender.Qt3DRender.QLevelOfDetailBoundingSphere)",
    "PySide6.Qt3DRender.Qt3DRender.QLevelOfDetailBoundingSphere.center(self)->PySide6.QtGui.QVector3D",
    "PySide6.Qt3DRender.Qt3DRender.QLevelOfDetailBoundingSphere.isEmpty(self)->bool",
    "PySide6.Qt3DRender.Qt3DRender.QLevelOfDetailBoundingSphere.radius(self)->float",
    nullptr}; // Sentinel

PyTypeObject *init_Qt3DRender_QLevelOfDetailBoundingSphere(PyObject *enclosingClass)
{
    _Sbk_Qt3DRender_QLevelOfDetailBoundingSphere_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "QLevelOfDetailBoundingSphere",
        "Qt3DRender::QLevelOfDetailBoundingSphere*",
        &Sbk_Qt3DRender_QLevelOfDetailBoundingSphere_spec,
        &Shiboken::callCppDestructor< ::Qt3DRender::QLevelOfDetailBoundingSphere >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::InnerClass);
    auto *pyType = Sbk_Qt3DRender_QLevelOfDetailBoundingSphere_TypeF(); // references _Sbk_Qt3DRender_QLevelOfDetailBoundingSphere_Type
    InitSignatureStrings(pyType, Qt3DRender_QLevelOfDetailBoundingSphere_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_Qt3DRender_QLevelOfDetailBoundingSphere_PropertyStrings);
    SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QLevelOfDetailBoundingSphere_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QLevelOfDetailBoundingSphere_PythonToCpp_QLevelOfDetailBoundingSphere_PTR,
        is_QLevelOfDetailBoundingSphere_PythonToCpp_QLevelOfDetailBoundingSphere_PTR_Convertible,
        QLevelOfDetailBoundingSphere_PTR_CppToPython_QLevelOfDetailBoundingSphere);

    Shiboken::Conversions::registerConverterName(converter, "Qt3DRender::QLevelOfDetailBoundingSphere");
    Shiboken::Conversions::registerConverterName(converter, "Qt3DRender::QLevelOfDetailBoundingSphere*");
    Shiboken::Conversions::registerConverterName(converter, "Qt3DRender::QLevelOfDetailBoundingSphere&");
    Shiboken::Conversions::registerConverterName(converter, "QLevelOfDetailBoundingSphere");
    Shiboken::Conversions::registerConverterName(converter, "QLevelOfDetailBoundingSphere*");
    Shiboken::Conversions::registerConverterName(converter, "QLevelOfDetailBoundingSphere&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::Qt3DRender::QLevelOfDetailBoundingSphere).name());

    qRegisterMetaType< ::Qt3DRender::QLevelOfDetailBoundingSphere *>();

    return pyType;
}
