// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QTextureImageDataGeneratorWrapper_H
#define SBK_QTextureImageDataGeneratorWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <Qt3DRender/qtextureimagedatagenerator.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QTextureImageDataGeneratorWrapper : public Qt3DRender::QTextureImageDataGenerator
{
public:
    QTextureImageDataGeneratorWrapper(const QTextureImageDataGeneratorWrapper &) = delete;
    QTextureImageDataGeneratorWrapper& operator=(const QTextureImageDataGeneratorWrapper &) = delete;
    QTextureImageDataGeneratorWrapper(QTextureImageDataGeneratorWrapper &&) = delete;
    QTextureImageDataGeneratorWrapper& operator=(QTextureImageDataGeneratorWrapper &&) = delete;

    QTextureImageDataGeneratorWrapper();
    ::qintptr id() const override;
    ::QSharedPointer<Qt3DRender::QTextureImageData> operator()() override;
    bool operator==(const ::Qt3DRender::QTextureImageDataGenerator & other) const override;
    ~QTextureImageDataGeneratorWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[3];
};

#endif // SBK_QTextureImageDataGeneratorWrapper_H

