// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QTextureWrapModeWrapper_H
#define SBK_QTextureWrapModeWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <Qt3DRender/qtexturewrapmode.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QTextureWrapModeWrapper : public Qt3DRender::QTextureWrapMode
{
public:
    QTextureWrapModeWrapper(const QTextureWrapModeWrapper &) = delete;
    QTextureWrapModeWrapper& operator=(const QTextureWrapModeWrapper &) = delete;
    QTextureWrapModeWrapper(QTextureWrapModeWrapper &&) = delete;
    QTextureWrapModeWrapper& operator=(QTextureWrapModeWrapper &&) = delete;

    QTextureWrapModeWrapper(::Qt3DRender::QTextureWrapMode::WrapMode wrapMode = Qt3DRender::QTextureWrapMode::WrapMode::ClampToEdge, ::QObject * parent = nullptr);
    QTextureWrapModeWrapper(::Qt3DRender::QTextureWrapMode::WrapMode x, ::Qt3DRender::QTextureWrapMode::WrapMode y, ::Qt3DRender::QTextureWrapMode::WrapMode z, ::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QTextureWrapModeWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7];
};

#endif // SBK_QTextureWrapModeWrapper_H

