// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <QtCore/QBuffer>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtbluetooth_python.h"

// main header
#include "qbluetoothserviceinfo_wrapper.h"

// inner classes
#include "qbluetoothserviceinfo_alternative_wrapper.h"
#include "qbluetoothserviceinfo_sequence_wrapper.h"

// Argument includes
#include <QList>
#include <QString>
#include <QtBluetooth/qbluetoothaddress.h>
#include <QtBluetooth/qbluetoothdeviceinfo.h>
#include <QtBluetooth/qbluetoothserviceinfo.h>
#include <QtBluetooth/qbluetoothuuid.h>
#include <qvariant.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QBluetoothServiceInfo_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QBluetoothServiceInfo >()))
        return -1;

    ::QBluetoothServiceInfo *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtBluetooth.QBluetoothServiceInfo.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QBluetoothServiceInfo", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QBluetoothServiceInfo::QBluetoothServiceInfo()
    // 1: QBluetoothServiceInfo::QBluetoothServiceInfo(QBluetoothServiceInfo)
    if (numArgs == 0) {
        overloadId = 0; // QBluetoothServiceInfo()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QBluetoothServiceInfo(QBluetoothServiceInfo)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QBluetoothServiceInfo()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QBluetoothServiceInfo()
                cptr = new ::QBluetoothServiceInfo();
            }
            break;
        }
        case 1: // QBluetoothServiceInfo(const QBluetoothServiceInfo & other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QBluetoothServiceInfo cppArg0_local;
            ::QBluetoothServiceInfo *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QBluetoothServiceInfo(QBluetoothServiceInfo)
                cptr = new ::QBluetoothServiceInfo(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QBluetoothServiceInfo >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_attribute(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtBluetooth.QBluetoothServiceInfo.attribute";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QBluetoothServiceInfo::attribute(quint16)const->QVariant
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint16>(), (pyArg)))) {
        overloadId = 0; // attribute(quint16)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        quint16 cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // attribute(quint16)const
            QVariant cppResult = const_cast<const ::QBluetoothServiceInfo *>(cppSelf)->attribute(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QVariant_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_attributes(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtBluetooth.QBluetoothServiceInfo.attributes";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // attributes()const
            QList<quint16> cppResult = const_cast<const ::QBluetoothServiceInfo *>(cppSelf)->attributes();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtBluetoothTypeConverters[SBK_QtBluetooth_QList_quint16_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_contains(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtBluetooth.QBluetoothServiceInfo.contains";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QBluetoothServiceInfo::contains(quint16)const->bool
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint16>(), (pyArg)))) {
        overloadId = 0; // contains(quint16)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        quint16 cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // contains(quint16)const
            bool cppResult = const_cast<const ::QBluetoothServiceInfo *>(cppSelf)->contains(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_device(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtBluetooth.QBluetoothServiceInfo.device";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // device()const
            QBluetoothDeviceInfo cppResult = const_cast<const ::QBluetoothServiceInfo *>(cppSelf)->device();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothDeviceInfo_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_isComplete(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtBluetooth.QBluetoothServiceInfo.isComplete";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isComplete()const
            bool cppResult = const_cast<const ::QBluetoothServiceInfo *>(cppSelf)->isComplete();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_isRegistered(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtBluetooth.QBluetoothServiceInfo.isRegistered";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isRegistered()const
            bool cppResult = const_cast<const ::QBluetoothServiceInfo *>(cppSelf)->isRegistered();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_isValid(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtBluetooth.QBluetoothServiceInfo.isValid";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isValid()const
            bool cppResult = const_cast<const ::QBluetoothServiceInfo *>(cppSelf)->isValid();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_protocolDescriptor(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtBluetooth.QBluetoothServiceInfo.protocolDescriptor";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QBluetoothServiceInfo::protocolDescriptor(QBluetoothUuid::ProtocolUuid)const->QBluetoothServiceInfo::Sequence
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothUuid_ProtocolUuid_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // protocolDescriptor(QBluetoothUuid::ProtocolUuid)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QBluetoothUuid::ProtocolUuid cppArg0 = static_cast< ::QBluetoothUuid::ProtocolUuid>(0);
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // protocolDescriptor(QBluetoothUuid::ProtocolUuid)const
            QBluetoothServiceInfo::Sequence cppResult = const_cast<const ::QBluetoothServiceInfo *>(cppSelf)->protocolDescriptor(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_Sequence_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_protocolServiceMultiplexer(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtBluetooth.QBluetoothServiceInfo.protocolServiceMultiplexer";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // protocolServiceMultiplexer()const
            int cppResult = const_cast<const ::QBluetoothServiceInfo *>(cppSelf)->protocolServiceMultiplexer();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_registerService(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtBluetooth.QBluetoothServiceInfo.registerService";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 0, 1));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|O:registerService", &(pyArgs[0])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QBluetoothServiceInfo::registerService(const QBluetoothAddress&=)->bool
    if (numArgs == 0) {
        overloadId = 0; // registerService(QBluetoothAddress)
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothAddress_IDX]), (pyArgs[0])))) {
        overloadId = 0; // registerService(QBluetoothAddress)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_localAdapter = Shiboken::String::createStaticString("localAdapter");
            if (PyDict_Contains(kwds, key_localAdapter) != 0) {
                value = PyDict_GetItem(kwds, key_localAdapter);
                if (value != nullptr && pyArgs[0] != nullptr ) {
                    errInfo.reset(key_localAdapter);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                if (value != nullptr) {
                    pyArgs[0] = value;
                    if (!(pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothAddress_IDX]), (pyArgs[0]))))
                        return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                PyDict_DelItem(kwds_dup, key_localAdapter);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments(args, fullName, errInfo);
            }
        }
        if (!Shiboken::Object::isValid(pyArgs[0]))
            return {};
        ::QBluetoothAddress cppArg0_local = QBluetoothAddress();
        ::QBluetoothAddress *cppArg0 = &cppArg0_local;
        if (pythonToCpp[0]) {
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);
            }

        if (Shiboken::Errors::occurred() == nullptr) {
            // registerService(QBluetoothAddress)
            bool cppResult = cppSelf->registerService(*cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_removeAttribute(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtBluetooth.QBluetoothServiceInfo.removeAttribute";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QBluetoothServiceInfo::removeAttribute(quint16)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint16>(), (pyArg)))) {
        overloadId = 0; // removeAttribute(quint16)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        quint16 cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // removeAttribute(quint16)
            cppSelf->removeAttribute(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_serverChannel(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtBluetooth.QBluetoothServiceInfo.serverChannel";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // serverChannel()const
            int cppResult = const_cast<const ::QBluetoothServiceInfo *>(cppSelf)->serverChannel();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_serviceAvailability(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtBluetooth.QBluetoothServiceInfo.serviceAvailability";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // serviceAvailability()const
            quint8 cppResult = const_cast<const ::QBluetoothServiceInfo *>(cppSelf)->serviceAvailability();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<quint8>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_serviceClassUuids(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtBluetooth.QBluetoothServiceInfo.serviceClassUuids";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // serviceClassUuids()const
            QList<QBluetoothUuid> cppResult = const_cast<const ::QBluetoothServiceInfo *>(cppSelf)->serviceClassUuids();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtBluetoothTypeConverters[SBK_QtBluetooth_QList_QBluetoothUuid_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_serviceDescription(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtBluetooth.QBluetoothServiceInfo.serviceDescription";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // serviceDescription()const
            QString cppResult = const_cast<const ::QBluetoothServiceInfo *>(cppSelf)->serviceDescription();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_serviceName(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtBluetooth.QBluetoothServiceInfo.serviceName";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // serviceName()const
            QString cppResult = const_cast<const ::QBluetoothServiceInfo *>(cppSelf)->serviceName();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_serviceProvider(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtBluetooth.QBluetoothServiceInfo.serviceProvider";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // serviceProvider()const
            QString cppResult = const_cast<const ::QBluetoothServiceInfo *>(cppSelf)->serviceProvider();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_serviceUuid(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtBluetooth.QBluetoothServiceInfo.serviceUuid";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // serviceUuid()const
            QBluetoothUuid cppResult = const_cast<const ::QBluetoothServiceInfo *>(cppSelf)->serviceUuid();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothUuid_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_setAttribute(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtBluetooth.QBluetoothServiceInfo.setAttribute";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "setAttribute", 2, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QBluetoothServiceInfo::setAttribute(quint16,QBluetoothServiceInfo::Alternative)
    // 1: QBluetoothServiceInfo::setAttribute(quint16,QBluetoothServiceInfo::Sequence)
    // 2: QBluetoothServiceInfo::setAttribute(quint16,QBluetoothUuid)
    // 3: QBluetoothServiceInfo::setAttribute(quint16,QVariant)
    if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint16>(), (pyArgs[0])))) {
        if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothUuid_IDX]), (pyArgs[1])))) {
            overloadId = 2; // setAttribute(quint16,QBluetoothUuid)
        } else if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_Sequence_IDX]), (pyArgs[1])))) {
            overloadId = 1; // setAttribute(quint16,QBluetoothServiceInfo::Sequence)
        } else if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_Alternative_IDX]), (pyArgs[1])))) {
            overloadId = 0; // setAttribute(quint16,QBluetoothServiceInfo::Alternative)
        } else if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QVariant_IDX], (pyArgs[1])))) {
            overloadId = 3; // setAttribute(quint16,QVariant)
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    switch (overloadId) {
        case 0: // setAttribute(quint16 attributeId, const QBluetoothServiceInfo::Alternative & value)
        {
            quint16 cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            if (!Shiboken::Object::isValid(pyArgs[1]))
                return {};
            ::QBluetoothServiceInfo::Alternative cppArg1_local;
            ::QBluetoothServiceInfo::Alternative *cppArg1 = &cppArg1_local;
            if (pythonToCpp[1].isValue())
                pythonToCpp[1](pyArgs[1], &cppArg1_local);
            else
                pythonToCpp[1](pyArgs[1], &cppArg1);


            if (Shiboken::Errors::occurred() == nullptr) {
                // setAttribute(quint16,QBluetoothServiceInfo::Alternative)
                cppSelf->setAttribute(cppArg0, *cppArg1);
            }
            break;
        }
        case 1: // setAttribute(quint16 attributeId, const QBluetoothServiceInfo::Sequence & value)
        {
            quint16 cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            if (!Shiboken::Object::isValid(pyArgs[1]))
                return {};
            ::QBluetoothServiceInfo::Sequence cppArg1_local;
            ::QBluetoothServiceInfo::Sequence *cppArg1 = &cppArg1_local;
            if (pythonToCpp[1].isValue())
                pythonToCpp[1](pyArgs[1], &cppArg1_local);
            else
                pythonToCpp[1](pyArgs[1], &cppArg1);


            if (Shiboken::Errors::occurred() == nullptr) {
                // setAttribute(quint16,QBluetoothServiceInfo::Sequence)
                cppSelf->setAttribute(cppArg0, *cppArg1);
            }
            break;
        }
        case 2: // setAttribute(quint16 attributeId, const QBluetoothUuid & value)
        {
            quint16 cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            if (!Shiboken::Object::isValid(pyArgs[1]))
                return {};
            ::QBluetoothUuid cppArg1_local;
            ::QBluetoothUuid *cppArg1 = &cppArg1_local;
            if (pythonToCpp[1].isValue())
                pythonToCpp[1](pyArgs[1], &cppArg1_local);
            else
                pythonToCpp[1](pyArgs[1], &cppArg1);


            if (Shiboken::Errors::occurred() == nullptr) {
                // setAttribute(quint16,QBluetoothUuid)
                cppSelf->setAttribute(cppArg0, *cppArg1);
            }
            break;
        }
        case 3: // setAttribute(quint16 attributeId, const QVariant & value)
        {
            quint16 cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            ::QVariant cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // setAttribute(quint16,QVariant)
                cppSelf->setAttribute(cppArg0, cppArg1);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_setDevice(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtBluetooth.QBluetoothServiceInfo.setDevice";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QBluetoothServiceInfo::setDevice(QBluetoothDeviceInfo)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothDeviceInfo_IDX]), (pyArg)))) {
        overloadId = 0; // setDevice(QBluetoothDeviceInfo)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QBluetoothDeviceInfo cppArg0_local;
        ::QBluetoothDeviceInfo *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // setDevice(QBluetoothDeviceInfo)
            cppSelf->setDevice(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_setServiceAvailability(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtBluetooth.QBluetoothServiceInfo.setServiceAvailability";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QBluetoothServiceInfo::setServiceAvailability(quint8)
    if (SbkChar_Check(pyArg) && (pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint8>(), (pyArg)))) {
        overloadId = 0; // setServiceAvailability(quint8)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        quint8 cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setServiceAvailability(quint8)
            cppSelf->setServiceAvailability(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_setServiceDescription(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtBluetooth.QBluetoothServiceInfo.setServiceDescription";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QBluetoothServiceInfo::setServiceDescription(QString)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArg)))) {
        overloadId = 0; // setServiceDescription(QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setServiceDescription(QString)
            cppSelf->setServiceDescription(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_setServiceName(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtBluetooth.QBluetoothServiceInfo.setServiceName";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QBluetoothServiceInfo::setServiceName(QString)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArg)))) {
        overloadId = 0; // setServiceName(QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setServiceName(QString)
            cppSelf->setServiceName(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_setServiceProvider(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtBluetooth.QBluetoothServiceInfo.setServiceProvider";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QBluetoothServiceInfo::setServiceProvider(QString)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArg)))) {
        overloadId = 0; // setServiceProvider(QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setServiceProvider(QString)
            cppSelf->setServiceProvider(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_setServiceUuid(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtBluetooth.QBluetoothServiceInfo.setServiceUuid";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QBluetoothServiceInfo::setServiceUuid(QBluetoothUuid)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothUuid_IDX]), (pyArg)))) {
        overloadId = 0; // setServiceUuid(QBluetoothUuid)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QBluetoothUuid cppArg0_local;
        ::QBluetoothUuid *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // setServiceUuid(QBluetoothUuid)
            cppSelf->setServiceUuid(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_socketProtocol(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtBluetooth.QBluetoothServiceInfo.socketProtocol";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // socketProtocol()const
            QBluetoothServiceInfo::Protocol cppResult = const_cast<const ::QBluetoothServiceInfo *>(cppSelf)->socketProtocol();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_Protocol_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_unregisterService(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtBluetooth.QBluetoothServiceInfo.unregisterService";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // unregisterService()
            bool cppResult = cppSelf->unregisterService();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QBluetoothServiceInfo__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QBluetoothServiceInfo_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QBluetoothServiceInfo_EnumFlagInfo[] = {
    "AttributeId:Enum",
    "Protocol:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QBluetoothServiceInfo_methods[] = {
    {"attribute", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_attribute), METH_O, nullptr},
    {"attributes", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_attributes), METH_NOARGS, nullptr},
    {"contains", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_contains), METH_O, nullptr},
    {"device", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_device), METH_NOARGS, nullptr},
    {"isComplete", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_isComplete), METH_NOARGS, nullptr},
    {"isRegistered", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_isRegistered), METH_NOARGS, nullptr},
    {"isValid", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_isValid), METH_NOARGS, nullptr},
    {"protocolDescriptor", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_protocolDescriptor), METH_O, nullptr},
    {"protocolServiceMultiplexer", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_protocolServiceMultiplexer), METH_NOARGS, nullptr},
    {"registerService", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_registerService), METH_VARARGS|METH_KEYWORDS, nullptr},
    {"removeAttribute", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_removeAttribute), METH_O, nullptr},
    {"serverChannel", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_serverChannel), METH_NOARGS, nullptr},
    {"serviceAvailability", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_serviceAvailability), METH_NOARGS, nullptr},
    {"serviceClassUuids", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_serviceClassUuids), METH_NOARGS, nullptr},
    {"serviceDescription", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_serviceDescription), METH_NOARGS, nullptr},
    {"serviceName", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_serviceName), METH_NOARGS, nullptr},
    {"serviceProvider", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_serviceProvider), METH_NOARGS, nullptr},
    {"serviceUuid", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_serviceUuid), METH_NOARGS, nullptr},
    {"setAttribute", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_setAttribute), METH_VARARGS, nullptr},
    {"setDevice", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_setDevice), METH_O, nullptr},
    {"setServiceAvailability", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_setServiceAvailability), METH_O, nullptr},
    {"setServiceDescription", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_setServiceDescription), METH_O, nullptr},
    {"setServiceName", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_setServiceName), METH_O, nullptr},
    {"setServiceProvider", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_setServiceProvider), METH_O, nullptr},
    {"setServiceUuid", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_setServiceUuid), METH_O, nullptr},
    {"socketProtocol", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_socketProtocol), METH_NOARGS, nullptr},
    {"unregisterService", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_unregisterService), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfo__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QBluetoothServiceInfo_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QBluetoothServiceInfo_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
extern "C"
{
static PyObject *Sbk_QBluetoothServiceInfo__repr__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    QBuffer buffer;
    buffer.open(QBuffer::ReadWrite);
    QDebug dbg(&buffer);
    dbg << *cppSelf;
    buffer.close();
    QByteArray str = buffer.data();
    const auto idx = str.indexOf('(');
    auto *typeName = Py_TYPE(self)->tp_name;
    if (idx >= 0)
        str.replace(0, idx, typeName);
    str = str.trimmed();
    Shiboken::AutoDecRef tpDict(PepType_GetDict(Py_TYPE(self)));
    PyObject *mod = PyDict_GetItem(tpDict.object(), Shiboken::PyMagicName::module());
    if (mod != nullptr && std::strchr(typeName, '.') == nullptr)
        return Shiboken::String::fromFormat("<%s.%s at %p>", Shiboken::String::toCString(mod), str.constData(), self);
    return Shiboken::String::fromFormat("<%s at %p>", str.constData(), self);
}
} // extern C

// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QBluetoothServiceInfo_Type = nullptr;
static PyTypeObject *Sbk_QBluetoothServiceInfo_TypeF(void)
{
    return _Sbk_QBluetoothServiceInfo_Type;
}

static PyType_Slot Sbk_QBluetoothServiceInfo_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_repr,        reinterpret_cast<void *>(Sbk_QBluetoothServiceInfo__repr__)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QBluetoothServiceInfo_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QBluetoothServiceInfo_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QBluetoothServiceInfo_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QBluetoothServiceInfo_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QBluetoothServiceInfo_spec = {
    "2:PySide6.QtBluetooth.QBluetoothServiceInfo",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QBluetoothServiceInfo_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void QBluetoothServiceInfo_AttributeId_PythonToCpp_QBluetoothServiceInfo_AttributeId(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QBluetoothServiceInfo::AttributeId>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QBluetoothServiceInfo::AttributeId *>(cppOut) = value;

}
static PythonToCppFunc is_QBluetoothServiceInfo_AttributeId_PythonToCpp_QBluetoothServiceInfo_AttributeId_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_AttributeId_IDX])))
        return QBluetoothServiceInfo_AttributeId_PythonToCpp_QBluetoothServiceInfo_AttributeId;
    return {};
}
static PyObject *QBluetoothServiceInfo_AttributeId_CppToPython_QBluetoothServiceInfo_AttributeId(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QBluetoothServiceInfo::AttributeId *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_AttributeId_IDX]), castCppIn);

}

static void QBluetoothServiceInfo_Protocol_PythonToCpp_QBluetoothServiceInfo_Protocol(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QBluetoothServiceInfo::Protocol>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QBluetoothServiceInfo::Protocol *>(cppOut) = value;

}
static PythonToCppFunc is_QBluetoothServiceInfo_Protocol_PythonToCpp_QBluetoothServiceInfo_Protocol_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_Protocol_IDX])))
        return QBluetoothServiceInfo_Protocol_PythonToCpp_QBluetoothServiceInfo_Protocol;
    return {};
}
static PyObject *QBluetoothServiceInfo_Protocol_CppToPython_QBluetoothServiceInfo_Protocol(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QBluetoothServiceInfo::Protocol *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_Protocol_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QBluetoothServiceInfo_PythonToCpp_QBluetoothServiceInfo_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QBluetoothServiceInfo_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QBluetoothServiceInfo_PythonToCpp_QBluetoothServiceInfo_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QBluetoothServiceInfo_TypeF()))
        return QBluetoothServiceInfo_PythonToCpp_QBluetoothServiceInfo_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QBluetoothServiceInfo_PTR_CppToPython_QBluetoothServiceInfo(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QBluetoothServiceInfo *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QBluetoothServiceInfo_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *QBluetoothServiceInfo_COPY_CppToPython_QBluetoothServiceInfo(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QBluetoothServiceInfo *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QBluetoothServiceInfo_TypeF(), new ::QBluetoothServiceInfo(*source), true, true);
}

// Python to C++ copy conversion.
static void QBluetoothServiceInfo_PythonToCpp_QBluetoothServiceInfo_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QBluetoothServiceInfo *>(cppOut) = *reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QBluetoothServiceInfo_PythonToCpp_QBluetoothServiceInfo_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QBluetoothServiceInfo_TypeF()))
        return QBluetoothServiceInfo_PythonToCpp_QBluetoothServiceInfo_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QBluetoothServiceInfo_SignatureStrings[] = {
    "1:PySide6.QtBluetooth.QBluetoothServiceInfo(self)",
    "0:PySide6.QtBluetooth.QBluetoothServiceInfo(self,other:PySide6.QtBluetooth.QBluetoothServiceInfo)",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.attribute(self,attributeId:quint16)->QVariant",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.attributes(self)->QList[quint16]",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.contains(self,attributeId:quint16)->bool",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.device(self)->PySide6.QtBluetooth.QBluetoothDeviceInfo",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.isComplete(self)->bool",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.isRegistered(self)->bool",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.isValid(self)->bool",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.protocolDescriptor(self,protocol:PySide6.QtBluetooth.QBluetoothUuid.ProtocolUuid)->PySide6.QtBluetooth.QBluetoothServiceInfo.Sequence",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.protocolServiceMultiplexer(self)->int",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.registerService(self,localAdapter:PySide6.QtBluetooth.QBluetoothAddress=QBluetoothAddress())->bool",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.removeAttribute(self,attributeId:quint16)",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.serverChannel(self)->int",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.serviceAvailability(self)->quint8",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.serviceClassUuids(self)->QList[PySide6.QtBluetooth.QBluetoothUuid]",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.serviceDescription(self)->QString",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.serviceName(self)->QString",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.serviceProvider(self)->QString",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.serviceUuid(self)->PySide6.QtBluetooth.QBluetoothUuid",
    "3:PySide6.QtBluetooth.QBluetoothServiceInfo.setAttribute(self,attributeId:quint16,value:typing.Union[PySide6.QtBluetooth.QBluetoothServiceInfo.Alternative, QList[QVariant]])",
    "2:PySide6.QtBluetooth.QBluetoothServiceInfo.setAttribute(self,attributeId:quint16,value:typing.Union[PySide6.QtBluetooth.QBluetoothServiceInfo.Sequence, QList[QVariant]])",
    "1:PySide6.QtBluetooth.QBluetoothServiceInfo.setAttribute(self,attributeId:quint16,value:typing.Union[PySide6.QtBluetooth.QBluetoothUuid, PySide6.QtBluetooth.QBluetoothUuid.CharacteristicType, PySide6.QtBluetooth.QBluetoothUuid.DescriptorType, PySide6.QtBluetooth.QBluetoothUuid.ProtocolUuid, PySide6.QtBluetooth.QBluetoothUuid.ServiceClassUuid, PySide6.QtCore.QUuid])",
    "0:PySide6.QtBluetooth.QBluetoothServiceInfo.setAttribute(self,attributeId:quint16,value:QVariant)",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.setDevice(self,info:PySide6.QtBluetooth.QBluetoothDeviceInfo)",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.setServiceAvailability(self,availability:quint8)",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.setServiceDescription(self,description:QString)",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.setServiceName(self,name:QString)",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.setServiceProvider(self,provider:QString)",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.setServiceUuid(self,uuid:typing.Union[PySide6.QtBluetooth.QBluetoothUuid, PySide6.QtBluetooth.QBluetoothUuid.CharacteristicType, PySide6.QtBluetooth.QBluetoothUuid.DescriptorType, PySide6.QtBluetooth.QBluetoothUuid.ProtocolUuid, PySide6.QtBluetooth.QBluetoothUuid.ServiceClassUuid, PySide6.QtCore.QUuid])",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.socketProtocol(self)->PySide6.QtBluetooth.QBluetoothServiceInfo.Protocol",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.unregisterService(self)->bool",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QBluetoothServiceInfo(PyObject *module)
{
    _Sbk_QBluetoothServiceInfo_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QBluetoothServiceInfo",
        "QBluetoothServiceInfo",
        &Sbk_QBluetoothServiceInfo_spec,
        &Shiboken::callCppDestructor< ::QBluetoothServiceInfo >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QBluetoothServiceInfo_TypeF(); // references _Sbk_QBluetoothServiceInfo_Type
    InitSignatureStrings(pyType, QBluetoothServiceInfo_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QBluetoothServiceInfo_PropertyStrings);
    SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QBluetoothServiceInfo_PythonToCpp_QBluetoothServiceInfo_PTR,
        is_QBluetoothServiceInfo_PythonToCpp_QBluetoothServiceInfo_PTR_Convertible,
        QBluetoothServiceInfo_PTR_CppToPython_QBluetoothServiceInfo,
        QBluetoothServiceInfo_COPY_CppToPython_QBluetoothServiceInfo);

    Shiboken::Conversions::registerConverterName(converter, "QBluetoothServiceInfo");
    Shiboken::Conversions::registerConverterName(converter, "QBluetoothServiceInfo*");
    Shiboken::Conversions::registerConverterName(converter, "QBluetoothServiceInfo&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QBluetoothServiceInfo).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QBluetoothServiceInfo_PythonToCpp_QBluetoothServiceInfo_COPY,
        is_QBluetoothServiceInfo_PythonToCpp_QBluetoothServiceInfo_COPY_Convertible);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QBluetoothServiceInfo_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'AttributeId'.
    const char *AttributeId_Initializer[] = {
        "ServiceRecordHandle",
        "ServiceClassIds",
        "ServiceRecordState",
        "ServiceId",
        "ProtocolDescriptorList",
        "BrowseGroupList",
        "LanguageBaseAttributeIdList",
        "ServiceInfoTimeToLive",
        "ServiceAvailability",
        "BluetoothProfileDescriptorList",
        "DocumentationUrl",
        "ClientExecutableUrl",
        "IconUrl",
        "AdditionalProtocolDescriptorList",
        "PrimaryLanguageBase",
        "ServiceName",
        "ServiceDescription",
        "ServiceProvider",
        nullptr};
    // "uint16_t" used instead of "unsigned int"
    constexpr uint16_t AttributeId_InitializerValues[] = {
        uint16_t(QBluetoothServiceInfo::AttributeId::ServiceRecordHandle),              //  0x0000  0
        uint16_t(QBluetoothServiceInfo::AttributeId::ServiceClassIds),                  //  0x0001  1
        uint16_t(QBluetoothServiceInfo::AttributeId::ServiceRecordState),               //  0x0002  2
        uint16_t(QBluetoothServiceInfo::AttributeId::ServiceId),                        //  0x0003  3
        uint16_t(QBluetoothServiceInfo::AttributeId::ProtocolDescriptorList),           //  0x0004  4
        uint16_t(QBluetoothServiceInfo::AttributeId::BrowseGroupList),                  //  0x0005  5
        uint16_t(QBluetoothServiceInfo::AttributeId::LanguageBaseAttributeIdList),      //  0x0006  6
        uint16_t(QBluetoothServiceInfo::AttributeId::ServiceInfoTimeToLive),            //  0x0007  7
        uint16_t(QBluetoothServiceInfo::AttributeId::ServiceAvailability),              //  0x0008  8
        uint16_t(QBluetoothServiceInfo::AttributeId::BluetoothProfileDescriptorList),   //  0x0009  9
        uint16_t(QBluetoothServiceInfo::AttributeId::DocumentationUrl),                 //  0x000a  10
        uint16_t(QBluetoothServiceInfo::AttributeId::ClientExecutableUrl),              //  0x000b  11
        uint16_t(QBluetoothServiceInfo::AttributeId::IconUrl),                          //  0x000c  12
        uint16_t(QBluetoothServiceInfo::AttributeId::AdditionalProtocolDescriptorList), //  0x000d  13
        uint16_t(QBluetoothServiceInfo::AttributeId::PrimaryLanguageBase),              //  0x0100  256
        uint16_t(QBluetoothServiceInfo::AttributeId::ServiceName),                      //  0x0100  256
        uint16_t(QBluetoothServiceInfo::AttributeId::ServiceDescription),               //  0x0101  257
        uint16_t(QBluetoothServiceInfo::AttributeId::ServiceProvider)                   //  0x0102  258
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QBluetoothServiceInfo_TypeF(),
        "2:PySide6.QtBluetooth.QBluetoothServiceInfo.AttributeId",
        AttributeId_Initializer, AttributeId_InitializerValues);
    SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_AttributeId_IDX].type = EType;
    // Register converter for enum 'QBluetoothServiceInfo::AttributeId'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QBluetoothServiceInfo_AttributeId_CppToPython_QBluetoothServiceInfo_AttributeId);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QBluetoothServiceInfo_AttributeId_PythonToCpp_QBluetoothServiceInfo_AttributeId,
            is_QBluetoothServiceInfo_AttributeId_PythonToCpp_QBluetoothServiceInfo_AttributeId_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QBluetoothServiceInfo::AttributeId");
        Shiboken::Conversions::registerConverterName(converter, "AttributeId");
    }
    // End of 'AttributeId' enum.

    // Initialization of enum 'Protocol'.
    const char *Protocol_Initializer[] = {
        "UnknownProtocol",
        "L2capProtocol",
        "RfcommProtocol",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t Protocol_InitializerValues[] = {
        uint8_t(QBluetoothServiceInfo::Protocol::UnknownProtocol), //  0x00  0
        uint8_t(QBluetoothServiceInfo::Protocol::L2capProtocol),   //  0x01  1
        uint8_t(QBluetoothServiceInfo::Protocol::RfcommProtocol)   //  0x02  2
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QBluetoothServiceInfo_TypeF(),
        "2:PySide6.QtBluetooth.QBluetoothServiceInfo.Protocol",
        Protocol_Initializer, Protocol_InitializerValues);
    SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothServiceInfo_Protocol_IDX].type = EType;
    // Register converter for enum 'QBluetoothServiceInfo::Protocol'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QBluetoothServiceInfo_Protocol_CppToPython_QBluetoothServiceInfo_Protocol);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QBluetoothServiceInfo_Protocol_PythonToCpp_QBluetoothServiceInfo_Protocol,
            is_QBluetoothServiceInfo_Protocol_PythonToCpp_QBluetoothServiceInfo_Protocol_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QBluetoothServiceInfo::Protocol");
        Shiboken::Conversions::registerConverterName(converter, "Protocol");
    }
    // End of 'Protocol' enum.

    qRegisterMetaType< ::QBluetoothServiceInfo >("QBluetoothServiceInfo");
    qRegisterMetaType< ::QBluetoothServiceInfo::AttributeId >("QBluetoothServiceInfo::AttributeId");
    qRegisterMetaType< ::QBluetoothServiceInfo::Protocol >("QBluetoothServiceInfo::Protocol");

    return pyType;
}
