// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtbluetooth_python.h"

// main header
#include "qlowenergyadvertisingparameters_wrapper.h"

// inner classes
#include "qlowenergyadvertisingparameters_addressinfo_wrapper.h"

// Argument includes
#include <QList>
#include <QtBluetooth/qlowenergyadvertisingparameters.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QLowEnergyAdvertisingParameters_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QLowEnergyAdvertisingParameters >()))
        return -1;

    ::QLowEnergyAdvertisingParameters *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QLowEnergyAdvertisingParameters", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QLowEnergyAdvertisingParameters::QLowEnergyAdvertisingParameters()
    // 1: QLowEnergyAdvertisingParameters::QLowEnergyAdvertisingParameters(QLowEnergyAdvertisingParameters)
    if (numArgs == 0) {
        overloadId = 0; // QLowEnergyAdvertisingParameters()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QLowEnergyAdvertisingParameters(QLowEnergyAdvertisingParameters)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QLowEnergyAdvertisingParameters()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QLowEnergyAdvertisingParameters()
                cptr = new ::QLowEnergyAdvertisingParameters();
            }
            break;
        }
        case 1: // QLowEnergyAdvertisingParameters(const QLowEnergyAdvertisingParameters & other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QLowEnergyAdvertisingParameters cppArg0_local;
            ::QLowEnergyAdvertisingParameters *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QLowEnergyAdvertisingParameters(QLowEnergyAdvertisingParameters)
                cptr = new ::QLowEnergyAdvertisingParameters(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QLowEnergyAdvertisingParameters >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QLowEnergyAdvertisingParametersFunc_filterPolicy(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingParameters *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.filterPolicy";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // filterPolicy()const
            QLowEnergyAdvertisingParameters::FilterPolicy cppResult = const_cast<const ::QLowEnergyAdvertisingParameters *>(cppSelf)->filterPolicy();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_FilterPolicy_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QLowEnergyAdvertisingParametersFunc_maximumInterval(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingParameters *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.maximumInterval";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // maximumInterval()const
            int cppResult = const_cast<const ::QLowEnergyAdvertisingParameters *>(cppSelf)->maximumInterval();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QLowEnergyAdvertisingParametersFunc_minimumInterval(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingParameters *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.minimumInterval";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // minimumInterval()const
            int cppResult = const_cast<const ::QLowEnergyAdvertisingParameters *>(cppSelf)->minimumInterval();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QLowEnergyAdvertisingParametersFunc_mode(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingParameters *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.mode";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // mode()const
            QLowEnergyAdvertisingParameters::Mode cppResult = const_cast<const ::QLowEnergyAdvertisingParameters *>(cppSelf)->mode();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_Mode_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QLowEnergyAdvertisingParametersFunc_setInterval(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingParameters *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.setInterval";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "setInterval", 2, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QLowEnergyAdvertisingParameters::setInterval(quint16,quint16)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint16>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint16>(), (pyArgs[1])))) {
        overloadId = 0; // setInterval(quint16,quint16)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        quint16 cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        quint16 cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setInterval(quint16,quint16)
            cppSelf->setInterval(cppArg0, cppArg1);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QLowEnergyAdvertisingParametersFunc_setMode(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingParameters *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.setMode";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QLowEnergyAdvertisingParameters::setMode(QLowEnergyAdvertisingParameters::Mode)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_Mode_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // setMode(QLowEnergyAdvertisingParameters::Mode)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QLowEnergyAdvertisingParameters::Mode cppArg0{QLowEnergyAdvertisingParameters::AdvInd};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setMode(QLowEnergyAdvertisingParameters::Mode)
            cppSelf->setMode(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QLowEnergyAdvertisingParametersFunc_setWhiteList(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingParameters *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.setWhiteList";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "setWhiteList", 2, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QLowEnergyAdvertisingParameters::setWhiteList(QList<QLowEnergyAdvertisingParameters::AddressInfo>,QLowEnergyAdvertisingParameters::FilterPolicy)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtBluetoothTypeConverters[SBK_QtBluetooth_QList_QLowEnergyAdvertisingParameters_AddressInfo_IDX], (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_FilterPolicy_IDX])))->converter, (pyArgs[1])))) {
        overloadId = 0; // setWhiteList(QList<QLowEnergyAdvertisingParameters::AddressInfo>,QLowEnergyAdvertisingParameters::FilterPolicy)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        ::QList<QLowEnergyAdvertisingParameters::AddressInfo> cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QLowEnergyAdvertisingParameters::FilterPolicy cppArg1{QLowEnergyAdvertisingParameters::IgnoreWhiteList};
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setWhiteList(QList<QLowEnergyAdvertisingParameters::AddressInfo>,QLowEnergyAdvertisingParameters::FilterPolicy)
            cppSelf->setWhiteList(cppArg0, cppArg1);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QLowEnergyAdvertisingParametersFunc_swap(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingParameters *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.swap";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QLowEnergyAdvertisingParameters::swap(QLowEnergyAdvertisingParameters&)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_IDX]), (pyArg)))) {
        overloadId = 0; // swap(QLowEnergyAdvertisingParameters&)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QLowEnergyAdvertisingParameters cppArg0_local;
        ::QLowEnergyAdvertisingParameters *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // swap(QLowEnergyAdvertisingParameters&)
            cppSelf->swap(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QLowEnergyAdvertisingParametersFunc_whiteList(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingParameters *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.whiteList";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // whiteList()const
            QList<QLowEnergyAdvertisingParameters::AddressInfo> cppResult = const_cast<const ::QLowEnergyAdvertisingParameters *>(cppSelf)->whiteList();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtBluetoothTypeConverters[SBK_QtBluetooth_QList_QLowEnergyAdvertisingParameters_AddressInfo_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QLowEnergyAdvertisingParameters__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QLowEnergyAdvertisingParameters *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QLowEnergyAdvertisingParameters_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QLowEnergyAdvertisingParameters_EnumFlagInfo[] = {
    "FilterPolicy:Enum",
    "Mode:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QLowEnergyAdvertisingParameters_methods[] = {
    {"filterPolicy", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingParametersFunc_filterPolicy), METH_NOARGS, nullptr},
    {"maximumInterval", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingParametersFunc_maximumInterval), METH_NOARGS, nullptr},
    {"minimumInterval", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingParametersFunc_minimumInterval), METH_NOARGS, nullptr},
    {"mode", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingParametersFunc_mode), METH_NOARGS, nullptr},
    {"setInterval", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingParametersFunc_setInterval), METH_VARARGS, nullptr},
    {"setMode", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingParametersFunc_setMode), METH_O, nullptr},
    {"setWhiteList", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingParametersFunc_setWhiteList), METH_VARARGS, nullptr},
    {"swap", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingParametersFunc_swap), METH_O, nullptr},
    {"whiteList", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingParametersFunc_whiteList), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingParameters__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QLowEnergyAdvertisingParameters_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QLowEnergyAdvertisingParameters *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_IDX]), (pyArg)))) {
                // operator!=(const QLowEnergyAdvertisingParameters & b)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QLowEnergyAdvertisingParameters cppArg0_local;
                ::QLowEnergyAdvertisingParameters *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_IDX]), (pyArg)))) {
                // operator==(const QLowEnergyAdvertisingParameters & b)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QLowEnergyAdvertisingParameters cppArg0_local;
                ::QLowEnergyAdvertisingParameters *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static int Sbk_QLowEnergyAdvertisingParameters_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QLowEnergyAdvertisingParameters_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QLowEnergyAdvertisingParameters_Type = nullptr;
static PyTypeObject *Sbk_QLowEnergyAdvertisingParameters_TypeF(void)
{
    return _Sbk_QLowEnergyAdvertisingParameters_Type;
}

static PyType_Slot Sbk_QLowEnergyAdvertisingParameters_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QLowEnergyAdvertisingParameters_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QLowEnergyAdvertisingParameters_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QLowEnergyAdvertisingParameters_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QLowEnergyAdvertisingParameters_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QLowEnergyAdvertisingParameters_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QLowEnergyAdvertisingParameters_spec = {
    "2:PySide6.QtBluetooth.QLowEnergyAdvertisingParameters",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QLowEnergyAdvertisingParameters_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void QLowEnergyAdvertisingParameters_Mode_PythonToCpp_QLowEnergyAdvertisingParameters_Mode(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QLowEnergyAdvertisingParameters::Mode>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QLowEnergyAdvertisingParameters::Mode *>(cppOut) = value;

}
static PythonToCppFunc is_QLowEnergyAdvertisingParameters_Mode_PythonToCpp_QLowEnergyAdvertisingParameters_Mode_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_Mode_IDX])))
        return QLowEnergyAdvertisingParameters_Mode_PythonToCpp_QLowEnergyAdvertisingParameters_Mode;
    return {};
}
static PyObject *QLowEnergyAdvertisingParameters_Mode_CppToPython_QLowEnergyAdvertisingParameters_Mode(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QLowEnergyAdvertisingParameters::Mode *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_Mode_IDX]), castCppIn);

}

static void QLowEnergyAdvertisingParameters_FilterPolicy_PythonToCpp_QLowEnergyAdvertisingParameters_FilterPolicy(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QLowEnergyAdvertisingParameters::FilterPolicy>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QLowEnergyAdvertisingParameters::FilterPolicy *>(cppOut) = value;

}
static PythonToCppFunc is_QLowEnergyAdvertisingParameters_FilterPolicy_PythonToCpp_QLowEnergyAdvertisingParameters_FilterPolicy_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_FilterPolicy_IDX])))
        return QLowEnergyAdvertisingParameters_FilterPolicy_PythonToCpp_QLowEnergyAdvertisingParameters_FilterPolicy;
    return {};
}
static PyObject *QLowEnergyAdvertisingParameters_FilterPolicy_CppToPython_QLowEnergyAdvertisingParameters_FilterPolicy(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QLowEnergyAdvertisingParameters::FilterPolicy *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_FilterPolicy_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QLowEnergyAdvertisingParameters_PythonToCpp_QLowEnergyAdvertisingParameters_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QLowEnergyAdvertisingParameters_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QLowEnergyAdvertisingParameters_PythonToCpp_QLowEnergyAdvertisingParameters_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QLowEnergyAdvertisingParameters_TypeF()))
        return QLowEnergyAdvertisingParameters_PythonToCpp_QLowEnergyAdvertisingParameters_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QLowEnergyAdvertisingParameters_PTR_CppToPython_QLowEnergyAdvertisingParameters(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QLowEnergyAdvertisingParameters *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QLowEnergyAdvertisingParameters_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *QLowEnergyAdvertisingParameters_COPY_CppToPython_QLowEnergyAdvertisingParameters(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QLowEnergyAdvertisingParameters *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QLowEnergyAdvertisingParameters_TypeF(), new ::QLowEnergyAdvertisingParameters(*source), true, true);
}

// Python to C++ copy conversion.
static void QLowEnergyAdvertisingParameters_PythonToCpp_QLowEnergyAdvertisingParameters_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QLowEnergyAdvertisingParameters *>(cppOut) = *reinterpret_cast< ::QLowEnergyAdvertisingParameters *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QLowEnergyAdvertisingParameters_PythonToCpp_QLowEnergyAdvertisingParameters_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QLowEnergyAdvertisingParameters_TypeF()))
        return QLowEnergyAdvertisingParameters_PythonToCpp_QLowEnergyAdvertisingParameters_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QLowEnergyAdvertisingParameters_SignatureStrings[] = {
    "1:PySide6.QtBluetooth.QLowEnergyAdvertisingParameters(self)",
    "0:PySide6.QtBluetooth.QLowEnergyAdvertisingParameters(self,other:PySide6.QtBluetooth.QLowEnergyAdvertisingParameters)",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.filterPolicy(self)->PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.FilterPolicy",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.maximumInterval(self)->int",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.minimumInterval(self)->int",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.mode(self)->PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.Mode",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.setInterval(self,minimum:quint16,maximum:quint16)",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.setMode(self,mode:PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.Mode)",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.setWhiteList(self,whiteList:QList[PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.AddressInfo],policy:PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.FilterPolicy)",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.swap(self,other:PySide6.QtBluetooth.QLowEnergyAdvertisingParameters)",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.whiteList(self)->QList[PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.AddressInfo]",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QLowEnergyAdvertisingParameters(PyObject *module)
{
    _Sbk_QLowEnergyAdvertisingParameters_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QLowEnergyAdvertisingParameters",
        "QLowEnergyAdvertisingParameters",
        &Sbk_QLowEnergyAdvertisingParameters_spec,
        &Shiboken::callCppDestructor< ::QLowEnergyAdvertisingParameters >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QLowEnergyAdvertisingParameters_TypeF(); // references _Sbk_QLowEnergyAdvertisingParameters_Type
    InitSignatureStrings(pyType, QLowEnergyAdvertisingParameters_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QLowEnergyAdvertisingParameters_PropertyStrings);
    SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QLowEnergyAdvertisingParameters_PythonToCpp_QLowEnergyAdvertisingParameters_PTR,
        is_QLowEnergyAdvertisingParameters_PythonToCpp_QLowEnergyAdvertisingParameters_PTR_Convertible,
        QLowEnergyAdvertisingParameters_PTR_CppToPython_QLowEnergyAdvertisingParameters,
        QLowEnergyAdvertisingParameters_COPY_CppToPython_QLowEnergyAdvertisingParameters);

    Shiboken::Conversions::registerConverterName(converter, "QLowEnergyAdvertisingParameters");
    Shiboken::Conversions::registerConverterName(converter, "QLowEnergyAdvertisingParameters*");
    Shiboken::Conversions::registerConverterName(converter, "QLowEnergyAdvertisingParameters&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QLowEnergyAdvertisingParameters).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QLowEnergyAdvertisingParameters_PythonToCpp_QLowEnergyAdvertisingParameters_COPY,
        is_QLowEnergyAdvertisingParameters_PythonToCpp_QLowEnergyAdvertisingParameters_COPY_Convertible);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QLowEnergyAdvertisingParameters_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'Mode'.
    const char *Mode_Initializer[] = {
        "AdvInd",
        "AdvScanInd",
        "AdvNonConnInd",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t Mode_InitializerValues[] = {
        uint8_t(QLowEnergyAdvertisingParameters::Mode::AdvInd),       //  0x00  0
        uint8_t(QLowEnergyAdvertisingParameters::Mode::AdvScanInd),   //  0x02  2
        uint8_t(QLowEnergyAdvertisingParameters::Mode::AdvNonConnInd) //  0x03  3
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QLowEnergyAdvertisingParameters_TypeF(),
        "2:PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.Mode",
        Mode_Initializer, Mode_InitializerValues);
    SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_Mode_IDX].type = EType;
    // Register converter for enum 'QLowEnergyAdvertisingParameters::Mode'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QLowEnergyAdvertisingParameters_Mode_CppToPython_QLowEnergyAdvertisingParameters_Mode);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QLowEnergyAdvertisingParameters_Mode_PythonToCpp_QLowEnergyAdvertisingParameters_Mode,
            is_QLowEnergyAdvertisingParameters_Mode_PythonToCpp_QLowEnergyAdvertisingParameters_Mode_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QLowEnergyAdvertisingParameters::Mode");
        Shiboken::Conversions::registerConverterName(converter, "Mode");
    }
    // End of 'Mode' enum.

    // Initialization of enum 'FilterPolicy'.
    const char *FilterPolicy_Initializer[] = {
        "IgnoreWhiteList",
        "UseWhiteListForScanning",
        "UseWhiteListForConnecting",
        "UseWhiteListForScanningAndConnecting",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t FilterPolicy_InitializerValues[] = {
        uint8_t(QLowEnergyAdvertisingParameters::FilterPolicy::IgnoreWhiteList),                     //  0x00  0
        uint8_t(QLowEnergyAdvertisingParameters::FilterPolicy::UseWhiteListForScanning),             //  0x01  1
        uint8_t(QLowEnergyAdvertisingParameters::FilterPolicy::UseWhiteListForConnecting),           //  0x02  2
        uint8_t(QLowEnergyAdvertisingParameters::FilterPolicy::UseWhiteListForScanningAndConnecting) //  0x03  3
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QLowEnergyAdvertisingParameters_TypeF(),
        "2:PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.FilterPolicy",
        FilterPolicy_Initializer, FilterPolicy_InitializerValues);
    SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_FilterPolicy_IDX].type = EType;
    // Register converter for enum 'QLowEnergyAdvertisingParameters::FilterPolicy'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QLowEnergyAdvertisingParameters_FilterPolicy_CppToPython_QLowEnergyAdvertisingParameters_FilterPolicy);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QLowEnergyAdvertisingParameters_FilterPolicy_PythonToCpp_QLowEnergyAdvertisingParameters_FilterPolicy,
            is_QLowEnergyAdvertisingParameters_FilterPolicy_PythonToCpp_QLowEnergyAdvertisingParameters_FilterPolicy_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QLowEnergyAdvertisingParameters::FilterPolicy");
        Shiboken::Conversions::registerConverterName(converter, "FilterPolicy");
    }
    // End of 'FilterPolicy' enum.

    qRegisterMetaType< ::QLowEnergyAdvertisingParameters >("QLowEnergyAdvertisingParameters");
    qRegisterMetaType< ::QLowEnergyAdvertisingParameters::Mode >("QLowEnergyAdvertisingParameters::Mode");
    qRegisterMetaType< ::QLowEnergyAdvertisingParameters::FilterPolicy >("QLowEnergyAdvertisingParameters::FilterPolicy");

    return pyType;
}
