// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtcore_python.h"

// main header
#include "qcalendarpermission_wrapper.h"

// Argument includes
#include <qobject.h>
#include <qobjectdefs.h>
#include <qpermissions.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QCalendarPermission_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QCalendarPermission >()))
        return -1;

    ::QCalendarPermission *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtCore.QCalendarPermission.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QCalendarPermission", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QCalendarPermission::QCalendarPermission()
    // 1: QCalendarPermission::QCalendarPermission(QCalendarPermission)
    if (numArgs == 0) {
        overloadId = 0; // QCalendarPermission()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCalendarPermission_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QCalendarPermission(QCalendarPermission)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QCalendarPermission()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QCalendarPermission()
                cptr = new ::QCalendarPermission();
            }
            break;
        }
        case 1: // QCalendarPermission(const QCalendarPermission & other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QCalendarPermission cppArg0_local;
            ::QCalendarPermission *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QCalendarPermission(QCalendarPermission)
                cptr = new ::QCalendarPermission(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QCalendarPermission >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QCalendarPermissionFunc_accessMode(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCalendarPermission *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCalendarPermission_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtCore.QCalendarPermission.accessMode";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // accessMode()const
            QCalendarPermission::AccessMode cppResult = const_cast<const ::QCalendarPermission *>(cppSelf)->accessMode();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCalendarPermission_AccessMode_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCalendarPermissionFunc_setAccessMode(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCalendarPermission *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCalendarPermission_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtCore.QCalendarPermission.setAccessMode";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QCalendarPermission::setAccessMode(QCalendarPermission::AccessMode)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCalendarPermission_AccessMode_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // setAccessMode(QCalendarPermission::AccessMode)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QCalendarPermission::AccessMode cppArg0{QCalendarPermission::ReadOnly};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setAccessMode(QCalendarPermission::AccessMode)
            cppSelf->setAccessMode(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QCalendarPermissionFunc_swap(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCalendarPermission *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCalendarPermission_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtCore.QCalendarPermission.swap";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QCalendarPermission::swap(QCalendarPermission&)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCalendarPermission_IDX]), (pyArg)))) {
        overloadId = 0; // swap(QCalendarPermission&)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QCalendarPermission cppArg0_local;
        ::QCalendarPermission *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // swap(QCalendarPermission&)
            cppSelf->swap(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QCalendarPermission__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QCalendarPermission *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCalendarPermission_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCalendarPermission_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QCalendarPermission_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QCalendarPermission_EnumFlagInfo[] = {
    "AccessMode:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QCalendarPermission_methods[] = {
    {"accessMode", reinterpret_cast<PyCFunction>(Sbk_QCalendarPermissionFunc_accessMode), METH_NOARGS, nullptr},
    {"setAccessMode", reinterpret_cast<PyCFunction>(Sbk_QCalendarPermissionFunc_setAccessMode), METH_O, nullptr},
    {"swap", reinterpret_cast<PyCFunction>(Sbk_QCalendarPermissionFunc_swap), METH_O, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QCalendarPermission__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QCalendarPermission_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QCalendarPermission_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QCalendarPermission_Type = nullptr;
static PyTypeObject *Sbk_QCalendarPermission_TypeF(void)
{
    return _Sbk_QCalendarPermission_Type;
}

static PyType_Slot Sbk_QCalendarPermission_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QCalendarPermission_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QCalendarPermission_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QCalendarPermission_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QCalendarPermission_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QCalendarPermission_spec = {
    "2:PySide6.QtCore.QCalendarPermission",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QCalendarPermission_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void QCalendarPermission_AccessMode_PythonToCpp_QCalendarPermission_AccessMode(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QCalendarPermission::AccessMode>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QCalendarPermission::AccessMode *>(cppOut) = value;

}
static PythonToCppFunc is_QCalendarPermission_AccessMode_PythonToCpp_QCalendarPermission_AccessMode_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCalendarPermission_AccessMode_IDX])))
        return QCalendarPermission_AccessMode_PythonToCpp_QCalendarPermission_AccessMode;
    return {};
}
static PyObject *QCalendarPermission_AccessMode_CppToPython_QCalendarPermission_AccessMode(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QCalendarPermission::AccessMode *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCalendarPermission_AccessMode_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QCalendarPermission_PythonToCpp_QCalendarPermission_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QCalendarPermission_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QCalendarPermission_PythonToCpp_QCalendarPermission_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QCalendarPermission_TypeF()))
        return QCalendarPermission_PythonToCpp_QCalendarPermission_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QCalendarPermission_PTR_CppToPython_QCalendarPermission(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QCalendarPermission *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QCalendarPermission_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *QCalendarPermission_COPY_CppToPython_QCalendarPermission(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QCalendarPermission *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QCalendarPermission_TypeF(), new ::QCalendarPermission(*source), true, true);
}

// Python to C++ copy conversion.
static void QCalendarPermission_PythonToCpp_QCalendarPermission_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QCalendarPermission *>(cppOut) = *reinterpret_cast< ::QCalendarPermission *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCalendarPermission_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QCalendarPermission_PythonToCpp_QCalendarPermission_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QCalendarPermission_TypeF()))
        return QCalendarPermission_PythonToCpp_QCalendarPermission_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QCalendarPermission_SignatureStrings[] = {
    "1:PySide6.QtCore.QCalendarPermission(self)",
    "0:PySide6.QtCore.QCalendarPermission(self,other:PySide6.QtCore.QCalendarPermission)",
    "PySide6.QtCore.QCalendarPermission.accessMode(self)->PySide6.QtCore.QCalendarPermission.AccessMode",
    "PySide6.QtCore.QCalendarPermission.setAccessMode(self,mode:PySide6.QtCore.QCalendarPermission.AccessMode)",
    "PySide6.QtCore.QCalendarPermission.swap(self,other:PySide6.QtCore.QCalendarPermission)",
    "PySide6.QtCore.QCalendarPermission.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QCalendarPermission(PyObject *module)
{
    _Sbk_QCalendarPermission_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QCalendarPermission",
        "QCalendarPermission",
        &Sbk_QCalendarPermission_spec,
        &Shiboken::callCppDestructor< ::QCalendarPermission >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QCalendarPermission_TypeF(); // references _Sbk_QCalendarPermission_Type
    InitSignatureStrings(pyType, QCalendarPermission_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QCalendarPermission_PropertyStrings);
    SbkPySide6_QtCoreTypeStructs[SBK_QCalendarPermission_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QCalendarPermission_PythonToCpp_QCalendarPermission_PTR,
        is_QCalendarPermission_PythonToCpp_QCalendarPermission_PTR_Convertible,
        QCalendarPermission_PTR_CppToPython_QCalendarPermission,
        QCalendarPermission_COPY_CppToPython_QCalendarPermission);

    Shiboken::Conversions::registerConverterName(converter, "QCalendarPermission");
    Shiboken::Conversions::registerConverterName(converter, "QCalendarPermission*");
    Shiboken::Conversions::registerConverterName(converter, "QCalendarPermission&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QCalendarPermission).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QCalendarPermission_PythonToCpp_QCalendarPermission_COPY,
        is_QCalendarPermission_PythonToCpp_QCalendarPermission_COPY_Convertible);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QCalendarPermission_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'AccessMode'.
    const char *AccessMode_Initializer[] = {
        "ReadOnly",
        "ReadWrite",
        nullptr};
    // "uint8_t" used instead of "unsigned char"
    constexpr uint8_t AccessMode_InitializerValues[] = {
        uint8_t(QCalendarPermission::AccessMode::ReadOnly), //  0x00  0
        uint8_t(QCalendarPermission::AccessMode::ReadWrite) //  0x01  1
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QCalendarPermission_TypeF(),
        "2:PySide6.QtCore.QCalendarPermission.AccessMode",
        AccessMode_Initializer, AccessMode_InitializerValues);
    SbkPySide6_QtCoreTypeStructs[SBK_QCalendarPermission_AccessMode_IDX].type = EType;
    // Register converter for enum 'QCalendarPermission::AccessMode'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QCalendarPermission_AccessMode_CppToPython_QCalendarPermission_AccessMode);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QCalendarPermission_AccessMode_PythonToCpp_QCalendarPermission_AccessMode,
            is_QCalendarPermission_AccessMode_PythonToCpp_QCalendarPermission_AccessMode_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QCalendarPermission::AccessMode");
        Shiboken::Conversions::registerConverterName(converter, "AccessMode");
    }
    // End of 'AccessMode' enum.

    qRegisterMetaType< ::QCalendarPermission >("QCalendarPermission");
    qRegisterMetaType< ::QCalendarPermission::AccessMode >("QCalendarPermission::AccessMode");

    return pyType;
}
