// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtcore_python.h"

// main header
#include "qcborstringresultbytearray_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QCborStringResultByteArray_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QCborStringResultByteArray >()))
        return -1;

    ::QCborStringResultByteArray *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtCore.QCborStringResultByteArray.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QCborStringResultByteArray", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QCborStringResultByteArray::QCborStringResultByteArray()
    // 1: QCborStringResultByteArray::QCborStringResultByteArray(QCborStringResultByteArray)
    if (numArgs == 0) {
        overloadId = 0; // QCborStringResultByteArray()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCborStringResultByteArray_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QCborStringResultByteArray(QCborStringResultByteArray)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QCborStringResultByteArray()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QCborStringResultByteArray()
                cptr = new ::QCborStringResultByteArray();
            }
            break;
        }
        case 1: // QCborStringResultByteArray(const QCborStringResultByteArray & QCborStringResultByteArray)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QCborStringResultByteArray cppArg0_local;
            ::QCborStringResultByteArray *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QCborStringResultByteArray(QCborStringResultByteArray)
                cptr = new ::QCborStringResultByteArray(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QCborStringResultByteArray >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QCborStringResultByteArray__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QCborStringResultByteArray *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCborStringResultByteArray_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCborStringResultByteArray_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QCborStringResultByteArray_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QCborStringResultByteArray_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QCborStringResultByteArray__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QCborStringResultByteArray_get_data(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCborStringResultByteArray *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCborStringResultByteArray_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->data)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX])));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->data))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->data)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), &(cppSelf->data), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_QCborStringResultByteArray_set_data(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QCborStringResultByteArray *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCborStringResultByteArray_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("data");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("data", "QByteArray");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->data;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QCborStringResultByteArray_get_status(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCborStringResultByteArray *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCborStringResultByteArray_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QCborStreamReader::StringResultCode cppOut_local = cppSelf->status;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCborStreamReader_StringResultCode_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QCborStringResultByteArray_set_status(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QCborStringResultByteArray *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCborStringResultByteArray_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("status");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCborStreamReader_StringResultCode_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("status", "StringResultCode");
        return -1;
    }

    auto cppOut_local = cppSelf->status;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->status = cppOut_local;

    return 0;
}

// Getters and Setters for QCborStringResultByteArray
static PyGetSetDef Sbk_QCborStringResultByteArray_getsetlist[] = {
    {const_cast<char *>("data"), Sbk_QCborStringResultByteArray_get_data, Sbk_QCborStringResultByteArray_set_data, nullptr, nullptr},
    {const_cast<char *>("status"), Sbk_QCborStringResultByteArray_get_status, Sbk_QCborStringResultByteArray_set_status, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QCborStringResultByteArray_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QCborStringResultByteArray_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QCborStringResultByteArray_Type = nullptr;
static PyTypeObject *Sbk_QCborStringResultByteArray_TypeF(void)
{
    return _Sbk_QCborStringResultByteArray_Type;
}

static PyType_Slot Sbk_QCborStringResultByteArray_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QCborStringResultByteArray_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QCborStringResultByteArray_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QCborStringResultByteArray_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QCborStringResultByteArray_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QCborStringResultByteArray_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QCborStringResultByteArray_spec = {
    "2:PySide6.QtCore.QCborStringResultByteArray",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QCborStringResultByteArray_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QCborStringResultByteArray_PythonToCpp_QCborStringResultByteArray_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QCborStringResultByteArray_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QCborStringResultByteArray_PythonToCpp_QCborStringResultByteArray_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QCborStringResultByteArray_TypeF()))
        return QCborStringResultByteArray_PythonToCpp_QCborStringResultByteArray_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QCborStringResultByteArray_PTR_CppToPython_QCborStringResultByteArray(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QCborStringResultByteArray *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QCborStringResultByteArray_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *QCborStringResultByteArray_COPY_CppToPython_QCborStringResultByteArray(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QCborStringResultByteArray *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QCborStringResultByteArray_TypeF(), new ::QCborStringResultByteArray(*source), true, true);
}

// Python to C++ copy conversion.
static void QCborStringResultByteArray_PythonToCpp_QCborStringResultByteArray_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QCborStringResultByteArray *>(cppOut) = *reinterpret_cast< ::QCborStringResultByteArray *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCborStringResultByteArray_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QCborStringResultByteArray_PythonToCpp_QCborStringResultByteArray_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QCborStringResultByteArray_TypeF()))
        return QCborStringResultByteArray_PythonToCpp_QCborStringResultByteArray_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QCborStringResultByteArray_SignatureStrings[] = {
    "1:PySide6.QtCore.QCborStringResultByteArray(self)",
    "0:PySide6.QtCore.QCborStringResultByteArray(self,QCborStringResultByteArray:PySide6.QtCore.QCborStringResultByteArray)",
    "PySide6.QtCore.QCborStringResultByteArray.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QCborStringResultByteArray(PyObject *module)
{
    _Sbk_QCborStringResultByteArray_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QCborStringResultByteArray",
        "QCborStringResultByteArray",
        &Sbk_QCborStringResultByteArray_spec,
        &Shiboken::callCppDestructor< ::QCborStringResultByteArray >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QCborStringResultByteArray_TypeF(); // references _Sbk_QCborStringResultByteArray_Type
    InitSignatureStrings(pyType, QCborStringResultByteArray_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QCborStringResultByteArray_PropertyStrings);
    SbkPySide6_QtCoreTypeStructs[SBK_QCborStringResultByteArray_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QCborStringResultByteArray_PythonToCpp_QCborStringResultByteArray_PTR,
        is_QCborStringResultByteArray_PythonToCpp_QCborStringResultByteArray_PTR_Convertible,
        QCborStringResultByteArray_PTR_CppToPython_QCborStringResultByteArray,
        QCborStringResultByteArray_COPY_CppToPython_QCborStringResultByteArray);

    Shiboken::Conversions::registerConverterName(converter, "QCborStringResultByteArray");
    Shiboken::Conversions::registerConverterName(converter, "QCborStringResultByteArray*");
    Shiboken::Conversions::registerConverterName(converter, "QCborStringResultByteArray&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QCborStringResultByteArray).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QCborStringResultByteArray_PythonToCpp_QCborStringResultByteArray_COPY,
        is_QCborStringResultByteArray_PythonToCpp_QCborStringResultByteArray_COPY_Convertible);

    qRegisterMetaType< ::QCborStringResultByteArray >("QCborStringResultByteArray");

    return pyType;
}
