// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtcore_python.h"

// main header
#include "qsemaphorereleaser_wrapper.h"

// Argument includes
#include <qsemaphore.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QSemaphoreReleaser_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QSemaphoreReleaser >()))
        return -1;

    ::QSemaphoreReleaser *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtCore.QSemaphoreReleaser.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 0, 2));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|OO:QSemaphoreReleaser", &(pyArgs[0]), &(pyArgs[1])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QSemaphoreReleaser::QSemaphoreReleaser()
    // 1: QSemaphoreReleaser::QSemaphoreReleaser(QSemaphore&,int=)
    // 2: QSemaphoreReleaser::QSemaphoreReleaser(QSemaphore*,int=)
    if (numArgs == 0) {
        overloadId = 0; // QSemaphoreReleaser()
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSemaphore_IDX]), (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 1; // QSemaphoreReleaser(QSemaphore&,int)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1])))) {
            overloadId = 1; // QSemaphoreReleaser(QSemaphore&,int)
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QSemaphoreReleaser()
        {
            if (kwds != nullptr && PyDict_Size(kwds) > 0) {
                errInfo.reset(kwds);
                Py_INCREF(errInfo.object());
                return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
            }

            if (Shiboken::Errors::occurred() == nullptr) {
                // QSemaphoreReleaser()
                cptr = new ::QSemaphoreReleaser();
            }
            break;
        }
        case 1: // QSemaphoreReleaser(QSemaphore & sem, int n)
        {
            if (kwds && PyDict_Size(kwds) > 0) {
                PyObject *value{};
                Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
                static PyObject *const key_n = Shiboken::String::createStaticString("n");
                if (PyDict_Contains(kwds, key_n) != 0) {
                    value = PyDict_GetItem(kwds, key_n);
                    if (value != nullptr && pyArgs[1] != nullptr ) {
                        errInfo.reset(key_n);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    if (value != nullptr) {
                        pyArgs[1] = value;
                        if (!(pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1]))))
                            return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    PyDict_DelItem(kwds_dup, key_n);
                }
                if (PyDict_Size(kwds_dup) > 0) {
                    errInfo.reset(kwds_dup.release());
                    return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                }
            }
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QSemaphore *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            int cppArg1 = 1;
            if (pythonToCpp[1])
                pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QSemaphoreReleaser(QSemaphore&,int)
                cptr = new ::QSemaphoreReleaser(*cppArg0, cppArg1);
            }
            break;
        }
        case 2: // QSemaphoreReleaser(QSemaphore * sem, int n)
        {
            if (kwds && PyDict_Size(kwds) > 0) {
                PyObject *value{};
                Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
                static PyObject *const key_n = Shiboken::String::createStaticString("n");
                if (PyDict_Contains(kwds, key_n) != 0) {
                    value = PyDict_GetItem(kwds, key_n);
                    if (value != nullptr && pyArgs[1] != nullptr ) {
                        errInfo.reset(key_n);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    if (value != nullptr) {
                        pyArgs[1] = value;
                        if (!(pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1]))))
                            return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    PyDict_DelItem(kwds_dup, key_n);
                }
                if (PyDict_Size(kwds_dup) > 0) {
                    errInfo.reset(kwds_dup.release());
                    return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                }
            }
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QSemaphore *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            int cppArg1 = 1;
            if (pythonToCpp[1])
                pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QSemaphoreReleaser(QSemaphore*,int)
                cptr = new ::QSemaphoreReleaser(cppArg0, cppArg1);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QSemaphoreReleaser >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QSemaphoreReleaserFunc_cancel(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSemaphoreReleaser *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSemaphoreReleaser_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtCore.QSemaphoreReleaser.cancel";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // cancel()
            QSemaphore * cppResult = cppSelf->cancel();
            pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSemaphore_IDX]), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSemaphoreReleaserFunc_semaphore(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSemaphoreReleaser *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSemaphoreReleaser_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtCore.QSemaphoreReleaser.semaphore";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // semaphore()const
            QSemaphore * cppResult = const_cast<const ::QSemaphoreReleaser *>(cppSelf)->semaphore();
            pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSemaphore_IDX]), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSemaphoreReleaserFunc_swap(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSemaphoreReleaser *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSemaphoreReleaser_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtCore.QSemaphoreReleaser.swap";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QSemaphoreReleaser::swap(QSemaphoreReleaser&)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSemaphoreReleaser_IDX]), (pyArg)))) {
        overloadId = 0; // swap(QSemaphoreReleaser&)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QSemaphoreReleaser *cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // swap(QSemaphoreReleaser&)
            cppSelf->swap(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}


static const char *Sbk_QSemaphoreReleaser_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QSemaphoreReleaser_methods[] = {
    {"cancel", reinterpret_cast<PyCFunction>(Sbk_QSemaphoreReleaserFunc_cancel), METH_NOARGS, nullptr},
    {"semaphore", reinterpret_cast<PyCFunction>(Sbk_QSemaphoreReleaserFunc_semaphore), METH_NOARGS, nullptr},
    {"swap", reinterpret_cast<PyCFunction>(Sbk_QSemaphoreReleaserFunc_swap), METH_O, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QSemaphoreReleaser_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QSemaphoreReleaser_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QSemaphoreReleaser_Type = nullptr;
static PyTypeObject *Sbk_QSemaphoreReleaser_TypeF(void)
{
    return _Sbk_QSemaphoreReleaser_Type;
}

static PyType_Slot Sbk_QSemaphoreReleaser_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QSemaphoreReleaser_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QSemaphoreReleaser_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QSemaphoreReleaser_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QSemaphoreReleaser_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QSemaphoreReleaser_spec = {
    "2:PySide6.QtCore.QSemaphoreReleaser",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QSemaphoreReleaser_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QSemaphoreReleaser_PythonToCpp_QSemaphoreReleaser_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QSemaphoreReleaser_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QSemaphoreReleaser_PythonToCpp_QSemaphoreReleaser_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QSemaphoreReleaser_TypeF()))
        return QSemaphoreReleaser_PythonToCpp_QSemaphoreReleaser_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QSemaphoreReleaser_PTR_CppToPython_QSemaphoreReleaser(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QSemaphoreReleaser *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QSemaphoreReleaser_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QSemaphoreReleaser_SignatureStrings[] = {
    "2:PySide6.QtCore.QSemaphoreReleaser(self)",
    "1:PySide6.QtCore.QSemaphoreReleaser(self,sem:PySide6.QtCore.QSemaphore,n:int=1)",
    "0:PySide6.QtCore.QSemaphoreReleaser(self,sem:PySide6.QtCore.QSemaphore,n:int=1)",
    "PySide6.QtCore.QSemaphoreReleaser.cancel(self)->PySide6.QtCore.QSemaphore",
    "PySide6.QtCore.QSemaphoreReleaser.semaphore(self)->PySide6.QtCore.QSemaphore",
    "PySide6.QtCore.QSemaphoreReleaser.swap(self,other:PySide6.QtCore.QSemaphoreReleaser)",
    nullptr}; // Sentinel

PyTypeObject *init_QSemaphoreReleaser(PyObject *module)
{
    _Sbk_QSemaphoreReleaser_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QSemaphoreReleaser",
        "QSemaphoreReleaser*",
        &Sbk_QSemaphoreReleaser_spec,
        &Shiboken::callCppDestructor< ::QSemaphoreReleaser >,
        nullptr,
        0,
        0);
    auto *pyType = Sbk_QSemaphoreReleaser_TypeF(); // references _Sbk_QSemaphoreReleaser_Type
    InitSignatureStrings(pyType, QSemaphoreReleaser_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QSemaphoreReleaser_PropertyStrings);
    SbkPySide6_QtCoreTypeStructs[SBK_QSemaphoreReleaser_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QSemaphoreReleaser_PythonToCpp_QSemaphoreReleaser_PTR,
        is_QSemaphoreReleaser_PythonToCpp_QSemaphoreReleaser_PTR_Convertible,
        QSemaphoreReleaser_PTR_CppToPython_QSemaphoreReleaser);

    Shiboken::Conversions::registerConverterName(converter, "QSemaphoreReleaser");
    Shiboken::Conversions::registerConverterName(converter, "QSemaphoreReleaser*");
    Shiboken::Conversions::registerConverterName(converter, "QSemaphoreReleaser&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QSemaphoreReleaser).name());

    qRegisterMetaType< ::QSemaphoreReleaser *>();

    return pyType;
}
