// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSettingsWrapper_H
#define SBK_QSettingsWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <qsettings.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QSettingsWrapper : public QSettings
{
public:
    QSettingsWrapper(const QSettingsWrapper &) = delete;
    QSettingsWrapper& operator=(const QSettingsWrapper &) = delete;
    QSettingsWrapper(QSettingsWrapper &&) = delete;
    QSettingsWrapper& operator=(QSettingsWrapper &&) = delete;

    QSettingsWrapper(::QObject * parent = nullptr);
    QSettingsWrapper(::QSettings::Format format, ::QSettings::Scope scope, const ::QString & organization, const ::QString & application = QString(), ::QObject * parent = nullptr);
    QSettingsWrapper(::QSettings::Scope scope, ::QObject * parent = nullptr);
    QSettingsWrapper(::QSettings::Scope scope, const ::QString & organization, const ::QString & application = QString(), ::QObject * parent = nullptr);
    QSettingsWrapper(const ::QString & fileName, ::QSettings::Format format, ::QObject * parent = nullptr);
    QSettingsWrapper(const ::QString & organization, const ::QString & application = QString(), ::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QSettingsWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7];
};

#endif // SBK_QSettingsWrapper_H

