// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtcore_python.h"

// main header
#include "qtcorehelper_qgenericreturnargumentholder_wrapper.h"

// Argument includes
#include <qmetatype.h>
#include <qobjectdefs.h>
#include <qtcorehelper.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>

using namespace QtCoreHelper;


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QtCoreHelper_QGenericReturnArgumentHolder_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QtCoreHelper::QGenericReturnArgumentHolder >()))
        return -1;

    ::QtCoreHelper::QGenericReturnArgumentHolder *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtCore.QGenericReturnArgumentHolder.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QGenericReturnArgumentHolder", 1, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QGenericReturnArgumentHolder::QGenericReturnArgumentHolder(QMetaType,void*)
    // 1: QGenericReturnArgumentHolder::QGenericReturnArgumentHolder(QtCoreHelper::QGenericReturnArgumentHolder)
    if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QtCoreHelper_QGenericReturnArgumentHolder_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QGenericReturnArgumentHolder(QtCoreHelper::QGenericReturnArgumentHolder)
    } else if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QMetaType_IDX]), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<void *>(), (pyArgs[1])))) {
        overloadId = 0; // QGenericReturnArgumentHolder(QMetaType,void*)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QGenericReturnArgumentHolder(const QMetaType & type, void * aData)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QMetaType cppArg0_local;
            ::QMetaType *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);

            void* cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QGenericReturnArgumentHolder(QMetaType,void*)
                cptr = new ::QtCoreHelper::QGenericReturnArgumentHolder(*cppArg0, cppArg1);
            }
            break;
        }
        case 1: // QGenericReturnArgumentHolder(const QtCoreHelper::QGenericReturnArgumentHolder & arg__1)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QtCoreHelper::QGenericReturnArgumentHolder cppArg0_local = ::QtCoreHelper::QGenericReturnArgumentHolder(::QMetaType(), static_cast<void*>(nullptr));
            ::QtCoreHelper::QGenericReturnArgumentHolder *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QGenericReturnArgumentHolder(QtCoreHelper::QGenericReturnArgumentHolder)
                cptr = new ::QtCoreHelper::QGenericReturnArgumentHolder(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QtCoreHelper::QGenericReturnArgumentHolder >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QtCoreHelper_QGenericReturnArgumentHolderFunc_data(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QtCoreHelper::QGenericReturnArgumentHolder *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QtCoreHelper_QGenericReturnArgumentHolder_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtCore.QGenericReturnArgumentHolder.data";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // data()const
            const void * cppResult = const_cast<const ::QtCoreHelper::QGenericReturnArgumentHolder *>(cppSelf)->data();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<void *>(), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QtCoreHelper_QGenericReturnArgumentHolderFunc_metaType(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QtCoreHelper::QGenericReturnArgumentHolder *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QtCoreHelper_QGenericReturnArgumentHolder_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtCore.QGenericReturnArgumentHolder.metaType";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // metaType()const
            QMetaType cppResult = const_cast<const ::QtCoreHelper::QGenericReturnArgumentHolder *>(cppSelf)->metaType();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QMetaType_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QtCoreHelper_QGenericReturnArgumentHolderFunc_toGenericReturnArgument(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QtCoreHelper::QGenericReturnArgumentHolder *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QtCoreHelper_QGenericReturnArgumentHolder_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtCore.QGenericReturnArgumentHolder.toGenericReturnArgument";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // toGenericReturnArgument()const
            QGenericReturnArgument cppResult = const_cast<const ::QtCoreHelper::QGenericReturnArgumentHolder *>(cppSelf)->toGenericReturnArgument();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QGenericReturnArgument_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QtCoreHelper_QGenericReturnArgumentHolder__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QtCoreHelper::QGenericReturnArgumentHolder *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QtCoreHelper_QGenericReturnArgumentHolder_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QtCoreHelper_QGenericReturnArgumentHolder_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QtCoreHelper_QGenericReturnArgumentHolder_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QtCoreHelper_QGenericReturnArgumentHolder_methods[] = {
    {"data", reinterpret_cast<PyCFunction>(Sbk_QtCoreHelper_QGenericReturnArgumentHolderFunc_data), METH_NOARGS, nullptr},
    {"metaType", reinterpret_cast<PyCFunction>(Sbk_QtCoreHelper_QGenericReturnArgumentHolderFunc_metaType), METH_NOARGS, nullptr},
    {"toGenericReturnArgument", reinterpret_cast<PyCFunction>(Sbk_QtCoreHelper_QGenericReturnArgumentHolderFunc_toGenericReturnArgument), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QtCoreHelper_QGenericReturnArgumentHolder__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QtCoreHelper_QGenericReturnArgumentHolder_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QtCoreHelper_QGenericReturnArgumentHolder_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QtCoreHelper_QGenericReturnArgumentHolder_Type = nullptr;
static PyTypeObject *Sbk_QtCoreHelper_QGenericReturnArgumentHolder_TypeF(void)
{
    return _Sbk_QtCoreHelper_QGenericReturnArgumentHolder_Type;
}

static PyType_Slot Sbk_QtCoreHelper_QGenericReturnArgumentHolder_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QtCoreHelper_QGenericReturnArgumentHolder_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QtCoreHelper_QGenericReturnArgumentHolder_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QtCoreHelper_QGenericReturnArgumentHolder_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QtCoreHelper_QGenericReturnArgumentHolder_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QtCoreHelper_QGenericReturnArgumentHolder_spec = {
    "2:PySide6.QtCore.QGenericReturnArgumentHolder",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QtCoreHelper_QGenericReturnArgumentHolder_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QGenericReturnArgumentHolder_PythonToCpp_QGenericReturnArgumentHolder_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QtCoreHelper_QGenericReturnArgumentHolder_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QGenericReturnArgumentHolder_PythonToCpp_QGenericReturnArgumentHolder_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QtCoreHelper_QGenericReturnArgumentHolder_TypeF()))
        return QGenericReturnArgumentHolder_PythonToCpp_QGenericReturnArgumentHolder_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QGenericReturnArgumentHolder_PTR_CppToPython_QGenericReturnArgumentHolder(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QtCoreHelper::QGenericReturnArgumentHolder *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QtCoreHelper_QGenericReturnArgumentHolder_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *QGenericReturnArgumentHolder_COPY_CppToPython_QGenericReturnArgumentHolder(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QtCoreHelper::QGenericReturnArgumentHolder *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QtCoreHelper_QGenericReturnArgumentHolder_TypeF(), new ::QtCoreHelper::QGenericReturnArgumentHolder(*source), true, true);
}

// Python to C++ copy conversion.
static void QGenericReturnArgumentHolder_PythonToCpp_QGenericReturnArgumentHolder_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QtCoreHelper::QGenericReturnArgumentHolder *>(cppOut) = *reinterpret_cast< ::QtCoreHelper::QGenericReturnArgumentHolder *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QtCoreHelper_QGenericReturnArgumentHolder_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QGenericReturnArgumentHolder_PythonToCpp_QGenericReturnArgumentHolder_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QtCoreHelper_QGenericReturnArgumentHolder_TypeF()))
        return QGenericReturnArgumentHolder_PythonToCpp_QGenericReturnArgumentHolder_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QtCoreHelper_QGenericReturnArgumentHolder_SignatureStrings[] = {
    "1:PySide6.QtCore.QGenericReturnArgumentHolder(self,type:typing.Union[PySide6.QtCore.QMetaType, PySide6.QtCore.QMetaType.Type],aData:void)",
    "0:PySide6.QtCore.QGenericReturnArgumentHolder(self,arg__1:PySide6.QtCore.QGenericReturnArgumentHolder)",
    "PySide6.QtCore.QGenericReturnArgumentHolder.data(self)->void",
    "PySide6.QtCore.QGenericReturnArgumentHolder.metaType(self)->PySide6.QtCore.QMetaType",
    "PySide6.QtCore.QGenericReturnArgumentHolder.toGenericReturnArgument(self)->PySide6.QtCore.QGenericReturnArgument",
    "PySide6.QtCore.QGenericReturnArgumentHolder.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QtCoreHelper_QGenericReturnArgumentHolder(PyObject *module)
{
    _Sbk_QtCoreHelper_QGenericReturnArgumentHolder_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QGenericReturnArgumentHolder",
        "QtCoreHelper::QGenericReturnArgumentHolder",
        &Sbk_QtCoreHelper_QGenericReturnArgumentHolder_spec,
        &Shiboken::callCppDestructor< ::QtCoreHelper::QGenericReturnArgumentHolder >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QtCoreHelper_QGenericReturnArgumentHolder_TypeF(); // references _Sbk_QtCoreHelper_QGenericReturnArgumentHolder_Type
    InitSignatureStrings(pyType, QtCoreHelper_QGenericReturnArgumentHolder_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QtCoreHelper_QGenericReturnArgumentHolder_PropertyStrings);
    SbkPySide6_QtCoreTypeStructs[SBK_QtCoreHelper_QGenericReturnArgumentHolder_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QGenericReturnArgumentHolder_PythonToCpp_QGenericReturnArgumentHolder_PTR,
        is_QGenericReturnArgumentHolder_PythonToCpp_QGenericReturnArgumentHolder_PTR_Convertible,
        QGenericReturnArgumentHolder_PTR_CppToPython_QGenericReturnArgumentHolder,
        QGenericReturnArgumentHolder_COPY_CppToPython_QGenericReturnArgumentHolder);

    Shiboken::Conversions::registerConverterName(converter, "QtCoreHelper::QGenericReturnArgumentHolder");
    Shiboken::Conversions::registerConverterName(converter, "QtCoreHelper::QGenericReturnArgumentHolder*");
    Shiboken::Conversions::registerConverterName(converter, "QtCoreHelper::QGenericReturnArgumentHolder&");
    Shiboken::Conversions::registerConverterName(converter, "QGenericReturnArgumentHolder");
    Shiboken::Conversions::registerConverterName(converter, "QGenericReturnArgumentHolder*");
    Shiboken::Conversions::registerConverterName(converter, "QGenericReturnArgumentHolder&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QtCoreHelper::QGenericReturnArgumentHolder).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QGenericReturnArgumentHolder_PythonToCpp_QGenericReturnArgumentHolder_COPY,
        is_QGenericReturnArgumentHolder_PythonToCpp_QGenericReturnArgumentHolder_COPY_Convertible);


    return pyType;
}
