// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QTimerEventWrapper_H
#define SBK_QTimerEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <qcoreevent.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QTimerEventWrapper : public QTimerEvent
{
public:
    QTimerEventWrapper(const QTimerEventWrapper &) = delete;
    QTimerEventWrapper& operator=(const QTimerEventWrapper &) = delete;
    QTimerEventWrapper(QTimerEventWrapper &&) = delete;
    QTimerEventWrapper& operator=(QTimerEventWrapper &&) = delete;

    QTimerEventWrapper(const QTimerEvent& self) : QTimerEvent(self)
    {
    }

    QTimerEventWrapper(int timerId);
    ::QTimerEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QTimerEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QTimerEventWrapper_H

