// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtcore_python.h"

// main header
#include "qtimezone_offsetdata_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QTimeZone_OffsetData_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QTimeZone::OffsetData >()))
        return -1;

    ::QTimeZone::OffsetData *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtCore.QTimeZone.OffsetData.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "OffsetData", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: OffsetData::OffsetData()
    // 1: OffsetData::OffsetData(QTimeZone::OffsetData)
    if (numArgs == 0) {
        overloadId = 0; // OffsetData()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QTimeZone_OffsetData_IDX]), (pyArgs[0])))) {
        overloadId = 1; // OffsetData(QTimeZone::OffsetData)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // OffsetData()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // OffsetData()
                cptr = new ::QTimeZone::OffsetData();
            }
            break;
        }
        case 1: // OffsetData(const QTimeZone::OffsetData & OffsetData)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QTimeZone::OffsetData cppArg0_local;
            ::QTimeZone::OffsetData *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // OffsetData(QTimeZone::OffsetData)
                cptr = new ::QTimeZone::OffsetData(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QTimeZone::OffsetData >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QTimeZone_OffsetData__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QTimeZone::OffsetData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QTimeZone_OffsetData_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QTimeZone_OffsetData_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QTimeZone_OffsetData_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QTimeZone_OffsetData_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QTimeZone_OffsetData__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QTimeZone_OffsetData_get_abbreviation(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QTimeZone::OffsetData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QTimeZone_OffsetData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppSelf->abbreviation);
    return pyOut;
}
static int Sbk_QTimeZone_OffsetData_set_abbreviation(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QTimeZone::OffsetData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QTimeZone_OffsetData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("abbreviation");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("abbreviation", "QString");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->abbreviation;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QTimeZone_OffsetData_get_atUtc(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QTimeZone::OffsetData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QTimeZone_OffsetData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->atUtc)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QDateTime_IDX])));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->atUtc))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->atUtc)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QDateTime_IDX]), &(cppSelf->atUtc), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_QTimeZone_OffsetData_set_atUtc(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QTimeZone::OffsetData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QTimeZone_OffsetData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("atUtc");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QDateTime_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("atUtc", "QDateTime");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->atUtc;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QTimeZone_OffsetData_get_offsetFromUtc(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QTimeZone::OffsetData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QTimeZone_OffsetData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->offsetFromUtc;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QTimeZone_OffsetData_set_offsetFromUtc(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QTimeZone::OffsetData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QTimeZone_OffsetData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("offsetFromUtc");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("offsetFromUtc", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->offsetFromUtc;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->offsetFromUtc = cppOut_local;

    return 0;
}

static PyObject *Sbk_QTimeZone_OffsetData_get_standardTimeOffset(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QTimeZone::OffsetData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QTimeZone_OffsetData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->standardTimeOffset;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QTimeZone_OffsetData_set_standardTimeOffset(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QTimeZone::OffsetData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QTimeZone_OffsetData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("standardTimeOffset");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("standardTimeOffset", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->standardTimeOffset;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->standardTimeOffset = cppOut_local;

    return 0;
}

static PyObject *Sbk_QTimeZone_OffsetData_get_daylightTimeOffset(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QTimeZone::OffsetData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QTimeZone_OffsetData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->daylightTimeOffset;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QTimeZone_OffsetData_set_daylightTimeOffset(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QTimeZone::OffsetData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QTimeZone_OffsetData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("daylightTimeOffset");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("daylightTimeOffset", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->daylightTimeOffset;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->daylightTimeOffset = cppOut_local;

    return 0;
}

// Getters and Setters for OffsetData
static PyGetSetDef Sbk_QTimeZone_OffsetData_getsetlist[] = {
    {const_cast<char *>("abbreviation"), Sbk_QTimeZone_OffsetData_get_abbreviation, Sbk_QTimeZone_OffsetData_set_abbreviation, nullptr, nullptr},
    {const_cast<char *>("atUtc"), Sbk_QTimeZone_OffsetData_get_atUtc, Sbk_QTimeZone_OffsetData_set_atUtc, nullptr, nullptr},
    {const_cast<char *>("offsetFromUtc"), Sbk_QTimeZone_OffsetData_get_offsetFromUtc, Sbk_QTimeZone_OffsetData_set_offsetFromUtc, nullptr, nullptr},
    {const_cast<char *>("standardTimeOffset"), Sbk_QTimeZone_OffsetData_get_standardTimeOffset, Sbk_QTimeZone_OffsetData_set_standardTimeOffset, nullptr, nullptr},
    {const_cast<char *>("daylightTimeOffset"), Sbk_QTimeZone_OffsetData_get_daylightTimeOffset, Sbk_QTimeZone_OffsetData_set_daylightTimeOffset, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QTimeZone_OffsetData_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QTimeZone_OffsetData_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QTimeZone_OffsetData_Type = nullptr;
static PyTypeObject *Sbk_QTimeZone_OffsetData_TypeF(void)
{
    return _Sbk_QTimeZone_OffsetData_Type;
}

static PyType_Slot Sbk_QTimeZone_OffsetData_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QTimeZone_OffsetData_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QTimeZone_OffsetData_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QTimeZone_OffsetData_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QTimeZone_OffsetData_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QTimeZone_OffsetData_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QTimeZone_OffsetData_spec = {
    "2:PySide6.QtCore.QTimeZone.OffsetData",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QTimeZone_OffsetData_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void OffsetData_PythonToCpp_OffsetData_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QTimeZone_OffsetData_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_OffsetData_PythonToCpp_OffsetData_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QTimeZone_OffsetData_TypeF()))
        return OffsetData_PythonToCpp_OffsetData_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *OffsetData_PTR_CppToPython_OffsetData(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QTimeZone::OffsetData *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QTimeZone_OffsetData_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *OffsetData_COPY_CppToPython_OffsetData(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QTimeZone::OffsetData *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QTimeZone_OffsetData_TypeF(), new ::QTimeZone::OffsetData(*source), true, true);
}

// Python to C++ copy conversion.
static void OffsetData_PythonToCpp_OffsetData_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QTimeZone::OffsetData *>(cppOut) = *reinterpret_cast< ::QTimeZone::OffsetData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QTimeZone_OffsetData_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_OffsetData_PythonToCpp_OffsetData_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QTimeZone_OffsetData_TypeF()))
        return OffsetData_PythonToCpp_OffsetData_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QTimeZone_OffsetData_SignatureStrings[] = {
    "1:PySide6.QtCore.QTimeZone.OffsetData(self)",
    "0:PySide6.QtCore.QTimeZone.OffsetData(self,OffsetData:PySide6.QtCore.QTimeZone.OffsetData)",
    "PySide6.QtCore.QTimeZone.OffsetData.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QTimeZone_OffsetData(PyObject *enclosingClass)
{
    _Sbk_QTimeZone_OffsetData_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "OffsetData",
        "QTimeZone::OffsetData",
        &Sbk_QTimeZone_OffsetData_spec,
        &Shiboken::callCppDestructor< ::QTimeZone::OffsetData >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QTimeZone_OffsetData_TypeF(); // references _Sbk_QTimeZone_OffsetData_Type
    InitSignatureStrings(pyType, QTimeZone_OffsetData_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QTimeZone_OffsetData_PropertyStrings);
    SbkPySide6_QtCoreTypeStructs[SBK_QTimeZone_OffsetData_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        OffsetData_PythonToCpp_OffsetData_PTR,
        is_OffsetData_PythonToCpp_OffsetData_PTR_Convertible,
        OffsetData_PTR_CppToPython_OffsetData,
        OffsetData_COPY_CppToPython_OffsetData);

    Shiboken::Conversions::registerConverterName(converter, "QTimeZone::OffsetData");
    Shiboken::Conversions::registerConverterName(converter, "QTimeZone::OffsetData*");
    Shiboken::Conversions::registerConverterName(converter, "QTimeZone::OffsetData&");
    Shiboken::Conversions::registerConverterName(converter, "OffsetData");
    Shiboken::Conversions::registerConverterName(converter, "OffsetData*");
    Shiboken::Conversions::registerConverterName(converter, "OffsetData&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QTimeZone::OffsetData).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        OffsetData_PythonToCpp_OffsetData_COPY,
        is_OffsetData_PythonToCpp_OffsetData_COPY_Convertible);

    qRegisterMetaType< ::QTimeZone::OffsetData >("OffsetData");
    qRegisterMetaType< ::QTimeZone::OffsetData >("QTimeZone::OffsetData");

    return pyType;
}
