// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QVariantAnimationWrapper_H
#define SBK_QVariantAnimationWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <qvariantanimation.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QVariantAnimationWrapper : public QVariantAnimation
{
public:
    QVariantAnimationWrapper(const QVariantAnimationWrapper &) = delete;
    QVariantAnimationWrapper& operator=(const QVariantAnimationWrapper &) = delete;
    QVariantAnimationWrapper(QVariantAnimationWrapper &&) = delete;
    QVariantAnimationWrapper& operator=(QVariantAnimationWrapper &&) = delete;

    QVariantAnimationWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    int duration() const override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QVariant interpolated(const ::QVariant & from, const ::QVariant & to, qreal progress) const override;
    void timerEvent(::QTimerEvent * event) override;
    void updateCurrentTime(int arg__1) override;
    void updateCurrentValue(const ::QVariant & value) override;
    void updateDirection(::QAbstractAnimation::Direction direction) override;
    void updateState(::QAbstractAnimation::State newState, ::QAbstractAnimation::State oldState) override;
    ~QVariantAnimationWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[13];
};

#endif // SBK_QVariantAnimationWrapper_H

