// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QXmlStreamEntityResolverWrapper_H
#define SBK_QXmlStreamEntityResolverWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <qxmlstream.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QXmlStreamEntityResolverWrapper : public QXmlStreamEntityResolver
{
public:
    QXmlStreamEntityResolverWrapper(const QXmlStreamEntityResolverWrapper &) = delete;
    QXmlStreamEntityResolverWrapper& operator=(const QXmlStreamEntityResolverWrapper &) = delete;
    QXmlStreamEntityResolverWrapper(QXmlStreamEntityResolverWrapper &&) = delete;
    QXmlStreamEntityResolverWrapper& operator=(QXmlStreamEntityResolverWrapper &&) = delete;

    QXmlStreamEntityResolverWrapper();
    ::QString resolveEntity(const ::QString & publicId, const ::QString & systemId) override;
    ::QString resolveUndeclaredEntity(const ::QString & name) override;
    ~QXmlStreamEntityResolverWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QXmlStreamEntityResolverWrapper_H

