// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtcore_python.h"

// main header
#include "qxmlstreamnamespacedeclaration_wrapper.h"

// Argument includes
#include <QString>
#include <QStringView>
#include <qxmlstream.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QXmlStreamNamespaceDeclaration_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QXmlStreamNamespaceDeclaration >()))
        return -1;

    ::QXmlStreamNamespaceDeclaration *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtCore.QXmlStreamNamespaceDeclaration.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QXmlStreamNamespaceDeclaration", 0, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QXmlStreamNamespaceDeclaration::QXmlStreamNamespaceDeclaration()
    // 1: QXmlStreamNamespaceDeclaration::QXmlStreamNamespaceDeclaration(QString,QString)
    // 2: QXmlStreamNamespaceDeclaration::QXmlStreamNamespaceDeclaration(QXmlStreamNamespaceDeclaration)
    if (numArgs == 0) {
        overloadId = 0; // QXmlStreamNamespaceDeclaration()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamNamespaceDeclaration_IDX]), (pyArgs[0])))) {
        overloadId = 2; // QXmlStreamNamespaceDeclaration(QXmlStreamNamespaceDeclaration)
    } else if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[1])))) {
        overloadId = 1; // QXmlStreamNamespaceDeclaration(QString,QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QXmlStreamNamespaceDeclaration()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QXmlStreamNamespaceDeclaration()
                cptr = new ::QXmlStreamNamespaceDeclaration();
            }
            break;
        }
        case 1: // QXmlStreamNamespaceDeclaration(const QString & prefix, const QString & namespaceUri)
        {
            ::QString cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            ::QString cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QXmlStreamNamespaceDeclaration(QString,QString)
                cptr = new ::QXmlStreamNamespaceDeclaration(cppArg0, cppArg1);
            }
            break;
        }
        case 2: // QXmlStreamNamespaceDeclaration(const QXmlStreamNamespaceDeclaration & QXmlStreamNamespaceDeclaration)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QXmlStreamNamespaceDeclaration cppArg0_local;
            ::QXmlStreamNamespaceDeclaration *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QXmlStreamNamespaceDeclaration(QXmlStreamNamespaceDeclaration)
                cptr = new ::QXmlStreamNamespaceDeclaration(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QXmlStreamNamespaceDeclaration >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QXmlStreamNamespaceDeclarationFunc_namespaceUri(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QXmlStreamNamespaceDeclaration *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamNamespaceDeclaration_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtCore.QXmlStreamNamespaceDeclaration.namespaceUri";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // namespaceUri()const
            QStringView cppResult = const_cast<const ::QXmlStreamNamespaceDeclaration *>(cppSelf)->namespaceUri();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QStringView_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QXmlStreamNamespaceDeclarationFunc_prefix(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QXmlStreamNamespaceDeclaration *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamNamespaceDeclaration_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtCore.QXmlStreamNamespaceDeclaration.prefix";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // prefix()const
            QStringView cppResult = const_cast<const ::QXmlStreamNamespaceDeclaration *>(cppSelf)->prefix();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QStringView_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QXmlStreamNamespaceDeclaration__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QXmlStreamNamespaceDeclaration *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamNamespaceDeclaration_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamNamespaceDeclaration_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QXmlStreamNamespaceDeclaration_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QXmlStreamNamespaceDeclaration_methods[] = {
    {"namespaceUri", reinterpret_cast<PyCFunction>(Sbk_QXmlStreamNamespaceDeclarationFunc_namespaceUri), METH_NOARGS, nullptr},
    {"prefix", reinterpret_cast<PyCFunction>(Sbk_QXmlStreamNamespaceDeclarationFunc_prefix), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QXmlStreamNamespaceDeclaration__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QXmlStreamNamespaceDeclaration_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QXmlStreamNamespaceDeclaration *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamNamespaceDeclaration_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamNamespaceDeclaration_IDX]), (pyArg)))) {
                // operator!=(const QXmlStreamNamespaceDeclaration & other) const
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QXmlStreamNamespaceDeclaration cppArg0_local;
                ::QXmlStreamNamespaceDeclaration *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamNamespaceDeclaration_IDX]), (pyArg)))) {
                // operator==(const QXmlStreamNamespaceDeclaration & other) const
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QXmlStreamNamespaceDeclaration cppArg0_local;
                ::QXmlStreamNamespaceDeclaration *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static int Sbk_QXmlStreamNamespaceDeclaration_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QXmlStreamNamespaceDeclaration_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QXmlStreamNamespaceDeclaration_Type = nullptr;
static PyTypeObject *Sbk_QXmlStreamNamespaceDeclaration_TypeF(void)
{
    return _Sbk_QXmlStreamNamespaceDeclaration_Type;
}

static PyType_Slot Sbk_QXmlStreamNamespaceDeclaration_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QXmlStreamNamespaceDeclaration_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QXmlStreamNamespaceDeclaration_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QXmlStreamNamespaceDeclaration_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QXmlStreamNamespaceDeclaration_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QXmlStreamNamespaceDeclaration_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QXmlStreamNamespaceDeclaration_spec = {
    "2:PySide6.QtCore.QXmlStreamNamespaceDeclaration",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QXmlStreamNamespaceDeclaration_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QXmlStreamNamespaceDeclaration_PythonToCpp_QXmlStreamNamespaceDeclaration_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QXmlStreamNamespaceDeclaration_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QXmlStreamNamespaceDeclaration_PythonToCpp_QXmlStreamNamespaceDeclaration_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QXmlStreamNamespaceDeclaration_TypeF()))
        return QXmlStreamNamespaceDeclaration_PythonToCpp_QXmlStreamNamespaceDeclaration_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QXmlStreamNamespaceDeclaration_PTR_CppToPython_QXmlStreamNamespaceDeclaration(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QXmlStreamNamespaceDeclaration *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QXmlStreamNamespaceDeclaration_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *QXmlStreamNamespaceDeclaration_COPY_CppToPython_QXmlStreamNamespaceDeclaration(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QXmlStreamNamespaceDeclaration *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QXmlStreamNamespaceDeclaration_TypeF(), new ::QXmlStreamNamespaceDeclaration(*source), true, true);
}

// Python to C++ copy conversion.
static void QXmlStreamNamespaceDeclaration_PythonToCpp_QXmlStreamNamespaceDeclaration_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QXmlStreamNamespaceDeclaration *>(cppOut) = *reinterpret_cast< ::QXmlStreamNamespaceDeclaration *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamNamespaceDeclaration_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QXmlStreamNamespaceDeclaration_PythonToCpp_QXmlStreamNamespaceDeclaration_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QXmlStreamNamespaceDeclaration_TypeF()))
        return QXmlStreamNamespaceDeclaration_PythonToCpp_QXmlStreamNamespaceDeclaration_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QXmlStreamNamespaceDeclaration_SignatureStrings[] = {
    "2:PySide6.QtCore.QXmlStreamNamespaceDeclaration(self)",
    "1:PySide6.QtCore.QXmlStreamNamespaceDeclaration(self,prefix:QString,namespaceUri:QString)",
    "0:PySide6.QtCore.QXmlStreamNamespaceDeclaration(self,QXmlStreamNamespaceDeclaration:PySide6.QtCore.QXmlStreamNamespaceDeclaration)",
    "PySide6.QtCore.QXmlStreamNamespaceDeclaration.namespaceUri(self)->QStringView",
    "PySide6.QtCore.QXmlStreamNamespaceDeclaration.prefix(self)->QStringView",
    "PySide6.QtCore.QXmlStreamNamespaceDeclaration.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QXmlStreamNamespaceDeclaration(PyObject *module)
{
    _Sbk_QXmlStreamNamespaceDeclaration_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QXmlStreamNamespaceDeclaration",
        "QXmlStreamNamespaceDeclaration",
        &Sbk_QXmlStreamNamespaceDeclaration_spec,
        &Shiboken::callCppDestructor< ::QXmlStreamNamespaceDeclaration >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QXmlStreamNamespaceDeclaration_TypeF(); // references _Sbk_QXmlStreamNamespaceDeclaration_Type
    InitSignatureStrings(pyType, QXmlStreamNamespaceDeclaration_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QXmlStreamNamespaceDeclaration_PropertyStrings);
    SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamNamespaceDeclaration_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QXmlStreamNamespaceDeclaration_PythonToCpp_QXmlStreamNamespaceDeclaration_PTR,
        is_QXmlStreamNamespaceDeclaration_PythonToCpp_QXmlStreamNamespaceDeclaration_PTR_Convertible,
        QXmlStreamNamespaceDeclaration_PTR_CppToPython_QXmlStreamNamespaceDeclaration,
        QXmlStreamNamespaceDeclaration_COPY_CppToPython_QXmlStreamNamespaceDeclaration);

    Shiboken::Conversions::registerConverterName(converter, "QXmlStreamNamespaceDeclaration");
    Shiboken::Conversions::registerConverterName(converter, "QXmlStreamNamespaceDeclaration*");
    Shiboken::Conversions::registerConverterName(converter, "QXmlStreamNamespaceDeclaration&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QXmlStreamNamespaceDeclaration).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QXmlStreamNamespaceDeclaration_PythonToCpp_QXmlStreamNamespaceDeclaration_COPY,
        is_QXmlStreamNamespaceDeclaration_PythonToCpp_QXmlStreamNamespaceDeclaration_COPY_Convertible);

    qRegisterMetaType< ::QXmlStreamNamespaceDeclaration >("QXmlStreamNamespaceDeclaration");

    return pyType;
}
