// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtdbus_python.h"

// main header
#include "qdbusobjectpath_wrapper.h"

// Argument includes
#include <QString>
#include <QtCore/qlatin1stringview.h>
#include <QtDBus/qdbusextratypes.h>
#include <qvariant.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QDBusObjectPath_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QDBusObjectPath >()))
        return -1;

    ::QDBusObjectPath *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtDBus.QDBusObjectPath.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QDBusObjectPath", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QDBusObjectPath::QDBusObjectPath()
    // 1: QDBusObjectPath::QDBusObjectPath(QLatin1String)
    // 2: QDBusObjectPath::QDBusObjectPath(QDBusObjectPath)
    // 3: QDBusObjectPath::QDBusObjectPath(QString)
    // 4: QDBusObjectPath::QDBusObjectPath(const char*)
    if (numArgs == 0) {
        overloadId = 0; // QDBusObjectPath()
    } else if (numArgs == 1
        && Shiboken::String::check(pyArgs[0]) && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<const char *>(), (pyArgs[0])))) {
        overloadId = 4; // QDBusObjectPath(const char*)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))) {
        overloadId = 3; // QDBusObjectPath(QString)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtDBusTypeStructs[SBK_QDBusObjectPath_IDX]), (pyArgs[0])))) {
        overloadId = 2; // QDBusObjectPath(QDBusObjectPath)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QLatin1String_IDX], (pyArgs[0])))) {
        overloadId = 1; // QDBusObjectPath(QLatin1String)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QDBusObjectPath()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QDBusObjectPath()
                cptr = new ::QDBusObjectPath();
            }
            break;
        }
        case 1: // QDBusObjectPath(QLatin1String path)
        {
            ::QLatin1String cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QDBusObjectPath(QLatin1String)
                cptr = new ::QDBusObjectPath(cppArg0);
            }
            break;
        }
        case 2: // QDBusObjectPath(const QDBusObjectPath & QDBusObjectPath)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QDBusObjectPath cppArg0_local;
            ::QDBusObjectPath *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QDBusObjectPath(QDBusObjectPath)
                cptr = new ::QDBusObjectPath(*cppArg0);
            }
            break;
        }
        case 3: // QDBusObjectPath(const QString & path)
        {
            ::QString cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QDBusObjectPath(QString)
                cptr = new ::QDBusObjectPath(cppArg0);
            }
            break;
        }
        case 4: // QDBusObjectPath(const char * path)
        {
            const char* cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QDBusObjectPath(const char*)
                cptr = new ::QDBusObjectPath(cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QDBusObjectPath >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QDBusObjectPathFunc_path(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDBusObjectPath *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDBusTypeStructs[SBK_QDBusObjectPath_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtDBus.QDBusObjectPath.path";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // path()const
            QString cppResult = const_cast<const ::QDBusObjectPath *>(cppSelf)->path();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDBusObjectPathFunc_setPath(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDBusObjectPath *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDBusTypeStructs[SBK_QDBusObjectPath_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtDBus.QDBusObjectPath.setPath";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QDBusObjectPath::setPath(QString)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArg)))) {
        overloadId = 0; // setPath(QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setPath(QString)
            cppSelf->setPath(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QDBusObjectPathFunc_swap(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDBusObjectPath *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDBusTypeStructs[SBK_QDBusObjectPath_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtDBus.QDBusObjectPath.swap";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QDBusObjectPath::swap(QDBusObjectPath&)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtDBusTypeStructs[SBK_QDBusObjectPath_IDX]), (pyArg)))) {
        overloadId = 0; // swap(QDBusObjectPath&)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QDBusObjectPath cppArg0_local;
        ::QDBusObjectPath *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // swap(QDBusObjectPath&)
            cppSelf->swap(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QDBusObjectPath__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QDBusObjectPath *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDBusTypeStructs[SBK_QDBusObjectPath_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtDBusTypeStructs[SBK_QDBusObjectPath_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QDBusObjectPath_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QDBusObjectPath_methods[] = {
    {"path", reinterpret_cast<PyCFunction>(Sbk_QDBusObjectPathFunc_path), METH_NOARGS, nullptr},
    {"setPath", reinterpret_cast<PyCFunction>(Sbk_QDBusObjectPathFunc_setPath), METH_O, nullptr},
    {"swap", reinterpret_cast<PyCFunction>(Sbk_QDBusObjectPathFunc_swap), METH_O, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QDBusObjectPath__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QDBusObjectPath_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QDBusObjectPath *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDBusTypeStructs[SBK_QDBusObjectPath_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtDBusTypeStructs[SBK_QDBusObjectPath_IDX]), (pyArg)))) {
                // operator!=(const QDBusObjectPath & rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QDBusObjectPath cppArg0_local;
                ::QDBusObjectPath *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_LT:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtDBusTypeStructs[SBK_QDBusObjectPath_IDX]), (pyArg)))) {
                // operator<(const QDBusObjectPath & rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QDBusObjectPath cppArg0_local;
                ::QDBusObjectPath *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf < (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                return Shiboken::returnFromRichCompare(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtDBusTypeStructs[SBK_QDBusObjectPath_IDX]), (pyArg)))) {
                // operator==(const QDBusObjectPath & rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QDBusObjectPath cppArg0_local;
                ::QDBusObjectPath *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static Py_hash_t Sbk_QDBusObjectPath_HashFunc(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDBusObjectPath *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDBusTypeStructs[SBK_QDBusObjectPath_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    return Py_hash_t(qHash(*cppSelf));
}

static int Sbk_QDBusObjectPath_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QDBusObjectPath_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QDBusObjectPath_Type = nullptr;
static PyTypeObject *Sbk_QDBusObjectPath_TypeF(void)
{
    return _Sbk_QDBusObjectPath_Type;
}

static PyType_Slot Sbk_QDBusObjectPath_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_hash,        reinterpret_cast<void *>(&Sbk_QDBusObjectPath_HashFunc)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QDBusObjectPath_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QDBusObjectPath_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QDBusObjectPath_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QDBusObjectPath_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QDBusObjectPath_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QDBusObjectPath_spec = {
    "2:PySide6.QtDBus.QDBusObjectPath",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QDBusObjectPath_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QDBusObjectPath_PythonToCpp_QDBusObjectPath_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QDBusObjectPath_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QDBusObjectPath_PythonToCpp_QDBusObjectPath_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QDBusObjectPath_TypeF()))
        return QDBusObjectPath_PythonToCpp_QDBusObjectPath_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QDBusObjectPath_PTR_CppToPython_QDBusObjectPath(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QDBusObjectPath *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QDBusObjectPath_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *QDBusObjectPath_COPY_CppToPython_QDBusObjectPath(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QDBusObjectPath *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QDBusObjectPath_TypeF(), new ::QDBusObjectPath(*source), true, true);
}

// Python to C++ copy conversion.
static void QDBusObjectPath_PythonToCpp_QDBusObjectPath_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QDBusObjectPath *>(cppOut) = *reinterpret_cast< ::QDBusObjectPath *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDBusTypeStructs[SBK_QDBusObjectPath_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QDBusObjectPath_PythonToCpp_QDBusObjectPath_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QDBusObjectPath_TypeF()))
        return QDBusObjectPath_PythonToCpp_QDBusObjectPath_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QDBusObjectPath_SignatureStrings[] = {
    "4:PySide6.QtDBus.QDBusObjectPath(self)",
    "3:PySide6.QtDBus.QDBusObjectPath(self,path:QLatin1String)",
    "2:PySide6.QtDBus.QDBusObjectPath(self,QDBusObjectPath:PySide6.QtDBus.QDBusObjectPath)",
    "1:PySide6.QtDBus.QDBusObjectPath(self,path:QString)",
    "0:PySide6.QtDBus.QDBusObjectPath(self,path:char*)",
    "PySide6.QtDBus.QDBusObjectPath.path(self)->QString",
    "PySide6.QtDBus.QDBusObjectPath.setPath(self,path:QString)",
    "PySide6.QtDBus.QDBusObjectPath.swap(self,other:PySide6.QtDBus.QDBusObjectPath)",
    "PySide6.QtDBus.QDBusObjectPath.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QDBusObjectPath(PyObject *module)
{
    _Sbk_QDBusObjectPath_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QDBusObjectPath",
        "QDBusObjectPath",
        &Sbk_QDBusObjectPath_spec,
        &Shiboken::callCppDestructor< ::QDBusObjectPath >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QDBusObjectPath_TypeF(); // references _Sbk_QDBusObjectPath_Type
    InitSignatureStrings(pyType, QDBusObjectPath_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QDBusObjectPath_PropertyStrings);
    SbkPySide6_QtDBusTypeStructs[SBK_QDBusObjectPath_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QDBusObjectPath_PythonToCpp_QDBusObjectPath_PTR,
        is_QDBusObjectPath_PythonToCpp_QDBusObjectPath_PTR_Convertible,
        QDBusObjectPath_PTR_CppToPython_QDBusObjectPath,
        QDBusObjectPath_COPY_CppToPython_QDBusObjectPath);

    Shiboken::Conversions::registerConverterName(converter, "QDBusObjectPath");
    Shiboken::Conversions::registerConverterName(converter, "QDBusObjectPath*");
    Shiboken::Conversions::registerConverterName(converter, "QDBusObjectPath&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QDBusObjectPath).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QDBusObjectPath_PythonToCpp_QDBusObjectPath_COPY,
        is_QDBusObjectPath_PythonToCpp_QDBusObjectPath_COPY_Convertible);

    qRegisterMetaType< ::QDBusObjectPath >("QDBusObjectPath");

    return pyType;
}
