// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QDBusVirtualObjectWrapper_H
#define SBK_QDBusVirtualObjectWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtDBus/qdbusvirtualobject.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QDBusVirtualObjectWrapper : public QDBusVirtualObject
{
public:
    QDBusVirtualObjectWrapper(const QDBusVirtualObjectWrapper &) = delete;
    QDBusVirtualObjectWrapper& operator=(const QDBusVirtualObjectWrapper &) = delete;
    QDBusVirtualObjectWrapper(QDBusVirtualObjectWrapper &&) = delete;
    QDBusVirtualObjectWrapper& operator=(QDBusVirtualObjectWrapper &&) = delete;

    QDBusVirtualObjectWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    bool handleMessage(const ::QDBusMessage & message, const ::QDBusConnection & connection) override;
    ::QString introspect(const ::QString & path) const override;
    void timerEvent(::QTimerEvent * event) override;
    ~QDBusVirtualObjectWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[9];
};

#endif // SBK_QDBusVirtualObjectWrapper_H

