// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAbstract3DInputHandlerWrapper_H
#define SBK_QAbstract3DInputHandlerWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtDataVisualization/qabstract3dinputhandler.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QAbstract3DInputHandlerWrapper : public QAbstract3DInputHandler
{
public:
    QAbstract3DInputHandlerWrapper(const QAbstract3DInputHandlerWrapper &) = delete;
    QAbstract3DInputHandlerWrapper& operator=(const QAbstract3DInputHandlerWrapper &) = delete;
    QAbstract3DInputHandlerWrapper(QAbstract3DInputHandlerWrapper &&) = delete;
    QAbstract3DInputHandlerWrapper& operator=(QAbstract3DInputHandlerWrapper &&) = delete;

    QAbstract3DInputHandlerWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void mouseDoubleClickEvent(::QMouseEvent * event) override;
    void mouseMoveEvent(::QMouseEvent * event, const ::QPoint & mousePos) override;
    void mousePressEvent(::QMouseEvent * event, const ::QPoint & mousePos) override;
    void mouseReleaseEvent(::QMouseEvent * event, const ::QPoint & mousePos) override;
    void timerEvent(::QTimerEvent * event) override;
    void touchEvent(::QTouchEvent * event) override;
    void wheelEvent(::QWheelEvent * event) override;
    ~QAbstract3DInputHandlerWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[13];
};

#endif // SBK_QAbstract3DInputHandlerWrapper_H

