// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QBar3DSeriesWrapper_H
#define SBK_QBar3DSeriesWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtDataVisualization/qbar3dseries.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QBar3DSeriesWrapper : public QBar3DSeries
{
public:
    QBar3DSeriesWrapper(const QBar3DSeriesWrapper &) = delete;
    QBar3DSeriesWrapper& operator=(const QBar3DSeriesWrapper &) = delete;
    QBar3DSeriesWrapper(QBar3DSeriesWrapper &&) = delete;
    QBar3DSeriesWrapper& operator=(QBar3DSeriesWrapper &&) = delete;

    QBar3DSeriesWrapper(::QBarDataProxy * dataProxy, ::QObject * parent = nullptr);
    QBar3DSeriesWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QBar3DSeriesWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7];
};

#endif // SBK_QBar3DSeriesWrapper_H

