// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QValue3DAxisFormatterWrapper_H
#define SBK_QValue3DAxisFormatterWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtDataVisualization/qvalue3daxisformatter.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QValue3DAxisFormatterWrapper : public QValue3DAxisFormatter
{
public:
    QValue3DAxisFormatterWrapper(const QValue3DAxisFormatterWrapper &) = delete;
    QValue3DAxisFormatterWrapper& operator=(const QValue3DAxisFormatterWrapper &) = delete;
    QValue3DAxisFormatterWrapper(QValue3DAxisFormatterWrapper &&) = delete;
    QValue3DAxisFormatterWrapper& operator=(QValue3DAxisFormatterWrapper &&) = delete;

    QValue3DAxisFormatterWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    ::QValue3DAxisFormatter * createNewInstance() const override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void populateCopy(::QValue3DAxisFormatter & copy) const override;
    float positionAt(float value) const override;
    void recalculate() override;
    ::QString stringForValue(qreal value, const ::QString & format) const override;
    void timerEvent(::QTimerEvent * event) override;
    float valueAt(float position) const override;
    ~QValue3DAxisFormatterWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[13];
};

#endif // SBK_QValue3DAxisFormatterWrapper_H

