// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtdesigner_python.h"

// main header
#include "qdesignerdnditeminterface_wrapper.h"

// Argument includes
#include <QtDesigner/abstractdnditem.h>
#include <QtWidgets/qwidget.h>
#include <qpoint.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QDesignerDnDItemInterface_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(args)
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PyTypeObject *type = self->ob_type;
    PyTypeObject *myType = Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerDnDItemInterface_IDX]);
    SBK_UNUSED(sbkSelf)
    SBK_UNUSED(type)
    SBK_UNUSED(myType)
    Shiboken::Errors::setInstantiateAbstractClassDisabledWrapper("QDesignerDnDItemInterface");
    return -1;
}

static PyObject *Sbk_QDesignerDnDItemInterfaceFunc_decoration(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDesignerDnDItemInterface *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerDnDItemInterface_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtDesigner.QDesignerDnDItemInterface.decoration";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // decoration()const
            if (Shiboken::Object::hasCppWrapper(reinterpret_cast<SbkObject *>(self))) {
                Shiboken::Errors::setPureVirtualMethodError("QDesignerDnDItemInterface.decoration");
                return {};
            }
            QWidget * cppResult = const_cast<const ::QDesignerDnDItemInterface *>(cppSelf)->decoration();
            pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QWidget_IDX]), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDesignerDnDItemInterfaceFunc_hotSpot(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDesignerDnDItemInterface *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerDnDItemInterface_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtDesigner.QDesignerDnDItemInterface.hotSpot";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // hotSpot()const
            if (Shiboken::Object::hasCppWrapper(reinterpret_cast<SbkObject *>(self))) {
                Shiboken::Errors::setPureVirtualMethodError("QDesignerDnDItemInterface.hotSpot");
                return {};
            }
            QPoint cppResult = const_cast<const ::QDesignerDnDItemInterface *>(cppSelf)->hotSpot();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QPoint_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDesignerDnDItemInterfaceFunc_source(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDesignerDnDItemInterface *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerDnDItemInterface_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtDesigner.QDesignerDnDItemInterface.source";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // source()const
            if (Shiboken::Object::hasCppWrapper(reinterpret_cast<SbkObject *>(self))) {
                Shiboken::Errors::setPureVirtualMethodError("QDesignerDnDItemInterface.source");
                return {};
            }
            QWidget * cppResult = const_cast<const ::QDesignerDnDItemInterface *>(cppSelf)->source();
            pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QWidget_IDX]), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDesignerDnDItemInterfaceFunc_type(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDesignerDnDItemInterface *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerDnDItemInterface_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtDesigner.QDesignerDnDItemInterface.type";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // type()const
            if (Shiboken::Object::hasCppWrapper(reinterpret_cast<SbkObject *>(self))) {
                Shiboken::Errors::setPureVirtualMethodError("QDesignerDnDItemInterface.type");
                return {};
            }
            QDesignerDnDItemInterface::DropType cppResult = const_cast<const ::QDesignerDnDItemInterface *>(cppSelf)->type();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerDnDItemInterface_DropType_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDesignerDnDItemInterfaceFunc_widget(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDesignerDnDItemInterface *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerDnDItemInterface_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtDesigner.QDesignerDnDItemInterface.widget";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // widget()const
            if (Shiboken::Object::hasCppWrapper(reinterpret_cast<SbkObject *>(self))) {
                Shiboken::Errors::setPureVirtualMethodError("QDesignerDnDItemInterface.widget");
                return {};
            }
            QWidget * cppResult = const_cast<const ::QDesignerDnDItemInterface *>(cppSelf)->widget();
            pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QWidget_IDX]), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QDesignerDnDItemInterface_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QDesignerDnDItemInterface_EnumFlagInfo[] = {
    "DropType:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QDesignerDnDItemInterface_methods[] = {
    {"decoration", reinterpret_cast<PyCFunction>(Sbk_QDesignerDnDItemInterfaceFunc_decoration), METH_NOARGS, nullptr},
    {"hotSpot", reinterpret_cast<PyCFunction>(Sbk_QDesignerDnDItemInterfaceFunc_hotSpot), METH_NOARGS, nullptr},
    {"source", reinterpret_cast<PyCFunction>(Sbk_QDesignerDnDItemInterfaceFunc_source), METH_NOARGS, nullptr},
    {"type", reinterpret_cast<PyCFunction>(Sbk_QDesignerDnDItemInterfaceFunc_type), METH_NOARGS, nullptr},
    {"widget", reinterpret_cast<PyCFunction>(Sbk_QDesignerDnDItemInterfaceFunc_widget), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static int Sbk_QDesignerDnDItemInterface_setattro(PyObject *self, PyObject *name, PyObject *value)
{
    PySide::Feature::Select(self);
    return PyObject_GenericSetAttr(self, name, value);
}

} // extern "C"

static int Sbk_QDesignerDnDItemInterface_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QDesignerDnDItemInterface_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QDesignerDnDItemInterface_Type = nullptr;
static PyTypeObject *Sbk_QDesignerDnDItemInterface_TypeF(void)
{
    return _Sbk_QDesignerDnDItemInterface_Type;
}

static PyType_Slot Sbk_QDesignerDnDItemInterface_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_setattro,    reinterpret_cast<void *>(Sbk_QDesignerDnDItemInterface_setattro)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QDesignerDnDItemInterface_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QDesignerDnDItemInterface_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QDesignerDnDItemInterface_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QDesignerDnDItemInterface_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QDesignerDnDItemInterface_spec = {
    "2:PySide6.QtDesigner.QDesignerDnDItemInterface",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QDesignerDnDItemInterface_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void QDesignerDnDItemInterface_DropType_PythonToCpp_QDesignerDnDItemInterface_DropType(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QDesignerDnDItemInterface::DropType>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QDesignerDnDItemInterface::DropType *>(cppOut) = value;

}
static PythonToCppFunc is_QDesignerDnDItemInterface_DropType_PythonToCpp_QDesignerDnDItemInterface_DropType_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerDnDItemInterface_DropType_IDX])))
        return QDesignerDnDItemInterface_DropType_PythonToCpp_QDesignerDnDItemInterface_DropType;
    return {};
}
static PyObject *QDesignerDnDItemInterface_DropType_CppToPython_QDesignerDnDItemInterface_DropType(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QDesignerDnDItemInterface::DropType *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerDnDItemInterface_DropType_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QDesignerDnDItemInterface_PythonToCpp_QDesignerDnDItemInterface_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QDesignerDnDItemInterface_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QDesignerDnDItemInterface_PythonToCpp_QDesignerDnDItemInterface_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QDesignerDnDItemInterface_TypeF()))
        return QDesignerDnDItemInterface_PythonToCpp_QDesignerDnDItemInterface_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QDesignerDnDItemInterface_PTR_CppToPython_QDesignerDnDItemInterface(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QDesignerDnDItemInterface *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QDesignerDnDItemInterface_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QDesignerDnDItemInterface_SignatureStrings[] = {
    "PySide6.QtDesigner.QDesignerDnDItemInterface(self)",
    "PySide6.QtDesigner.QDesignerDnDItemInterface.decoration(self)->PySide6.QtWidgets.QWidget",
    "PySide6.QtDesigner.QDesignerDnDItemInterface.hotSpot(self)->PySide6.QtCore.QPoint",
    "PySide6.QtDesigner.QDesignerDnDItemInterface.source(self)->PySide6.QtWidgets.QWidget",
    "PySide6.QtDesigner.QDesignerDnDItemInterface.type(self)->PySide6.QtDesigner.QDesignerDnDItemInterface.DropType",
    "PySide6.QtDesigner.QDesignerDnDItemInterface.widget(self)->PySide6.QtWidgets.QWidget",
    nullptr}; // Sentinel

PyTypeObject *init_QDesignerDnDItemInterface(PyObject *module)
{
    _Sbk_QDesignerDnDItemInterface_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QDesignerDnDItemInterface",
        "QDesignerDnDItemInterface*",
        &Sbk_QDesignerDnDItemInterface_spec,
        &Shiboken::callCppDestructor< ::QDesignerDnDItemInterface >,
        nullptr,
        0,
        0);
    auto *pyType = Sbk_QDesignerDnDItemInterface_TypeF(); // references _Sbk_QDesignerDnDItemInterface_Type
    InitSignatureStrings(pyType, QDesignerDnDItemInterface_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QDesignerDnDItemInterface_PropertyStrings);
    SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerDnDItemInterface_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QDesignerDnDItemInterface_PythonToCpp_QDesignerDnDItemInterface_PTR,
        is_QDesignerDnDItemInterface_PythonToCpp_QDesignerDnDItemInterface_PTR_Convertible,
        QDesignerDnDItemInterface_PTR_CppToPython_QDesignerDnDItemInterface);

    Shiboken::Conversions::registerConverterName(converter, "QDesignerDnDItemInterface");
    Shiboken::Conversions::registerConverterName(converter, "QDesignerDnDItemInterface*");
    Shiboken::Conversions::registerConverterName(converter, "QDesignerDnDItemInterface&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QDesignerDnDItemInterface).name());

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QDesignerDnDItemInterface_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'DropType'.
    const char *DropType_Initializer[] = {
        "MoveDrop",
        "CopyDrop",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t DropType_InitializerValues[] = {
        uint8_t(QDesignerDnDItemInterface::DropType::MoveDrop), //  0x00  0
        uint8_t(QDesignerDnDItemInterface::DropType::CopyDrop)  //  0x01  1
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QDesignerDnDItemInterface_TypeF(),
        "2:PySide6.QtDesigner.QDesignerDnDItemInterface.DropType",
        DropType_Initializer, DropType_InitializerValues);
    SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerDnDItemInterface_DropType_IDX].type = EType;
    // Register converter for enum 'QDesignerDnDItemInterface::DropType'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QDesignerDnDItemInterface_DropType_CppToPython_QDesignerDnDItemInterface_DropType);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QDesignerDnDItemInterface_DropType_PythonToCpp_QDesignerDnDItemInterface_DropType,
            is_QDesignerDnDItemInterface_DropType_PythonToCpp_QDesignerDnDItemInterface_DropType_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QDesignerDnDItemInterface::DropType");
        Shiboken::Conversions::registerConverterName(converter, "DropType");
    }
    // End of 'DropType' enum.

    qRegisterMetaType< ::QDesignerDnDItemInterface *>();
    qRegisterMetaType< ::QDesignerDnDItemInterface::DropType >("QDesignerDnDItemInterface::DropType");

    return pyType;
}
