// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QDesignerTaskMenuExtensionWrapper_H
#define SBK_QDesignerTaskMenuExtensionWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtDesigner/taskmenu.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QDesignerTaskMenuExtensionWrapper : public QDesignerTaskMenuExtension
{
public:
    QDesignerTaskMenuExtensionWrapper(const QDesignerTaskMenuExtensionWrapper &) = delete;
    QDesignerTaskMenuExtensionWrapper& operator=(const QDesignerTaskMenuExtensionWrapper &) = delete;
    QDesignerTaskMenuExtensionWrapper(QDesignerTaskMenuExtensionWrapper &&) = delete;
    QDesignerTaskMenuExtensionWrapper& operator=(QDesignerTaskMenuExtensionWrapper &&) = delete;

    QDesignerTaskMenuExtensionWrapper() noexcept;
    ::QAction * preferredEditAction() const override;
    ::QList<QAction*> taskActions() const override;
    ~QDesignerTaskMenuExtensionWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QDesignerTaskMenuExtensionWrapper_H

