// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtdesigner_python.h"

// main header
#include "qpydesignercustomwidgetcollection_wrapper.h"

// Extra includes
#include <qpydesignerextensions.h>

// Argument includes
#include <QList>
#include <QString>
#include <QtUiPlugin/customwidget.h>
#include <qpydesignerextensions.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static PyObject *Sbk_QPyDesignerCustomWidgetCollectionFunc_addCustomWidget(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtDesigner.QPyDesignerCustomWidgetCollection.addCustomWidget";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static QPyDesignerCustomWidgetCollection::addCustomWidget(QDesignerCustomWidgetInterface*)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerCustomWidgetInterface_IDX]), (pyArg)))) {
        overloadId = 0; // addCustomWidget(QDesignerCustomWidgetInterface*)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QDesignerCustomWidgetInterface *cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // addCustomWidget(QDesignerCustomWidgetInterface*)
            ::QPyDesignerCustomWidgetCollection::addCustomWidget(cppArg0);

            // Ownership transferences.
            Shiboken::Object::releaseOwnership(pyArg);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QPyDesignerCustomWidgetCollectionFunc_customWidgets(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPyDesignerCustomWidgetCollection *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QPyDesignerCustomWidgetCollection_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtDesigner.QPyDesignerCustomWidgetCollection.customWidgets";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // customWidgets()const
            QList<QDesignerCustomWidgetInterface*> cppResult = Shiboken::Object::hasCppWrapper(reinterpret_cast<SbkObject *>(self))
                ? const_cast<const ::QPyDesignerCustomWidgetCollection *>(cppSelf)->::QPyDesignerCustomWidgetCollection::customWidgets()
                : const_cast<const ::QPyDesignerCustomWidgetCollection *>(cppSelf)->customWidgets();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtDesignerTypeConverters[SBK_QtDesigner_QList_QDesignerCustomWidgetInterfacePTR_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPyDesignerCustomWidgetCollectionFunc_instance(PyObject *self)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtDesigner.QPyDesignerCustomWidgetCollection.instance";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // instance()
            QPyDesignerCustomWidgetCollection * cppResult = ::QPyDesignerCustomWidgetCollection::instance();
            pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QPyDesignerCustomWidgetCollection_IDX]), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPyDesignerCustomWidgetCollectionFunc_registerCustomWidget(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(self)
    SBK_UNUSED(kwds)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtDesigner.QPyDesignerCustomWidgetCollection.registerCustomWidget";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[7];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr, nullptr, nullptr, nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 1, 7));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|OOOOOOO:registerCustomWidget", &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2]), &(pyArgs[3]), &(pyArgs[4]), &(pyArgs[5]), &(pyArgs[6])) == 0)
        return {};


    // Overloaded function decisor
    // 0: static QPyDesignerCustomWidgetCollection::registerCustomWidget(PyObject*,const QString&=,const QString&=,const QString&=,const QString&=,bool=,const QString&=)
    if (numArgs >= 1
        && true) {
        if (numArgs == 1) {
            overloadId = 0; // registerCustomWidget(PyObject*,QString,QString,QString,QString,bool,QString)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[1])))) {
            if (numArgs == 2) {
                overloadId = 0; // registerCustomWidget(PyObject*,QString,QString,QString,QString,bool,QString)
            } else if (numArgs >= 3
                && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[2])))) {
                if (numArgs == 3) {
                    overloadId = 0; // registerCustomWidget(PyObject*,QString,QString,QString,QString,bool,QString)
                } else if (numArgs >= 4
                    && (pythonToCpp[3] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[3])))) {
                    if (numArgs == 4) {
                        overloadId = 0; // registerCustomWidget(PyObject*,QString,QString,QString,QString,bool,QString)
                    } else if (numArgs >= 5
                        && (pythonToCpp[4] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[4])))) {
                        if (numArgs == 5) {
                            overloadId = 0; // registerCustomWidget(PyObject*,QString,QString,QString,QString,bool,QString)
                        } else if (numArgs >= 6
                            && (pythonToCpp[5] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArgs[5])))) {
                            if (numArgs == 6) {
                                overloadId = 0; // registerCustomWidget(PyObject*,QString,QString,QString,QString,bool,QString)
                            } else if (numArgs >= 7
                                && (pythonToCpp[6] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[6])))) {
                                overloadId = 0; // registerCustomWidget(PyObject*,QString,QString,QString,QString,bool,QString)
                            }
                        }
                    }
                }
            }
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_xml = Shiboken::String::createStaticString("xml");
            if (PyDict_Contains(kwds, key_xml) != 0) {
                value = PyDict_GetItem(kwds, key_xml);
                if (value != nullptr && pyArgs[1] != nullptr ) {
                    errInfo.reset(key_xml);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                if (value != nullptr) {
                    pyArgs[1] = value;
                    if (!(pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[1]))))
                        return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                PyDict_DelItem(kwds_dup, key_xml);
            }
            static PyObject *const key_tool_tip = Shiboken::String::createStaticString("tool_tip");
            if (PyDict_Contains(kwds, key_tool_tip) != 0) {
                value = PyDict_GetItem(kwds, key_tool_tip);
                if (value != nullptr && pyArgs[2] != nullptr ) {
                    errInfo.reset(key_tool_tip);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                if (value != nullptr) {
                    pyArgs[2] = value;
                    if (!(pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[2]))))
                        return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                PyDict_DelItem(kwds_dup, key_tool_tip);
            }
            static PyObject *const key_group = Shiboken::String::createStaticString("group");
            if (PyDict_Contains(kwds, key_group) != 0) {
                value = PyDict_GetItem(kwds, key_group);
                if (value != nullptr && pyArgs[3] != nullptr ) {
                    errInfo.reset(key_group);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                if (value != nullptr) {
                    pyArgs[3] = value;
                    if (!(pythonToCpp[3] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[3]))))
                        return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                PyDict_DelItem(kwds_dup, key_group);
            }
            static PyObject *const key_module = Shiboken::String::createStaticString("module");
            if (PyDict_Contains(kwds, key_module) != 0) {
                value = PyDict_GetItem(kwds, key_module);
                if (value != nullptr && pyArgs[4] != nullptr ) {
                    errInfo.reset(key_module);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                if (value != nullptr) {
                    pyArgs[4] = value;
                    if (!(pythonToCpp[4] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[4]))))
                        return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                PyDict_DelItem(kwds_dup, key_module);
            }
            static PyObject *const key_container = Shiboken::String::createStaticString("container");
            if (PyDict_Contains(kwds, key_container) != 0) {
                value = PyDict_GetItem(kwds, key_container);
                if (value != nullptr && pyArgs[5] != nullptr ) {
                    errInfo.reset(key_container);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                if (value != nullptr) {
                    pyArgs[5] = value;
                    if (!(pythonToCpp[5] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArgs[5]))))
                        return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                PyDict_DelItem(kwds_dup, key_container);
            }
            static PyObject *const key_icon = Shiboken::String::createStaticString("icon");
            if (PyDict_Contains(kwds, key_icon) != 0) {
                value = PyDict_GetItem(kwds, key_icon);
                if (value != nullptr && pyArgs[6] != nullptr ) {
                    errInfo.reset(key_icon);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                if (value != nullptr) {
                    pyArgs[6] = value;
                    if (!(pythonToCpp[6] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[6]))))
                        return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                PyDict_DelItem(kwds_dup, key_icon);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments(args, fullName, errInfo);
            }
        }
        ::QString cppArg1{};
        if (pythonToCpp[1])
            pythonToCpp[1](pyArgs[1], &cppArg1);
        SBK_UNUSED(cppArg1)
        ::QString cppArg2{};
        if (pythonToCpp[2])
            pythonToCpp[2](pyArgs[2], &cppArg2);
        SBK_UNUSED(cppArg2)
        ::QString cppArg3{};
        if (pythonToCpp[3])
            pythonToCpp[3](pyArgs[3], &cppArg3);
        SBK_UNUSED(cppArg3)
        ::QString cppArg4{};
        if (pythonToCpp[4])
            pythonToCpp[4](pyArgs[4], &cppArg4);
        SBK_UNUSED(cppArg4)
        bool cppArg5 = false;
        if (pythonToCpp[5])
            pythonToCpp[5](pyArgs[5], &cppArg5);
        SBK_UNUSED(cppArg5)
        ::QString cppArg6{};
        if (pythonToCpp[6])
            pythonToCpp[6](pyArgs[6], &cppArg6);
        SBK_UNUSED(cppArg6)

        if (Shiboken::Errors::occurred() == nullptr) {
            // registerCustomWidget(PyObject*,QString,QString,QString,QString,bool,QString)
            // Begin code injection
            // ========================================================================
            // START of custom code block [file: ../glue/qtdesigner.cpp (qtdesigner-registercustomwidget)]
            if (!QPyDesignerCustomWidgetCollection::_registerCustomWidgetHelper(pyArgs[1-1], kwds))
                return {};
            // END of custom code block [file: ../glue/qtdesigner.cpp (qtdesigner-registercustomwidget)]
            // ========================================================================
            // End of code injection

        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}


static const char *Sbk_QPyDesignerCustomWidgetCollection_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QPyDesignerCustomWidgetCollection_methods[] = {
    {"addCustomWidget", reinterpret_cast<PyCFunction>(Sbk_QPyDesignerCustomWidgetCollectionFunc_addCustomWidget), METH_O|METH_STATIC, nullptr},
    {"customWidgets", reinterpret_cast<PyCFunction>(Sbk_QPyDesignerCustomWidgetCollectionFunc_customWidgets), METH_NOARGS, nullptr},
    {"instance", reinterpret_cast<PyCFunction>(Sbk_QPyDesignerCustomWidgetCollectionFunc_instance), METH_NOARGS|METH_STATIC, nullptr},
    {"registerCustomWidget", reinterpret_cast<PyCFunction>(Sbk_QPyDesignerCustomWidgetCollectionFunc_registerCustomWidget), METH_VARARGS|METH_KEYWORDS|METH_STATIC, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static int Sbk_QPyDesignerCustomWidgetCollection_setattro(PyObject *self, PyObject *name, PyObject *value)
{
    PySide::Feature::Select(self);
    return PyObject_GenericSetAttr(self, name, value);
}

} // extern "C"

static int Sbk_QPyDesignerCustomWidgetCollection_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QPyDesignerCustomWidgetCollection_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QPyDesignerCustomWidgetCollection_Type = nullptr;
static PyTypeObject *Sbk_QPyDesignerCustomWidgetCollection_TypeF(void)
{
    return _Sbk_QPyDesignerCustomWidgetCollection_Type;
}

static PyType_Slot Sbk_QPyDesignerCustomWidgetCollection_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_setattro,    reinterpret_cast<void *>(Sbk_QPyDesignerCustomWidgetCollection_setattro)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QPyDesignerCustomWidgetCollection_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QPyDesignerCustomWidgetCollection_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QPyDesignerCustomWidgetCollection_methods)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QPyDesignerCustomWidgetCollection_spec = {
    "2:PySide6.QtDesigner.QPyDesignerCustomWidgetCollection",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QPyDesignerCustomWidgetCollection_slots
};

} //extern "C"

static void *Sbk_QPyDesignerCustomWidgetCollection_typeDiscovery(void *cptr, PyTypeObject *instanceType)
{
    SBK_UNUSED(cptr)
    SBK_UNUSED(instanceType)
    if (instanceType == Shiboken::SbkType< ::QDesignerCustomWidgetCollectionInterface >())
        return dynamic_cast< ::QPyDesignerCustomWidgetCollection *>(reinterpret_cast< ::QDesignerCustomWidgetCollectionInterface *>(cptr));
    return {};
}


// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QPyDesignerCustomWidgetCollection_PythonToCpp_QPyDesignerCustomWidgetCollection_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QPyDesignerCustomWidgetCollection_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QPyDesignerCustomWidgetCollection_PythonToCpp_QPyDesignerCustomWidgetCollection_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QPyDesignerCustomWidgetCollection_TypeF()))
        return QPyDesignerCustomWidgetCollection_PythonToCpp_QPyDesignerCustomWidgetCollection_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QPyDesignerCustomWidgetCollection_PTR_CppToPython_QPyDesignerCustomWidgetCollection(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QPyDesignerCustomWidgetCollection *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QPyDesignerCustomWidgetCollection_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QPyDesignerCustomWidgetCollection_SignatureStrings[] = {
    "PySide6.QtDesigner.QPyDesignerCustomWidgetCollection.addCustomWidget(c:PySide6.QtDesigner.QDesignerCustomWidgetInterface)",
    "PySide6.QtDesigner.QPyDesignerCustomWidgetCollection.customWidgets(self)->QList[PySide6.QtDesigner.QDesignerCustomWidgetInterface]",
    "PySide6.QtDesigner.QPyDesignerCustomWidgetCollection.instance()->PySide6.QtDesigner.QPyDesignerCustomWidgetCollection",
    "PySide6.QtDesigner.QPyDesignerCustomWidgetCollection.registerCustomWidget(customWidgetType:PyObject,xml:QString={},tool_tip:QString={},group:QString={},module:QString={},container:bool=false,icon:QString={})",
    nullptr}; // Sentinel

PyTypeObject *init_QPyDesignerCustomWidgetCollection(PyObject *module)
{
    _Sbk_QPyDesignerCustomWidgetCollection_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QPyDesignerCustomWidgetCollection",
        "QPyDesignerCustomWidgetCollection*",
        &Sbk_QPyDesignerCustomWidgetCollection_spec,
        &Shiboken::callCppDestructor< ::QPyDesignerCustomWidgetCollection >,
        Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerCustomWidgetCollectionInterface_IDX]),
        0,
        0);
    auto *pyType = Sbk_QPyDesignerCustomWidgetCollection_TypeF(); // references _Sbk_QPyDesignerCustomWidgetCollection_Type
    InitSignatureStrings(pyType, QPyDesignerCustomWidgetCollection_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QPyDesignerCustomWidgetCollection_PropertyStrings);
    SbkPySide6_QtDesignerTypeStructs[SBK_QPyDesignerCustomWidgetCollection_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QPyDesignerCustomWidgetCollection_PythonToCpp_QPyDesignerCustomWidgetCollection_PTR,
        is_QPyDesignerCustomWidgetCollection_PythonToCpp_QPyDesignerCustomWidgetCollection_PTR_Convertible,
        QPyDesignerCustomWidgetCollection_PTR_CppToPython_QPyDesignerCustomWidgetCollection);

    Shiboken::Conversions::registerConverterName(converter, "QPyDesignerCustomWidgetCollection");
    Shiboken::Conversions::registerConverterName(converter, "QPyDesignerCustomWidgetCollection*");
    Shiboken::Conversions::registerConverterName(converter, "QPyDesignerCustomWidgetCollection&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QPyDesignerCustomWidgetCollection).name());

    Shiboken::ObjectType::setTypeDiscoveryFunctionV2(
        Sbk_QPyDesignerCustomWidgetCollection_TypeF(), &Sbk_QPyDesignerCustomWidgetCollection_typeDiscovery);

    qRegisterMetaType< ::QPyDesignerCustomWidgetCollection *>();

    return pyType;
}
