// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtgui_python.h"
#include "pyside6_qtgui_python_p.h"

// main header
#include "qabstracttextdocumentlayout_paintcontext_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QAbstractTextDocumentLayout_PaintContext_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QAbstractTextDocumentLayout::PaintContext >()))
        return -1;

    ::QAbstractTextDocumentLayout::PaintContext *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QAbstractTextDocumentLayout.PaintContext.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "PaintContext", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: PaintContext::PaintContext()
    // 1: PaintContext::PaintContext(QAbstractTextDocumentLayout::PaintContext)
    if (numArgs == 0) {
        overloadId = 0; // PaintContext()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QAbstractTextDocumentLayout_PaintContext_IDX]), (pyArgs[0])))) {
        overloadId = 1; // PaintContext(QAbstractTextDocumentLayout::PaintContext)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // PaintContext()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // PaintContext()
                cptr = new ::QAbstractTextDocumentLayout::PaintContext();
            }
            break;
        }
        case 1: // PaintContext(const QAbstractTextDocumentLayout::PaintContext & PaintContext)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QAbstractTextDocumentLayout::PaintContext cppArg0_local;
            ::QAbstractTextDocumentLayout::PaintContext *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // PaintContext(QAbstractTextDocumentLayout::PaintContext)
                cptr = new ::QAbstractTextDocumentLayout::PaintContext(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QAbstractTextDocumentLayout::PaintContext >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QAbstractTextDocumentLayout_PaintContext__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QAbstractTextDocumentLayout::PaintContext *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QAbstractTextDocumentLayout_PaintContext_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QAbstractTextDocumentLayout_PaintContext_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QAbstractTextDocumentLayout_PaintContext_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QAbstractTextDocumentLayout_PaintContext_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QAbstractTextDocumentLayout_PaintContext__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QAbstractTextDocumentLayout_PaintContext_get_cursorPosition(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QAbstractTextDocumentLayout::PaintContext *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QAbstractTextDocumentLayout_PaintContext_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->cursorPosition;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QAbstractTextDocumentLayout_PaintContext_set_cursorPosition(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QAbstractTextDocumentLayout::PaintContext *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QAbstractTextDocumentLayout_PaintContext_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("cursorPosition");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("cursorPosition", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->cursorPosition;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->cursorPosition = cppOut_local;

    return 0;
}

static PyObject *Sbk_QAbstractTextDocumentLayout_PaintContext_get_palette(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QAbstractTextDocumentLayout::PaintContext *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QAbstractTextDocumentLayout_PaintContext_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->palette)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPalette_IDX])));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->palette))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->palette)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPalette_IDX]), &(cppSelf->palette), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_QAbstractTextDocumentLayout_PaintContext_set_palette(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QAbstractTextDocumentLayout::PaintContext *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QAbstractTextDocumentLayout_PaintContext_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("palette");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPalette_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("palette", "QPalette");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->palette;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QAbstractTextDocumentLayout_PaintContext_get_clip(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QAbstractTextDocumentLayout::PaintContext *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QAbstractTextDocumentLayout_PaintContext_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->clip)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRectF_IDX])));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->clip))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->clip)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRectF_IDX]), &(cppSelf->clip), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_QAbstractTextDocumentLayout_PaintContext_set_clip(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QAbstractTextDocumentLayout::PaintContext *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QAbstractTextDocumentLayout_PaintContext_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("clip");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRectF_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("clip", "QRectF");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->clip;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QAbstractTextDocumentLayout_PaintContext_get_selections(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QAbstractTextDocumentLayout::PaintContext *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QAbstractTextDocumentLayout_PaintContext_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(SbkPySide6_QtGuiTypeConverters[SBK_QtGui_QList_QAbstractTextDocumentLayout_Selection_IDX], &cppSelf->selections);
    return pyOut;
}
static int Sbk_QAbstractTextDocumentLayout_PaintContext_set_selections(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QAbstractTextDocumentLayout::PaintContext *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QAbstractTextDocumentLayout_PaintContext_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("selections");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtGuiTypeConverters[SBK_QtGui_QList_QAbstractTextDocumentLayout_Selection_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("selections", "QList");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->selections;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

// Getters and Setters for PaintContext
static PyGetSetDef Sbk_QAbstractTextDocumentLayout_PaintContext_getsetlist[] = {
    {const_cast<char *>("cursorPosition"), Sbk_QAbstractTextDocumentLayout_PaintContext_get_cursorPosition, Sbk_QAbstractTextDocumentLayout_PaintContext_set_cursorPosition, nullptr, nullptr},
    {const_cast<char *>("palette"), Sbk_QAbstractTextDocumentLayout_PaintContext_get_palette, Sbk_QAbstractTextDocumentLayout_PaintContext_set_palette, nullptr, nullptr},
    {const_cast<char *>("clip"), Sbk_QAbstractTextDocumentLayout_PaintContext_get_clip, Sbk_QAbstractTextDocumentLayout_PaintContext_set_clip, nullptr, nullptr},
    {const_cast<char *>("selections"), Sbk_QAbstractTextDocumentLayout_PaintContext_get_selections, Sbk_QAbstractTextDocumentLayout_PaintContext_set_selections, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QAbstractTextDocumentLayout_PaintContext_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QAbstractTextDocumentLayout_PaintContext_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QAbstractTextDocumentLayout_PaintContext_Type = nullptr;
static PyTypeObject *Sbk_QAbstractTextDocumentLayout_PaintContext_TypeF(void)
{
    return _Sbk_QAbstractTextDocumentLayout_PaintContext_Type;
}

static PyType_Slot Sbk_QAbstractTextDocumentLayout_PaintContext_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QAbstractTextDocumentLayout_PaintContext_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QAbstractTextDocumentLayout_PaintContext_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QAbstractTextDocumentLayout_PaintContext_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QAbstractTextDocumentLayout_PaintContext_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QAbstractTextDocumentLayout_PaintContext_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QAbstractTextDocumentLayout_PaintContext_spec = {
    "2:PySide6.QtGui.QAbstractTextDocumentLayout.PaintContext",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QAbstractTextDocumentLayout_PaintContext_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void PaintContext_PythonToCpp_PaintContext_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QAbstractTextDocumentLayout_PaintContext_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_PaintContext_PythonToCpp_PaintContext_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QAbstractTextDocumentLayout_PaintContext_TypeF()))
        return PaintContext_PythonToCpp_PaintContext_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *PaintContext_PTR_CppToPython_PaintContext(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QAbstractTextDocumentLayout::PaintContext *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QAbstractTextDocumentLayout_PaintContext_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *PaintContext_COPY_CppToPython_PaintContext(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QAbstractTextDocumentLayout::PaintContext *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QAbstractTextDocumentLayout_PaintContext_TypeF(), new ::QAbstractTextDocumentLayout::PaintContext(*source), true, true);
}

// Python to C++ copy conversion.
static void PaintContext_PythonToCpp_PaintContext_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QAbstractTextDocumentLayout::PaintContext *>(cppOut) = *reinterpret_cast< ::QAbstractTextDocumentLayout::PaintContext *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QAbstractTextDocumentLayout_PaintContext_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_PaintContext_PythonToCpp_PaintContext_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QAbstractTextDocumentLayout_PaintContext_TypeF()))
        return PaintContext_PythonToCpp_PaintContext_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QAbstractTextDocumentLayout_PaintContext_SignatureStrings[] = {
    "1:PySide6.QtGui.QAbstractTextDocumentLayout.PaintContext(self)",
    "0:PySide6.QtGui.QAbstractTextDocumentLayout.PaintContext(self,PaintContext:PySide6.QtGui.QAbstractTextDocumentLayout.PaintContext)",
    "PySide6.QtGui.QAbstractTextDocumentLayout.PaintContext.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QAbstractTextDocumentLayout_PaintContext(PyObject *enclosingClass)
{
    _Sbk_QAbstractTextDocumentLayout_PaintContext_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "PaintContext",
        "QAbstractTextDocumentLayout::PaintContext",
        &Sbk_QAbstractTextDocumentLayout_PaintContext_spec,
        &Shiboken::callCppDestructor< ::QAbstractTextDocumentLayout::PaintContext >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QAbstractTextDocumentLayout_PaintContext_TypeF(); // references _Sbk_QAbstractTextDocumentLayout_PaintContext_Type
    InitSignatureStrings(pyType, QAbstractTextDocumentLayout_PaintContext_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QAbstractTextDocumentLayout_PaintContext_PropertyStrings);
    SbkPySide6_QtGuiTypeStructs[SBK_QAbstractTextDocumentLayout_PaintContext_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        PaintContext_PythonToCpp_PaintContext_PTR,
        is_PaintContext_PythonToCpp_PaintContext_PTR_Convertible,
        PaintContext_PTR_CppToPython_PaintContext,
        PaintContext_COPY_CppToPython_PaintContext);

    Shiboken::Conversions::registerConverterName(converter, "QAbstractTextDocumentLayout::PaintContext");
    Shiboken::Conversions::registerConverterName(converter, "QAbstractTextDocumentLayout::PaintContext*");
    Shiboken::Conversions::registerConverterName(converter, "QAbstractTextDocumentLayout::PaintContext&");
    Shiboken::Conversions::registerConverterName(converter, "PaintContext");
    Shiboken::Conversions::registerConverterName(converter, "PaintContext*");
    Shiboken::Conversions::registerConverterName(converter, "PaintContext&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QAbstractTextDocumentLayout::PaintContext).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        PaintContext_PythonToCpp_PaintContext_COPY,
        is_PaintContext_PythonToCpp_PaintContext_COPY_Convertible);

    qRegisterMetaType< ::QAbstractTextDocumentLayout::PaintContext >("PaintContext");
    qRegisterMetaType< ::QAbstractTextDocumentLayout::PaintContext >("QAbstractTextDocumentLayout::PaintContext");

    return pyType;
}
