// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAccessibleEventWrapper_H
#define SBK_QAccessibleEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qaccessible.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QAccessibleEventWrapper : public QAccessibleEvent
{
public:
    QAccessibleEventWrapper(const QAccessibleEventWrapper &) = delete;
    QAccessibleEventWrapper& operator=(const QAccessibleEventWrapper &) = delete;
    QAccessibleEventWrapper(QAccessibleEventWrapper &&) = delete;
    QAccessibleEventWrapper& operator=(QAccessibleEventWrapper &&) = delete;

    QAccessibleEventWrapper(::QAccessibleInterface * iface, ::QAccessible::Event typ);
    QAccessibleEventWrapper(::QObject * obj, ::QAccessible::Event typ);
    ::QAccessibleInterface * accessibleInterface() const override;
    ~QAccessibleEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1];
};

#endif // SBK_QAccessibleEventWrapper_H

