// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAccessibleTableModelChangeEventWrapper_H
#define SBK_QAccessibleTableModelChangeEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qaccessible.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QAccessibleTableModelChangeEventWrapper : public QAccessibleTableModelChangeEvent
{
public:
    QAccessibleTableModelChangeEventWrapper(const QAccessibleTableModelChangeEventWrapper &) = delete;
    QAccessibleTableModelChangeEventWrapper& operator=(const QAccessibleTableModelChangeEventWrapper &) = delete;
    QAccessibleTableModelChangeEventWrapper(QAccessibleTableModelChangeEventWrapper &&) = delete;
    QAccessibleTableModelChangeEventWrapper& operator=(QAccessibleTableModelChangeEventWrapper &&) = delete;

    QAccessibleTableModelChangeEventWrapper(::QAccessibleInterface * iface, ::QAccessibleTableModelChangeEvent::ModelChangeType changeType);
    QAccessibleTableModelChangeEventWrapper(::QObject * obj, ::QAccessibleTableModelChangeEvent::ModelChangeType changeType);
    ::QAccessibleInterface * accessibleInterface() const override;
    ~QAccessibleTableModelChangeEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1];
};

#endif // SBK_QAccessibleTableModelChangeEventWrapper_H

