// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAccessibleTextSelectionEventWrapper_H
#define SBK_QAccessibleTextSelectionEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qaccessible.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QAccessibleTextSelectionEventWrapper : public QAccessibleTextSelectionEvent
{
public:
    QAccessibleTextSelectionEventWrapper(const QAccessibleTextSelectionEventWrapper &) = delete;
    QAccessibleTextSelectionEventWrapper& operator=(const QAccessibleTextSelectionEventWrapper &) = delete;
    QAccessibleTextSelectionEventWrapper(QAccessibleTextSelectionEventWrapper &&) = delete;
    QAccessibleTextSelectionEventWrapper& operator=(QAccessibleTextSelectionEventWrapper &&) = delete;

    QAccessibleTextSelectionEventWrapper(::QAccessibleInterface * iface, int start, int end);
    QAccessibleTextSelectionEventWrapper(::QObject * obj, int start, int end);
    ::QAccessibleInterface * accessibleInterface() const override;
    ~QAccessibleTextSelectionEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1];
};

#endif // SBK_QAccessibleTextSelectionEventWrapper_H

