// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QDragLeaveEventWrapper_H
#define SBK_QDragLeaveEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QDragLeaveEventWrapper : public QDragLeaveEvent
{
public:
    QDragLeaveEventWrapper(const QDragLeaveEventWrapper &) = delete;
    QDragLeaveEventWrapper& operator=(const QDragLeaveEventWrapper &) = delete;
    QDragLeaveEventWrapper(QDragLeaveEventWrapper &&) = delete;
    QDragLeaveEventWrapper& operator=(QDragLeaveEventWrapper &&) = delete;

    QDragLeaveEventWrapper();
    QDragLeaveEventWrapper(const QDragLeaveEvent& self) : QDragLeaveEvent(self)
    {
    }

    ::QDragLeaveEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QDragLeaveEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QDragLeaveEventWrapper_H

