// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QFocusEventWrapper_H
#define SBK_QFocusEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QFocusEventWrapper : public QFocusEvent
{
public:
    QFocusEventWrapper(const QFocusEventWrapper &) = delete;
    QFocusEventWrapper& operator=(const QFocusEventWrapper &) = delete;
    QFocusEventWrapper(QFocusEventWrapper &&) = delete;
    QFocusEventWrapper& operator=(QFocusEventWrapper &&) = delete;

    QFocusEventWrapper(::QEvent::Type type, ::Qt::FocusReason reason = Qt::OtherFocusReason);
    QFocusEventWrapper(const QFocusEvent& self) : QFocusEvent(self)
    {
    }

    ::QFocusEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QFocusEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QFocusEventWrapper_H

