// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtgui_python.h"
#include "pyside6_qtgui_python_p.h"

// main header
#include "qiconengine_scaledpixmapargument_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QIconEngine_ScaledPixmapArgument_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(args)
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QIconEngine::ScaledPixmapArgument >()))
        return -1;

    ::QIconEngine::ScaledPixmapArgument *cptr{};
    static const char fullName[] = "PySide6.QtGui.QIconEngine.ScaledPixmapArgument.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // ScaledPixmapArgument()
            cptr = new ::QIconEngine::ScaledPixmapArgument();
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QIconEngine::ScaledPixmapArgument >(), cptr)) {
        delete cptr;
        return -1;
    }
    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}


static const char *Sbk_QIconEngine_ScaledPixmapArgument_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QIconEngine_ScaledPixmapArgument_methods[] = {
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QIconEngine_ScaledPixmapArgument_get_size(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QIconEngine::ScaledPixmapArgument *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QIconEngine_ScaledPixmapArgument_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->size)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSize_IDX])));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->size))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->size)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSize_IDX]), &(cppSelf->size), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_QIconEngine_ScaledPixmapArgument_set_size(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QIconEngine::ScaledPixmapArgument *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QIconEngine_ScaledPixmapArgument_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("size");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSize_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("size", "QSize");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->size;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QIconEngine_ScaledPixmapArgument_get_mode(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QIconEngine::ScaledPixmapArgument *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QIconEngine_ScaledPixmapArgument_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QIcon::Mode cppOut_local = cppSelf->mode;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QIcon_Mode_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QIconEngine_ScaledPixmapArgument_set_mode(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QIconEngine::ScaledPixmapArgument *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QIconEngine_ScaledPixmapArgument_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("mode");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QIcon_Mode_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("mode", "Mode");
        return -1;
    }

    auto cppOut_local = cppSelf->mode;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->mode = cppOut_local;

    return 0;
}

static PyObject *Sbk_QIconEngine_ScaledPixmapArgument_get_state(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QIconEngine::ScaledPixmapArgument *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QIconEngine_ScaledPixmapArgument_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QIcon::State cppOut_local = cppSelf->state;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QIcon_State_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QIconEngine_ScaledPixmapArgument_set_state(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QIconEngine::ScaledPixmapArgument *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QIconEngine_ScaledPixmapArgument_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("state");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QIcon_State_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("state", "State");
        return -1;
    }

    auto cppOut_local = cppSelf->state;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->state = cppOut_local;

    return 0;
}

static PyObject *Sbk_QIconEngine_ScaledPixmapArgument_get_scale(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QIconEngine::ScaledPixmapArgument *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QIconEngine_ScaledPixmapArgument_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppSelf->scale);
    return pyOut;
}
static int Sbk_QIconEngine_ScaledPixmapArgument_set_scale(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QIconEngine::ScaledPixmapArgument *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QIconEngine_ScaledPixmapArgument_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("scale");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("scale", "qreal");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->scale;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QIconEngine_ScaledPixmapArgument_get_pixmap(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QIconEngine::ScaledPixmapArgument *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QIconEngine_ScaledPixmapArgument_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->pixmap)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixmap_IDX])));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->pixmap))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->pixmap)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixmap_IDX]), &(cppSelf->pixmap), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_QIconEngine_ScaledPixmapArgument_set_pixmap(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QIconEngine::ScaledPixmapArgument *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QIconEngine_ScaledPixmapArgument_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("pixmap");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPixmap_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("pixmap", "QPixmap");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->pixmap;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

// Getters and Setters for ScaledPixmapArgument
static PyGetSetDef Sbk_QIconEngine_ScaledPixmapArgument_getsetlist[] = {
    {const_cast<char *>("size"), Sbk_QIconEngine_ScaledPixmapArgument_get_size, Sbk_QIconEngine_ScaledPixmapArgument_set_size, nullptr, nullptr},
    {const_cast<char *>("mode"), Sbk_QIconEngine_ScaledPixmapArgument_get_mode, Sbk_QIconEngine_ScaledPixmapArgument_set_mode, nullptr, nullptr},
    {const_cast<char *>("state"), Sbk_QIconEngine_ScaledPixmapArgument_get_state, Sbk_QIconEngine_ScaledPixmapArgument_set_state, nullptr, nullptr},
    {const_cast<char *>("scale"), Sbk_QIconEngine_ScaledPixmapArgument_get_scale, Sbk_QIconEngine_ScaledPixmapArgument_set_scale, nullptr, nullptr},
    {const_cast<char *>("pixmap"), Sbk_QIconEngine_ScaledPixmapArgument_get_pixmap, Sbk_QIconEngine_ScaledPixmapArgument_set_pixmap, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QIconEngine_ScaledPixmapArgument_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QIconEngine_ScaledPixmapArgument_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QIconEngine_ScaledPixmapArgument_Type = nullptr;
static PyTypeObject *Sbk_QIconEngine_ScaledPixmapArgument_TypeF(void)
{
    return _Sbk_QIconEngine_ScaledPixmapArgument_Type;
}

static PyType_Slot Sbk_QIconEngine_ScaledPixmapArgument_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QIconEngine_ScaledPixmapArgument_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QIconEngine_ScaledPixmapArgument_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QIconEngine_ScaledPixmapArgument_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QIconEngine_ScaledPixmapArgument_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QIconEngine_ScaledPixmapArgument_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QIconEngine_ScaledPixmapArgument_spec = {
    "2:PySide6.QtGui.QIconEngine.ScaledPixmapArgument",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QIconEngine_ScaledPixmapArgument_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void ScaledPixmapArgument_PythonToCpp_ScaledPixmapArgument_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QIconEngine_ScaledPixmapArgument_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_ScaledPixmapArgument_PythonToCpp_ScaledPixmapArgument_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QIconEngine_ScaledPixmapArgument_TypeF()))
        return ScaledPixmapArgument_PythonToCpp_ScaledPixmapArgument_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *ScaledPixmapArgument_PTR_CppToPython_ScaledPixmapArgument(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QIconEngine::ScaledPixmapArgument *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QIconEngine_ScaledPixmapArgument_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QIconEngine_ScaledPixmapArgument_SignatureStrings[] = {
    "PySide6.QtGui.QIconEngine.ScaledPixmapArgument(self)",
    nullptr}; // Sentinel

PyTypeObject *init_QIconEngine_ScaledPixmapArgument(PyObject *enclosingClass)
{
    _Sbk_QIconEngine_ScaledPixmapArgument_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "ScaledPixmapArgument",
        "QIconEngine::ScaledPixmapArgument*",
        &Sbk_QIconEngine_ScaledPixmapArgument_spec,
        &Shiboken::callCppDestructor< ::QIconEngine::ScaledPixmapArgument >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::InnerClass);
    auto *pyType = Sbk_QIconEngine_ScaledPixmapArgument_TypeF(); // references _Sbk_QIconEngine_ScaledPixmapArgument_Type
    InitSignatureStrings(pyType, QIconEngine_ScaledPixmapArgument_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QIconEngine_ScaledPixmapArgument_PropertyStrings);
    SbkPySide6_QtGuiTypeStructs[SBK_QIconEngine_ScaledPixmapArgument_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        ScaledPixmapArgument_PythonToCpp_ScaledPixmapArgument_PTR,
        is_ScaledPixmapArgument_PythonToCpp_ScaledPixmapArgument_PTR_Convertible,
        ScaledPixmapArgument_PTR_CppToPython_ScaledPixmapArgument);

    Shiboken::Conversions::registerConverterName(converter, "QIconEngine::ScaledPixmapArgument");
    Shiboken::Conversions::registerConverterName(converter, "QIconEngine::ScaledPixmapArgument*");
    Shiboken::Conversions::registerConverterName(converter, "QIconEngine::ScaledPixmapArgument&");
    Shiboken::Conversions::registerConverterName(converter, "ScaledPixmapArgument");
    Shiboken::Conversions::registerConverterName(converter, "ScaledPixmapArgument*");
    Shiboken::Conversions::registerConverterName(converter, "ScaledPixmapArgument&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QIconEngine::ScaledPixmapArgument).name());

    qRegisterMetaType< ::QIconEngine::ScaledPixmapArgument *>();

    return pyType;
}
