// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QInputEventWrapper_H
#define SBK_QInputEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QInputEventWrapper : public QInputEvent
{
public:
    QInputEventWrapper(const QInputEventWrapper &) = delete;
    QInputEventWrapper& operator=(const QInputEventWrapper &) = delete;
    QInputEventWrapper(QInputEventWrapper &&) = delete;
    QInputEventWrapper& operator=(QInputEventWrapper &&) = delete;

    QInputEventWrapper(::QEvent::Type type, const ::QInputDevice * m_dev, ::QFlags<Qt::KeyboardModifier> modifiers = Qt::NoModifier);
    QInputEventWrapper(const QInputEvent& self) : QInputEvent(self)
    {
    }

    ::QInputEvent * clone() const override;
    void setAccepted(bool accepted) override;
    void setTimestamp(quint64 timestamp) override;
    ~QInputEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[3];
};

#endif // SBK_QInputEventWrapper_H

