// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QInputMethodEventWrapper_H
#define SBK_QInputMethodEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QInputMethodEventWrapper : public QInputMethodEvent
{
public:
    QInputMethodEventWrapper(const QInputMethodEventWrapper &) = delete;
    QInputMethodEventWrapper& operator=(const QInputMethodEventWrapper &) = delete;
    QInputMethodEventWrapper(QInputMethodEventWrapper &&) = delete;
    QInputMethodEventWrapper& operator=(QInputMethodEventWrapper &&) = delete;

    QInputMethodEventWrapper();
    QInputMethodEventWrapper(const QInputMethodEvent& self) : QInputMethodEvent(self)
    {
    }

    QInputMethodEventWrapper(const ::QString & preeditText, const ::QList<QInputMethodEvent::Attribute> & attributes);
    ::QInputMethodEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QInputMethodEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QInputMethodEventWrapper_H

