// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QPlatformSurfaceEventWrapper_H
#define SBK_QPlatformSurfaceEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QPlatformSurfaceEventWrapper : public QPlatformSurfaceEvent
{
public:
    QPlatformSurfaceEventWrapper(const QPlatformSurfaceEventWrapper &) = delete;
    QPlatformSurfaceEventWrapper& operator=(const QPlatformSurfaceEventWrapper &) = delete;
    QPlatformSurfaceEventWrapper(QPlatformSurfaceEventWrapper &&) = delete;
    QPlatformSurfaceEventWrapper& operator=(QPlatformSurfaceEventWrapper &&) = delete;

    QPlatformSurfaceEventWrapper(const QPlatformSurfaceEvent& self) : QPlatformSurfaceEvent(self)
    {
    }

    ::QPlatformSurfaceEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QPlatformSurfaceEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QPlatformSurfaceEventWrapper_H

