// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtgui_python.h"
#include "pyside6_qtgui_python_p.h"

// main header
#include "qpointingdeviceuniqueid_wrapper.h"

// Argument includes
#include <QtGui/qpointingdevice.h>
#include <qobject.h>
#include <qobjectdefs.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QPointingDeviceUniqueId_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QPointingDeviceUniqueId >()))
        return -1;

    ::QPointingDeviceUniqueId *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QPointingDeviceUniqueId.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QPointingDeviceUniqueId", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QPointingDeviceUniqueId::QPointingDeviceUniqueId()
    // 1: QPointingDeviceUniqueId::QPointingDeviceUniqueId(QPointingDeviceUniqueId)
    if (numArgs == 0) {
        overloadId = 0; // QPointingDeviceUniqueId()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPointingDeviceUniqueId_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QPointingDeviceUniqueId(QPointingDeviceUniqueId)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QPointingDeviceUniqueId()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QPointingDeviceUniqueId()
                cptr = new ::QPointingDeviceUniqueId();
            }
            break;
        }
        case 1: // QPointingDeviceUniqueId(const QPointingDeviceUniqueId & QPointingDeviceUniqueId)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QPointingDeviceUniqueId cppArg0_local;
            ::QPointingDeviceUniqueId *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QPointingDeviceUniqueId(QPointingDeviceUniqueId)
                cptr = new ::QPointingDeviceUniqueId(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QPointingDeviceUniqueId >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QPointingDeviceUniqueIdFunc_fromNumericId(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QPointingDeviceUniqueId.fromNumericId";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static QPointingDeviceUniqueId::fromNumericId(qint64)->QPointingDeviceUniqueId
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qint64>(), (pyArg)))) {
        overloadId = 0; // fromNumericId(qint64)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        qint64 cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // fromNumericId(qint64)
            QPointingDeviceUniqueId cppResult = ::QPointingDeviceUniqueId::fromNumericId(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPointingDeviceUniqueId_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPointingDeviceUniqueIdFunc_isValid(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPointingDeviceUniqueId *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPointingDeviceUniqueId_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QPointingDeviceUniqueId.isValid";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isValid()const
            bool cppResult = const_cast<const ::QPointingDeviceUniqueId *>(cppSelf)->isValid();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPointingDeviceUniqueIdFunc_numericId(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPointingDeviceUniqueId *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPointingDeviceUniqueId_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QPointingDeviceUniqueId.numericId";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // numericId()const
            qint64 cppResult = const_cast<const ::QPointingDeviceUniqueId *>(cppSelf)->numericId();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qint64>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPointingDeviceUniqueId__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QPointingDeviceUniqueId *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPointingDeviceUniqueId_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPointingDeviceUniqueId_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QPointingDeviceUniqueId_PropertyStrings[] = {
    "numericId:",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QPointingDeviceUniqueId_methods[] = {
    {"fromNumericId", reinterpret_cast<PyCFunction>(Sbk_QPointingDeviceUniqueIdFunc_fromNumericId), METH_O|METH_STATIC, nullptr},
    {"isValid", reinterpret_cast<PyCFunction>(Sbk_QPointingDeviceUniqueIdFunc_isValid), METH_NOARGS, nullptr},
    {"numericId", reinterpret_cast<PyCFunction>(Sbk_QPointingDeviceUniqueIdFunc_numericId), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QPointingDeviceUniqueId__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QPointingDeviceUniqueId_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QPointingDeviceUniqueId *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPointingDeviceUniqueId_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPointingDeviceUniqueId_IDX]), (pyArg)))) {
                // operator!=(QPointingDeviceUniqueId rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QPointingDeviceUniqueId cppArg0;
                pythonToCpp(pyArg, &cppArg0);
                bool cppResult = cppSelf != (cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPointingDeviceUniqueId_IDX]), (pyArg)))) {
                // operator==(QPointingDeviceUniqueId rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QPointingDeviceUniqueId cppArg0;
                pythonToCpp(pyArg, &cppArg0);
                bool cppResult = cppSelf == (cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static Py_hash_t Sbk_QPointingDeviceUniqueId_HashFunc(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPointingDeviceUniqueId *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPointingDeviceUniqueId_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    return Py_hash_t(qHash(*cppSelf));
}

static int Sbk_QPointingDeviceUniqueId_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QPointingDeviceUniqueId_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QPointingDeviceUniqueId_Type = nullptr;
static PyTypeObject *Sbk_QPointingDeviceUniqueId_TypeF(void)
{
    return _Sbk_QPointingDeviceUniqueId_Type;
}

static PyType_Slot Sbk_QPointingDeviceUniqueId_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_hash,        reinterpret_cast<void *>(&Sbk_QPointingDeviceUniqueId_HashFunc)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QPointingDeviceUniqueId_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QPointingDeviceUniqueId_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QPointingDeviceUniqueId_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QPointingDeviceUniqueId_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QPointingDeviceUniqueId_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QPointingDeviceUniqueId_spec = {
    "2:PySide6.QtGui.QPointingDeviceUniqueId",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QPointingDeviceUniqueId_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QPointingDeviceUniqueId_PythonToCpp_QPointingDeviceUniqueId_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QPointingDeviceUniqueId_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QPointingDeviceUniqueId_PythonToCpp_QPointingDeviceUniqueId_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QPointingDeviceUniqueId_TypeF()))
        return QPointingDeviceUniqueId_PythonToCpp_QPointingDeviceUniqueId_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QPointingDeviceUniqueId_PTR_CppToPython_QPointingDeviceUniqueId(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QPointingDeviceUniqueId *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QPointingDeviceUniqueId_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *QPointingDeviceUniqueId_COPY_CppToPython_QPointingDeviceUniqueId(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QPointingDeviceUniqueId *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QPointingDeviceUniqueId_TypeF(), new ::QPointingDeviceUniqueId(*source), true, true);
}

// Python to C++ copy conversion.
static void QPointingDeviceUniqueId_PythonToCpp_QPointingDeviceUniqueId_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QPointingDeviceUniqueId *>(cppOut) = *reinterpret_cast< ::QPointingDeviceUniqueId *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPointingDeviceUniqueId_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QPointingDeviceUniqueId_PythonToCpp_QPointingDeviceUniqueId_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QPointingDeviceUniqueId_TypeF()))
        return QPointingDeviceUniqueId_PythonToCpp_QPointingDeviceUniqueId_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QPointingDeviceUniqueId_SignatureStrings[] = {
    "1:PySide6.QtGui.QPointingDeviceUniqueId(self)",
    "0:PySide6.QtGui.QPointingDeviceUniqueId(self,QPointingDeviceUniqueId:PySide6.QtGui.QPointingDeviceUniqueId)",
    "PySide6.QtGui.QPointingDeviceUniqueId.fromNumericId(id:qint64)->PySide6.QtGui.QPointingDeviceUniqueId",
    "PySide6.QtGui.QPointingDeviceUniqueId.isValid(self)->bool",
    "PySide6.QtGui.QPointingDeviceUniqueId.numericId(self)->qint64",
    "PySide6.QtGui.QPointingDeviceUniqueId.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QPointingDeviceUniqueId(PyObject *module)
{
    _Sbk_QPointingDeviceUniqueId_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QPointingDeviceUniqueId",
        "QPointingDeviceUniqueId",
        &Sbk_QPointingDeviceUniqueId_spec,
        &Shiboken::callCppDestructor< ::QPointingDeviceUniqueId >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QPointingDeviceUniqueId_TypeF(); // references _Sbk_QPointingDeviceUniqueId_Type
    InitSignatureStrings(pyType, QPointingDeviceUniqueId_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QPointingDeviceUniqueId_PropertyStrings);
    SbkPySide6_QtGuiTypeStructs[SBK_QPointingDeviceUniqueId_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QPointingDeviceUniqueId_PythonToCpp_QPointingDeviceUniqueId_PTR,
        is_QPointingDeviceUniqueId_PythonToCpp_QPointingDeviceUniqueId_PTR_Convertible,
        QPointingDeviceUniqueId_PTR_CppToPython_QPointingDeviceUniqueId,
        QPointingDeviceUniqueId_COPY_CppToPython_QPointingDeviceUniqueId);

    Shiboken::Conversions::registerConverterName(converter, "QPointingDeviceUniqueId");
    Shiboken::Conversions::registerConverterName(converter, "QPointingDeviceUniqueId*");
    Shiboken::Conversions::registerConverterName(converter, "QPointingDeviceUniqueId&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QPointingDeviceUniqueId).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QPointingDeviceUniqueId_PythonToCpp_QPointingDeviceUniqueId_COPY,
        is_QPointingDeviceUniqueId_PythonToCpp_QPointingDeviceUniqueId_COPY_Convertible);

    qRegisterMetaType< ::QPointingDeviceUniqueId >("QPointingDeviceUniqueId");

    return pyType;
}
