// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <QtCore/QBuffer>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtgui_python.h"
#include "pyside6_qtgui_python_p.h"

// main header
#include "qrhidepthstencilclearvalue_wrapper.h"

// Argument includes
#include <rhi/qrhi.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QRhiDepthStencilClearValue_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QRhiDepthStencilClearValue >()))
        return -1;

    ::QRhiDepthStencilClearValue *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QRhiDepthStencilClearValue.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QRhiDepthStencilClearValue", 0, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QRhiDepthStencilClearValue::QRhiDepthStencilClearValue()
    // 1: QRhiDepthStencilClearValue::QRhiDepthStencilClearValue(QRhiDepthStencilClearValue)
    // 2: QRhiDepthStencilClearValue::QRhiDepthStencilClearValue(float,quint32)
    if (numArgs == 0) {
        overloadId = 0; // QRhiDepthStencilClearValue()
    } else if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<float>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), (pyArgs[1])))) {
        overloadId = 2; // QRhiDepthStencilClearValue(float,quint32)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiDepthStencilClearValue_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QRhiDepthStencilClearValue(QRhiDepthStencilClearValue)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QRhiDepthStencilClearValue()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiDepthStencilClearValue()
                cptr = new ::QRhiDepthStencilClearValue();
            }
            break;
        }
        case 1: // QRhiDepthStencilClearValue(const QRhiDepthStencilClearValue & QRhiDepthStencilClearValue)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QRhiDepthStencilClearValue cppArg0_local;
            ::QRhiDepthStencilClearValue *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiDepthStencilClearValue(QRhiDepthStencilClearValue)
                cptr = new ::QRhiDepthStencilClearValue(*cppArg0);
            }
            break;
        }
        case 2: // QRhiDepthStencilClearValue(float d, quint32 s)
        {
            float cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            quint32 cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiDepthStencilClearValue(float,quint32)
                cptr = new ::QRhiDepthStencilClearValue(cppArg0, cppArg1);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QRhiDepthStencilClearValue >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QRhiDepthStencilClearValueFunc_depthClearValue(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiDepthStencilClearValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiDepthStencilClearValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QRhiDepthStencilClearValue.depthClearValue";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // depthClearValue()const
            float cppResult = const_cast<const ::QRhiDepthStencilClearValue *>(cppSelf)->depthClearValue();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<float>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiDepthStencilClearValueFunc_setDepthClearValue(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiDepthStencilClearValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiDepthStencilClearValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QRhiDepthStencilClearValue.setDepthClearValue";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiDepthStencilClearValue::setDepthClearValue(float)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<float>(), (pyArg)))) {
        overloadId = 0; // setDepthClearValue(float)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        float cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setDepthClearValue(float)
            cppSelf->setDepthClearValue(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiDepthStencilClearValueFunc_setStencilClearValue(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiDepthStencilClearValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiDepthStencilClearValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QRhiDepthStencilClearValue.setStencilClearValue";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiDepthStencilClearValue::setStencilClearValue(quint32)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), (pyArg)))) {
        overloadId = 0; // setStencilClearValue(quint32)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        quint32 cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setStencilClearValue(quint32)
            cppSelf->setStencilClearValue(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiDepthStencilClearValueFunc_stencilClearValue(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiDepthStencilClearValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiDepthStencilClearValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QRhiDepthStencilClearValue.stencilClearValue";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // stencilClearValue()const
            quint32 cppResult = const_cast<const ::QRhiDepthStencilClearValue *>(cppSelf)->stencilClearValue();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiDepthStencilClearValue__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QRhiDepthStencilClearValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiDepthStencilClearValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiDepthStencilClearValue_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QRhiDepthStencilClearValue_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QRhiDepthStencilClearValue_methods[] = {
    {"depthClearValue", reinterpret_cast<PyCFunction>(Sbk_QRhiDepthStencilClearValueFunc_depthClearValue), METH_NOARGS, nullptr},
    {"setDepthClearValue", reinterpret_cast<PyCFunction>(Sbk_QRhiDepthStencilClearValueFunc_setDepthClearValue), METH_O, nullptr},
    {"setStencilClearValue", reinterpret_cast<PyCFunction>(Sbk_QRhiDepthStencilClearValueFunc_setStencilClearValue), METH_O, nullptr},
    {"stencilClearValue", reinterpret_cast<PyCFunction>(Sbk_QRhiDepthStencilClearValueFunc_stencilClearValue), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QRhiDepthStencilClearValue__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QRhiDepthStencilClearValue_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QRhiDepthStencilClearValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiDepthStencilClearValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiDepthStencilClearValue_IDX]), (pyArg)))) {
                // operator!=(const QRhiDepthStencilClearValue & b)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QRhiDepthStencilClearValue cppArg0_local;
                ::QRhiDepthStencilClearValue *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiDepthStencilClearValue_IDX]), (pyArg)))) {
                // operator==(const QRhiDepthStencilClearValue & b)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QRhiDepthStencilClearValue cppArg0_local;
                ::QRhiDepthStencilClearValue *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static Py_hash_t Sbk_QRhiDepthStencilClearValue_HashFunc(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiDepthStencilClearValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiDepthStencilClearValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    return Py_hash_t(qHash(*cppSelf));
}

static int Sbk_QRhiDepthStencilClearValue_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QRhiDepthStencilClearValue_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
extern "C"
{
static PyObject *Sbk_QRhiDepthStencilClearValue__repr__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiDepthStencilClearValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiDepthStencilClearValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    QBuffer buffer;
    buffer.open(QBuffer::ReadWrite);
    QDebug dbg(&buffer);
    dbg << *cppSelf;
    buffer.close();
    QByteArray str = buffer.data();
    const auto idx = str.indexOf('(');
    auto *typeName = Py_TYPE(self)->tp_name;
    if (idx >= 0)
        str.replace(0, idx, typeName);
    str = str.trimmed();
    Shiboken::AutoDecRef tpDict(PepType_GetDict(Py_TYPE(self)));
    PyObject *mod = PyDict_GetItem(tpDict.object(), Shiboken::PyMagicName::module());
    if (mod != nullptr && std::strchr(typeName, '.') == nullptr)
        return Shiboken::String::fromFormat("<%s.%s at %p>", Shiboken::String::toCString(mod), str.constData(), self);
    return Shiboken::String::fromFormat("<%s at %p>", str.constData(), self);
}
} // extern C

// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QRhiDepthStencilClearValue_Type = nullptr;
static PyTypeObject *Sbk_QRhiDepthStencilClearValue_TypeF(void)
{
    return _Sbk_QRhiDepthStencilClearValue_Type;
}

static PyType_Slot Sbk_QRhiDepthStencilClearValue_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_repr,        reinterpret_cast<void *>(Sbk_QRhiDepthStencilClearValue__repr__)},
    {Py_tp_hash,        reinterpret_cast<void *>(&Sbk_QRhiDepthStencilClearValue_HashFunc)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QRhiDepthStencilClearValue_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QRhiDepthStencilClearValue_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QRhiDepthStencilClearValue_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QRhiDepthStencilClearValue_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QRhiDepthStencilClearValue_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QRhiDepthStencilClearValue_spec = {
    "2:PySide6.QtGui.QRhiDepthStencilClearValue",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QRhiDepthStencilClearValue_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QRhiDepthStencilClearValue_PythonToCpp_QRhiDepthStencilClearValue_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QRhiDepthStencilClearValue_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QRhiDepthStencilClearValue_PythonToCpp_QRhiDepthStencilClearValue_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiDepthStencilClearValue_TypeF()))
        return QRhiDepthStencilClearValue_PythonToCpp_QRhiDepthStencilClearValue_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QRhiDepthStencilClearValue_PTR_CppToPython_QRhiDepthStencilClearValue(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QRhiDepthStencilClearValue *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QRhiDepthStencilClearValue_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *QRhiDepthStencilClearValue_COPY_CppToPython_QRhiDepthStencilClearValue(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QRhiDepthStencilClearValue *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QRhiDepthStencilClearValue_TypeF(), new ::QRhiDepthStencilClearValue(*source), true, true);
}

// Python to C++ copy conversion.
static void QRhiDepthStencilClearValue_PythonToCpp_QRhiDepthStencilClearValue_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QRhiDepthStencilClearValue *>(cppOut) = *reinterpret_cast< ::QRhiDepthStencilClearValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiDepthStencilClearValue_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QRhiDepthStencilClearValue_PythonToCpp_QRhiDepthStencilClearValue_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiDepthStencilClearValue_TypeF()))
        return QRhiDepthStencilClearValue_PythonToCpp_QRhiDepthStencilClearValue_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QRhiDepthStencilClearValue_SignatureStrings[] = {
    "2:PySide6.QtGui.QRhiDepthStencilClearValue(self)",
    "1:PySide6.QtGui.QRhiDepthStencilClearValue(self,QRhiDepthStencilClearValue:PySide6.QtGui.QRhiDepthStencilClearValue)",
    "0:PySide6.QtGui.QRhiDepthStencilClearValue(self,d:float,s:quint32)",
    "PySide6.QtGui.QRhiDepthStencilClearValue.depthClearValue(self)->float",
    "PySide6.QtGui.QRhiDepthStencilClearValue.setDepthClearValue(self,d:float)",
    "PySide6.QtGui.QRhiDepthStencilClearValue.setStencilClearValue(self,s:quint32)",
    "PySide6.QtGui.QRhiDepthStencilClearValue.stencilClearValue(self)->quint32",
    "PySide6.QtGui.QRhiDepthStencilClearValue.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QRhiDepthStencilClearValue(PyObject *module)
{
    _Sbk_QRhiDepthStencilClearValue_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QRhiDepthStencilClearValue",
        "QRhiDepthStencilClearValue",
        &Sbk_QRhiDepthStencilClearValue_spec,
        &Shiboken::callCppDestructor< ::QRhiDepthStencilClearValue >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QRhiDepthStencilClearValue_TypeF(); // references _Sbk_QRhiDepthStencilClearValue_Type
    InitSignatureStrings(pyType, QRhiDepthStencilClearValue_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QRhiDepthStencilClearValue_PropertyStrings);
    SbkPySide6_QtGuiTypeStructs[SBK_QRhiDepthStencilClearValue_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QRhiDepthStencilClearValue_PythonToCpp_QRhiDepthStencilClearValue_PTR,
        is_QRhiDepthStencilClearValue_PythonToCpp_QRhiDepthStencilClearValue_PTR_Convertible,
        QRhiDepthStencilClearValue_PTR_CppToPython_QRhiDepthStencilClearValue,
        QRhiDepthStencilClearValue_COPY_CppToPython_QRhiDepthStencilClearValue);

    Shiboken::Conversions::registerConverterName(converter, "QRhiDepthStencilClearValue");
    Shiboken::Conversions::registerConverterName(converter, "QRhiDepthStencilClearValue*");
    Shiboken::Conversions::registerConverterName(converter, "QRhiDepthStencilClearValue&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QRhiDepthStencilClearValue).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QRhiDepthStencilClearValue_PythonToCpp_QRhiDepthStencilClearValue_COPY,
        is_QRhiDepthStencilClearValue_PythonToCpp_QRhiDepthStencilClearValue_COPY_Convertible);

    qRegisterMetaType< ::QRhiDepthStencilClearValue >("QRhiDepthStencilClearValue");

    return pyType;
}
