// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtgui_python.h"
#include "pyside6_qtgui_python_p.h"

// main header
#include "qrhigles2initparams_wrapper.h"

// Argument includes
#include <QtGui/qoffscreensurface.h>
#include <QtGui/qsurfaceformat.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QRhiGles2InitParams_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QRhiGles2InitParams >()))
        return -1;

    ::QRhiGles2InitParams *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QRhiGles2InitParams.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QRhiGles2InitParams", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QRhiGles2InitParams::QRhiGles2InitParams()
    // 1: QRhiGles2InitParams::QRhiGles2InitParams(QRhiGles2InitParams)
    if (numArgs == 0) {
        overloadId = 0; // QRhiGles2InitParams()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGles2InitParams_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QRhiGles2InitParams(QRhiGles2InitParams)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QRhiGles2InitParams()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiGles2InitParams()
                cptr = new ::QRhiGles2InitParams();
            }
            break;
        }
        case 1: // QRhiGles2InitParams(const QRhiGles2InitParams & QRhiGles2InitParams)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QRhiGles2InitParams cppArg0_local;
            ::QRhiGles2InitParams *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiGles2InitParams(QRhiGles2InitParams)
                cptr = new ::QRhiGles2InitParams(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QRhiGles2InitParams >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QRhiGles2InitParamsFunc_newFallbackSurface(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(self)
    SBK_UNUSED(kwds)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QRhiGles2InitParams.newFallbackSurface";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 0, 1));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|O:newFallbackSurface", &(pyArgs[0])) == 0)
        return {};


    // Overloaded function decisor
    // 0: static QRhiGles2InitParams::newFallbackSurface(const QSurfaceFormat&=)->QOffscreenSurface*
    if (numArgs == 0) {
        overloadId = 0; // newFallbackSurface(QSurfaceFormat)
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QSurfaceFormat_IDX]), (pyArgs[0])))) {
        overloadId = 0; // newFallbackSurface(QSurfaceFormat)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_format = Shiboken::String::createStaticString("format");
            if (PyDict_Contains(kwds, key_format) != 0) {
                value = PyDict_GetItem(kwds, key_format);
                if (value != nullptr && pyArgs[0] != nullptr ) {
                    errInfo.reset(key_format);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                if (value != nullptr) {
                    pyArgs[0] = value;
                    if (!(pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QSurfaceFormat_IDX]), (pyArgs[0]))))
                        return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                PyDict_DelItem(kwds_dup, key_format);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments(args, fullName, errInfo);
            }
        }
        if (!Shiboken::Object::isValid(pyArgs[0]))
            return {};
        ::QSurfaceFormat cppArg0_local = QSurfaceFormat::defaultFormat();
        ::QSurfaceFormat *cppArg0 = &cppArg0_local;
        if (pythonToCpp[0]) {
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);
            }

        if (Shiboken::Errors::occurred() == nullptr) {
            // newFallbackSurface(QSurfaceFormat)
            QOffscreenSurface * cppResult = ::QRhiGles2InitParams::newFallbackSurface(*cppArg0);
            pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QOffscreenSurface_IDX]), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiGles2InitParams__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QRhiGles2InitParams *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGles2InitParams_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGles2InitParams_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QRhiGles2InitParams_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QRhiGles2InitParams_methods[] = {
    {"newFallbackSurface", reinterpret_cast<PyCFunction>(Sbk_QRhiGles2InitParamsFunc_newFallbackSurface), METH_VARARGS|METH_KEYWORDS|METH_STATIC, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QRhiGles2InitParams__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QRhiGles2InitParams_get_format(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiGles2InitParams *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGles2InitParams_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->format)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QSurfaceFormat_IDX])));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->format))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->format)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QSurfaceFormat_IDX]), &(cppSelf->format), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_QRhiGles2InitParams_set_format(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QRhiGles2InitParams *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGles2InitParams_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("format");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QSurfaceFormat_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("format", "QSurfaceFormat");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->format;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QRhiGles2InitParams_get_fallbackSurface(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiGles2InitParams *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGles2InitParams_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QSurface_IDX]), cppSelf->fallbackSurface);
    return pyOut;
}
static int Sbk_QRhiGles2InitParams_set_fallbackSurface(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QRhiGles2InitParams *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGles2InitParams_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("fallbackSurface");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QSurface_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("fallbackSurface", "QSurface");
        return -1;
    }

    auto *&cppOut_ptr = cppSelf->fallbackSurface;
    pythonToCpp(pyIn, &cppOut_ptr);

    Shiboken::Object::keepReference(reinterpret_cast<SbkObject *>(self), "fallbackSurface", pyIn);
    return 0;
}

static PyObject *Sbk_QRhiGles2InitParams_get_window(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiGles2InitParams *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGles2InitParams_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QWindow_IDX]), cppSelf->window);
    return pyOut;
}
static int Sbk_QRhiGles2InitParams_set_window(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QRhiGles2InitParams *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGles2InitParams_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("window");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QWindow_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("window", "QWindow");
        return -1;
    }

    auto *&cppOut_ptr = cppSelf->window;
    pythonToCpp(pyIn, &cppOut_ptr);

    Shiboken::Object::keepReference(reinterpret_cast<SbkObject *>(self), "window", pyIn);
    return 0;
}

static PyObject *Sbk_QRhiGles2InitParams_get_shareContext(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiGles2InitParams *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGles2InitParams_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QOpenGLContext_IDX]), cppSelf->shareContext);
    return pyOut;
}
static int Sbk_QRhiGles2InitParams_set_shareContext(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QRhiGles2InitParams *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGles2InitParams_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("shareContext");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QOpenGLContext_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("shareContext", "QOpenGLContext");
        return -1;
    }

    auto *&cppOut_ptr = cppSelf->shareContext;
    pythonToCpp(pyIn, &cppOut_ptr);

    Shiboken::Object::keepReference(reinterpret_cast<SbkObject *>(self), "shareContext", pyIn);
    return 0;
}

// Getters and Setters for QRhiGles2InitParams
static PyGetSetDef Sbk_QRhiGles2InitParams_getsetlist[] = {
    {const_cast<char *>("format"), Sbk_QRhiGles2InitParams_get_format, Sbk_QRhiGles2InitParams_set_format, nullptr, nullptr},
    {const_cast<char *>("fallbackSurface"), Sbk_QRhiGles2InitParams_get_fallbackSurface, Sbk_QRhiGles2InitParams_set_fallbackSurface, nullptr, nullptr},
    {const_cast<char *>("window"), Sbk_QRhiGles2InitParams_get_window, Sbk_QRhiGles2InitParams_set_window, nullptr, nullptr},
    {const_cast<char *>("shareContext"), Sbk_QRhiGles2InitParams_get_shareContext, Sbk_QRhiGles2InitParams_set_shareContext, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QRhiGles2InitParams_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QRhiGles2InitParams_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QRhiGles2InitParams_Type = nullptr;
static PyTypeObject *Sbk_QRhiGles2InitParams_TypeF(void)
{
    return _Sbk_QRhiGles2InitParams_Type;
}

static PyType_Slot Sbk_QRhiGles2InitParams_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QRhiGles2InitParams_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QRhiGles2InitParams_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QRhiGles2InitParams_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QRhiGles2InitParams_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QRhiGles2InitParams_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QRhiGles2InitParams_spec = {
    "2:PySide6.QtGui.QRhiGles2InitParams",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QRhiGles2InitParams_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QRhiGles2InitParams_PythonToCpp_QRhiGles2InitParams_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QRhiGles2InitParams_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QRhiGles2InitParams_PythonToCpp_QRhiGles2InitParams_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiGles2InitParams_TypeF()))
        return QRhiGles2InitParams_PythonToCpp_QRhiGles2InitParams_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QRhiGles2InitParams_PTR_CppToPython_QRhiGles2InitParams(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QRhiGles2InitParams *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QRhiGles2InitParams_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *QRhiGles2InitParams_COPY_CppToPython_QRhiGles2InitParams(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QRhiGles2InitParams *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QRhiGles2InitParams_TypeF(), new ::QRhiGles2InitParams(*source), true, true);
}

// Python to C++ copy conversion.
static void QRhiGles2InitParams_PythonToCpp_QRhiGles2InitParams_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QRhiGles2InitParams *>(cppOut) = *reinterpret_cast< ::QRhiGles2InitParams *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGles2InitParams_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QRhiGles2InitParams_PythonToCpp_QRhiGles2InitParams_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiGles2InitParams_TypeF()))
        return QRhiGles2InitParams_PythonToCpp_QRhiGles2InitParams_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QRhiGles2InitParams_SignatureStrings[] = {
    "1:PySide6.QtGui.QRhiGles2InitParams(self)",
    "0:PySide6.QtGui.QRhiGles2InitParams(self,QRhiGles2InitParams:PySide6.QtGui.QRhiGles2InitParams)",
    "PySide6.QtGui.QRhiGles2InitParams.newFallbackSurface(format:typing.Union[PySide6.QtGui.QSurfaceFormat, PySide6.QtGui.QSurfaceFormat.FormatOption]=QSurfaceFormat.defaultFormat())->PySide6.QtGui.QOffscreenSurface",
    "PySide6.QtGui.QRhiGles2InitParams.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QRhiGles2InitParams(PyObject *module)
{
    _Sbk_QRhiGles2InitParams_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QRhiGles2InitParams",
        "QRhiGles2InitParams",
        &Sbk_QRhiGles2InitParams_spec,
        &Shiboken::callCppDestructor< ::QRhiGles2InitParams >,
        Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiInitParams_IDX]),
        0,
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QRhiGles2InitParams_TypeF(); // references _Sbk_QRhiGles2InitParams_Type
    InitSignatureStrings(pyType, QRhiGles2InitParams_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QRhiGles2InitParams_PropertyStrings);
    SbkPySide6_QtGuiTypeStructs[SBK_QRhiGles2InitParams_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QRhiGles2InitParams_PythonToCpp_QRhiGles2InitParams_PTR,
        is_QRhiGles2InitParams_PythonToCpp_QRhiGles2InitParams_PTR_Convertible,
        QRhiGles2InitParams_PTR_CppToPython_QRhiGles2InitParams,
        QRhiGles2InitParams_COPY_CppToPython_QRhiGles2InitParams);

    Shiboken::Conversions::registerConverterName(converter, "QRhiGles2InitParams");
    Shiboken::Conversions::registerConverterName(converter, "QRhiGles2InitParams*");
    Shiboken::Conversions::registerConverterName(converter, "QRhiGles2InitParams&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QRhiGles2InitParams).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QRhiGles2InitParams_PythonToCpp_QRhiGles2InitParams_COPY,
        is_QRhiGles2InitParams_PythonToCpp_QRhiGles2InitParams_COPY_Convertible);

    qRegisterMetaType< ::QRhiGles2InitParams >("QRhiGles2InitParams");

    return pyType;
}
