// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtgui_python.h"
#include "pyside6_qtgui_python_p.h"

// main header
#include "qrhigraphicspipeline_targetblend_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QRhiGraphicsPipeline_TargetBlend_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QRhiGraphicsPipeline::TargetBlend >()))
        return -1;

    ::QRhiGraphicsPipeline::TargetBlend *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QRhiGraphicsPipeline.TargetBlend.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "TargetBlend", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: TargetBlend::TargetBlend()
    // 1: TargetBlend::TargetBlend(QRhiGraphicsPipeline::TargetBlend)
    if (numArgs == 0) {
        overloadId = 0; // TargetBlend()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_TargetBlend_IDX]), (pyArgs[0])))) {
        overloadId = 1; // TargetBlend(QRhiGraphicsPipeline::TargetBlend)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // TargetBlend()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // TargetBlend()
                cptr = new ::QRhiGraphicsPipeline::TargetBlend();
            }
            break;
        }
        case 1: // TargetBlend(const QRhiGraphicsPipeline::TargetBlend & TargetBlend)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QRhiGraphicsPipeline::TargetBlend cppArg0_local;
            ::QRhiGraphicsPipeline::TargetBlend *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // TargetBlend(QRhiGraphicsPipeline::TargetBlend)
                cptr = new ::QRhiGraphicsPipeline::TargetBlend(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QRhiGraphicsPipeline::TargetBlend >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QRhiGraphicsPipeline_TargetBlend__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QRhiGraphicsPipeline::TargetBlend *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_TargetBlend_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_TargetBlend_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QRhiGraphicsPipeline_TargetBlend_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QRhiGraphicsPipeline_TargetBlend_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QRhiGraphicsPipeline_TargetBlend__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QRhiGraphicsPipeline_TargetBlend_get_colorWrite(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiGraphicsPipeline::TargetBlend *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_TargetBlend_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFlags_QRhiGraphicsPipeline_ColorMaskComponent_IDX])))->converter, &cppSelf->colorWrite);
    return pyOut;
}
static int Sbk_QRhiGraphicsPipeline_TargetBlend_set_colorWrite(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QRhiGraphicsPipeline::TargetBlend *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_TargetBlend_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("colorWrite");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFlags_QRhiGraphicsPipeline_ColorMaskComponent_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("colorWrite", "ColorMask");
        return -1;
    }

    auto cppOut_local = cppSelf->colorWrite;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->colorWrite = cppOut_local;

    return 0;
}

static PyObject *Sbk_QRhiGraphicsPipeline_TargetBlend_get_enable(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiGraphicsPipeline::TargetBlend *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_TargetBlend_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->enable;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QRhiGraphicsPipeline_TargetBlend_set_enable(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QRhiGraphicsPipeline::TargetBlend *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_TargetBlend_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("enable");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("enable", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->enable;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->enable = cppOut_local;

    return 0;
}

static PyObject *Sbk_QRhiGraphicsPipeline_TargetBlend_get_srcColor(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiGraphicsPipeline::TargetBlend *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_TargetBlend_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QRhiGraphicsPipeline::BlendFactor cppOut_local = cppSelf->srcColor;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_BlendFactor_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QRhiGraphicsPipeline_TargetBlend_set_srcColor(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QRhiGraphicsPipeline::TargetBlend *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_TargetBlend_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("srcColor");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_BlendFactor_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("srcColor", "BlendFactor");
        return -1;
    }

    auto cppOut_local = cppSelf->srcColor;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->srcColor = cppOut_local;

    return 0;
}

static PyObject *Sbk_QRhiGraphicsPipeline_TargetBlend_get_dstColor(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiGraphicsPipeline::TargetBlend *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_TargetBlend_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QRhiGraphicsPipeline::BlendFactor cppOut_local = cppSelf->dstColor;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_BlendFactor_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QRhiGraphicsPipeline_TargetBlend_set_dstColor(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QRhiGraphicsPipeline::TargetBlend *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_TargetBlend_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("dstColor");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_BlendFactor_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("dstColor", "BlendFactor");
        return -1;
    }

    auto cppOut_local = cppSelf->dstColor;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->dstColor = cppOut_local;

    return 0;
}

static PyObject *Sbk_QRhiGraphicsPipeline_TargetBlend_get_opColor(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiGraphicsPipeline::TargetBlend *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_TargetBlend_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QRhiGraphicsPipeline::BlendOp cppOut_local = cppSelf->opColor;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_BlendOp_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QRhiGraphicsPipeline_TargetBlend_set_opColor(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QRhiGraphicsPipeline::TargetBlend *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_TargetBlend_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("opColor");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_BlendOp_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("opColor", "BlendOp");
        return -1;
    }

    auto cppOut_local = cppSelf->opColor;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->opColor = cppOut_local;

    return 0;
}

static PyObject *Sbk_QRhiGraphicsPipeline_TargetBlend_get_srcAlpha(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiGraphicsPipeline::TargetBlend *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_TargetBlend_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QRhiGraphicsPipeline::BlendFactor cppOut_local = cppSelf->srcAlpha;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_BlendFactor_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QRhiGraphicsPipeline_TargetBlend_set_srcAlpha(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QRhiGraphicsPipeline::TargetBlend *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_TargetBlend_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("srcAlpha");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_BlendFactor_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("srcAlpha", "BlendFactor");
        return -1;
    }

    auto cppOut_local = cppSelf->srcAlpha;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->srcAlpha = cppOut_local;

    return 0;
}

static PyObject *Sbk_QRhiGraphicsPipeline_TargetBlend_get_dstAlpha(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiGraphicsPipeline::TargetBlend *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_TargetBlend_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QRhiGraphicsPipeline::BlendFactor cppOut_local = cppSelf->dstAlpha;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_BlendFactor_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QRhiGraphicsPipeline_TargetBlend_set_dstAlpha(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QRhiGraphicsPipeline::TargetBlend *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_TargetBlend_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("dstAlpha");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_BlendFactor_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("dstAlpha", "BlendFactor");
        return -1;
    }

    auto cppOut_local = cppSelf->dstAlpha;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->dstAlpha = cppOut_local;

    return 0;
}

static PyObject *Sbk_QRhiGraphicsPipeline_TargetBlend_get_opAlpha(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiGraphicsPipeline::TargetBlend *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_TargetBlend_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QRhiGraphicsPipeline::BlendOp cppOut_local = cppSelf->opAlpha;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_BlendOp_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QRhiGraphicsPipeline_TargetBlend_set_opAlpha(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QRhiGraphicsPipeline::TargetBlend *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_TargetBlend_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("opAlpha");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_BlendOp_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("opAlpha", "BlendOp");
        return -1;
    }

    auto cppOut_local = cppSelf->opAlpha;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->opAlpha = cppOut_local;

    return 0;
}

// Getters and Setters for TargetBlend
static PyGetSetDef Sbk_QRhiGraphicsPipeline_TargetBlend_getsetlist[] = {
    {const_cast<char *>("colorWrite"), Sbk_QRhiGraphicsPipeline_TargetBlend_get_colorWrite, Sbk_QRhiGraphicsPipeline_TargetBlend_set_colorWrite, nullptr, nullptr},
    {const_cast<char *>("enable"), Sbk_QRhiGraphicsPipeline_TargetBlend_get_enable, Sbk_QRhiGraphicsPipeline_TargetBlend_set_enable, nullptr, nullptr},
    {const_cast<char *>("srcColor"), Sbk_QRhiGraphicsPipeline_TargetBlend_get_srcColor, Sbk_QRhiGraphicsPipeline_TargetBlend_set_srcColor, nullptr, nullptr},
    {const_cast<char *>("dstColor"), Sbk_QRhiGraphicsPipeline_TargetBlend_get_dstColor, Sbk_QRhiGraphicsPipeline_TargetBlend_set_dstColor, nullptr, nullptr},
    {const_cast<char *>("opColor"), Sbk_QRhiGraphicsPipeline_TargetBlend_get_opColor, Sbk_QRhiGraphicsPipeline_TargetBlend_set_opColor, nullptr, nullptr},
    {const_cast<char *>("srcAlpha"), Sbk_QRhiGraphicsPipeline_TargetBlend_get_srcAlpha, Sbk_QRhiGraphicsPipeline_TargetBlend_set_srcAlpha, nullptr, nullptr},
    {const_cast<char *>("dstAlpha"), Sbk_QRhiGraphicsPipeline_TargetBlend_get_dstAlpha, Sbk_QRhiGraphicsPipeline_TargetBlend_set_dstAlpha, nullptr, nullptr},
    {const_cast<char *>("opAlpha"), Sbk_QRhiGraphicsPipeline_TargetBlend_get_opAlpha, Sbk_QRhiGraphicsPipeline_TargetBlend_set_opAlpha, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QRhiGraphicsPipeline_TargetBlend_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QRhiGraphicsPipeline_TargetBlend_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QRhiGraphicsPipeline_TargetBlend_Type = nullptr;
static PyTypeObject *Sbk_QRhiGraphicsPipeline_TargetBlend_TypeF(void)
{
    return _Sbk_QRhiGraphicsPipeline_TargetBlend_Type;
}

static PyType_Slot Sbk_QRhiGraphicsPipeline_TargetBlend_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QRhiGraphicsPipeline_TargetBlend_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QRhiGraphicsPipeline_TargetBlend_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QRhiGraphicsPipeline_TargetBlend_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QRhiGraphicsPipeline_TargetBlend_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QRhiGraphicsPipeline_TargetBlend_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QRhiGraphicsPipeline_TargetBlend_spec = {
    "2:PySide6.QtGui.QRhiGraphicsPipeline.TargetBlend",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QRhiGraphicsPipeline_TargetBlend_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void TargetBlend_PythonToCpp_TargetBlend_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QRhiGraphicsPipeline_TargetBlend_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_TargetBlend_PythonToCpp_TargetBlend_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiGraphicsPipeline_TargetBlend_TypeF()))
        return TargetBlend_PythonToCpp_TargetBlend_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *TargetBlend_PTR_CppToPython_TargetBlend(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QRhiGraphicsPipeline::TargetBlend *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QRhiGraphicsPipeline_TargetBlend_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *TargetBlend_COPY_CppToPython_TargetBlend(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QRhiGraphicsPipeline::TargetBlend *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QRhiGraphicsPipeline_TargetBlend_TypeF(), new ::QRhiGraphicsPipeline::TargetBlend(*source), true, true);
}

// Python to C++ copy conversion.
static void TargetBlend_PythonToCpp_TargetBlend_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QRhiGraphicsPipeline::TargetBlend *>(cppOut) = *reinterpret_cast< ::QRhiGraphicsPipeline::TargetBlend *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_TargetBlend_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_TargetBlend_PythonToCpp_TargetBlend_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiGraphicsPipeline_TargetBlend_TypeF()))
        return TargetBlend_PythonToCpp_TargetBlend_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QRhiGraphicsPipeline_TargetBlend_SignatureStrings[] = {
    "1:PySide6.QtGui.QRhiGraphicsPipeline.TargetBlend(self)",
    "0:PySide6.QtGui.QRhiGraphicsPipeline.TargetBlend(self,TargetBlend:PySide6.QtGui.QRhiGraphicsPipeline.TargetBlend)",
    "PySide6.QtGui.QRhiGraphicsPipeline.TargetBlend.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QRhiGraphicsPipeline_TargetBlend(PyObject *enclosingClass)
{
    _Sbk_QRhiGraphicsPipeline_TargetBlend_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "TargetBlend",
        "QRhiGraphicsPipeline::TargetBlend",
        &Sbk_QRhiGraphicsPipeline_TargetBlend_spec,
        &Shiboken::callCppDestructor< ::QRhiGraphicsPipeline::TargetBlend >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QRhiGraphicsPipeline_TargetBlend_TypeF(); // references _Sbk_QRhiGraphicsPipeline_TargetBlend_Type
    InitSignatureStrings(pyType, QRhiGraphicsPipeline_TargetBlend_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QRhiGraphicsPipeline_TargetBlend_PropertyStrings);
    SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_TargetBlend_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        TargetBlend_PythonToCpp_TargetBlend_PTR,
        is_TargetBlend_PythonToCpp_TargetBlend_PTR_Convertible,
        TargetBlend_PTR_CppToPython_TargetBlend,
        TargetBlend_COPY_CppToPython_TargetBlend);

    Shiboken::Conversions::registerConverterName(converter, "QRhiGraphicsPipeline::TargetBlend");
    Shiboken::Conversions::registerConverterName(converter, "QRhiGraphicsPipeline::TargetBlend*");
    Shiboken::Conversions::registerConverterName(converter, "QRhiGraphicsPipeline::TargetBlend&");
    Shiboken::Conversions::registerConverterName(converter, "TargetBlend");
    Shiboken::Conversions::registerConverterName(converter, "TargetBlend*");
    Shiboken::Conversions::registerConverterName(converter, "TargetBlend&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QRhiGraphicsPipeline::TargetBlend).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        TargetBlend_PythonToCpp_TargetBlend_COPY,
        is_TargetBlend_PythonToCpp_TargetBlend_COPY_Convertible);

    qRegisterMetaType< ::QRhiGraphicsPipeline::TargetBlend >("TargetBlend");
    qRegisterMetaType< ::QRhiGraphicsPipeline::TargetBlend >("QRhiGraphicsPipeline::TargetBlend");

    return pyType;
}
