// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QRhiGraphicsPipelineWrapper_H
#define SBK_QRhiGraphicsPipelineWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <rhi/qrhi.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QRhiGraphicsPipelineWrapper : public QRhiGraphicsPipeline
{
public:
    QRhiGraphicsPipelineWrapper(const QRhiGraphicsPipelineWrapper &) = delete;
    QRhiGraphicsPipelineWrapper& operator=(const QRhiGraphicsPipelineWrapper &) = delete;
    QRhiGraphicsPipelineWrapper(QRhiGraphicsPipelineWrapper &&) = delete;
    QRhiGraphicsPipelineWrapper& operator=(QRhiGraphicsPipelineWrapper &&) = delete;

    bool create() override;
    void destroy() override;
    ::QRhiResource::Type resourceType() const override;
    ~QRhiGraphicsPipelineWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[3];
};

#endif // SBK_QRhiGraphicsPipelineWrapper_H

