// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtgui_python.h"
#include "pyside6_qtgui_python_p.h"

// main header
#include "qrhiinitparams_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QRhiInitParams_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QRhiInitParams >()))
        return -1;

    ::QRhiInitParams *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QRhiInitParams.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QRhiInitParams", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QRhiInitParams::QRhiInitParams()
    // 1: QRhiInitParams::QRhiInitParams(QRhiInitParams)
    if (numArgs == 0) {
        overloadId = 0; // QRhiInitParams()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiInitParams_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QRhiInitParams(QRhiInitParams)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QRhiInitParams()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiInitParams()
                cptr = new ::QRhiInitParams();
            }
            break;
        }
        case 1: // QRhiInitParams(const QRhiInitParams & QRhiInitParams)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QRhiInitParams cppArg0_local;
            ::QRhiInitParams *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiInitParams(QRhiInitParams)
                cptr = new ::QRhiInitParams(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QRhiInitParams >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QRhiInitParams__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QRhiInitParams *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiInitParams_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiInitParams_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QRhiInitParams_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QRhiInitParams_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QRhiInitParams__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QRhiInitParams_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QRhiInitParams_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QRhiInitParams_Type = nullptr;
static PyTypeObject *Sbk_QRhiInitParams_TypeF(void)
{
    return _Sbk_QRhiInitParams_Type;
}

static PyType_Slot Sbk_QRhiInitParams_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QRhiInitParams_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QRhiInitParams_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QRhiInitParams_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QRhiInitParams_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QRhiInitParams_spec = {
    "2:PySide6.QtGui.QRhiInitParams",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QRhiInitParams_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QRhiInitParams_PythonToCpp_QRhiInitParams_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QRhiInitParams_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QRhiInitParams_PythonToCpp_QRhiInitParams_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiInitParams_TypeF()))
        return QRhiInitParams_PythonToCpp_QRhiInitParams_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QRhiInitParams_PTR_CppToPython_QRhiInitParams(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QRhiInitParams *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QRhiInitParams_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *QRhiInitParams_COPY_CppToPython_QRhiInitParams(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QRhiInitParams *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QRhiInitParams_TypeF(), new ::QRhiInitParams(*source), true, true);
}

// Python to C++ copy conversion.
static void QRhiInitParams_PythonToCpp_QRhiInitParams_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QRhiInitParams *>(cppOut) = *reinterpret_cast< ::QRhiInitParams *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiInitParams_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QRhiInitParams_PythonToCpp_QRhiInitParams_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiInitParams_TypeF()))
        return QRhiInitParams_PythonToCpp_QRhiInitParams_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QRhiInitParams_SignatureStrings[] = {
    "1:PySide6.QtGui.QRhiInitParams(self)",
    "0:PySide6.QtGui.QRhiInitParams(self,QRhiInitParams:PySide6.QtGui.QRhiInitParams)",
    "PySide6.QtGui.QRhiInitParams.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QRhiInitParams(PyObject *module)
{
    _Sbk_QRhiInitParams_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QRhiInitParams",
        "QRhiInitParams",
        &Sbk_QRhiInitParams_spec,
        &Shiboken::callCppDestructor< ::QRhiInitParams >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QRhiInitParams_TypeF(); // references _Sbk_QRhiInitParams_Type
    InitSignatureStrings(pyType, QRhiInitParams_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QRhiInitParams_PropertyStrings);
    SbkPySide6_QtGuiTypeStructs[SBK_QRhiInitParams_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QRhiInitParams_PythonToCpp_QRhiInitParams_PTR,
        is_QRhiInitParams_PythonToCpp_QRhiInitParams_PTR_Convertible,
        QRhiInitParams_PTR_CppToPython_QRhiInitParams,
        QRhiInitParams_COPY_CppToPython_QRhiInitParams);

    Shiboken::Conversions::registerConverterName(converter, "QRhiInitParams");
    Shiboken::Conversions::registerConverterName(converter, "QRhiInitParams*");
    Shiboken::Conversions::registerConverterName(converter, "QRhiInitParams&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QRhiInitParams).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QRhiInitParams_PythonToCpp_QRhiInitParams_COPY,
        is_QRhiInitParams_PythonToCpp_QRhiInitParams_COPY_Convertible);

    qRegisterMetaType< ::QRhiInitParams >("QRhiInitParams");

    return pyType;
}
