// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <QtCore/QBuffer>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtgui_python.h"
#include "pyside6_qtgui_python_p.h"

// main header
#include "qrhishaderstage_wrapper.h"

// Argument includes
#include <rhi/qrhi.h>
#include <rhi/qshader.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QRhiShaderStage_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QRhiShaderStage >()))
        return -1;

    ::QRhiShaderStage *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QRhiShaderStage.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[3];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 0, 3));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|OOO:QRhiShaderStage", &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QRhiShaderStage::QRhiShaderStage()
    // 1: QRhiShaderStage::QRhiShaderStage(QRhiShaderStage::Type,QShader,QShader::Variant=)
    // 2: QRhiShaderStage::QRhiShaderStage(QRhiShaderStage)
    if (numArgs == 0) {
        overloadId = 0; // QRhiShaderStage()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderStage_IDX]), (pyArgs[0])))) {
        overloadId = 2; // QRhiShaderStage(QRhiShaderStage)
    } else if (numArgs >= 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderStage_Type_IDX])))->converter, (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QShader_IDX]), (pyArgs[1])))) {
        if (numArgs == 2) {
            overloadId = 1; // QRhiShaderStage(QRhiShaderStage::Type,QShader,QShader::Variant)
        } else if (numArgs >= 3
            && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QShader_Variant_IDX])))->converter, (pyArgs[2])))) {
            overloadId = 1; // QRhiShaderStage(QRhiShaderStage::Type,QShader,QShader::Variant)
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QRhiShaderStage()
        {
            if (kwds != nullptr && PyDict_Size(kwds) > 0) {
                errInfo.reset(kwds);
                Py_INCREF(errInfo.object());
                return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
            }

            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiShaderStage()
                cptr = new ::QRhiShaderStage();
            }
            break;
        }
        case 1: // QRhiShaderStage(QRhiShaderStage::Type type, const QShader & shader, QShader::Variant v)
        {
            if (kwds && PyDict_Size(kwds) > 0) {
                PyObject *value{};
                Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
                static PyObject *const key_v = Shiboken::String::createStaticString("v");
                if (PyDict_Contains(kwds, key_v) != 0) {
                    value = PyDict_GetItem(kwds, key_v);
                    if (value != nullptr && pyArgs[2] != nullptr ) {
                        errInfo.reset(key_v);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    if (value != nullptr) {
                        pyArgs[2] = value;
                        if (!(pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QShader_Variant_IDX])))->converter, (pyArgs[2]))))
                            return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    PyDict_DelItem(kwds_dup, key_v);
                }
                if (PyDict_Size(kwds_dup) > 0) {
                    errInfo.reset(kwds_dup.release());
                    return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                }
            }
            ::QRhiShaderStage::Type cppArg0{QRhiShaderStage::Vertex};
            pythonToCpp[0](pyArgs[0], &cppArg0);
            if (!Shiboken::Object::isValid(pyArgs[1]))
                return -1;
            ::QShader cppArg1_local;
            ::QShader *cppArg1 = &cppArg1_local;
            if (pythonToCpp[1].isValue())
                pythonToCpp[1](pyArgs[1], &cppArg1_local);
            else
                pythonToCpp[1](pyArgs[1], &cppArg1);

            ::QShader::Variant cppArg2(QShader::StandardShader);
            if (pythonToCpp[2])
                pythonToCpp[2](pyArgs[2], &cppArg2);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiShaderStage(QRhiShaderStage::Type,QShader,QShader::Variant)
                cptr = new ::QRhiShaderStage(cppArg0, *cppArg1, cppArg2);
            }
            break;
        }
        case 2: // QRhiShaderStage(const QRhiShaderStage & QRhiShaderStage)
        {
            if (kwds != nullptr && PyDict_Size(kwds) > 0) {
                errInfo.reset(kwds);
                Py_INCREF(errInfo.object());
                return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
            }
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QRhiShaderStage cppArg0_local;
            ::QRhiShaderStage *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiShaderStage(QRhiShaderStage)
                cptr = new ::QRhiShaderStage(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QRhiShaderStage >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QRhiShaderStageFunc_setShader(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiShaderStage *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderStage_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QRhiShaderStage.setShader";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiShaderStage::setShader(QShader)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QShader_IDX]), (pyArg)))) {
        overloadId = 0; // setShader(QShader)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QShader cppArg0_local;
        ::QShader *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // setShader(QShader)
            cppSelf->setShader(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiShaderStageFunc_setShaderVariant(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiShaderStage *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderStage_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QRhiShaderStage.setShaderVariant";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiShaderStage::setShaderVariant(QShader::Variant)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QShader_Variant_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // setShaderVariant(QShader::Variant)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QShader::Variant cppArg0{QShader::StandardShader};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setShaderVariant(QShader::Variant)
            cppSelf->setShaderVariant(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiShaderStageFunc_setType(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiShaderStage *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderStage_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QRhiShaderStage.setType";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiShaderStage::setType(QRhiShaderStage::Type)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderStage_Type_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // setType(QRhiShaderStage::Type)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QRhiShaderStage::Type cppArg0{QRhiShaderStage::Vertex};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setType(QRhiShaderStage::Type)
            cppSelf->setType(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiShaderStageFunc_shader(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiShaderStage *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderStage_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QRhiShaderStage.shader";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // shader()const
            QShader cppResult = const_cast<const ::QRhiShaderStage *>(cppSelf)->shader();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QShader_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiShaderStageFunc_shaderVariant(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiShaderStage *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderStage_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QRhiShaderStage.shaderVariant";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // shaderVariant()const
            QShader::Variant cppResult = const_cast<const ::QRhiShaderStage *>(cppSelf)->shaderVariant();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QShader_Variant_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiShaderStageFunc_type(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiShaderStage *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderStage_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QRhiShaderStage.type";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // type()const
            QRhiShaderStage::Type cppResult = const_cast<const ::QRhiShaderStage *>(cppSelf)->type();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderStage_Type_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiShaderStage__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QRhiShaderStage *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderStage_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderStage_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QRhiShaderStage_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QRhiShaderStage_EnumFlagInfo[] = {
    "Type:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QRhiShaderStage_methods[] = {
    {"setShader", reinterpret_cast<PyCFunction>(Sbk_QRhiShaderStageFunc_setShader), METH_O, nullptr},
    {"setShaderVariant", reinterpret_cast<PyCFunction>(Sbk_QRhiShaderStageFunc_setShaderVariant), METH_O, nullptr},
    {"setType", reinterpret_cast<PyCFunction>(Sbk_QRhiShaderStageFunc_setType), METH_O, nullptr},
    {"shader", reinterpret_cast<PyCFunction>(Sbk_QRhiShaderStageFunc_shader), METH_NOARGS, nullptr},
    {"shaderVariant", reinterpret_cast<PyCFunction>(Sbk_QRhiShaderStageFunc_shaderVariant), METH_NOARGS, nullptr},
    {"type", reinterpret_cast<PyCFunction>(Sbk_QRhiShaderStageFunc_type), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QRhiShaderStage__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QRhiShaderStage_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QRhiShaderStage *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderStage_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderStage_IDX]), (pyArg)))) {
                // operator!=(const QRhiShaderStage & b)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QRhiShaderStage cppArg0_local;
                ::QRhiShaderStage *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderStage_IDX]), (pyArg)))) {
                // operator==(const QRhiShaderStage & b)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QRhiShaderStage cppArg0_local;
                ::QRhiShaderStage *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static Py_hash_t Sbk_QRhiShaderStage_HashFunc(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiShaderStage *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderStage_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    return Py_hash_t(qHash(*cppSelf));
}

static int Sbk_QRhiShaderStage_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QRhiShaderStage_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
extern "C"
{
static PyObject *Sbk_QRhiShaderStage__repr__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiShaderStage *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderStage_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    QBuffer buffer;
    buffer.open(QBuffer::ReadWrite);
    QDebug dbg(&buffer);
    dbg << *cppSelf;
    buffer.close();
    QByteArray str = buffer.data();
    const auto idx = str.indexOf('(');
    auto *typeName = Py_TYPE(self)->tp_name;
    if (idx >= 0)
        str.replace(0, idx, typeName);
    str = str.trimmed();
    Shiboken::AutoDecRef tpDict(PepType_GetDict(Py_TYPE(self)));
    PyObject *mod = PyDict_GetItem(tpDict.object(), Shiboken::PyMagicName::module());
    if (mod != nullptr && std::strchr(typeName, '.') == nullptr)
        return Shiboken::String::fromFormat("<%s.%s at %p>", Shiboken::String::toCString(mod), str.constData(), self);
    return Shiboken::String::fromFormat("<%s at %p>", str.constData(), self);
}
} // extern C

// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QRhiShaderStage_Type = nullptr;
static PyTypeObject *Sbk_QRhiShaderStage_TypeF(void)
{
    return _Sbk_QRhiShaderStage_Type;
}

static PyType_Slot Sbk_QRhiShaderStage_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_repr,        reinterpret_cast<void *>(Sbk_QRhiShaderStage__repr__)},
    {Py_tp_hash,        reinterpret_cast<void *>(&Sbk_QRhiShaderStage_HashFunc)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QRhiShaderStage_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QRhiShaderStage_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QRhiShaderStage_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QRhiShaderStage_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QRhiShaderStage_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QRhiShaderStage_spec = {
    "2:PySide6.QtGui.QRhiShaderStage",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QRhiShaderStage_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void QRhiShaderStage_Type_PythonToCpp_QRhiShaderStage_Type(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QRhiShaderStage::Type>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QRhiShaderStage::Type *>(cppOut) = value;

}
static PythonToCppFunc is_QRhiShaderStage_Type_PythonToCpp_QRhiShaderStage_Type_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderStage_Type_IDX])))
        return QRhiShaderStage_Type_PythonToCpp_QRhiShaderStage_Type;
    return {};
}
static PyObject *QRhiShaderStage_Type_CppToPython_QRhiShaderStage_Type(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QRhiShaderStage::Type *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderStage_Type_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QRhiShaderStage_PythonToCpp_QRhiShaderStage_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QRhiShaderStage_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QRhiShaderStage_PythonToCpp_QRhiShaderStage_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiShaderStage_TypeF()))
        return QRhiShaderStage_PythonToCpp_QRhiShaderStage_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QRhiShaderStage_PTR_CppToPython_QRhiShaderStage(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QRhiShaderStage *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QRhiShaderStage_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *QRhiShaderStage_COPY_CppToPython_QRhiShaderStage(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QRhiShaderStage *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QRhiShaderStage_TypeF(), new ::QRhiShaderStage(*source), true, true);
}

// Python to C++ copy conversion.
static void QRhiShaderStage_PythonToCpp_QRhiShaderStage_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QRhiShaderStage *>(cppOut) = *reinterpret_cast< ::QRhiShaderStage *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderStage_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QRhiShaderStage_PythonToCpp_QRhiShaderStage_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiShaderStage_TypeF()))
        return QRhiShaderStage_PythonToCpp_QRhiShaderStage_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QRhiShaderStage_SignatureStrings[] = {
    "2:PySide6.QtGui.QRhiShaderStage(self)",
    "1:PySide6.QtGui.QRhiShaderStage(self,type:PySide6.QtGui.QRhiShaderStage.Type,shader:PySide6.QtGui.QShader,v:PySide6.QtGui.QShader.Variant=QShader.StandardShader)",
    "0:PySide6.QtGui.QRhiShaderStage(self,QRhiShaderStage:PySide6.QtGui.QRhiShaderStage)",
    "PySide6.QtGui.QRhiShaderStage.setShader(self,s:PySide6.QtGui.QShader)",
    "PySide6.QtGui.QRhiShaderStage.setShaderVariant(self,v:PySide6.QtGui.QShader.Variant)",
    "PySide6.QtGui.QRhiShaderStage.setType(self,t:PySide6.QtGui.QRhiShaderStage.Type)",
    "PySide6.QtGui.QRhiShaderStage.shader(self)->PySide6.QtGui.QShader",
    "PySide6.QtGui.QRhiShaderStage.shaderVariant(self)->PySide6.QtGui.QShader.Variant",
    "PySide6.QtGui.QRhiShaderStage.type(self)->PySide6.QtGui.QRhiShaderStage.Type",
    "PySide6.QtGui.QRhiShaderStage.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QRhiShaderStage(PyObject *module)
{
    _Sbk_QRhiShaderStage_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QRhiShaderStage",
        "QRhiShaderStage",
        &Sbk_QRhiShaderStage_spec,
        &Shiboken::callCppDestructor< ::QRhiShaderStage >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QRhiShaderStage_TypeF(); // references _Sbk_QRhiShaderStage_Type
    InitSignatureStrings(pyType, QRhiShaderStage_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QRhiShaderStage_PropertyStrings);
    SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderStage_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QRhiShaderStage_PythonToCpp_QRhiShaderStage_PTR,
        is_QRhiShaderStage_PythonToCpp_QRhiShaderStage_PTR_Convertible,
        QRhiShaderStage_PTR_CppToPython_QRhiShaderStage,
        QRhiShaderStage_COPY_CppToPython_QRhiShaderStage);

    Shiboken::Conversions::registerConverterName(converter, "QRhiShaderStage");
    Shiboken::Conversions::registerConverterName(converter, "QRhiShaderStage*");
    Shiboken::Conversions::registerConverterName(converter, "QRhiShaderStage&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QRhiShaderStage).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QRhiShaderStage_PythonToCpp_QRhiShaderStage_COPY,
        is_QRhiShaderStage_PythonToCpp_QRhiShaderStage_COPY_Convertible);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QRhiShaderStage_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'Type'.
    const char *Type_Initializer[] = {
        "Vertex",
        "TessellationControl",
        "TessellationEvaluation",
        "Geometry",
        "Fragment",
        "Compute",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t Type_InitializerValues[] = {
        uint8_t(QRhiShaderStage::Type::Vertex),                 //  0x00  0
        uint8_t(QRhiShaderStage::Type::TessellationControl),    //  0x01  1
        uint8_t(QRhiShaderStage::Type::TessellationEvaluation), //  0x02  2
        uint8_t(QRhiShaderStage::Type::Geometry),               //  0x03  3
        uint8_t(QRhiShaderStage::Type::Fragment),               //  0x04  4
        uint8_t(QRhiShaderStage::Type::Compute)                 //  0x05  5
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QRhiShaderStage_TypeF(),
        "2:PySide6.QtGui.QRhiShaderStage.Type",
        Type_Initializer, Type_InitializerValues);
    SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderStage_Type_IDX].type = EType;
    // Register converter for enum 'QRhiShaderStage::Type'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QRhiShaderStage_Type_CppToPython_QRhiShaderStage_Type);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QRhiShaderStage_Type_PythonToCpp_QRhiShaderStage_Type,
            is_QRhiShaderStage_Type_PythonToCpp_QRhiShaderStage_Type_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QRhiShaderStage::Type");
        Shiboken::Conversions::registerConverterName(converter, "Type");
    }
    // End of 'Type' enum.

    qRegisterMetaType< ::QRhiShaderStage >("QRhiShaderStage");
    qRegisterMetaType< ::QRhiShaderStage::Type >("QRhiShaderStage::Type");

    return pyType;
}
