// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtgui_python.h"
#include "pyside6_qtgui_python_p.h"

// main header
#include "qrhitexturerendertargetdescription_wrapper.h"

// Argument includes
#include <QList>
#include <rhi/qrhi.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QRhiTextureRenderTargetDescription_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QRhiTextureRenderTargetDescription >()))
        return -1;

    ::QRhiTextureRenderTargetDescription *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QRhiTextureRenderTargetDescription.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QRhiTextureRenderTargetDescription", 0, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QRhiTextureRenderTargetDescription::QRhiTextureRenderTargetDescription()
    // 1: QRhiTextureRenderTargetDescription::QRhiTextureRenderTargetDescription(QRhiColorAttachment)
    // 2: QRhiTextureRenderTargetDescription::QRhiTextureRenderTargetDescription(QRhiColorAttachment,QRhiRenderBuffer*)
    // 3: QRhiTextureRenderTargetDescription::QRhiTextureRenderTargetDescription(QRhiColorAttachment,QRhiTexture*)
    // 4: QRhiTextureRenderTargetDescription::QRhiTextureRenderTargetDescription(QRhiTextureRenderTargetDescription)
    if (numArgs == 0) {
        overloadId = 0; // QRhiTextureRenderTargetDescription()
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiColorAttachment_IDX]), (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 1; // QRhiTextureRenderTargetDescription(QRhiColorAttachment)
        } else if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTexture_IDX]), (pyArgs[1])))) {
            overloadId = 3; // QRhiTextureRenderTargetDescription(QRhiColorAttachment,QRhiTexture*)
        } else if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiRenderBuffer_IDX]), (pyArgs[1])))) {
            overloadId = 2; // QRhiTextureRenderTargetDescription(QRhiColorAttachment,QRhiRenderBuffer*)
        }
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureRenderTargetDescription_IDX]), (pyArgs[0])))) {
        overloadId = 4; // QRhiTextureRenderTargetDescription(QRhiTextureRenderTargetDescription)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QRhiTextureRenderTargetDescription()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiTextureRenderTargetDescription()
                cptr = new ::QRhiTextureRenderTargetDescription();
            }
            break;
        }
        case 1: // QRhiTextureRenderTargetDescription(const QRhiColorAttachment & colorAttachment)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QRhiColorAttachment cppArg0_local;
            ::QRhiColorAttachment *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiTextureRenderTargetDescription(QRhiColorAttachment)
                cptr = new ::QRhiTextureRenderTargetDescription(*cppArg0);
            }
            break;
        }
        case 2: // QRhiTextureRenderTargetDescription(const QRhiColorAttachment & colorAttachment, QRhiRenderBuffer * depthStencilBuffer)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QRhiColorAttachment cppArg0_local;
            ::QRhiColorAttachment *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);

            if (!Shiboken::Object::isValid(pyArgs[1]))
                return -1;
            ::QRhiRenderBuffer *cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiTextureRenderTargetDescription(QRhiColorAttachment,QRhiRenderBuffer*)
                cptr = new ::QRhiTextureRenderTargetDescription(*cppArg0, cppArg1);
            }
            break;
        }
        case 3: // QRhiTextureRenderTargetDescription(const QRhiColorAttachment & colorAttachment, QRhiTexture * depthTexture)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QRhiColorAttachment cppArg0_local;
            ::QRhiColorAttachment *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);

            if (!Shiboken::Object::isValid(pyArgs[1]))
                return -1;
            ::QRhiTexture *cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiTextureRenderTargetDescription(QRhiColorAttachment,QRhiTexture*)
                cptr = new ::QRhiTextureRenderTargetDescription(*cppArg0, cppArg1);
            }
            break;
        }
        case 4: // QRhiTextureRenderTargetDescription(const QRhiTextureRenderTargetDescription & QRhiTextureRenderTargetDescription)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QRhiTextureRenderTargetDescription cppArg0_local;
            ::QRhiTextureRenderTargetDescription *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiTextureRenderTargetDescription(QRhiTextureRenderTargetDescription)
                cptr = new ::QRhiTextureRenderTargetDescription(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QRhiTextureRenderTargetDescription >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QRhiTextureRenderTargetDescriptionFunc_cbeginColorAttachments(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureRenderTargetDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureRenderTargetDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QRhiTextureRenderTargetDescription.cbeginColorAttachments";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // cbeginColorAttachments()const
            const QRhiColorAttachment * cppResult = const_cast<const ::QRhiTextureRenderTargetDescription *>(cppSelf)->cbeginColorAttachments();
            pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiColorAttachment_IDX]), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiTextureRenderTargetDescriptionFunc_cendColorAttachments(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureRenderTargetDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureRenderTargetDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QRhiTextureRenderTargetDescription.cendColorAttachments";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // cendColorAttachments()const
            const QRhiColorAttachment * cppResult = const_cast<const ::QRhiTextureRenderTargetDescription *>(cppSelf)->cendColorAttachments();
            pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiColorAttachment_IDX]), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiTextureRenderTargetDescriptionFunc_colorAttachmentAt(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureRenderTargetDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureRenderTargetDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QRhiTextureRenderTargetDescription.colorAttachmentAt";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiTextureRenderTargetDescription::colorAttachmentAt(qsizetype)const->const QRhiColorAttachment*
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qsizetype>(), (pyArg)))) {
        overloadId = 0; // colorAttachmentAt(qsizetype)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        qsizetype cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // colorAttachmentAt(qsizetype)const
            const QRhiColorAttachment * cppResult = const_cast<const ::QRhiTextureRenderTargetDescription *>(cppSelf)->colorAttachmentAt(cppArg0);
            pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiColorAttachment_IDX]), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiTextureRenderTargetDescriptionFunc_colorAttachmentCount(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureRenderTargetDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureRenderTargetDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QRhiTextureRenderTargetDescription.colorAttachmentCount";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // colorAttachmentCount()const
            qsizetype cppResult = const_cast<const ::QRhiTextureRenderTargetDescription *>(cppSelf)->colorAttachmentCount();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qsizetype>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiTextureRenderTargetDescriptionFunc_depthStencilBuffer(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureRenderTargetDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureRenderTargetDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QRhiTextureRenderTargetDescription.depthStencilBuffer";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // depthStencilBuffer()const
            QRhiRenderBuffer * cppResult = const_cast<const ::QRhiTextureRenderTargetDescription *>(cppSelf)->depthStencilBuffer();
            pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiRenderBuffer_IDX]), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiTextureRenderTargetDescriptionFunc_depthTexture(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureRenderTargetDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureRenderTargetDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QRhiTextureRenderTargetDescription.depthTexture";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // depthTexture()const
            QRhiTexture * cppResult = const_cast<const ::QRhiTextureRenderTargetDescription *>(cppSelf)->depthTexture();
            pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTexture_IDX]), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiTextureRenderTargetDescriptionFunc_setColorAttachments(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureRenderTargetDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureRenderTargetDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QRhiTextureRenderTargetDescription.setColorAttachments";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiTextureRenderTargetDescription::setColorAttachments(QList<QRhiColorAttachment>)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtGuiTypeConverters[SBK_QtGui_QList_QRhiColorAttachment_IDX], (pyArg)))) {
        overloadId = 0; // setColorAttachments(QList<QRhiColorAttachment>)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QList<QRhiColorAttachment> cppArg0;
        pythonToCpp(pyArg, &cppArg0);
        SBK_UNUSED(cppArg0)

        if (Shiboken::Errors::occurred() == nullptr) {
            // setColorAttachments(QList<QRhiColorAttachment>)
            // Begin code injection
            // ========================================================================
            // START of custom code block [file: ../glue/qtgui.cpp (qrhi-initializer-list)]
            cppSelf->setColorAttachments(cppArg0.cbegin(), cppArg0.cend());
            // END of custom code block [file: ../glue/qtgui.cpp (qrhi-initializer-list)]
            // ========================================================================
            // End of code injection

        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiTextureRenderTargetDescriptionFunc_setDepthStencilBuffer(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureRenderTargetDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureRenderTargetDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QRhiTextureRenderTargetDescription.setDepthStencilBuffer";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiTextureRenderTargetDescription::setDepthStencilBuffer(QRhiRenderBuffer*)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiRenderBuffer_IDX]), (pyArg)))) {
        overloadId = 0; // setDepthStencilBuffer(QRhiRenderBuffer*)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QRhiRenderBuffer *cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setDepthStencilBuffer(QRhiRenderBuffer*)
            cppSelf->setDepthStencilBuffer(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiTextureRenderTargetDescriptionFunc_setDepthTexture(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureRenderTargetDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureRenderTargetDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QRhiTextureRenderTargetDescription.setDepthTexture";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiTextureRenderTargetDescription::setDepthTexture(QRhiTexture*)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTexture_IDX]), (pyArg)))) {
        overloadId = 0; // setDepthTexture(QRhiTexture*)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QRhiTexture *cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setDepthTexture(QRhiTexture*)
            cppSelf->setDepthTexture(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiTextureRenderTargetDescription__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QRhiTextureRenderTargetDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureRenderTargetDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureRenderTargetDescription_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QRhiTextureRenderTargetDescription_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QRhiTextureRenderTargetDescription_methods[] = {
    {"cbeginColorAttachments", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureRenderTargetDescriptionFunc_cbeginColorAttachments), METH_NOARGS, nullptr},
    {"cendColorAttachments", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureRenderTargetDescriptionFunc_cendColorAttachments), METH_NOARGS, nullptr},
    {"colorAttachmentAt", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureRenderTargetDescriptionFunc_colorAttachmentAt), METH_O, nullptr},
    {"colorAttachmentCount", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureRenderTargetDescriptionFunc_colorAttachmentCount), METH_NOARGS, nullptr},
    {"depthStencilBuffer", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureRenderTargetDescriptionFunc_depthStencilBuffer), METH_NOARGS, nullptr},
    {"depthTexture", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureRenderTargetDescriptionFunc_depthTexture), METH_NOARGS, nullptr},
    {"setColorAttachments", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureRenderTargetDescriptionFunc_setColorAttachments), METH_O, nullptr},
    {"setDepthStencilBuffer", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureRenderTargetDescriptionFunc_setDepthStencilBuffer), METH_O, nullptr},
    {"setDepthTexture", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureRenderTargetDescriptionFunc_setDepthTexture), METH_O, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureRenderTargetDescription__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QRhiTextureRenderTargetDescription_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QRhiTextureRenderTargetDescription_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QRhiTextureRenderTargetDescription_Type = nullptr;
static PyTypeObject *Sbk_QRhiTextureRenderTargetDescription_TypeF(void)
{
    return _Sbk_QRhiTextureRenderTargetDescription_Type;
}

static PyType_Slot Sbk_QRhiTextureRenderTargetDescription_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QRhiTextureRenderTargetDescription_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QRhiTextureRenderTargetDescription_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QRhiTextureRenderTargetDescription_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QRhiTextureRenderTargetDescription_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QRhiTextureRenderTargetDescription_spec = {
    "2:PySide6.QtGui.QRhiTextureRenderTargetDescription",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QRhiTextureRenderTargetDescription_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QRhiTextureRenderTargetDescription_PythonToCpp_QRhiTextureRenderTargetDescription_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QRhiTextureRenderTargetDescription_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QRhiTextureRenderTargetDescription_PythonToCpp_QRhiTextureRenderTargetDescription_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiTextureRenderTargetDescription_TypeF()))
        return QRhiTextureRenderTargetDescription_PythonToCpp_QRhiTextureRenderTargetDescription_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QRhiTextureRenderTargetDescription_PTR_CppToPython_QRhiTextureRenderTargetDescription(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QRhiTextureRenderTargetDescription *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QRhiTextureRenderTargetDescription_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *QRhiTextureRenderTargetDescription_COPY_CppToPython_QRhiTextureRenderTargetDescription(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QRhiTextureRenderTargetDescription *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QRhiTextureRenderTargetDescription_TypeF(), new ::QRhiTextureRenderTargetDescription(*source), true, true);
}

// Python to C++ copy conversion.
static void QRhiTextureRenderTargetDescription_PythonToCpp_QRhiTextureRenderTargetDescription_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QRhiTextureRenderTargetDescription *>(cppOut) = *reinterpret_cast< ::QRhiTextureRenderTargetDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureRenderTargetDescription_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QRhiTextureRenderTargetDescription_PythonToCpp_QRhiTextureRenderTargetDescription_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiTextureRenderTargetDescription_TypeF()))
        return QRhiTextureRenderTargetDescription_PythonToCpp_QRhiTextureRenderTargetDescription_COPY;
    return {};
}

// Implicit conversions.
static void constQRhiColorAttachmentREF_PythonToCpp_QRhiTextureRenderTargetDescription(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QRhiTextureRenderTargetDescription *>(cppOut) = ::QRhiTextureRenderTargetDescription( *reinterpret_cast< ::QRhiColorAttachment *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiColorAttachment_IDX]), reinterpret_cast<SbkObject *>(pyIn))));
}
static PythonToCppFunc is_constQRhiColorAttachmentREF_PythonToCpp_QRhiTextureRenderTargetDescription_Convertible(PyObject *pyIn)
{
    if (SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiColorAttachment_IDX]), pyIn))
        return constQRhiColorAttachmentREF_PythonToCpp_QRhiTextureRenderTargetDescription;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QRhiTextureRenderTargetDescription_SignatureStrings[] = {
    "4:PySide6.QtGui.QRhiTextureRenderTargetDescription(self)",
    "3:PySide6.QtGui.QRhiTextureRenderTargetDescription(self,colorAttachment:typing.Union[PySide6.QtGui.QRhiColorAttachment, PySide6.QtGui.QRhiRenderBuffer, PySide6.QtGui.QRhiTexture])",
    "2:PySide6.QtGui.QRhiTextureRenderTargetDescription(self,colorAttachment:typing.Union[PySide6.QtGui.QRhiColorAttachment, PySide6.QtGui.QRhiRenderBuffer, PySide6.QtGui.QRhiTexture],depthStencilBuffer:PySide6.QtGui.QRhiRenderBuffer)",
    "1:PySide6.QtGui.QRhiTextureRenderTargetDescription(self,colorAttachment:typing.Union[PySide6.QtGui.QRhiColorAttachment, PySide6.QtGui.QRhiRenderBuffer, PySide6.QtGui.QRhiTexture],depthTexture:PySide6.QtGui.QRhiTexture)",
    "0:PySide6.QtGui.QRhiTextureRenderTargetDescription(self,QRhiTextureRenderTargetDescription:typing.Union[PySide6.QtGui.QRhiTextureRenderTargetDescription, PySide6.QtGui.QRhiColorAttachment])",
    "PySide6.QtGui.QRhiTextureRenderTargetDescription.cbeginColorAttachments(self)->PySide6.QtGui.QRhiColorAttachment",
    "PySide6.QtGui.QRhiTextureRenderTargetDescription.cendColorAttachments(self)->PySide6.QtGui.QRhiColorAttachment",
    "PySide6.QtGui.QRhiTextureRenderTargetDescription.colorAttachmentAt(self,index:qsizetype)->PySide6.QtGui.QRhiColorAttachment",
    "PySide6.QtGui.QRhiTextureRenderTargetDescription.colorAttachmentCount(self)->qsizetype",
    "PySide6.QtGui.QRhiTextureRenderTargetDescription.depthStencilBuffer(self)->PySide6.QtGui.QRhiRenderBuffer",
    "PySide6.QtGui.QRhiTextureRenderTargetDescription.depthTexture(self)->PySide6.QtGui.QRhiTexture",
    "PySide6.QtGui.QRhiTextureRenderTargetDescription.setColorAttachments(self,bcolor_attachments:QList[PySide6.QtGui.QRhiColorAttachment])",
    "PySide6.QtGui.QRhiTextureRenderTargetDescription.setDepthStencilBuffer(self,renderBuffer:PySide6.QtGui.QRhiRenderBuffer)",
    "PySide6.QtGui.QRhiTextureRenderTargetDescription.setDepthTexture(self,texture:PySide6.QtGui.QRhiTexture)",
    "PySide6.QtGui.QRhiTextureRenderTargetDescription.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QRhiTextureRenderTargetDescription(PyObject *module)
{
    _Sbk_QRhiTextureRenderTargetDescription_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QRhiTextureRenderTargetDescription",
        "QRhiTextureRenderTargetDescription",
        &Sbk_QRhiTextureRenderTargetDescription_spec,
        &Shiboken::callCppDestructor< ::QRhiTextureRenderTargetDescription >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QRhiTextureRenderTargetDescription_TypeF(); // references _Sbk_QRhiTextureRenderTargetDescription_Type
    InitSignatureStrings(pyType, QRhiTextureRenderTargetDescription_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QRhiTextureRenderTargetDescription_PropertyStrings);
    SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureRenderTargetDescription_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QRhiTextureRenderTargetDescription_PythonToCpp_QRhiTextureRenderTargetDescription_PTR,
        is_QRhiTextureRenderTargetDescription_PythonToCpp_QRhiTextureRenderTargetDescription_PTR_Convertible,
        QRhiTextureRenderTargetDescription_PTR_CppToPython_QRhiTextureRenderTargetDescription,
        QRhiTextureRenderTargetDescription_COPY_CppToPython_QRhiTextureRenderTargetDescription);

    Shiboken::Conversions::registerConverterName(converter, "QRhiTextureRenderTargetDescription");
    Shiboken::Conversions::registerConverterName(converter, "QRhiTextureRenderTargetDescription*");
    Shiboken::Conversions::registerConverterName(converter, "QRhiTextureRenderTargetDescription&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QRhiTextureRenderTargetDescription).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QRhiTextureRenderTargetDescription_PythonToCpp_QRhiTextureRenderTargetDescription_COPY,
        is_QRhiTextureRenderTargetDescription_PythonToCpp_QRhiTextureRenderTargetDescription_COPY_Convertible);
    // Add implicit conversions to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        constQRhiColorAttachmentREF_PythonToCpp_QRhiTextureRenderTargetDescription,
        is_constQRhiColorAttachmentREF_PythonToCpp_QRhiTextureRenderTargetDescription_Convertible);

    qRegisterMetaType< ::QRhiTextureRenderTargetDescription >("QRhiTextureRenderTargetDescription");

    return pyType;
}
