// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtgui_python.h"
#include "pyside6_qtgui_python_p.h"

// main header
#include "qrhitextureuploadentry_wrapper.h"

// Argument includes
#include <rhi/qrhi.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QRhiTextureUploadEntry_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QRhiTextureUploadEntry >()))
        return -1;

    ::QRhiTextureUploadEntry *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QRhiTextureUploadEntry.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[3];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr};

    // invalid argument lengths
    if (numArgs == 2)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    if (PyArg_UnpackTuple(args, "QRhiTextureUploadEntry", 0, 3, &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QRhiTextureUploadEntry::QRhiTextureUploadEntry()
    // 1: QRhiTextureUploadEntry::QRhiTextureUploadEntry(QRhiTextureUploadEntry)
    // 2: QRhiTextureUploadEntry::QRhiTextureUploadEntry(int,int,QRhiTextureSubresourceUploadDescription)
    if (numArgs == 0) {
        overloadId = 0; // QRhiTextureUploadEntry()
    } else if (numArgs == 3
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1])))
        && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureSubresourceUploadDescription_IDX]), (pyArgs[2])))) {
        overloadId = 2; // QRhiTextureUploadEntry(int,int,QRhiTextureSubresourceUploadDescription)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QRhiTextureUploadEntry(QRhiTextureUploadEntry)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QRhiTextureUploadEntry()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiTextureUploadEntry()
                cptr = new ::QRhiTextureUploadEntry();
            }
            break;
        }
        case 1: // QRhiTextureUploadEntry(const QRhiTextureUploadEntry & QRhiTextureUploadEntry)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QRhiTextureUploadEntry cppArg0_local;
            ::QRhiTextureUploadEntry *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiTextureUploadEntry(QRhiTextureUploadEntry)
                cptr = new ::QRhiTextureUploadEntry(*cppArg0);
            }
            break;
        }
        case 2: // QRhiTextureUploadEntry(int layer, int level, const QRhiTextureSubresourceUploadDescription & desc)
        {
            int cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            int cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);
            if (!Shiboken::Object::isValid(pyArgs[2]))
                return -1;
            ::QRhiTextureSubresourceUploadDescription cppArg2_local;
            ::QRhiTextureSubresourceUploadDescription *cppArg2 = &cppArg2_local;
            if (pythonToCpp[2].isValue())
                pythonToCpp[2](pyArgs[2], &cppArg2_local);
            else
                pythonToCpp[2](pyArgs[2], &cppArg2);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiTextureUploadEntry(int,int,QRhiTextureSubresourceUploadDescription)
                cptr = new ::QRhiTextureUploadEntry(cppArg0, cppArg1, *cppArg2);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QRhiTextureUploadEntry >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QRhiTextureUploadEntryFunc_description(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureUploadEntry *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QRhiTextureUploadEntry.description";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // description()const
            QRhiTextureSubresourceUploadDescription cppResult = const_cast<const ::QRhiTextureUploadEntry *>(cppSelf)->description();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureSubresourceUploadDescription_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiTextureUploadEntryFunc_layer(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureUploadEntry *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QRhiTextureUploadEntry.layer";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // layer()const
            int cppResult = const_cast<const ::QRhiTextureUploadEntry *>(cppSelf)->layer();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiTextureUploadEntryFunc_level(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureUploadEntry *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QRhiTextureUploadEntry.level";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // level()const
            int cppResult = const_cast<const ::QRhiTextureUploadEntry *>(cppSelf)->level();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiTextureUploadEntryFunc_setDescription(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureUploadEntry *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QRhiTextureUploadEntry.setDescription";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiTextureUploadEntry::setDescription(QRhiTextureSubresourceUploadDescription)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureSubresourceUploadDescription_IDX]), (pyArg)))) {
        overloadId = 0; // setDescription(QRhiTextureSubresourceUploadDescription)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QRhiTextureSubresourceUploadDescription cppArg0_local;
        ::QRhiTextureSubresourceUploadDescription *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // setDescription(QRhiTextureSubresourceUploadDescription)
            cppSelf->setDescription(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiTextureUploadEntryFunc_setLayer(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureUploadEntry *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QRhiTextureUploadEntry.setLayer";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiTextureUploadEntry::setLayer(int)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // setLayer(int)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setLayer(int)
            cppSelf->setLayer(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiTextureUploadEntryFunc_setLevel(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureUploadEntry *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QRhiTextureUploadEntry.setLevel";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiTextureUploadEntry::setLevel(int)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // setLevel(int)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setLevel(int)
            cppSelf->setLevel(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiTextureUploadEntry__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QRhiTextureUploadEntry *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QRhiTextureUploadEntry_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QRhiTextureUploadEntry_methods[] = {
    {"description", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureUploadEntryFunc_description), METH_NOARGS, nullptr},
    {"layer", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureUploadEntryFunc_layer), METH_NOARGS, nullptr},
    {"level", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureUploadEntryFunc_level), METH_NOARGS, nullptr},
    {"setDescription", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureUploadEntryFunc_setDescription), METH_O, nullptr},
    {"setLayer", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureUploadEntryFunc_setLayer), METH_O, nullptr},
    {"setLevel", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureUploadEntryFunc_setLevel), METH_O, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureUploadEntry__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QRhiTextureUploadEntry_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QRhiTextureUploadEntry_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QRhiTextureUploadEntry_Type = nullptr;
static PyTypeObject *Sbk_QRhiTextureUploadEntry_TypeF(void)
{
    return _Sbk_QRhiTextureUploadEntry_Type;
}

static PyType_Slot Sbk_QRhiTextureUploadEntry_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QRhiTextureUploadEntry_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QRhiTextureUploadEntry_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QRhiTextureUploadEntry_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QRhiTextureUploadEntry_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QRhiTextureUploadEntry_spec = {
    "2:PySide6.QtGui.QRhiTextureUploadEntry",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QRhiTextureUploadEntry_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QRhiTextureUploadEntry_PythonToCpp_QRhiTextureUploadEntry_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QRhiTextureUploadEntry_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QRhiTextureUploadEntry_PythonToCpp_QRhiTextureUploadEntry_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiTextureUploadEntry_TypeF()))
        return QRhiTextureUploadEntry_PythonToCpp_QRhiTextureUploadEntry_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QRhiTextureUploadEntry_PTR_CppToPython_QRhiTextureUploadEntry(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QRhiTextureUploadEntry *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QRhiTextureUploadEntry_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *QRhiTextureUploadEntry_COPY_CppToPython_QRhiTextureUploadEntry(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QRhiTextureUploadEntry *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QRhiTextureUploadEntry_TypeF(), new ::QRhiTextureUploadEntry(*source), true, true);
}

// Python to C++ copy conversion.
static void QRhiTextureUploadEntry_PythonToCpp_QRhiTextureUploadEntry_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QRhiTextureUploadEntry *>(cppOut) = *reinterpret_cast< ::QRhiTextureUploadEntry *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QRhiTextureUploadEntry_PythonToCpp_QRhiTextureUploadEntry_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiTextureUploadEntry_TypeF()))
        return QRhiTextureUploadEntry_PythonToCpp_QRhiTextureUploadEntry_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QRhiTextureUploadEntry_SignatureStrings[] = {
    "2:PySide6.QtGui.QRhiTextureUploadEntry(self)",
    "1:PySide6.QtGui.QRhiTextureUploadEntry(self,QRhiTextureUploadEntry:PySide6.QtGui.QRhiTextureUploadEntry)",
    "0:PySide6.QtGui.QRhiTextureUploadEntry(self,layer:int,level:int,desc:PySide6.QtGui.QRhiTextureSubresourceUploadDescription)",
    "PySide6.QtGui.QRhiTextureUploadEntry.description(self)->PySide6.QtGui.QRhiTextureSubresourceUploadDescription",
    "PySide6.QtGui.QRhiTextureUploadEntry.layer(self)->int",
    "PySide6.QtGui.QRhiTextureUploadEntry.level(self)->int",
    "PySide6.QtGui.QRhiTextureUploadEntry.setDescription(self,desc:PySide6.QtGui.QRhiTextureSubresourceUploadDescription)",
    "PySide6.QtGui.QRhiTextureUploadEntry.setLayer(self,layer:int)",
    "PySide6.QtGui.QRhiTextureUploadEntry.setLevel(self,level:int)",
    "PySide6.QtGui.QRhiTextureUploadEntry.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QRhiTextureUploadEntry(PyObject *module)
{
    _Sbk_QRhiTextureUploadEntry_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QRhiTextureUploadEntry",
        "QRhiTextureUploadEntry",
        &Sbk_QRhiTextureUploadEntry_spec,
        &Shiboken::callCppDestructor< ::QRhiTextureUploadEntry >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QRhiTextureUploadEntry_TypeF(); // references _Sbk_QRhiTextureUploadEntry_Type
    InitSignatureStrings(pyType, QRhiTextureUploadEntry_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QRhiTextureUploadEntry_PropertyStrings);
    SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QRhiTextureUploadEntry_PythonToCpp_QRhiTextureUploadEntry_PTR,
        is_QRhiTextureUploadEntry_PythonToCpp_QRhiTextureUploadEntry_PTR_Convertible,
        QRhiTextureUploadEntry_PTR_CppToPython_QRhiTextureUploadEntry,
        QRhiTextureUploadEntry_COPY_CppToPython_QRhiTextureUploadEntry);

    Shiboken::Conversions::registerConverterName(converter, "QRhiTextureUploadEntry");
    Shiboken::Conversions::registerConverterName(converter, "QRhiTextureUploadEntry*");
    Shiboken::Conversions::registerConverterName(converter, "QRhiTextureUploadEntry&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QRhiTextureUploadEntry).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QRhiTextureUploadEntry_PythonToCpp_QRhiTextureUploadEntry_COPY,
        is_QRhiTextureUploadEntry_PythonToCpp_QRhiTextureUploadEntry_COPY_Convertible);

    qRegisterMetaType< ::QRhiTextureUploadEntry >("QRhiTextureUploadEntry");

    return pyType;
}
