// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <QtCore/QBuffer>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtgui_python.h"
#include "pyside6_qtgui_python_p.h"

// main header
#include "qrhivertexinputbinding_wrapper.h"

// Argument includes
#include <rhi/qrhi.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QRhiVertexInputBinding_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QRhiVertexInputBinding >()))
        return -1;

    ::QRhiVertexInputBinding *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QRhiVertexInputBinding.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[3];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 0, 3));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|OOO:QRhiVertexInputBinding", &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QRhiVertexInputBinding::QRhiVertexInputBinding()
    // 1: QRhiVertexInputBinding::QRhiVertexInputBinding(QRhiVertexInputBinding)
    // 2: QRhiVertexInputBinding::QRhiVertexInputBinding(quint32,QRhiVertexInputBinding::Classification=,quint32=)
    if (numArgs == 0) {
        overloadId = 0; // QRhiVertexInputBinding()
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 2; // QRhiVertexInputBinding(quint32,QRhiVertexInputBinding::Classification,quint32)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputBinding_Classification_IDX])))->converter, (pyArgs[1])))) {
            if (numArgs == 2) {
                overloadId = 2; // QRhiVertexInputBinding(quint32,QRhiVertexInputBinding::Classification,quint32)
            } else if (numArgs >= 3
                && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), (pyArgs[2])))) {
                overloadId = 2; // QRhiVertexInputBinding(quint32,QRhiVertexInputBinding::Classification,quint32)
            }
        }
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputBinding_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QRhiVertexInputBinding(QRhiVertexInputBinding)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QRhiVertexInputBinding()
        {
            if (kwds != nullptr && PyDict_Size(kwds) > 0) {
                errInfo.reset(kwds);
                Py_INCREF(errInfo.object());
                return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
            }

            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiVertexInputBinding()
                cptr = new ::QRhiVertexInputBinding();
            }
            break;
        }
        case 1: // QRhiVertexInputBinding(const QRhiVertexInputBinding & QRhiVertexInputBinding)
        {
            if (kwds != nullptr && PyDict_Size(kwds) > 0) {
                errInfo.reset(kwds);
                Py_INCREF(errInfo.object());
                return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
            }
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QRhiVertexInputBinding cppArg0_local;
            ::QRhiVertexInputBinding *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiVertexInputBinding(QRhiVertexInputBinding)
                cptr = new ::QRhiVertexInputBinding(*cppArg0);
            }
            break;
        }
        case 2: // QRhiVertexInputBinding(quint32 stride, QRhiVertexInputBinding::Classification cls, quint32 stepRate)
        {
            if (kwds && PyDict_Size(kwds) > 0) {
                PyObject *value{};
                Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
                static PyObject *const key_cls = Shiboken::String::createStaticString("cls");
                if (PyDict_Contains(kwds, key_cls) != 0) {
                    value = PyDict_GetItem(kwds, key_cls);
                    if (value != nullptr && pyArgs[1] != nullptr ) {
                        errInfo.reset(key_cls);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    if (value != nullptr) {
                        pyArgs[1] = value;
                        if (!(pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputBinding_Classification_IDX])))->converter, (pyArgs[1]))))
                            return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    PyDict_DelItem(kwds_dup, key_cls);
                }
                static PyObject *const key_stepRate = Shiboken::String::createStaticString("stepRate");
                if (PyDict_Contains(kwds, key_stepRate) != 0) {
                    value = PyDict_GetItem(kwds, key_stepRate);
                    if (value != nullptr && pyArgs[2] != nullptr ) {
                        errInfo.reset(key_stepRate);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    if (value != nullptr) {
                        pyArgs[2] = value;
                        if (!(pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), (pyArgs[2]))))
                            return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    PyDict_DelItem(kwds_dup, key_stepRate);
                }
                if (PyDict_Size(kwds_dup) > 0) {
                    errInfo.reset(kwds_dup.release());
                    return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                }
            }
            quint32 cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            ::QRhiVertexInputBinding::Classification cppArg1(QRhiVertexInputBinding::Classification::PerVertex);
            if (pythonToCpp[1])
                pythonToCpp[1](pyArgs[1], &cppArg1);
            quint32 cppArg2 = 1;
            if (pythonToCpp[2])
                pythonToCpp[2](pyArgs[2], &cppArg2);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiVertexInputBinding(quint32,QRhiVertexInputBinding::Classification,quint32)
                cptr = new ::QRhiVertexInputBinding(cppArg0, cppArg1, cppArg2);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QRhiVertexInputBinding >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QRhiVertexInputBindingFunc_classification(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiVertexInputBinding *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputBinding_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QRhiVertexInputBinding.classification";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // classification()const
            QRhiVertexInputBinding::Classification cppResult = const_cast<const ::QRhiVertexInputBinding *>(cppSelf)->classification();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputBinding_Classification_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiVertexInputBindingFunc_instanceStepRate(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiVertexInputBinding *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputBinding_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QRhiVertexInputBinding.instanceStepRate";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // instanceStepRate()const
            quint32 cppResult = const_cast<const ::QRhiVertexInputBinding *>(cppSelf)->instanceStepRate();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiVertexInputBindingFunc_setClassification(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiVertexInputBinding *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputBinding_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QRhiVertexInputBinding.setClassification";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiVertexInputBinding::setClassification(QRhiVertexInputBinding::Classification)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputBinding_Classification_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // setClassification(QRhiVertexInputBinding::Classification)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QRhiVertexInputBinding::Classification cppArg0{QRhiVertexInputBinding::PerVertex};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setClassification(QRhiVertexInputBinding::Classification)
            cppSelf->setClassification(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiVertexInputBindingFunc_setInstanceStepRate(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiVertexInputBinding *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputBinding_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QRhiVertexInputBinding.setInstanceStepRate";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiVertexInputBinding::setInstanceStepRate(quint32)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), (pyArg)))) {
        overloadId = 0; // setInstanceStepRate(quint32)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        quint32 cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setInstanceStepRate(quint32)
            cppSelf->setInstanceStepRate(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiVertexInputBindingFunc_setStride(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiVertexInputBinding *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputBinding_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QRhiVertexInputBinding.setStride";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiVertexInputBinding::setStride(quint32)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), (pyArg)))) {
        overloadId = 0; // setStride(quint32)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        quint32 cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setStride(quint32)
            cppSelf->setStride(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiVertexInputBindingFunc_stride(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiVertexInputBinding *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputBinding_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QRhiVertexInputBinding.stride";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // stride()const
            quint32 cppResult = const_cast<const ::QRhiVertexInputBinding *>(cppSelf)->stride();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiVertexInputBinding__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QRhiVertexInputBinding *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputBinding_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputBinding_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QRhiVertexInputBinding_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QRhiVertexInputBinding_EnumFlagInfo[] = {
    "Classification:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QRhiVertexInputBinding_methods[] = {
    {"classification", reinterpret_cast<PyCFunction>(Sbk_QRhiVertexInputBindingFunc_classification), METH_NOARGS, nullptr},
    {"instanceStepRate", reinterpret_cast<PyCFunction>(Sbk_QRhiVertexInputBindingFunc_instanceStepRate), METH_NOARGS, nullptr},
    {"setClassification", reinterpret_cast<PyCFunction>(Sbk_QRhiVertexInputBindingFunc_setClassification), METH_O, nullptr},
    {"setInstanceStepRate", reinterpret_cast<PyCFunction>(Sbk_QRhiVertexInputBindingFunc_setInstanceStepRate), METH_O, nullptr},
    {"setStride", reinterpret_cast<PyCFunction>(Sbk_QRhiVertexInputBindingFunc_setStride), METH_O, nullptr},
    {"stride", reinterpret_cast<PyCFunction>(Sbk_QRhiVertexInputBindingFunc_stride), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QRhiVertexInputBinding__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QRhiVertexInputBinding_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QRhiVertexInputBinding *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputBinding_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputBinding_IDX]), (pyArg)))) {
                // operator!=(const QRhiVertexInputBinding & b)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QRhiVertexInputBinding cppArg0_local;
                ::QRhiVertexInputBinding *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputBinding_IDX]), (pyArg)))) {
                // operator==(const QRhiVertexInputBinding & b)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QRhiVertexInputBinding cppArg0_local;
                ::QRhiVertexInputBinding *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static Py_hash_t Sbk_QRhiVertexInputBinding_HashFunc(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiVertexInputBinding *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputBinding_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    return Py_hash_t(qHash(*cppSelf));
}

static int Sbk_QRhiVertexInputBinding_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QRhiVertexInputBinding_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
extern "C"
{
static PyObject *Sbk_QRhiVertexInputBinding__repr__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiVertexInputBinding *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputBinding_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    QBuffer buffer;
    buffer.open(QBuffer::ReadWrite);
    QDebug dbg(&buffer);
    dbg << *cppSelf;
    buffer.close();
    QByteArray str = buffer.data();
    const auto idx = str.indexOf('(');
    auto *typeName = Py_TYPE(self)->tp_name;
    if (idx >= 0)
        str.replace(0, idx, typeName);
    str = str.trimmed();
    Shiboken::AutoDecRef tpDict(PepType_GetDict(Py_TYPE(self)));
    PyObject *mod = PyDict_GetItem(tpDict.object(), Shiboken::PyMagicName::module());
    if (mod != nullptr && std::strchr(typeName, '.') == nullptr)
        return Shiboken::String::fromFormat("<%s.%s at %p>", Shiboken::String::toCString(mod), str.constData(), self);
    return Shiboken::String::fromFormat("<%s at %p>", str.constData(), self);
}
} // extern C

// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QRhiVertexInputBinding_Type = nullptr;
static PyTypeObject *Sbk_QRhiVertexInputBinding_TypeF(void)
{
    return _Sbk_QRhiVertexInputBinding_Type;
}

static PyType_Slot Sbk_QRhiVertexInputBinding_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_repr,        reinterpret_cast<void *>(Sbk_QRhiVertexInputBinding__repr__)},
    {Py_tp_hash,        reinterpret_cast<void *>(&Sbk_QRhiVertexInputBinding_HashFunc)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QRhiVertexInputBinding_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QRhiVertexInputBinding_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QRhiVertexInputBinding_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QRhiVertexInputBinding_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QRhiVertexInputBinding_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QRhiVertexInputBinding_spec = {
    "2:PySide6.QtGui.QRhiVertexInputBinding",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QRhiVertexInputBinding_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void QRhiVertexInputBinding_Classification_PythonToCpp_QRhiVertexInputBinding_Classification(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QRhiVertexInputBinding::Classification>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QRhiVertexInputBinding::Classification *>(cppOut) = value;

}
static PythonToCppFunc is_QRhiVertexInputBinding_Classification_PythonToCpp_QRhiVertexInputBinding_Classification_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputBinding_Classification_IDX])))
        return QRhiVertexInputBinding_Classification_PythonToCpp_QRhiVertexInputBinding_Classification;
    return {};
}
static PyObject *QRhiVertexInputBinding_Classification_CppToPython_QRhiVertexInputBinding_Classification(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QRhiVertexInputBinding::Classification *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputBinding_Classification_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QRhiVertexInputBinding_PythonToCpp_QRhiVertexInputBinding_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QRhiVertexInputBinding_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QRhiVertexInputBinding_PythonToCpp_QRhiVertexInputBinding_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiVertexInputBinding_TypeF()))
        return QRhiVertexInputBinding_PythonToCpp_QRhiVertexInputBinding_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QRhiVertexInputBinding_PTR_CppToPython_QRhiVertexInputBinding(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QRhiVertexInputBinding *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QRhiVertexInputBinding_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *QRhiVertexInputBinding_COPY_CppToPython_QRhiVertexInputBinding(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QRhiVertexInputBinding *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QRhiVertexInputBinding_TypeF(), new ::QRhiVertexInputBinding(*source), true, true);
}

// Python to C++ copy conversion.
static void QRhiVertexInputBinding_PythonToCpp_QRhiVertexInputBinding_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QRhiVertexInputBinding *>(cppOut) = *reinterpret_cast< ::QRhiVertexInputBinding *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputBinding_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QRhiVertexInputBinding_PythonToCpp_QRhiVertexInputBinding_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiVertexInputBinding_TypeF()))
        return QRhiVertexInputBinding_PythonToCpp_QRhiVertexInputBinding_COPY;
    return {};
}

// Implicit conversions.
static void PySide6_QtCore_quint32_PythonToCpp_QRhiVertexInputBinding(PyObject *pyIn, void *cppOut)
{
    quint32 cppIn;
    Shiboken::Conversions::pythonToCppCopy(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), pyIn, &cppIn);
    *reinterpret_cast<::QRhiVertexInputBinding *>(cppOut) = ::QRhiVertexInputBinding(cppIn);
}
static PythonToCppFunc is_PySide6_QtCore_quint32_PythonToCpp_QRhiVertexInputBinding_Convertible(PyObject *pyIn)
{
    if (PyLong_Check(pyIn))
        return PySide6_QtCore_quint32_PythonToCpp_QRhiVertexInputBinding;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QRhiVertexInputBinding_SignatureStrings[] = {
    "2:PySide6.QtGui.QRhiVertexInputBinding(self)",
    "1:PySide6.QtGui.QRhiVertexInputBinding(self,QRhiVertexInputBinding:typing.Union[PySide6.QtGui.QRhiVertexInputBinding, quint32])",
    "0:PySide6.QtGui.QRhiVertexInputBinding(self,stride:quint32,cls:PySide6.QtGui.QRhiVertexInputBinding.Classification=QRhiVertexInputBinding.Classification.PerVertex,stepRate:quint32=1)",
    "PySide6.QtGui.QRhiVertexInputBinding.classification(self)->PySide6.QtGui.QRhiVertexInputBinding.Classification",
    "PySide6.QtGui.QRhiVertexInputBinding.instanceStepRate(self)->quint32",
    "PySide6.QtGui.QRhiVertexInputBinding.setClassification(self,c:PySide6.QtGui.QRhiVertexInputBinding.Classification)",
    "PySide6.QtGui.QRhiVertexInputBinding.setInstanceStepRate(self,rate:quint32)",
    "PySide6.QtGui.QRhiVertexInputBinding.setStride(self,s:quint32)",
    "PySide6.QtGui.QRhiVertexInputBinding.stride(self)->quint32",
    "PySide6.QtGui.QRhiVertexInputBinding.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QRhiVertexInputBinding(PyObject *module)
{
    _Sbk_QRhiVertexInputBinding_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QRhiVertexInputBinding",
        "QRhiVertexInputBinding",
        &Sbk_QRhiVertexInputBinding_spec,
        &Shiboken::callCppDestructor< ::QRhiVertexInputBinding >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QRhiVertexInputBinding_TypeF(); // references _Sbk_QRhiVertexInputBinding_Type
    InitSignatureStrings(pyType, QRhiVertexInputBinding_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QRhiVertexInputBinding_PropertyStrings);
    SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputBinding_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QRhiVertexInputBinding_PythonToCpp_QRhiVertexInputBinding_PTR,
        is_QRhiVertexInputBinding_PythonToCpp_QRhiVertexInputBinding_PTR_Convertible,
        QRhiVertexInputBinding_PTR_CppToPython_QRhiVertexInputBinding,
        QRhiVertexInputBinding_COPY_CppToPython_QRhiVertexInputBinding);

    Shiboken::Conversions::registerConverterName(converter, "QRhiVertexInputBinding");
    Shiboken::Conversions::registerConverterName(converter, "QRhiVertexInputBinding*");
    Shiboken::Conversions::registerConverterName(converter, "QRhiVertexInputBinding&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QRhiVertexInputBinding).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QRhiVertexInputBinding_PythonToCpp_QRhiVertexInputBinding_COPY,
        is_QRhiVertexInputBinding_PythonToCpp_QRhiVertexInputBinding_COPY_Convertible);
    // Add implicit conversions to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        PySide6_QtCore_quint32_PythonToCpp_QRhiVertexInputBinding,
        is_PySide6_QtCore_quint32_PythonToCpp_QRhiVertexInputBinding_Convertible);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QRhiVertexInputBinding_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'Classification'.
    const char *Classification_Initializer[] = {
        "PerVertex",
        "PerInstance",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t Classification_InitializerValues[] = {
        uint8_t(QRhiVertexInputBinding::Classification::PerVertex),  //  0x00  0
        uint8_t(QRhiVertexInputBinding::Classification::PerInstance) //  0x01  1
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QRhiVertexInputBinding_TypeF(),
        "2:PySide6.QtGui.QRhiVertexInputBinding.Classification",
        Classification_Initializer, Classification_InitializerValues);
    SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputBinding_Classification_IDX].type = EType;
    // Register converter for enum 'QRhiVertexInputBinding::Classification'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QRhiVertexInputBinding_Classification_CppToPython_QRhiVertexInputBinding_Classification);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QRhiVertexInputBinding_Classification_PythonToCpp_QRhiVertexInputBinding_Classification,
            is_QRhiVertexInputBinding_Classification_PythonToCpp_QRhiVertexInputBinding_Classification_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QRhiVertexInputBinding::Classification");
        Shiboken::Conversions::registerConverterName(converter, "Classification");
    }
    // End of 'Classification' enum.

    qRegisterMetaType< ::QRhiVertexInputBinding >("QRhiVertexInputBinding");
    qRegisterMetaType< ::QRhiVertexInputBinding::Classification >("QRhiVertexInputBinding::Classification");

    return pyType;
}
