// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QScrollEventWrapper_H
#define SBK_QScrollEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QScrollEventWrapper : public QScrollEvent
{
public:
    QScrollEventWrapper(const QScrollEventWrapper &) = delete;
    QScrollEventWrapper& operator=(const QScrollEventWrapper &) = delete;
    QScrollEventWrapper(QScrollEventWrapper &&) = delete;
    QScrollEventWrapper& operator=(QScrollEventWrapper &&) = delete;

    QScrollEventWrapper(const ::QPointF & contentPos, const ::QPointF & overshoot, ::QScrollEvent::ScrollState scrollState);
    QScrollEventWrapper(const QScrollEvent& self) : QScrollEvent(self)
    {
    }

    ::QScrollEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QScrollEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QScrollEventWrapper_H

