// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QScrollPrepareEventWrapper_H
#define SBK_QScrollPrepareEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QScrollPrepareEventWrapper : public QScrollPrepareEvent
{
public:
    QScrollPrepareEventWrapper(const QScrollPrepareEventWrapper &) = delete;
    QScrollPrepareEventWrapper& operator=(const QScrollPrepareEventWrapper &) = delete;
    QScrollPrepareEventWrapper(QScrollPrepareEventWrapper &&) = delete;
    QScrollPrepareEventWrapper& operator=(QScrollPrepareEventWrapper &&) = delete;

    QScrollPrepareEventWrapper(const ::QPointF & startPos);
    QScrollPrepareEventWrapper(const QScrollPrepareEvent& self) : QScrollPrepareEvent(self)
    {
    }

    ::QScrollPrepareEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QScrollPrepareEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QScrollPrepareEventWrapper_H

