// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QValidatorWrapper_H
#define SBK_QValidatorWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qvalidator.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QValidatorWrapper : public QValidator
{
public:
    QValidatorWrapper(const QValidatorWrapper &) = delete;
    QValidatorWrapper& operator=(const QValidatorWrapper &) = delete;
    QValidatorWrapper(QValidatorWrapper &&) = delete;
    QValidatorWrapper& operator=(QValidatorWrapper &&) = delete;

    QValidatorWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void fixup(::QString & arg__1) const override;
    void timerEvent(::QTimerEvent * event) override;
    ::QValidator::State validate(::QString & arg__1, int & arg__2) const override;
    ~QValidatorWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[9];
};

#endif // SBK_QValidatorWrapper_H

