// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qthelp_python.h"

// main header
#include "qhelpsearchquery_wrapper.h"

// Argument includes
#include <QStringList>
#include <QtHelp/qhelpsearchengine.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QHelpSearchQuery_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QHelpSearchQuery >()))
        return -1;

    ::QHelpSearchQuery *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtHelp.QHelpSearchQuery.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QHelpSearchQuery", 0, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QHelpSearchQuery::QHelpSearchQuery()
    // 1: QHelpSearchQuery::QHelpSearchQuery(QHelpSearchQuery::FieldName,QStringList)
    // 2: QHelpSearchQuery::QHelpSearchQuery(QHelpSearchQuery)
    if (numArgs == 0) {
        overloadId = 0; // QHelpSearchQuery()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QHelpSearchQuery_IDX]), (pyArgs[0])))) {
        overloadId = 2; // QHelpSearchQuery(QHelpSearchQuery)
    } else if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QHelpSearchQuery_FieldName_IDX])))->converter, (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QStringList_IDX], (pyArgs[1])))) {
        overloadId = 1; // QHelpSearchQuery(QHelpSearchQuery::FieldName,QStringList)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QHelpSearchQuery()
        {
            Shiboken::Warnings::warnDeprecated("QHelpSearchQuery", "QHelpSearchQuery()");
            if (Shiboken::Errors::occurred() != nullptr)
                return -1;

            if (Shiboken::Errors::occurred() == nullptr) {
                // QHelpSearchQuery()
                cptr = new ::QHelpSearchQuery();
            }
            break;
        }
        case 1: // QHelpSearchQuery(QHelpSearchQuery::FieldName field, const QStringList & wordList_)
        {
            Shiboken::Warnings::warnDeprecated("QHelpSearchQuery", "QHelpSearchQuery(QHelpSearchQuery.FieldName field, const QStringList & wordList_)");
            if (Shiboken::Errors::occurred() != nullptr)
                return -1;
            ::QHelpSearchQuery::FieldName cppArg0{QHelpSearchQuery::DEFAULT};
            pythonToCpp[0](pyArgs[0], &cppArg0);
            ::QStringList cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QHelpSearchQuery(QHelpSearchQuery::FieldName,QStringList)
                cptr = new ::QHelpSearchQuery(cppArg0, cppArg1);
            }
            break;
        }
        case 2: // QHelpSearchQuery(const QHelpSearchQuery & QHelpSearchQuery)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QHelpSearchQuery cppArg0_local;
            ::QHelpSearchQuery *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QHelpSearchQuery(QHelpSearchQuery)
                cptr = new ::QHelpSearchQuery(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QHelpSearchQuery >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QHelpSearchQuery__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QHelpSearchQuery *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QHelpSearchQuery_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QHelpSearchQuery_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QHelpSearchQuery_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QHelpSearchQuery_EnumFlagInfo[] = {
    "FieldName:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QHelpSearchQuery_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QHelpSearchQuery__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QHelpSearchQuery_get_fieldName(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QHelpSearchQuery *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QHelpSearchQuery_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QHelpSearchQuery::FieldName cppOut_local = cppSelf->fieldName;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QHelpSearchQuery_FieldName_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QHelpSearchQuery_set_fieldName(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QHelpSearchQuery *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QHelpSearchQuery_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("fieldName");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QHelpSearchQuery_FieldName_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("fieldName", "FieldName");
        return -1;
    }

    auto cppOut_local = cppSelf->fieldName;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->fieldName = cppOut_local;

    return 0;
}

static PyObject *Sbk_QHelpSearchQuery_get_wordList(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QHelpSearchQuery *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QHelpSearchQuery_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QStringList_IDX], &cppSelf->wordList);
    return pyOut;
}
static int Sbk_QHelpSearchQuery_set_wordList(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QHelpSearchQuery *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QHelpSearchQuery_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("wordList");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QStringList_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("wordList", "QStringList");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->wordList;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

// Getters and Setters for QHelpSearchQuery
static PyGetSetDef Sbk_QHelpSearchQuery_getsetlist[] = {
    {const_cast<char *>("fieldName"), Sbk_QHelpSearchQuery_get_fieldName, Sbk_QHelpSearchQuery_set_fieldName, nullptr, nullptr},
    {const_cast<char *>("wordList"), Sbk_QHelpSearchQuery_get_wordList, Sbk_QHelpSearchQuery_set_wordList, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QHelpSearchQuery_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QHelpSearchQuery_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QHelpSearchQuery_Type = nullptr;
static PyTypeObject *Sbk_QHelpSearchQuery_TypeF(void)
{
    return _Sbk_QHelpSearchQuery_Type;
}

static PyType_Slot Sbk_QHelpSearchQuery_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QHelpSearchQuery_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QHelpSearchQuery_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QHelpSearchQuery_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QHelpSearchQuery_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QHelpSearchQuery_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QHelpSearchQuery_spec = {
    "2:PySide6.QtHelp.QHelpSearchQuery",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QHelpSearchQuery_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void QHelpSearchQuery_FieldName_PythonToCpp_QHelpSearchQuery_FieldName(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QHelpSearchQuery::FieldName>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QHelpSearchQuery::FieldName *>(cppOut) = value;

}
static PythonToCppFunc is_QHelpSearchQuery_FieldName_PythonToCpp_QHelpSearchQuery_FieldName_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QHelpSearchQuery_FieldName_IDX])))
        return QHelpSearchQuery_FieldName_PythonToCpp_QHelpSearchQuery_FieldName;
    return {};
}
static PyObject *QHelpSearchQuery_FieldName_CppToPython_QHelpSearchQuery_FieldName(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QHelpSearchQuery::FieldName *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QHelpSearchQuery_FieldName_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QHelpSearchQuery_PythonToCpp_QHelpSearchQuery_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QHelpSearchQuery_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QHelpSearchQuery_PythonToCpp_QHelpSearchQuery_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QHelpSearchQuery_TypeF()))
        return QHelpSearchQuery_PythonToCpp_QHelpSearchQuery_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QHelpSearchQuery_PTR_CppToPython_QHelpSearchQuery(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QHelpSearchQuery *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QHelpSearchQuery_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *QHelpSearchQuery_COPY_CppToPython_QHelpSearchQuery(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QHelpSearchQuery *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QHelpSearchQuery_TypeF(), new ::QHelpSearchQuery(*source), true, true);
}

// Python to C++ copy conversion.
static void QHelpSearchQuery_PythonToCpp_QHelpSearchQuery_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QHelpSearchQuery *>(cppOut) = *reinterpret_cast< ::QHelpSearchQuery *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QHelpSearchQuery_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QHelpSearchQuery_PythonToCpp_QHelpSearchQuery_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QHelpSearchQuery_TypeF()))
        return QHelpSearchQuery_PythonToCpp_QHelpSearchQuery_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QHelpSearchQuery_SignatureStrings[] = {
    "2:PySide6.QtHelp.QHelpSearchQuery(self)",
    "1:PySide6.QtHelp.QHelpSearchQuery(self,field:PySide6.QtHelp.QHelpSearchQuery.FieldName,wordList_:QStringList)",
    "0:PySide6.QtHelp.QHelpSearchQuery(self,QHelpSearchQuery:PySide6.QtHelp.QHelpSearchQuery)",
    "PySide6.QtHelp.QHelpSearchQuery.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QHelpSearchQuery(PyObject *module)
{
    _Sbk_QHelpSearchQuery_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QHelpSearchQuery",
        "QHelpSearchQuery",
        &Sbk_QHelpSearchQuery_spec,
        &Shiboken::callCppDestructor< ::QHelpSearchQuery >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QHelpSearchQuery_TypeF(); // references _Sbk_QHelpSearchQuery_Type
    InitSignatureStrings(pyType, QHelpSearchQuery_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QHelpSearchQuery_PropertyStrings);
    SbkPySide6_QtHelpTypeStructs[SBK_QHelpSearchQuery_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QHelpSearchQuery_PythonToCpp_QHelpSearchQuery_PTR,
        is_QHelpSearchQuery_PythonToCpp_QHelpSearchQuery_PTR_Convertible,
        QHelpSearchQuery_PTR_CppToPython_QHelpSearchQuery,
        QHelpSearchQuery_COPY_CppToPython_QHelpSearchQuery);

    Shiboken::Conversions::registerConverterName(converter, "QHelpSearchQuery");
    Shiboken::Conversions::registerConverterName(converter, "QHelpSearchQuery*");
    Shiboken::Conversions::registerConverterName(converter, "QHelpSearchQuery&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QHelpSearchQuery).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QHelpSearchQuery_PythonToCpp_QHelpSearchQuery_COPY,
        is_QHelpSearchQuery_PythonToCpp_QHelpSearchQuery_COPY_Convertible);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QHelpSearchQuery_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'FieldName'.
    const char *FieldName_Initializer[] = {
        "DEFAULT",
        "FUZZY",
        "WITHOUT",
        "PHRASE",
        "ALL",
        "ATLEAST",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t FieldName_InitializerValues[] = {
        uint8_t(QHelpSearchQuery::FieldName::DEFAULT), //  0x00  0
        uint8_t(QHelpSearchQuery::FieldName::FUZZY),   //  0x01  1
        uint8_t(QHelpSearchQuery::FieldName::WITHOUT), //  0x02  2
        uint8_t(QHelpSearchQuery::FieldName::PHRASE),  //  0x03  3
        uint8_t(QHelpSearchQuery::FieldName::ALL),     //  0x04  4
        uint8_t(QHelpSearchQuery::FieldName::ATLEAST)  //  0x05  5
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QHelpSearchQuery_TypeF(),
        "2:PySide6.QtHelp.QHelpSearchQuery.FieldName",
        FieldName_Initializer, FieldName_InitializerValues);
    SbkPySide6_QtHelpTypeStructs[SBK_QHelpSearchQuery_FieldName_IDX].type = EType;
    // Register converter for enum 'QHelpSearchQuery::FieldName'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QHelpSearchQuery_FieldName_CppToPython_QHelpSearchQuery_FieldName);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QHelpSearchQuery_FieldName_PythonToCpp_QHelpSearchQuery_FieldName,
            is_QHelpSearchQuery_FieldName_PythonToCpp_QHelpSearchQuery_FieldName_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QHelpSearchQuery::FieldName");
        Shiboken::Conversions::registerConverterName(converter, "FieldName");
    }
    // End of 'FieldName' enum.

    qRegisterMetaType< ::QHelpSearchQuery >("QHelpSearchQuery");
    qRegisterMetaType< ::QHelpSearchQuery::FieldName >("QHelpSearchQuery::FieldName");

    return pyType;
}
