// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QPlaceManagerEngineWrapper_H
#define SBK_QPlaceManagerEngineWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtLocation/qplacemanagerengine.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QPlaceManagerEngineWrapper : public QPlaceManagerEngine
{
public:
    QPlaceManagerEngineWrapper(const QPlaceManagerEngineWrapper &) = delete;
    QPlaceManagerEngineWrapper& operator=(const QPlaceManagerEngineWrapper &) = delete;
    QPlaceManagerEngineWrapper(QPlaceManagerEngineWrapper &&) = delete;
    QPlaceManagerEngineWrapper& operator=(QPlaceManagerEngineWrapper &&) = delete;

    QPlaceManagerEngineWrapper(const ::QMap<QString,QVariant> & parameters, ::QObject * parent = nullptr);
    ::QPlaceCategory category(const ::QString & categoryId) const override;
    ::QList<QPlaceCategory> childCategories(const ::QString & parentId) const override;
    ::QStringList childCategoryIds(const ::QString & categoryId) const override;
    void childEvent(::QChildEvent * event) override;
    ::QPlace compatiblePlace(const ::QPlace & original) const override;
    void connectNotify(const ::QMetaMethod & signal) override;
    ::QUrl constructIconUrl(const ::QPlaceIcon & icon, const ::QSize & size) const override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QPlaceContentReply * getPlaceContent(const ::QPlaceContentRequest & request) override;
    ::QPlaceDetailsReply * getPlaceDetails(const ::QString & placeId) override;
    ::QPlaceReply * initializeCategories() override;
    ::QList<QLocale> locales() const override;
    ::QPlaceMatchReply * matchingPlaces(const ::QPlaceMatchRequest & request) override;
    ::QString parentCategoryId(const ::QString & categoryId) const override;
    ::QPlaceIdReply * removeCategory(const ::QString & categoryId) override;
    ::QPlaceIdReply * removePlace(const ::QString & placeId) override;
    ::QPlaceIdReply * saveCategory(const ::QPlaceCategory & category, const ::QString & parentId) override;
    ::QPlaceIdReply * savePlace(const ::QPlace & place) override;
    ::QPlaceSearchReply * search(const ::QPlaceSearchRequest & request) override;
    ::QPlaceSearchSuggestionReply * searchSuggestions(const ::QPlaceSearchRequest & request) override;
    void setLocales(const ::QList<QLocale> & locales) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QPlaceManagerEngineWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[25];
};

#endif // SBK_QPlaceManagerEngineWrapper_H

