// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtmultimedia_python.h"

// main header
#include "qmediametadata_wrapper.h"

// Argument includes
#include <QList>
#include <QString>
#include <QtMultimedia/qmediametadata.h>
#include <qmetatype.h>
#include <qobject.h>
#include <qobjectdefs.h>
#include <qvariant.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QMediaMetaData_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QMediaMetaData >()))
        return -1;

    ::QMediaMetaData *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtMultimedia.QMediaMetaData.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QMediaMetaData", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QMediaMetaData::QMediaMetaData()
    // 1: QMediaMetaData::QMediaMetaData(QMediaMetaData)
    if (numArgs == 0) {
        overloadId = 0; // QMediaMetaData()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QMediaMetaData_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QMediaMetaData(QMediaMetaData)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QMediaMetaData()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QMediaMetaData()
                cptr = new ::QMediaMetaData();
            }
            break;
        }
        case 1: // QMediaMetaData(const QMediaMetaData & QMediaMetaData)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QMediaMetaData cppArg0_local;
            ::QMediaMetaData *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QMediaMetaData(QMediaMetaData)
                cptr = new ::QMediaMetaData(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QMediaMetaData >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QMediaMetaDataFunc_clear(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QMediaMetaData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QMediaMetaData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    static const char fullName[] = "PySide6.QtMultimedia.QMediaMetaData.clear";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // clear()
            cppSelf->clear();
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QMediaMetaDataFunc_insert(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QMediaMetaData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QMediaMetaData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtMultimedia.QMediaMetaData.insert";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "insert", 2, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QMediaMetaData::insert(QMediaMetaData::Key,QVariant)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QMediaMetaData_Key_IDX])))->converter, (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QVariant_IDX], (pyArgs[1])))) {
        overloadId = 0; // insert(QMediaMetaData::Key,QVariant)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        ::QMediaMetaData::Key cppArg0{QMediaMetaData::Title};
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QVariant cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (Shiboken::Errors::occurred() == nullptr) {
            // insert(QMediaMetaData::Key,QVariant)
            cppSelf->insert(cppArg0, cppArg1);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QMediaMetaDataFunc_isEmpty(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QMediaMetaData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QMediaMetaData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtMultimedia.QMediaMetaData.isEmpty";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isEmpty()const
            bool cppResult = const_cast<const ::QMediaMetaData *>(cppSelf)->isEmpty();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QMediaMetaDataFunc_keyType(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtMultimedia.QMediaMetaData.keyType";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static QMediaMetaData::keyType(QMediaMetaData::Key)->QMetaType
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QMediaMetaData_Key_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // keyType(QMediaMetaData::Key)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QMediaMetaData::Key cppArg0{QMediaMetaData::Title};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // keyType(QMediaMetaData::Key)
            QMetaType cppResult = ::QMediaMetaData::keyType(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QMetaType_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QMediaMetaDataFunc_keys(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QMediaMetaData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QMediaMetaData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtMultimedia.QMediaMetaData.keys";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // keys()const
            QList<QMediaMetaData::Key> cppResult = const_cast<const ::QMediaMetaData *>(cppSelf)->keys();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtMultimediaTypeConverters[SBK_QtMultimedia_QList_QMediaMetaData_Key_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QMediaMetaDataFunc_metaDataKeyToString(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtMultimedia.QMediaMetaData.metaDataKeyToString";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static QMediaMetaData::metaDataKeyToString(QMediaMetaData::Key)->QString
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QMediaMetaData_Key_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // metaDataKeyToString(QMediaMetaData::Key)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QMediaMetaData::Key cppArg0{QMediaMetaData::Title};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // metaDataKeyToString(QMediaMetaData::Key)
            QString cppResult = ::QMediaMetaData::metaDataKeyToString(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QMediaMetaDataFunc_remove(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QMediaMetaData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QMediaMetaData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtMultimedia.QMediaMetaData.remove";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QMediaMetaData::remove(QMediaMetaData::Key)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QMediaMetaData_Key_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // remove(QMediaMetaData::Key)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QMediaMetaData::Key cppArg0{QMediaMetaData::Title};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // remove(QMediaMetaData::Key)
            cppSelf->remove(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QMediaMetaDataFunc_stringValue(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QMediaMetaData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QMediaMetaData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtMultimedia.QMediaMetaData.stringValue";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QMediaMetaData::stringValue(QMediaMetaData::Key)const->QString
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QMediaMetaData_Key_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // stringValue(QMediaMetaData::Key)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QMediaMetaData::Key cppArg0{QMediaMetaData::Title};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // stringValue(QMediaMetaData::Key)const
            QString cppResult = const_cast<const ::QMediaMetaData *>(cppSelf)->stringValue(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QMediaMetaDataFunc_value(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QMediaMetaData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QMediaMetaData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtMultimedia.QMediaMetaData.value";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QMediaMetaData::value(QMediaMetaData::Key)const->QVariant
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QMediaMetaData_Key_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // value(QMediaMetaData::Key)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QMediaMetaData::Key cppArg0{QMediaMetaData::Title};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // value(QMediaMetaData::Key)const
            QVariant cppResult = const_cast<const ::QMediaMetaData *>(cppSelf)->value(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QVariant_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QMediaMetaData__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QMediaMetaData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QMediaMetaData_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QMediaMetaData_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QMediaMetaData_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QMediaMetaData_EnumFlagInfo[] = {
    "Key:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QMediaMetaData_methods[] = {
    {"clear", reinterpret_cast<PyCFunction>(Sbk_QMediaMetaDataFunc_clear), METH_NOARGS, nullptr},
    {"insert", reinterpret_cast<PyCFunction>(Sbk_QMediaMetaDataFunc_insert), METH_VARARGS, nullptr},
    {"isEmpty", reinterpret_cast<PyCFunction>(Sbk_QMediaMetaDataFunc_isEmpty), METH_NOARGS, nullptr},
    {"keyType", reinterpret_cast<PyCFunction>(Sbk_QMediaMetaDataFunc_keyType), METH_O|METH_STATIC, nullptr},
    {"keys", reinterpret_cast<PyCFunction>(Sbk_QMediaMetaDataFunc_keys), METH_NOARGS, nullptr},
    {"metaDataKeyToString", reinterpret_cast<PyCFunction>(Sbk_QMediaMetaDataFunc_metaDataKeyToString), METH_O|METH_STATIC, nullptr},
    {"remove", reinterpret_cast<PyCFunction>(Sbk_QMediaMetaDataFunc_remove), METH_O, nullptr},
    {"stringValue", reinterpret_cast<PyCFunction>(Sbk_QMediaMetaDataFunc_stringValue), METH_O, nullptr},
    {"value", reinterpret_cast<PyCFunction>(Sbk_QMediaMetaDataFunc_value), METH_O, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QMediaMetaData__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QMediaMetaData_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QMediaMetaData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QMediaMetaData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QMediaMetaData_IDX]), (pyArg)))) {
                // operator!=(const QMediaMetaData & b)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QMediaMetaData cppArg0_local;
                ::QMediaMetaData *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QMediaMetaData_IDX]), (pyArg)))) {
                // operator==(const QMediaMetaData & b)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QMediaMetaData cppArg0_local;
                ::QMediaMetaData *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}


static PyObject *Sbk_QMediaMetaData_get_data(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QMediaMetaData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QMediaMetaData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(SbkPySide6_QtMultimediaTypeConverters[SBK_QtMultimedia_QHash_QMediaMetaData_Key_QVariant_IDX], &cppSelf->data);
    return pyOut;
}
static int Sbk_QMediaMetaData_set_data(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QMediaMetaData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QMediaMetaData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("data");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtMultimediaTypeConverters[SBK_QtMultimedia_QHash_QMediaMetaData_Key_QVariant_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("data", "QHash");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->data;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

// Getters and Setters for QMediaMetaData
static PyGetSetDef Sbk_QMediaMetaData_getsetlist[] = {
    {const_cast<char *>("data"), Sbk_QMediaMetaData_get_data, Sbk_QMediaMetaData_set_data, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QMediaMetaData_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QMediaMetaData_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QMediaMetaData_Type = nullptr;
static PyTypeObject *Sbk_QMediaMetaData_TypeF(void)
{
    return _Sbk_QMediaMetaData_Type;
}

static PyType_Slot Sbk_QMediaMetaData_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QMediaMetaData_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QMediaMetaData_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QMediaMetaData_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QMediaMetaData_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QMediaMetaData_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QMediaMetaData_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QMediaMetaData_spec = {
    "2:PySide6.QtMultimedia.QMediaMetaData",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QMediaMetaData_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void QMediaMetaData_Key_PythonToCpp_QMediaMetaData_Key(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QMediaMetaData::Key>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QMediaMetaData::Key *>(cppOut) = value;

}
static PythonToCppFunc is_QMediaMetaData_Key_PythonToCpp_QMediaMetaData_Key_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QMediaMetaData_Key_IDX])))
        return QMediaMetaData_Key_PythonToCpp_QMediaMetaData_Key;
    return {};
}
static PyObject *QMediaMetaData_Key_CppToPython_QMediaMetaData_Key(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QMediaMetaData::Key *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QMediaMetaData_Key_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QMediaMetaData_PythonToCpp_QMediaMetaData_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QMediaMetaData_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QMediaMetaData_PythonToCpp_QMediaMetaData_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QMediaMetaData_TypeF()))
        return QMediaMetaData_PythonToCpp_QMediaMetaData_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QMediaMetaData_PTR_CppToPython_QMediaMetaData(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QMediaMetaData *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QMediaMetaData_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *QMediaMetaData_COPY_CppToPython_QMediaMetaData(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QMediaMetaData *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QMediaMetaData_TypeF(), new ::QMediaMetaData(*source), true, true);
}

// Python to C++ copy conversion.
static void QMediaMetaData_PythonToCpp_QMediaMetaData_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QMediaMetaData *>(cppOut) = *reinterpret_cast< ::QMediaMetaData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QMediaMetaData_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QMediaMetaData_PythonToCpp_QMediaMetaData_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QMediaMetaData_TypeF()))
        return QMediaMetaData_PythonToCpp_QMediaMetaData_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QMediaMetaData_SignatureStrings[] = {
    "1:PySide6.QtMultimedia.QMediaMetaData(self)",
    "0:PySide6.QtMultimedia.QMediaMetaData(self,QMediaMetaData:PySide6.QtMultimedia.QMediaMetaData)",
    "PySide6.QtMultimedia.QMediaMetaData.clear(self)",
    "PySide6.QtMultimedia.QMediaMetaData.insert(self,k:PySide6.QtMultimedia.QMediaMetaData.Key,value:QVariant)",
    "PySide6.QtMultimedia.QMediaMetaData.isEmpty(self)->bool",
    "PySide6.QtMultimedia.QMediaMetaData.keyType(key:PySide6.QtMultimedia.QMediaMetaData.Key)->PySide6.QtCore.QMetaType",
    "PySide6.QtMultimedia.QMediaMetaData.keys(self)->QList[PySide6.QtMultimedia.QMediaMetaData.Key]",
    "PySide6.QtMultimedia.QMediaMetaData.metaDataKeyToString(k:PySide6.QtMultimedia.QMediaMetaData.Key)->QString",
    "PySide6.QtMultimedia.QMediaMetaData.remove(self,k:PySide6.QtMultimedia.QMediaMetaData.Key)",
    "PySide6.QtMultimedia.QMediaMetaData.stringValue(self,k:PySide6.QtMultimedia.QMediaMetaData.Key)->QString",
    "PySide6.QtMultimedia.QMediaMetaData.value(self,k:PySide6.QtMultimedia.QMediaMetaData.Key)->QVariant",
    "PySide6.QtMultimedia.QMediaMetaData.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QMediaMetaData(PyObject *module)
{
    _Sbk_QMediaMetaData_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QMediaMetaData",
        "QMediaMetaData",
        &Sbk_QMediaMetaData_spec,
        &Shiboken::callCppDestructor< ::QMediaMetaData >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QMediaMetaData_TypeF(); // references _Sbk_QMediaMetaData_Type
    InitSignatureStrings(pyType, QMediaMetaData_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QMediaMetaData_PropertyStrings);
    SbkPySide6_QtMultimediaTypeStructs[SBK_QMediaMetaData_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QMediaMetaData_PythonToCpp_QMediaMetaData_PTR,
        is_QMediaMetaData_PythonToCpp_QMediaMetaData_PTR_Convertible,
        QMediaMetaData_PTR_CppToPython_QMediaMetaData,
        QMediaMetaData_COPY_CppToPython_QMediaMetaData);

    Shiboken::Conversions::registerConverterName(converter, "QMediaMetaData");
    Shiboken::Conversions::registerConverterName(converter, "QMediaMetaData*");
    Shiboken::Conversions::registerConverterName(converter, "QMediaMetaData&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QMediaMetaData).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QMediaMetaData_PythonToCpp_QMediaMetaData_COPY,
        is_QMediaMetaData_PythonToCpp_QMediaMetaData_COPY_Convertible);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QMediaMetaData_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'Key'.
    const char *Key_Initializer[] = {
        "Title",
        "Author",
        "Comment",
        "Description",
        "Genre",
        "Date",
        "Language",
        "Publisher",
        "Copyright",
        "Url",
        "Duration",
        "MediaType",
        "FileFormat",
        "AudioBitRate",
        "AudioCodec",
        "VideoBitRate",
        "VideoCodec",
        "VideoFrameRate",
        "AlbumTitle",
        "AlbumArtist",
        "ContributingArtist",
        "TrackNumber",
        "Composer",
        "LeadPerformer",
        "ThumbnailImage",
        "CoverArtImage",
        "Orientation",
        "Resolution",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t Key_InitializerValues[] = {
        uint8_t(QMediaMetaData::Key::Title),              //  0x00  0
        uint8_t(QMediaMetaData::Key::Author),             //  0x01  1
        uint8_t(QMediaMetaData::Key::Comment),            //  0x02  2
        uint8_t(QMediaMetaData::Key::Description),        //  0x03  3
        uint8_t(QMediaMetaData::Key::Genre),              //  0x04  4
        uint8_t(QMediaMetaData::Key::Date),               //  0x05  5
        uint8_t(QMediaMetaData::Key::Language),           //  0x06  6
        uint8_t(QMediaMetaData::Key::Publisher),          //  0x07  7
        uint8_t(QMediaMetaData::Key::Copyright),          //  0x08  8
        uint8_t(QMediaMetaData::Key::Url),                //  0x09  9
        uint8_t(QMediaMetaData::Key::Duration),           //  0x0a  10
        uint8_t(QMediaMetaData::Key::MediaType),          //  0x0b  11
        uint8_t(QMediaMetaData::Key::FileFormat),         //  0x0c  12
        uint8_t(QMediaMetaData::Key::AudioBitRate),       //  0x0d  13
        uint8_t(QMediaMetaData::Key::AudioCodec),         //  0x0e  14
        uint8_t(QMediaMetaData::Key::VideoBitRate),       //  0x0f  15
        uint8_t(QMediaMetaData::Key::VideoCodec),         //  0x10  16
        uint8_t(QMediaMetaData::Key::VideoFrameRate),     //  0x11  17
        uint8_t(QMediaMetaData::Key::AlbumTitle),         //  0x12  18
        uint8_t(QMediaMetaData::Key::AlbumArtist),        //  0x13  19
        uint8_t(QMediaMetaData::Key::ContributingArtist), //  0x14  20
        uint8_t(QMediaMetaData::Key::TrackNumber),        //  0x15  21
        uint8_t(QMediaMetaData::Key::Composer),           //  0x16  22
        uint8_t(QMediaMetaData::Key::LeadPerformer),      //  0x17  23
        uint8_t(QMediaMetaData::Key::ThumbnailImage),     //  0x18  24
        uint8_t(QMediaMetaData::Key::CoverArtImage),      //  0x19  25
        uint8_t(QMediaMetaData::Key::Orientation),        //  0x1a  26
        uint8_t(QMediaMetaData::Key::Resolution)          //  0x1b  27
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QMediaMetaData_TypeF(),
        "2:PySide6.QtMultimedia.QMediaMetaData.Key",
        Key_Initializer, Key_InitializerValues);
    SbkPySide6_QtMultimediaTypeStructs[SBK_QMediaMetaData_Key_IDX].type = EType;
    // Register converter for enum 'QMediaMetaData::Key'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QMediaMetaData_Key_CppToPython_QMediaMetaData_Key);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QMediaMetaData_Key_PythonToCpp_QMediaMetaData_Key,
            is_QMediaMetaData_Key_PythonToCpp_QMediaMetaData_Key_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QMediaMetaData::Key");
        Shiboken::Conversions::registerConverterName(converter, "Key");
    }
    // End of 'Key' enum.

    qRegisterMetaType< ::QMediaMetaData >("QMediaMetaData");
    qRegisterMetaType< ::QMediaMetaData::Key >("QMediaMetaData::Key");

    return pyType;
}

PyTypeObject *init_QMediaMetaDataStaticFields(PyObject *module)
{
    auto *obType = PyObject_GetAttrString(module, "QMediaMetaData");
    auto *type = reinterpret_cast<PyTypeObject *>(obType);
    Shiboken::AutoDecRef dict(PepType_GetDict(type));
    PyDict_SetItemString(dict, "NumMetaData",
                         Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &QMediaMetaData::NumMetaData));
    return type;
}
