// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <QtCore/QBuffer>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtmultimedia_python.h"

// main header
#include "qvideoframeformat_wrapper.h"

// Argument includes
#include <QString>
#include <QtGui/qimage.h>
#include <QtGui/qmatrix4x4.h>
#include <QtMultimedia/qvideoframe.h>
#include <QtMultimedia/qvideoframeformat.h>
#include <qbytearray.h>
#include <qrect.h>
#include <qsize.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QVideoFrameFormat_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QVideoFrameFormat >()))
        return -1;

    ::QVideoFrameFormat *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtMultimedia.QVideoFrameFormat.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QVideoFrameFormat", 0, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QVideoFrameFormat::QVideoFrameFormat()
    // 1: QVideoFrameFormat::QVideoFrameFormat(QSize,QVideoFrameFormat::PixelFormat)
    // 2: QVideoFrameFormat::QVideoFrameFormat(QVideoFrameFormat)
    if (numArgs == 0) {
        overloadId = 0; // QVideoFrameFormat()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), (pyArgs[0])))) {
        overloadId = 2; // QVideoFrameFormat(QVideoFrameFormat)
    } else if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSize_IDX]), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_PixelFormat_IDX])))->converter, (pyArgs[1])))) {
        overloadId = 1; // QVideoFrameFormat(QSize,QVideoFrameFormat::PixelFormat)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QVideoFrameFormat()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QVideoFrameFormat()
                cptr = new ::QVideoFrameFormat();
            }
            break;
        }
        case 1: // QVideoFrameFormat(const QSize & size, QVideoFrameFormat::PixelFormat pixelFormat)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QSize cppArg0_local;
            ::QSize *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);

            ::QVideoFrameFormat::PixelFormat cppArg1{QVideoFrameFormat::Format_Invalid};
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QVideoFrameFormat(QSize,QVideoFrameFormat::PixelFormat)
                cptr = new ::QVideoFrameFormat(*cppArg0, cppArg1);
            }
            break;
        }
        case 2: // QVideoFrameFormat(const QVideoFrameFormat & format)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QVideoFrameFormat cppArg0_local;
            ::QVideoFrameFormat *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QVideoFrameFormat(QVideoFrameFormat)
                cptr = new ::QVideoFrameFormat(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QVideoFrameFormat >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QVideoFrameFormatFunc_colorRange(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QVideoFrameFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtMultimedia.QVideoFrameFormat.colorRange";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // colorRange()const
            QVideoFrameFormat::ColorRange cppResult = const_cast<const ::QVideoFrameFormat *>(cppSelf)->colorRange();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_ColorRange_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QVideoFrameFormatFunc_colorSpace(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QVideoFrameFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtMultimedia.QVideoFrameFormat.colorSpace";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // colorSpace()const
            QVideoFrameFormat::ColorSpace cppResult = const_cast<const ::QVideoFrameFormat *>(cppSelf)->colorSpace();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_ColorSpace_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QVideoFrameFormatFunc_colorTransfer(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QVideoFrameFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtMultimedia.QVideoFrameFormat.colorTransfer";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // colorTransfer()const
            QVideoFrameFormat::ColorTransfer cppResult = const_cast<const ::QVideoFrameFormat *>(cppSelf)->colorTransfer();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_ColorTransfer_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QVideoFrameFormatFunc_fragmentShaderFileName(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QVideoFrameFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtMultimedia.QVideoFrameFormat.fragmentShaderFileName";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // fragmentShaderFileName()const
            QString cppResult = const_cast<const ::QVideoFrameFormat *>(cppSelf)->fragmentShaderFileName();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QVideoFrameFormatFunc_frameHeight(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QVideoFrameFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtMultimedia.QVideoFrameFormat.frameHeight";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // frameHeight()const
            int cppResult = const_cast<const ::QVideoFrameFormat *>(cppSelf)->frameHeight();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QVideoFrameFormatFunc_frameRate(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QVideoFrameFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtMultimedia.QVideoFrameFormat.frameRate";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // frameRate()const
            qreal cppResult = const_cast<const ::QVideoFrameFormat *>(cppSelf)->frameRate();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QVideoFrameFormatFunc_frameSize(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QVideoFrameFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtMultimedia.QVideoFrameFormat.frameSize";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // frameSize()const
            QSize cppResult = const_cast<const ::QVideoFrameFormat *>(cppSelf)->frameSize();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSize_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QVideoFrameFormatFunc_frameWidth(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QVideoFrameFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtMultimedia.QVideoFrameFormat.frameWidth";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // frameWidth()const
            int cppResult = const_cast<const ::QVideoFrameFormat *>(cppSelf)->frameWidth();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QVideoFrameFormatFunc_imageFormatFromPixelFormat(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtMultimedia.QVideoFrameFormat.imageFormatFromPixelFormat";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static QVideoFrameFormat::imageFormatFromPixelFormat(QVideoFrameFormat::PixelFormat)->QImage::Format
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_PixelFormat_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // imageFormatFromPixelFormat(QVideoFrameFormat::PixelFormat)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QVideoFrameFormat::PixelFormat cppArg0{QVideoFrameFormat::Format_Invalid};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // imageFormatFromPixelFormat(QVideoFrameFormat::PixelFormat)
            QImage::Format cppResult = ::QVideoFrameFormat::imageFormatFromPixelFormat(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QImage_Format_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QVideoFrameFormatFunc_isMirrored(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QVideoFrameFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtMultimedia.QVideoFrameFormat.isMirrored";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isMirrored()const
            bool cppResult = const_cast<const ::QVideoFrameFormat *>(cppSelf)->isMirrored();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QVideoFrameFormatFunc_isValid(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QVideoFrameFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtMultimedia.QVideoFrameFormat.isValid";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isValid()const
            bool cppResult = const_cast<const ::QVideoFrameFormat *>(cppSelf)->isValid();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QVideoFrameFormatFunc_maxLuminance(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QVideoFrameFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtMultimedia.QVideoFrameFormat.maxLuminance";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // maxLuminance()const
            float cppResult = const_cast<const ::QVideoFrameFormat *>(cppSelf)->maxLuminance();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<float>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QVideoFrameFormatFunc_pixelFormat(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QVideoFrameFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtMultimedia.QVideoFrameFormat.pixelFormat";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // pixelFormat()const
            QVideoFrameFormat::PixelFormat cppResult = const_cast<const ::QVideoFrameFormat *>(cppSelf)->pixelFormat();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_PixelFormat_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QVideoFrameFormatFunc_pixelFormatFromImageFormat(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtMultimedia.QVideoFrameFormat.pixelFormatFromImageFormat";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static QVideoFrameFormat::pixelFormatFromImageFormat(QImage::Format)->QVideoFrameFormat::PixelFormat
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QImage_Format_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // pixelFormatFromImageFormat(QImage::Format)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QImage::Format cppArg0{QImage::Format_Invalid};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // pixelFormatFromImageFormat(QImage::Format)
            QVideoFrameFormat::PixelFormat cppResult = ::QVideoFrameFormat::pixelFormatFromImageFormat(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_PixelFormat_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QVideoFrameFormatFunc_pixelFormatToString(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtMultimedia.QVideoFrameFormat.pixelFormatToString";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static QVideoFrameFormat::pixelFormatToString(QVideoFrameFormat::PixelFormat)->QString
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_PixelFormat_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // pixelFormatToString(QVideoFrameFormat::PixelFormat)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QVideoFrameFormat::PixelFormat cppArg0{QVideoFrameFormat::Format_Invalid};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // pixelFormatToString(QVideoFrameFormat::PixelFormat)
            QString cppResult = ::QVideoFrameFormat::pixelFormatToString(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QVideoFrameFormatFunc_planeCount(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QVideoFrameFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtMultimedia.QVideoFrameFormat.planeCount";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // planeCount()const
            int cppResult = const_cast<const ::QVideoFrameFormat *>(cppSelf)->planeCount();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QVideoFrameFormatFunc_scanLineDirection(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QVideoFrameFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtMultimedia.QVideoFrameFormat.scanLineDirection";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // scanLineDirection()const
            QVideoFrameFormat::Direction cppResult = const_cast<const ::QVideoFrameFormat *>(cppSelf)->scanLineDirection();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_Direction_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QVideoFrameFormatFunc_setColorRange(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QVideoFrameFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtMultimedia.QVideoFrameFormat.setColorRange";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QVideoFrameFormat::setColorRange(QVideoFrameFormat::ColorRange)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_ColorRange_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // setColorRange(QVideoFrameFormat::ColorRange)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QVideoFrameFormat::ColorRange cppArg0{QVideoFrameFormat::ColorRange_Unknown};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setColorRange(QVideoFrameFormat::ColorRange)
            cppSelf->setColorRange(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QVideoFrameFormatFunc_setColorSpace(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QVideoFrameFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtMultimedia.QVideoFrameFormat.setColorSpace";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QVideoFrameFormat::setColorSpace(QVideoFrameFormat::ColorSpace)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_ColorSpace_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // setColorSpace(QVideoFrameFormat::ColorSpace)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QVideoFrameFormat::ColorSpace cppArg0{QVideoFrameFormat::ColorSpace_Undefined};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setColorSpace(QVideoFrameFormat::ColorSpace)
            cppSelf->setColorSpace(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QVideoFrameFormatFunc_setColorTransfer(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QVideoFrameFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtMultimedia.QVideoFrameFormat.setColorTransfer";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QVideoFrameFormat::setColorTransfer(QVideoFrameFormat::ColorTransfer)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_ColorTransfer_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // setColorTransfer(QVideoFrameFormat::ColorTransfer)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QVideoFrameFormat::ColorTransfer cppArg0{QVideoFrameFormat::ColorTransfer_Unknown};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setColorTransfer(QVideoFrameFormat::ColorTransfer)
            cppSelf->setColorTransfer(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QVideoFrameFormatFunc_setFrameRate(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QVideoFrameFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtMultimedia.QVideoFrameFormat.setFrameRate";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QVideoFrameFormat::setFrameRate(qreal)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), (pyArg)))) {
        overloadId = 0; // setFrameRate(qreal)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        qreal cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setFrameRate(qreal)
            cppSelf->setFrameRate(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QVideoFrameFormatFunc_setFrameSize(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QVideoFrameFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtMultimedia.QVideoFrameFormat.setFrameSize";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "setFrameSize", 1, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QVideoFrameFormat::setFrameSize(QSize)
    // 1: QVideoFrameFormat::setFrameSize(int,int)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1])))) {
        overloadId = 1; // setFrameSize(int,int)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSize_IDX]), (pyArgs[0])))) {
        overloadId = 0; // setFrameSize(QSize)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    switch (overloadId) {
        case 0: // setFrameSize(const QSize & size)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return {};
            ::QSize cppArg0_local;
            ::QSize *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // setFrameSize(QSize)
                cppSelf->setFrameSize(*cppArg0);
            }
            break;
        }
        case 1: // setFrameSize(int width, int height)
        {
            int cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            int cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // setFrameSize(int,int)
                cppSelf->setFrameSize(cppArg0, cppArg1);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QVideoFrameFormatFunc_setMaxLuminance(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QVideoFrameFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtMultimedia.QVideoFrameFormat.setMaxLuminance";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QVideoFrameFormat::setMaxLuminance(float)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<float>(), (pyArg)))) {
        overloadId = 0; // setMaxLuminance(float)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        float cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setMaxLuminance(float)
            cppSelf->setMaxLuminance(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QVideoFrameFormatFunc_setMirrored(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QVideoFrameFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtMultimedia.QVideoFrameFormat.setMirrored";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QVideoFrameFormat::setMirrored(bool)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArg)))) {
        overloadId = 0; // setMirrored(bool)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        bool cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setMirrored(bool)
            cppSelf->setMirrored(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QVideoFrameFormatFunc_setScanLineDirection(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QVideoFrameFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtMultimedia.QVideoFrameFormat.setScanLineDirection";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QVideoFrameFormat::setScanLineDirection(QVideoFrameFormat::Direction)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_Direction_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // setScanLineDirection(QVideoFrameFormat::Direction)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QVideoFrameFormat::Direction cppArg0{QVideoFrameFormat::TopToBottom};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setScanLineDirection(QVideoFrameFormat::Direction)
            cppSelf->setScanLineDirection(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QVideoFrameFormatFunc_setViewport(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QVideoFrameFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtMultimedia.QVideoFrameFormat.setViewport";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QVideoFrameFormat::setViewport(QRect)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRect_IDX]), (pyArg)))) {
        overloadId = 0; // setViewport(QRect)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QRect cppArg0_local;
        ::QRect *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // setViewport(QRect)
            cppSelf->setViewport(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QVideoFrameFormatFunc_setYCbCrColorSpace(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QVideoFrameFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtMultimedia.QVideoFrameFormat.setYCbCrColorSpace";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QVideoFrameFormat::setYCbCrColorSpace(QVideoFrameFormat::YCbCrColorSpace)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_YCbCrColorSpace_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // setYCbCrColorSpace(QVideoFrameFormat::YCbCrColorSpace)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        Shiboken::Warnings::warnDeprecated("QVideoFrameFormat", "setYCbCrColorSpace(QVideoFrameFormat.YCbCrColorSpace colorSpace)");
        if (Shiboken::Errors::occurred() != nullptr)
            return {};
        ::QVideoFrameFormat::YCbCrColorSpace cppArg0{QVideoFrameFormat::YCbCr_Undefined};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setYCbCrColorSpace(QVideoFrameFormat::YCbCrColorSpace)
            cppSelf->setYCbCrColorSpace(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QVideoFrameFormatFunc_swap(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QVideoFrameFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtMultimedia.QVideoFrameFormat.swap";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QVideoFrameFormat::swap(QVideoFrameFormat&)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), (pyArg)))) {
        overloadId = 0; // swap(QVideoFrameFormat&)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QVideoFrameFormat cppArg0_local;
        ::QVideoFrameFormat *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // swap(QVideoFrameFormat&)
            cppSelf->swap(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QVideoFrameFormatFunc_updateUniformData(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QVideoFrameFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtMultimedia.QVideoFrameFormat.updateUniformData";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[4];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "updateUniformData", 4, 4, &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2]), &(pyArgs[3])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QVideoFrameFormat::updateUniformData(QByteArray*,QVideoFrame,QMatrix4x4,float)const
    if (numArgs == 4
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrame_IDX]), (pyArgs[1])))
        && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QMatrix4x4_IDX]), (pyArgs[2])))
        && (pythonToCpp[3] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<float>(), (pyArgs[3])))) {
        overloadId = 0; // updateUniformData(QByteArray*,QVideoFrame,QMatrix4x4,float)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArgs[0]))
            return {};
        ::QByteArray *cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        if (!Shiboken::Object::isValid(pyArgs[1]))
            return {};
        ::QVideoFrame cppArg1_local;
        ::QVideoFrame *cppArg1 = &cppArg1_local;
        if (pythonToCpp[1].isValue())
            pythonToCpp[1](pyArgs[1], &cppArg1_local);
        else
            pythonToCpp[1](pyArgs[1], &cppArg1);

        if (!Shiboken::Object::isValid(pyArgs[2]))
            return {};
        ::QMatrix4x4 cppArg2_local;
        ::QMatrix4x4 *cppArg2 = &cppArg2_local;
        if (pythonToCpp[2].isValue())
            pythonToCpp[2](pyArgs[2], &cppArg2_local);
        else
            pythonToCpp[2](pyArgs[2], &cppArg2);

        float cppArg3;
        pythonToCpp[3](pyArgs[3], &cppArg3);

        if (Shiboken::Errors::occurred() == nullptr) {
            // updateUniformData(QByteArray*,QVideoFrame,QMatrix4x4,float)const
            const_cast<const ::QVideoFrameFormat *>(cppSelf)->updateUniformData(cppArg0, *cppArg1, *cppArg2, cppArg3);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QVideoFrameFormatFunc_vertexShaderFileName(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QVideoFrameFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtMultimedia.QVideoFrameFormat.vertexShaderFileName";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // vertexShaderFileName()const
            QString cppResult = const_cast<const ::QVideoFrameFormat *>(cppSelf)->vertexShaderFileName();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QVideoFrameFormatFunc_viewport(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QVideoFrameFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtMultimedia.QVideoFrameFormat.viewport";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // viewport()const
            QRect cppResult = const_cast<const ::QVideoFrameFormat *>(cppSelf)->viewport();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRect_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QVideoFrameFormatFunc_yCbCrColorSpace(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QVideoFrameFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtMultimedia.QVideoFrameFormat.yCbCrColorSpace";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {
        Shiboken::Warnings::warnDeprecated("QVideoFrameFormat", "yCbCrColorSpace() const");
        if (Shiboken::Errors::occurred() != nullptr)
            return {};

        if (Shiboken::Errors::occurred() == nullptr) {
            // yCbCrColorSpace()const
            QVideoFrameFormat::YCbCrColorSpace cppResult = const_cast<const ::QVideoFrameFormat *>(cppSelf)->yCbCrColorSpace();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_YCbCrColorSpace_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QVideoFrameFormat__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QVideoFrameFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QVideoFrameFormat_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QVideoFrameFormat_EnumFlagInfo[] = {
    "ColorRange:Enum",
    "ColorSpace:Enum",
    "ColorTransfer:Enum",
    "Direction:Enum",
    "PixelFormat:Enum",
    "YCbCrColorSpace:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QVideoFrameFormat_methods[] = {
    {"colorRange", reinterpret_cast<PyCFunction>(Sbk_QVideoFrameFormatFunc_colorRange), METH_NOARGS, nullptr},
    {"colorSpace", reinterpret_cast<PyCFunction>(Sbk_QVideoFrameFormatFunc_colorSpace), METH_NOARGS, nullptr},
    {"colorTransfer", reinterpret_cast<PyCFunction>(Sbk_QVideoFrameFormatFunc_colorTransfer), METH_NOARGS, nullptr},
    {"fragmentShaderFileName", reinterpret_cast<PyCFunction>(Sbk_QVideoFrameFormatFunc_fragmentShaderFileName), METH_NOARGS, nullptr},
    {"frameHeight", reinterpret_cast<PyCFunction>(Sbk_QVideoFrameFormatFunc_frameHeight), METH_NOARGS, nullptr},
    {"frameRate", reinterpret_cast<PyCFunction>(Sbk_QVideoFrameFormatFunc_frameRate), METH_NOARGS, nullptr},
    {"frameSize", reinterpret_cast<PyCFunction>(Sbk_QVideoFrameFormatFunc_frameSize), METH_NOARGS, nullptr},
    {"frameWidth", reinterpret_cast<PyCFunction>(Sbk_QVideoFrameFormatFunc_frameWidth), METH_NOARGS, nullptr},
    {"imageFormatFromPixelFormat", reinterpret_cast<PyCFunction>(Sbk_QVideoFrameFormatFunc_imageFormatFromPixelFormat), METH_O|METH_STATIC, nullptr},
    {"isMirrored", reinterpret_cast<PyCFunction>(Sbk_QVideoFrameFormatFunc_isMirrored), METH_NOARGS, nullptr},
    {"isValid", reinterpret_cast<PyCFunction>(Sbk_QVideoFrameFormatFunc_isValid), METH_NOARGS, nullptr},
    {"maxLuminance", reinterpret_cast<PyCFunction>(Sbk_QVideoFrameFormatFunc_maxLuminance), METH_NOARGS, nullptr},
    {"pixelFormat", reinterpret_cast<PyCFunction>(Sbk_QVideoFrameFormatFunc_pixelFormat), METH_NOARGS, nullptr},
    {"pixelFormatFromImageFormat", reinterpret_cast<PyCFunction>(Sbk_QVideoFrameFormatFunc_pixelFormatFromImageFormat), METH_O|METH_STATIC, nullptr},
    {"pixelFormatToString", reinterpret_cast<PyCFunction>(Sbk_QVideoFrameFormatFunc_pixelFormatToString), METH_O|METH_STATIC, nullptr},
    {"planeCount", reinterpret_cast<PyCFunction>(Sbk_QVideoFrameFormatFunc_planeCount), METH_NOARGS, nullptr},
    {"scanLineDirection", reinterpret_cast<PyCFunction>(Sbk_QVideoFrameFormatFunc_scanLineDirection), METH_NOARGS, nullptr},
    {"setColorRange", reinterpret_cast<PyCFunction>(Sbk_QVideoFrameFormatFunc_setColorRange), METH_O, nullptr},
    {"setColorSpace", reinterpret_cast<PyCFunction>(Sbk_QVideoFrameFormatFunc_setColorSpace), METH_O, nullptr},
    {"setColorTransfer", reinterpret_cast<PyCFunction>(Sbk_QVideoFrameFormatFunc_setColorTransfer), METH_O, nullptr},
    {"setFrameRate", reinterpret_cast<PyCFunction>(Sbk_QVideoFrameFormatFunc_setFrameRate), METH_O, nullptr},
    {"setFrameSize", reinterpret_cast<PyCFunction>(Sbk_QVideoFrameFormatFunc_setFrameSize), METH_VARARGS, nullptr},
    {"setMaxLuminance", reinterpret_cast<PyCFunction>(Sbk_QVideoFrameFormatFunc_setMaxLuminance), METH_O, nullptr},
    {"setMirrored", reinterpret_cast<PyCFunction>(Sbk_QVideoFrameFormatFunc_setMirrored), METH_O, nullptr},
    {"setScanLineDirection", reinterpret_cast<PyCFunction>(Sbk_QVideoFrameFormatFunc_setScanLineDirection), METH_O, nullptr},
    {"setViewport", reinterpret_cast<PyCFunction>(Sbk_QVideoFrameFormatFunc_setViewport), METH_O, nullptr},
    {"setYCbCrColorSpace", reinterpret_cast<PyCFunction>(Sbk_QVideoFrameFormatFunc_setYCbCrColorSpace), METH_O, nullptr},
    {"swap", reinterpret_cast<PyCFunction>(Sbk_QVideoFrameFormatFunc_swap), METH_O, nullptr},
    {"updateUniformData", reinterpret_cast<PyCFunction>(Sbk_QVideoFrameFormatFunc_updateUniformData), METH_VARARGS, nullptr},
    {"vertexShaderFileName", reinterpret_cast<PyCFunction>(Sbk_QVideoFrameFormatFunc_vertexShaderFileName), METH_NOARGS, nullptr},
    {"viewport", reinterpret_cast<PyCFunction>(Sbk_QVideoFrameFormatFunc_viewport), METH_NOARGS, nullptr},
    {"yCbCrColorSpace", reinterpret_cast<PyCFunction>(Sbk_QVideoFrameFormatFunc_yCbCrColorSpace), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QVideoFrameFormat__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QVideoFrameFormat_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QVideoFrameFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), (pyArg)))) {
                // operator!=(const QVideoFrameFormat & format) const
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QVideoFrameFormat cppArg0_local;
                ::QVideoFrameFormat *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), (pyArg)))) {
                // operator==(const QVideoFrameFormat & format) const
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QVideoFrameFormat cppArg0_local;
                ::QVideoFrameFormat *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static int Sbk_QVideoFrameFormat_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QVideoFrameFormat_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
extern "C"
{
static PyObject *Sbk_QVideoFrameFormat__repr__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QVideoFrameFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    QBuffer buffer;
    buffer.open(QBuffer::ReadWrite);
    QDebug dbg(&buffer);
    dbg << *cppSelf;
    buffer.close();
    QByteArray str = buffer.data();
    const auto idx = str.indexOf('(');
    auto *typeName = Py_TYPE(self)->tp_name;
    if (idx >= 0)
        str.replace(0, idx, typeName);
    str = str.trimmed();
    Shiboken::AutoDecRef tpDict(PepType_GetDict(Py_TYPE(self)));
    PyObject *mod = PyDict_GetItem(tpDict.object(), Shiboken::PyMagicName::module());
    if (mod != nullptr && std::strchr(typeName, '.') == nullptr)
        return Shiboken::String::fromFormat("<%s.%s at %p>", Shiboken::String::toCString(mod), str.constData(), self);
    return Shiboken::String::fromFormat("<%s at %p>", str.constData(), self);
}
} // extern C

// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QVideoFrameFormat_Type = nullptr;
static PyTypeObject *Sbk_QVideoFrameFormat_TypeF(void)
{
    return _Sbk_QVideoFrameFormat_Type;
}

static PyType_Slot Sbk_QVideoFrameFormat_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_repr,        reinterpret_cast<void *>(Sbk_QVideoFrameFormat__repr__)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QVideoFrameFormat_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QVideoFrameFormat_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QVideoFrameFormat_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QVideoFrameFormat_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QVideoFrameFormat_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QVideoFrameFormat_spec = {
    "2:PySide6.QtMultimedia.QVideoFrameFormat",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QVideoFrameFormat_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void QVideoFrameFormat_PixelFormat_PythonToCpp_QVideoFrameFormat_PixelFormat(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QVideoFrameFormat::PixelFormat>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QVideoFrameFormat::PixelFormat *>(cppOut) = value;

}
static PythonToCppFunc is_QVideoFrameFormat_PixelFormat_PythonToCpp_QVideoFrameFormat_PixelFormat_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_PixelFormat_IDX])))
        return QVideoFrameFormat_PixelFormat_PythonToCpp_QVideoFrameFormat_PixelFormat;
    return {};
}
static PyObject *QVideoFrameFormat_PixelFormat_CppToPython_QVideoFrameFormat_PixelFormat(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QVideoFrameFormat::PixelFormat *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_PixelFormat_IDX]), castCppIn);

}

static void QVideoFrameFormat_Direction_PythonToCpp_QVideoFrameFormat_Direction(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QVideoFrameFormat::Direction>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QVideoFrameFormat::Direction *>(cppOut) = value;

}
static PythonToCppFunc is_QVideoFrameFormat_Direction_PythonToCpp_QVideoFrameFormat_Direction_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_Direction_IDX])))
        return QVideoFrameFormat_Direction_PythonToCpp_QVideoFrameFormat_Direction;
    return {};
}
static PyObject *QVideoFrameFormat_Direction_CppToPython_QVideoFrameFormat_Direction(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QVideoFrameFormat::Direction *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_Direction_IDX]), castCppIn);

}

static void QVideoFrameFormat_YCbCrColorSpace_PythonToCpp_QVideoFrameFormat_YCbCrColorSpace(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QVideoFrameFormat::YCbCrColorSpace>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QVideoFrameFormat::YCbCrColorSpace *>(cppOut) = value;

}
static PythonToCppFunc is_QVideoFrameFormat_YCbCrColorSpace_PythonToCpp_QVideoFrameFormat_YCbCrColorSpace_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_YCbCrColorSpace_IDX])))
        return QVideoFrameFormat_YCbCrColorSpace_PythonToCpp_QVideoFrameFormat_YCbCrColorSpace;
    return {};
}
static PyObject *QVideoFrameFormat_YCbCrColorSpace_CppToPython_QVideoFrameFormat_YCbCrColorSpace(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QVideoFrameFormat::YCbCrColorSpace *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_YCbCrColorSpace_IDX]), castCppIn);

}

static void QVideoFrameFormat_ColorSpace_PythonToCpp_QVideoFrameFormat_ColorSpace(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QVideoFrameFormat::ColorSpace>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QVideoFrameFormat::ColorSpace *>(cppOut) = value;

}
static PythonToCppFunc is_QVideoFrameFormat_ColorSpace_PythonToCpp_QVideoFrameFormat_ColorSpace_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_ColorSpace_IDX])))
        return QVideoFrameFormat_ColorSpace_PythonToCpp_QVideoFrameFormat_ColorSpace;
    return {};
}
static PyObject *QVideoFrameFormat_ColorSpace_CppToPython_QVideoFrameFormat_ColorSpace(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QVideoFrameFormat::ColorSpace *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_ColorSpace_IDX]), castCppIn);

}

static void QVideoFrameFormat_ColorTransfer_PythonToCpp_QVideoFrameFormat_ColorTransfer(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QVideoFrameFormat::ColorTransfer>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QVideoFrameFormat::ColorTransfer *>(cppOut) = value;

}
static PythonToCppFunc is_QVideoFrameFormat_ColorTransfer_PythonToCpp_QVideoFrameFormat_ColorTransfer_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_ColorTransfer_IDX])))
        return QVideoFrameFormat_ColorTransfer_PythonToCpp_QVideoFrameFormat_ColorTransfer;
    return {};
}
static PyObject *QVideoFrameFormat_ColorTransfer_CppToPython_QVideoFrameFormat_ColorTransfer(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QVideoFrameFormat::ColorTransfer *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_ColorTransfer_IDX]), castCppIn);

}

static void QVideoFrameFormat_ColorRange_PythonToCpp_QVideoFrameFormat_ColorRange(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QVideoFrameFormat::ColorRange>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QVideoFrameFormat::ColorRange *>(cppOut) = value;

}
static PythonToCppFunc is_QVideoFrameFormat_ColorRange_PythonToCpp_QVideoFrameFormat_ColorRange_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_ColorRange_IDX])))
        return QVideoFrameFormat_ColorRange_PythonToCpp_QVideoFrameFormat_ColorRange;
    return {};
}
static PyObject *QVideoFrameFormat_ColorRange_CppToPython_QVideoFrameFormat_ColorRange(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QVideoFrameFormat::ColorRange *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_ColorRange_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QVideoFrameFormat_PythonToCpp_QVideoFrameFormat_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QVideoFrameFormat_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QVideoFrameFormat_PythonToCpp_QVideoFrameFormat_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QVideoFrameFormat_TypeF()))
        return QVideoFrameFormat_PythonToCpp_QVideoFrameFormat_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QVideoFrameFormat_PTR_CppToPython_QVideoFrameFormat(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QVideoFrameFormat *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QVideoFrameFormat_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *QVideoFrameFormat_COPY_CppToPython_QVideoFrameFormat(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QVideoFrameFormat *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QVideoFrameFormat_TypeF(), new ::QVideoFrameFormat(*source), true, true);
}

// Python to C++ copy conversion.
static void QVideoFrameFormat_PythonToCpp_QVideoFrameFormat_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QVideoFrameFormat *>(cppOut) = *reinterpret_cast< ::QVideoFrameFormat *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QVideoFrameFormat_PythonToCpp_QVideoFrameFormat_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QVideoFrameFormat_TypeF()))
        return QVideoFrameFormat_PythonToCpp_QVideoFrameFormat_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QVideoFrameFormat_SignatureStrings[] = {
    "2:PySide6.QtMultimedia.QVideoFrameFormat(self)",
    "1:PySide6.QtMultimedia.QVideoFrameFormat(self,size:PySide6.QtCore.QSize,pixelFormat:PySide6.QtMultimedia.QVideoFrameFormat.PixelFormat)",
    "0:PySide6.QtMultimedia.QVideoFrameFormat(self,format:PySide6.QtMultimedia.QVideoFrameFormat)",
    "PySide6.QtMultimedia.QVideoFrameFormat.colorRange(self)->PySide6.QtMultimedia.QVideoFrameFormat.ColorRange",
    "PySide6.QtMultimedia.QVideoFrameFormat.colorSpace(self)->PySide6.QtMultimedia.QVideoFrameFormat.ColorSpace",
    "PySide6.QtMultimedia.QVideoFrameFormat.colorTransfer(self)->PySide6.QtMultimedia.QVideoFrameFormat.ColorTransfer",
    "PySide6.QtMultimedia.QVideoFrameFormat.fragmentShaderFileName(self)->QString",
    "PySide6.QtMultimedia.QVideoFrameFormat.frameHeight(self)->int",
    "PySide6.QtMultimedia.QVideoFrameFormat.frameRate(self)->qreal",
    "PySide6.QtMultimedia.QVideoFrameFormat.frameSize(self)->PySide6.QtCore.QSize",
    "PySide6.QtMultimedia.QVideoFrameFormat.frameWidth(self)->int",
    "PySide6.QtMultimedia.QVideoFrameFormat.imageFormatFromPixelFormat(format:PySide6.QtMultimedia.QVideoFrameFormat.PixelFormat)->PySide6.QtGui.QImage.Format",
    "PySide6.QtMultimedia.QVideoFrameFormat.isMirrored(self)->bool",
    "PySide6.QtMultimedia.QVideoFrameFormat.isValid(self)->bool",
    "PySide6.QtMultimedia.QVideoFrameFormat.maxLuminance(self)->float",
    "PySide6.QtMultimedia.QVideoFrameFormat.pixelFormat(self)->PySide6.QtMultimedia.QVideoFrameFormat.PixelFormat",
    "PySide6.QtMultimedia.QVideoFrameFormat.pixelFormatFromImageFormat(format:PySide6.QtGui.QImage.Format)->PySide6.QtMultimedia.QVideoFrameFormat.PixelFormat",
    "PySide6.QtMultimedia.QVideoFrameFormat.pixelFormatToString(pixelFormat:PySide6.QtMultimedia.QVideoFrameFormat.PixelFormat)->QString",
    "PySide6.QtMultimedia.QVideoFrameFormat.planeCount(self)->int",
    "PySide6.QtMultimedia.QVideoFrameFormat.scanLineDirection(self)->PySide6.QtMultimedia.QVideoFrameFormat.Direction",
    "PySide6.QtMultimedia.QVideoFrameFormat.setColorRange(self,range:PySide6.QtMultimedia.QVideoFrameFormat.ColorRange)",
    "PySide6.QtMultimedia.QVideoFrameFormat.setColorSpace(self,colorSpace:PySide6.QtMultimedia.QVideoFrameFormat.ColorSpace)",
    "PySide6.QtMultimedia.QVideoFrameFormat.setColorTransfer(self,colorTransfer:PySide6.QtMultimedia.QVideoFrameFormat.ColorTransfer)",
    "PySide6.QtMultimedia.QVideoFrameFormat.setFrameRate(self,rate:qreal)",
    "1:PySide6.QtMultimedia.QVideoFrameFormat.setFrameSize(self,size:PySide6.QtCore.QSize)",
    "0:PySide6.QtMultimedia.QVideoFrameFormat.setFrameSize(self,width:int,height:int)",
    "PySide6.QtMultimedia.QVideoFrameFormat.setMaxLuminance(self,lum:float)",
    "PySide6.QtMultimedia.QVideoFrameFormat.setMirrored(self,mirrored:bool)",
    "PySide6.QtMultimedia.QVideoFrameFormat.setScanLineDirection(self,direction:PySide6.QtMultimedia.QVideoFrameFormat.Direction)",
    "PySide6.QtMultimedia.QVideoFrameFormat.setViewport(self,viewport:PySide6.QtCore.QRect)",
    "PySide6.QtMultimedia.QVideoFrameFormat.setYCbCrColorSpace(self,colorSpace:PySide6.QtMultimedia.QVideoFrameFormat.YCbCrColorSpace)",
    "PySide6.QtMultimedia.QVideoFrameFormat.swap(self,other:PySide6.QtMultimedia.QVideoFrameFormat)",
    "PySide6.QtMultimedia.QVideoFrameFormat.updateUniformData(self,dst:typing.Union[PySide6.QtCore.QByteArray, char*],frame:typing.Union[PySide6.QtMultimedia.QVideoFrame, PySide6.QtMultimedia.QVideoFrameFormat],transform:typing.Union[PySide6.QtGui.QMatrix4x4, PySide6.QtGui.QTransform],opacity:float)",
    "PySide6.QtMultimedia.QVideoFrameFormat.vertexShaderFileName(self)->QString",
    "PySide6.QtMultimedia.QVideoFrameFormat.viewport(self)->PySide6.QtCore.QRect",
    "PySide6.QtMultimedia.QVideoFrameFormat.yCbCrColorSpace(self)->PySide6.QtMultimedia.QVideoFrameFormat.YCbCrColorSpace",
    "PySide6.QtMultimedia.QVideoFrameFormat.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QVideoFrameFormat(PyObject *module)
{
    _Sbk_QVideoFrameFormat_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QVideoFrameFormat",
        "QVideoFrameFormat",
        &Sbk_QVideoFrameFormat_spec,
        &Shiboken::callCppDestructor< ::QVideoFrameFormat >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QVideoFrameFormat_TypeF(); // references _Sbk_QVideoFrameFormat_Type
    InitSignatureStrings(pyType, QVideoFrameFormat_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QVideoFrameFormat_PropertyStrings);
    SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QVideoFrameFormat_PythonToCpp_QVideoFrameFormat_PTR,
        is_QVideoFrameFormat_PythonToCpp_QVideoFrameFormat_PTR_Convertible,
        QVideoFrameFormat_PTR_CppToPython_QVideoFrameFormat,
        QVideoFrameFormat_COPY_CppToPython_QVideoFrameFormat);

    Shiboken::Conversions::registerConverterName(converter, "QVideoFrameFormat");
    Shiboken::Conversions::registerConverterName(converter, "QVideoFrameFormat*");
    Shiboken::Conversions::registerConverterName(converter, "QVideoFrameFormat&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QVideoFrameFormat).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QVideoFrameFormat_PythonToCpp_QVideoFrameFormat_COPY,
        is_QVideoFrameFormat_PythonToCpp_QVideoFrameFormat_COPY_Convertible);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QVideoFrameFormat_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'PixelFormat'.
    const char *PixelFormat_Initializer[] = {
        "Format_Invalid",
        "Format_ARGB8888",
        "Format_ARGB8888_Premultiplied",
        "Format_XRGB8888",
        "Format_BGRA8888",
        "Format_BGRA8888_Premultiplied",
        "Format_BGRX8888",
        "Format_ABGR8888",
        "Format_XBGR8888",
        "Format_RGBA8888",
        "Format_RGBX8888",
        "Format_AYUV",
        "Format_AYUV_Premultiplied",
        "Format_YUV420P",
        "Format_YUV422P",
        "Format_YV12",
        "Format_UYVY",
        "Format_YUYV",
        "Format_NV12",
        "Format_NV21",
        "Format_IMC1",
        "Format_IMC2",
        "Format_IMC3",
        "Format_IMC4",
        "Format_Y8",
        "Format_Y16",
        "Format_P010",
        "Format_P016",
        "Format_SamplerExternalOES",
        "Format_Jpeg",
        "Format_SamplerRect",
        "Format_YUV420P10",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t PixelFormat_InitializerValues[] = {
        uint8_t(QVideoFrameFormat::PixelFormat::Format_Invalid),                //  0x00  0
        uint8_t(QVideoFrameFormat::PixelFormat::Format_ARGB8888),               //  0x01  1
        uint8_t(QVideoFrameFormat::PixelFormat::Format_ARGB8888_Premultiplied), //  0x02  2
        uint8_t(QVideoFrameFormat::PixelFormat::Format_XRGB8888),               //  0x03  3
        uint8_t(QVideoFrameFormat::PixelFormat::Format_BGRA8888),               //  0x04  4
        uint8_t(QVideoFrameFormat::PixelFormat::Format_BGRA8888_Premultiplied), //  0x05  5
        uint8_t(QVideoFrameFormat::PixelFormat::Format_BGRX8888),               //  0x06  6
        uint8_t(QVideoFrameFormat::PixelFormat::Format_ABGR8888),               //  0x07  7
        uint8_t(QVideoFrameFormat::PixelFormat::Format_XBGR8888),               //  0x08  8
        uint8_t(QVideoFrameFormat::PixelFormat::Format_RGBA8888),               //  0x09  9
        uint8_t(QVideoFrameFormat::PixelFormat::Format_RGBX8888),               //  0x0a  10
        uint8_t(QVideoFrameFormat::PixelFormat::Format_AYUV),                   //  0x0b  11
        uint8_t(QVideoFrameFormat::PixelFormat::Format_AYUV_Premultiplied),     //  0x0c  12
        uint8_t(QVideoFrameFormat::PixelFormat::Format_YUV420P),                //  0x0d  13
        uint8_t(QVideoFrameFormat::PixelFormat::Format_YUV422P),                //  0x0e  14
        uint8_t(QVideoFrameFormat::PixelFormat::Format_YV12),                   //  0x0f  15
        uint8_t(QVideoFrameFormat::PixelFormat::Format_UYVY),                   //  0x10  16
        uint8_t(QVideoFrameFormat::PixelFormat::Format_YUYV),                   //  0x11  17
        uint8_t(QVideoFrameFormat::PixelFormat::Format_NV12),                   //  0x12  18
        uint8_t(QVideoFrameFormat::PixelFormat::Format_NV21),                   //  0x13  19
        uint8_t(QVideoFrameFormat::PixelFormat::Format_IMC1),                   //  0x14  20
        uint8_t(QVideoFrameFormat::PixelFormat::Format_IMC2),                   //  0x15  21
        uint8_t(QVideoFrameFormat::PixelFormat::Format_IMC3),                   //  0x16  22
        uint8_t(QVideoFrameFormat::PixelFormat::Format_IMC4),                   //  0x17  23
        uint8_t(QVideoFrameFormat::PixelFormat::Format_Y8),                     //  0x18  24
        uint8_t(QVideoFrameFormat::PixelFormat::Format_Y16),                    //  0x19  25
        uint8_t(QVideoFrameFormat::PixelFormat::Format_P010),                   //  0x1a  26
        uint8_t(QVideoFrameFormat::PixelFormat::Format_P016),                   //  0x1b  27
        uint8_t(QVideoFrameFormat::PixelFormat::Format_SamplerExternalOES),     //  0x1c  28
        uint8_t(QVideoFrameFormat::PixelFormat::Format_Jpeg),                   //  0x1d  29
        uint8_t(QVideoFrameFormat::PixelFormat::Format_SamplerRect),            //  0x1e  30
        uint8_t(QVideoFrameFormat::PixelFormat::Format_YUV420P10)               //  0x1f  31
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QVideoFrameFormat_TypeF(),
        "2:PySide6.QtMultimedia.QVideoFrameFormat.PixelFormat",
        PixelFormat_Initializer, PixelFormat_InitializerValues);
    SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_PixelFormat_IDX].type = EType;
    // Register converter for enum 'QVideoFrameFormat::PixelFormat'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QVideoFrameFormat_PixelFormat_CppToPython_QVideoFrameFormat_PixelFormat);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QVideoFrameFormat_PixelFormat_PythonToCpp_QVideoFrameFormat_PixelFormat,
            is_QVideoFrameFormat_PixelFormat_PythonToCpp_QVideoFrameFormat_PixelFormat_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QVideoFrameFormat::PixelFormat");
        Shiboken::Conversions::registerConverterName(converter, "PixelFormat");
    }
    // End of 'PixelFormat' enum.

    // Initialization of enum 'Direction'.
    const char *Direction_Initializer[] = {
        "TopToBottom",
        "BottomToTop",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t Direction_InitializerValues[] = {
        uint8_t(QVideoFrameFormat::Direction::TopToBottom), //  0x00  0
        uint8_t(QVideoFrameFormat::Direction::BottomToTop)  //  0x01  1
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QVideoFrameFormat_TypeF(),
        "2:PySide6.QtMultimedia.QVideoFrameFormat.Direction",
        Direction_Initializer, Direction_InitializerValues);
    SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_Direction_IDX].type = EType;
    // Register converter for enum 'QVideoFrameFormat::Direction'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QVideoFrameFormat_Direction_CppToPython_QVideoFrameFormat_Direction);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QVideoFrameFormat_Direction_PythonToCpp_QVideoFrameFormat_Direction,
            is_QVideoFrameFormat_Direction_PythonToCpp_QVideoFrameFormat_Direction_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QVideoFrameFormat::Direction");
        Shiboken::Conversions::registerConverterName(converter, "Direction");
    }
    // End of 'Direction' enum.

    // Initialization of enum 'YCbCrColorSpace'.
    const char *YCbCrColorSpace_Initializer[] = {
        "YCbCr_Undefined",
        "YCbCr_BT601",
        "YCbCr_BT709",
        "YCbCr_xvYCC601",
        "YCbCr_xvYCC709",
        "YCbCr_JPEG",
        "YCbCr_BT2020",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t YCbCrColorSpace_InitializerValues[] = {
        uint8_t(QVideoFrameFormat::YCbCrColorSpace::YCbCr_Undefined), //  0x00  0
        uint8_t(QVideoFrameFormat::YCbCrColorSpace::YCbCr_BT601),     //  0x01  1
        uint8_t(QVideoFrameFormat::YCbCrColorSpace::YCbCr_BT709),     //  0x02  2
        uint8_t(QVideoFrameFormat::YCbCrColorSpace::YCbCr_xvYCC601),  //  0x03  3
        uint8_t(QVideoFrameFormat::YCbCrColorSpace::YCbCr_xvYCC709),  //  0x04  4
        uint8_t(QVideoFrameFormat::YCbCrColorSpace::YCbCr_JPEG),      //  0x05  5
        uint8_t(QVideoFrameFormat::YCbCrColorSpace::YCbCr_BT2020)     //  0x06  6
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QVideoFrameFormat_TypeF(),
        "2:PySide6.QtMultimedia.QVideoFrameFormat.YCbCrColorSpace",
        YCbCrColorSpace_Initializer, YCbCrColorSpace_InitializerValues);
    SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_YCbCrColorSpace_IDX].type = EType;
    // Register converter for enum 'QVideoFrameFormat::YCbCrColorSpace'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QVideoFrameFormat_YCbCrColorSpace_CppToPython_QVideoFrameFormat_YCbCrColorSpace);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QVideoFrameFormat_YCbCrColorSpace_PythonToCpp_QVideoFrameFormat_YCbCrColorSpace,
            is_QVideoFrameFormat_YCbCrColorSpace_PythonToCpp_QVideoFrameFormat_YCbCrColorSpace_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QVideoFrameFormat::YCbCrColorSpace");
        Shiboken::Conversions::registerConverterName(converter, "YCbCrColorSpace");
    }
    // End of 'YCbCrColorSpace' enum.

    // Initialization of enum 'ColorSpace'.
    const char *ColorSpace_Initializer[] = {
        "ColorSpace_Undefined",
        "ColorSpace_BT601",
        "ColorSpace_BT709",
        "ColorSpace_AdobeRgb",
        "ColorSpace_BT2020",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t ColorSpace_InitializerValues[] = {
        uint8_t(QVideoFrameFormat::ColorSpace::ColorSpace_Undefined), //  0x00  0
        uint8_t(QVideoFrameFormat::ColorSpace::ColorSpace_BT601),     //  0x01  1
        uint8_t(QVideoFrameFormat::ColorSpace::ColorSpace_BT709),     //  0x02  2
        uint8_t(QVideoFrameFormat::ColorSpace::ColorSpace_AdobeRgb),  //  0x05  5
        uint8_t(QVideoFrameFormat::ColorSpace::ColorSpace_BT2020)     //  0x06  6
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QVideoFrameFormat_TypeF(),
        "2:PySide6.QtMultimedia.QVideoFrameFormat.ColorSpace",
        ColorSpace_Initializer, ColorSpace_InitializerValues);
    SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_ColorSpace_IDX].type = EType;
    // Register converter for enum 'QVideoFrameFormat::ColorSpace'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QVideoFrameFormat_ColorSpace_CppToPython_QVideoFrameFormat_ColorSpace);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QVideoFrameFormat_ColorSpace_PythonToCpp_QVideoFrameFormat_ColorSpace,
            is_QVideoFrameFormat_ColorSpace_PythonToCpp_QVideoFrameFormat_ColorSpace_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QVideoFrameFormat::ColorSpace");
        Shiboken::Conversions::registerConverterName(converter, "ColorSpace");
    }
    // End of 'ColorSpace' enum.

    // Initialization of enum 'ColorTransfer'.
    const char *ColorTransfer_Initializer[] = {
        "ColorTransfer_Unknown",
        "ColorTransfer_BT709",
        "ColorTransfer_BT601",
        "ColorTransfer_Linear",
        "ColorTransfer_Gamma22",
        "ColorTransfer_Gamma28",
        "ColorTransfer_ST2084",
        "ColorTransfer_STD_B67",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t ColorTransfer_InitializerValues[] = {
        uint8_t(QVideoFrameFormat::ColorTransfer::ColorTransfer_Unknown), //  0x00  0
        uint8_t(QVideoFrameFormat::ColorTransfer::ColorTransfer_BT709),   //  0x01  1
        uint8_t(QVideoFrameFormat::ColorTransfer::ColorTransfer_BT601),   //  0x02  2
        uint8_t(QVideoFrameFormat::ColorTransfer::ColorTransfer_Linear),  //  0x03  3
        uint8_t(QVideoFrameFormat::ColorTransfer::ColorTransfer_Gamma22), //  0x04  4
        uint8_t(QVideoFrameFormat::ColorTransfer::ColorTransfer_Gamma28), //  0x05  5
        uint8_t(QVideoFrameFormat::ColorTransfer::ColorTransfer_ST2084),  //  0x06  6
        uint8_t(QVideoFrameFormat::ColorTransfer::ColorTransfer_STD_B67)  //  0x07  7
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QVideoFrameFormat_TypeF(),
        "2:PySide6.QtMultimedia.QVideoFrameFormat.ColorTransfer",
        ColorTransfer_Initializer, ColorTransfer_InitializerValues);
    SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_ColorTransfer_IDX].type = EType;
    // Register converter for enum 'QVideoFrameFormat::ColorTransfer'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QVideoFrameFormat_ColorTransfer_CppToPython_QVideoFrameFormat_ColorTransfer);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QVideoFrameFormat_ColorTransfer_PythonToCpp_QVideoFrameFormat_ColorTransfer,
            is_QVideoFrameFormat_ColorTransfer_PythonToCpp_QVideoFrameFormat_ColorTransfer_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QVideoFrameFormat::ColorTransfer");
        Shiboken::Conversions::registerConverterName(converter, "ColorTransfer");
    }
    // End of 'ColorTransfer' enum.

    // Initialization of enum 'ColorRange'.
    const char *ColorRange_Initializer[] = {
        "ColorRange_Unknown",
        "ColorRange_Video",
        "ColorRange_Full",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t ColorRange_InitializerValues[] = {
        uint8_t(QVideoFrameFormat::ColorRange::ColorRange_Unknown), //  0x00  0
        uint8_t(QVideoFrameFormat::ColorRange::ColorRange_Video),   //  0x01  1
        uint8_t(QVideoFrameFormat::ColorRange::ColorRange_Full)     //  0x02  2
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QVideoFrameFormat_TypeF(),
        "2:PySide6.QtMultimedia.QVideoFrameFormat.ColorRange",
        ColorRange_Initializer, ColorRange_InitializerValues);
    SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrameFormat_ColorRange_IDX].type = EType;
    // Register converter for enum 'QVideoFrameFormat::ColorRange'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QVideoFrameFormat_ColorRange_CppToPython_QVideoFrameFormat_ColorRange);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QVideoFrameFormat_ColorRange_PythonToCpp_QVideoFrameFormat_ColorRange,
            is_QVideoFrameFormat_ColorRange_PythonToCpp_QVideoFrameFormat_ColorRange_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QVideoFrameFormat::ColorRange");
        Shiboken::Conversions::registerConverterName(converter, "ColorRange");
    }
    // End of 'ColorRange' enum.

    qRegisterMetaType< ::QVideoFrameFormat >("QVideoFrameFormat");
    qRegisterMetaType< ::QVideoFrameFormat::PixelFormat >("QVideoFrameFormat::PixelFormat");
    qRegisterMetaType< ::QVideoFrameFormat::Direction >("QVideoFrameFormat::Direction");
    qRegisterMetaType< ::QVideoFrameFormat::YCbCrColorSpace >("QVideoFrameFormat::YCbCrColorSpace");
    qRegisterMetaType< ::QVideoFrameFormat::ColorSpace >("QVideoFrameFormat::ColorSpace");
    qRegisterMetaType< ::QVideoFrameFormat::ColorTransfer >("QVideoFrameFormat::ColorTransfer");
    qRegisterMetaType< ::QVideoFrameFormat::ColorRange >("QVideoFrameFormat::ColorRange");

    return pyType;
}

PyTypeObject *init_QVideoFrameFormatStaticFields(PyObject *module)
{
    auto *obType = PyObject_GetAttrString(module, "QVideoFrameFormat");
    auto *type = reinterpret_cast<PyTypeObject *>(obType);
    Shiboken::AutoDecRef dict(PepType_GetDict(type));
    PyDict_SetItemString(dict, "NPixelFormats",
                         Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &QVideoFrameFormat::NPixelFormats));
    return type;
}
