// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtnetwork_python.h"

// main header
#include "qdnsmailexchangerecord_wrapper.h"

// Argument includes
#include <QString>
#include <QtNetwork/qdnslookup.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QDnsMailExchangeRecord_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QDnsMailExchangeRecord >()))
        return -1;

    ::QDnsMailExchangeRecord *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtNetwork.QDnsMailExchangeRecord.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QDnsMailExchangeRecord", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QDnsMailExchangeRecord::QDnsMailExchangeRecord()
    // 1: QDnsMailExchangeRecord::QDnsMailExchangeRecord(QDnsMailExchangeRecord)
    if (numArgs == 0) {
        overloadId = 0; // QDnsMailExchangeRecord()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsMailExchangeRecord_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QDnsMailExchangeRecord(QDnsMailExchangeRecord)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QDnsMailExchangeRecord()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QDnsMailExchangeRecord()
                cptr = new ::QDnsMailExchangeRecord();
            }
            break;
        }
        case 1: // QDnsMailExchangeRecord(const QDnsMailExchangeRecord & other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QDnsMailExchangeRecord cppArg0_local;
            ::QDnsMailExchangeRecord *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QDnsMailExchangeRecord(QDnsMailExchangeRecord)
                cptr = new ::QDnsMailExchangeRecord(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QDnsMailExchangeRecord >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QDnsMailExchangeRecordFunc_exchange(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDnsMailExchangeRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsMailExchangeRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtNetwork.QDnsMailExchangeRecord.exchange";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // exchange()const
            QString cppResult = const_cast<const ::QDnsMailExchangeRecord *>(cppSelf)->exchange();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDnsMailExchangeRecordFunc_name(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDnsMailExchangeRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsMailExchangeRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtNetwork.QDnsMailExchangeRecord.name";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // name()const
            QString cppResult = const_cast<const ::QDnsMailExchangeRecord *>(cppSelf)->name();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDnsMailExchangeRecordFunc_preference(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDnsMailExchangeRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsMailExchangeRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtNetwork.QDnsMailExchangeRecord.preference";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // preference()const
            quint16 cppResult = const_cast<const ::QDnsMailExchangeRecord *>(cppSelf)->preference();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<quint16>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDnsMailExchangeRecordFunc_swap(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDnsMailExchangeRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsMailExchangeRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtNetwork.QDnsMailExchangeRecord.swap";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QDnsMailExchangeRecord::swap(QDnsMailExchangeRecord&)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsMailExchangeRecord_IDX]), (pyArg)))) {
        overloadId = 0; // swap(QDnsMailExchangeRecord&)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QDnsMailExchangeRecord cppArg0_local;
        ::QDnsMailExchangeRecord *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // swap(QDnsMailExchangeRecord&)
            cppSelf->swap(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QDnsMailExchangeRecordFunc_timeToLive(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDnsMailExchangeRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsMailExchangeRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtNetwork.QDnsMailExchangeRecord.timeToLive";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // timeToLive()const
            quint32 cppResult = const_cast<const ::QDnsMailExchangeRecord *>(cppSelf)->timeToLive();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDnsMailExchangeRecord__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QDnsMailExchangeRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsMailExchangeRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsMailExchangeRecord_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QDnsMailExchangeRecord_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QDnsMailExchangeRecord_methods[] = {
    {"exchange", reinterpret_cast<PyCFunction>(Sbk_QDnsMailExchangeRecordFunc_exchange), METH_NOARGS, nullptr},
    {"name", reinterpret_cast<PyCFunction>(Sbk_QDnsMailExchangeRecordFunc_name), METH_NOARGS, nullptr},
    {"preference", reinterpret_cast<PyCFunction>(Sbk_QDnsMailExchangeRecordFunc_preference), METH_NOARGS, nullptr},
    {"swap", reinterpret_cast<PyCFunction>(Sbk_QDnsMailExchangeRecordFunc_swap), METH_O, nullptr},
    {"timeToLive", reinterpret_cast<PyCFunction>(Sbk_QDnsMailExchangeRecordFunc_timeToLive), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QDnsMailExchangeRecord__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QDnsMailExchangeRecord_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QDnsMailExchangeRecord_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QDnsMailExchangeRecord_Type = nullptr;
static PyTypeObject *Sbk_QDnsMailExchangeRecord_TypeF(void)
{
    return _Sbk_QDnsMailExchangeRecord_Type;
}

static PyType_Slot Sbk_QDnsMailExchangeRecord_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QDnsMailExchangeRecord_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QDnsMailExchangeRecord_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QDnsMailExchangeRecord_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QDnsMailExchangeRecord_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QDnsMailExchangeRecord_spec = {
    "2:PySide6.QtNetwork.QDnsMailExchangeRecord",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QDnsMailExchangeRecord_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QDnsMailExchangeRecord_PythonToCpp_QDnsMailExchangeRecord_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QDnsMailExchangeRecord_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QDnsMailExchangeRecord_PythonToCpp_QDnsMailExchangeRecord_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QDnsMailExchangeRecord_TypeF()))
        return QDnsMailExchangeRecord_PythonToCpp_QDnsMailExchangeRecord_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QDnsMailExchangeRecord_PTR_CppToPython_QDnsMailExchangeRecord(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QDnsMailExchangeRecord *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QDnsMailExchangeRecord_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *QDnsMailExchangeRecord_COPY_CppToPython_QDnsMailExchangeRecord(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QDnsMailExchangeRecord *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QDnsMailExchangeRecord_TypeF(), new ::QDnsMailExchangeRecord(*source), true, true);
}

// Python to C++ copy conversion.
static void QDnsMailExchangeRecord_PythonToCpp_QDnsMailExchangeRecord_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QDnsMailExchangeRecord *>(cppOut) = *reinterpret_cast< ::QDnsMailExchangeRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsMailExchangeRecord_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QDnsMailExchangeRecord_PythonToCpp_QDnsMailExchangeRecord_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QDnsMailExchangeRecord_TypeF()))
        return QDnsMailExchangeRecord_PythonToCpp_QDnsMailExchangeRecord_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QDnsMailExchangeRecord_SignatureStrings[] = {
    "1:PySide6.QtNetwork.QDnsMailExchangeRecord(self)",
    "0:PySide6.QtNetwork.QDnsMailExchangeRecord(self,other:PySide6.QtNetwork.QDnsMailExchangeRecord)",
    "PySide6.QtNetwork.QDnsMailExchangeRecord.exchange(self)->QString",
    "PySide6.QtNetwork.QDnsMailExchangeRecord.name(self)->QString",
    "PySide6.QtNetwork.QDnsMailExchangeRecord.preference(self)->quint16",
    "PySide6.QtNetwork.QDnsMailExchangeRecord.swap(self,other:PySide6.QtNetwork.QDnsMailExchangeRecord)",
    "PySide6.QtNetwork.QDnsMailExchangeRecord.timeToLive(self)->quint32",
    "PySide6.QtNetwork.QDnsMailExchangeRecord.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QDnsMailExchangeRecord(PyObject *module)
{
    _Sbk_QDnsMailExchangeRecord_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QDnsMailExchangeRecord",
        "QDnsMailExchangeRecord",
        &Sbk_QDnsMailExchangeRecord_spec,
        &Shiboken::callCppDestructor< ::QDnsMailExchangeRecord >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QDnsMailExchangeRecord_TypeF(); // references _Sbk_QDnsMailExchangeRecord_Type
    InitSignatureStrings(pyType, QDnsMailExchangeRecord_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QDnsMailExchangeRecord_PropertyStrings);
    SbkPySide6_QtNetworkTypeStructs[SBK_QDnsMailExchangeRecord_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QDnsMailExchangeRecord_PythonToCpp_QDnsMailExchangeRecord_PTR,
        is_QDnsMailExchangeRecord_PythonToCpp_QDnsMailExchangeRecord_PTR_Convertible,
        QDnsMailExchangeRecord_PTR_CppToPython_QDnsMailExchangeRecord,
        QDnsMailExchangeRecord_COPY_CppToPython_QDnsMailExchangeRecord);

    Shiboken::Conversions::registerConverterName(converter, "QDnsMailExchangeRecord");
    Shiboken::Conversions::registerConverterName(converter, "QDnsMailExchangeRecord*");
    Shiboken::Conversions::registerConverterName(converter, "QDnsMailExchangeRecord&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QDnsMailExchangeRecord).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QDnsMailExchangeRecord_PythonToCpp_QDnsMailExchangeRecord_COPY,
        is_QDnsMailExchangeRecord_PythonToCpp_QDnsMailExchangeRecord_COPY_Convertible);

    qRegisterMetaType< ::QDnsMailExchangeRecord >("QDnsMailExchangeRecord");

    return pyType;
}
