// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QNetworkProxyFactoryWrapper_H
#define SBK_QNetworkProxyFactoryWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtNetwork/qnetworkproxy.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QNetworkProxyFactoryWrapper : public QNetworkProxyFactory
{
public:
    QNetworkProxyFactoryWrapper(const QNetworkProxyFactoryWrapper &) = delete;
    QNetworkProxyFactoryWrapper& operator=(const QNetworkProxyFactoryWrapper &) = delete;
    QNetworkProxyFactoryWrapper(QNetworkProxyFactoryWrapper &&) = delete;
    QNetworkProxyFactoryWrapper& operator=(QNetworkProxyFactoryWrapper &&) = delete;

    QNetworkProxyFactoryWrapper();
    ::QList<QNetworkProxy> queryProxy(const ::QNetworkProxyQuery & query = QNetworkProxyQuery()) override;
    ~QNetworkProxyFactoryWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1];
};

#endif // SBK_QNetworkProxyFactoryWrapper_H

