// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtnetwork_python.h"

// main header
#include "qssl_wrapper.h"

// Extra includes
#include <qssl.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {

static const char *Sbk_QSsl_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QSsl_EnumFlagInfo[] = {
    "AlertLevel:Enum",
    "AlertType:Enum",
    "AlternativeNameEntryType:Enum",
    "EncodingFormat:Enum",
    "ImplementedClass:Enum",
    "KeyAlgorithm:Enum",
    "KeyType:Enum",
    "SslOption:Flag:SslOptions",
    "SslProtocol:Enum",
    "SupportedFeature:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QSsl_methods[] = {
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QSsl_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QSsl_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QSsl_Type = nullptr;
static PyTypeObject *Sbk_QSsl_TypeF(void)
{
    return _Sbk_QSsl_Type;
}

static PyType_Slot Sbk_QSsl_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(Sbk_object_dealloc /* PYSIDE-832: Prevent replacement of "0" with subtype_dealloc. */)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QSsl_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QSsl_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QSsl_methods)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QSsl_spec = {
    "2:PySide6.QtNetwork.QSsl",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QSsl_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void QSsl_KeyType_PythonToCpp_QSsl_KeyType(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QSsl::KeyType>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QSsl::KeyType *>(cppOut) = value;

}
static PythonToCppFunc is_QSsl_KeyType_PythonToCpp_QSsl_KeyType_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSsl_KeyType_IDX])))
        return QSsl_KeyType_PythonToCpp_QSsl_KeyType;
    return {};
}
static PyObject *QSsl_KeyType_CppToPython_QSsl_KeyType(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QSsl::KeyType *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSsl_KeyType_IDX]), castCppIn);

}

static void QSsl_EncodingFormat_PythonToCpp_QSsl_EncodingFormat(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QSsl::EncodingFormat>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QSsl::EncodingFormat *>(cppOut) = value;

}
static PythonToCppFunc is_QSsl_EncodingFormat_PythonToCpp_QSsl_EncodingFormat_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSsl_EncodingFormat_IDX])))
        return QSsl_EncodingFormat_PythonToCpp_QSsl_EncodingFormat;
    return {};
}
static PyObject *QSsl_EncodingFormat_CppToPython_QSsl_EncodingFormat(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QSsl::EncodingFormat *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSsl_EncodingFormat_IDX]), castCppIn);

}

static void QSsl_KeyAlgorithm_PythonToCpp_QSsl_KeyAlgorithm(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QSsl::KeyAlgorithm>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QSsl::KeyAlgorithm *>(cppOut) = value;

}
static PythonToCppFunc is_QSsl_KeyAlgorithm_PythonToCpp_QSsl_KeyAlgorithm_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSsl_KeyAlgorithm_IDX])))
        return QSsl_KeyAlgorithm_PythonToCpp_QSsl_KeyAlgorithm;
    return {};
}
static PyObject *QSsl_KeyAlgorithm_CppToPython_QSsl_KeyAlgorithm(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QSsl::KeyAlgorithm *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSsl_KeyAlgorithm_IDX]), castCppIn);

}

static void QSsl_AlternativeNameEntryType_PythonToCpp_QSsl_AlternativeNameEntryType(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QSsl::AlternativeNameEntryType>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QSsl::AlternativeNameEntryType *>(cppOut) = value;

}
static PythonToCppFunc is_QSsl_AlternativeNameEntryType_PythonToCpp_QSsl_AlternativeNameEntryType_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSsl_AlternativeNameEntryType_IDX])))
        return QSsl_AlternativeNameEntryType_PythonToCpp_QSsl_AlternativeNameEntryType;
    return {};
}
static PyObject *QSsl_AlternativeNameEntryType_CppToPython_QSsl_AlternativeNameEntryType(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QSsl::AlternativeNameEntryType *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSsl_AlternativeNameEntryType_IDX]), castCppIn);

}

static void QSsl_SslProtocol_PythonToCpp_QSsl_SslProtocol(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QSsl::SslProtocol>(Shiboken::Enum::getValue(pyIn));
    switch (value) {
    case QSsl::SslProtocol::TlsV1_0:
        Shiboken::Warnings::warnDeprecatedEnumValue("QSsl::SslProtocol", "TlsV1_0");
        break;
    case QSsl::SslProtocol::TlsV1_1:
        Shiboken::Warnings::warnDeprecatedEnumValue("QSsl::SslProtocol", "TlsV1_1");
        break;
    case QSsl::SslProtocol::TlsV1_0OrLater:
        Shiboken::Warnings::warnDeprecatedEnumValue("QSsl::SslProtocol", "TlsV1_0OrLater");
        break;
    case QSsl::SslProtocol::TlsV1_1OrLater:
        Shiboken::Warnings::warnDeprecatedEnumValue("QSsl::SslProtocol", "TlsV1_1OrLater");
        break;
    case QSsl::SslProtocol::DtlsV1_0:
        Shiboken::Warnings::warnDeprecatedEnumValue("QSsl::SslProtocol", "DtlsV1_0");
        break;
    case QSsl::SslProtocol::DtlsV1_0OrLater:
        Shiboken::Warnings::warnDeprecatedEnumValue("QSsl::SslProtocol", "DtlsV1_0OrLater");
        break;
    default:
        break;
    }
    *reinterpret_cast<::QSsl::SslProtocol *>(cppOut) = value;

}
static PythonToCppFunc is_QSsl_SslProtocol_PythonToCpp_QSsl_SslProtocol_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSsl_SslProtocol_IDX])))
        return QSsl_SslProtocol_PythonToCpp_QSsl_SslProtocol;
    return {};
}
static PyObject *QSsl_SslProtocol_CppToPython_QSsl_SslProtocol(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QSsl::SslProtocol *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSsl_SslProtocol_IDX]), castCppIn);

}

static void QSsl_SslOption_PythonToCpp_QSsl_SslOption(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QSsl::SslOption>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QSsl::SslOption *>(cppOut) = value;

}
static PythonToCppFunc is_QSsl_SslOption_PythonToCpp_QSsl_SslOption_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSsl_SslOption_IDX])))
        return QSsl_SslOption_PythonToCpp_QSsl_SslOption;
    return {};
}
static PyObject *QSsl_SslOption_CppToPython_QSsl_SslOption(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QSsl::SslOption *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSsl_SslOption_IDX]), castCppIn);

}

static void QSsl_AlertLevel_PythonToCpp_QSsl_AlertLevel(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QSsl::AlertLevel>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QSsl::AlertLevel *>(cppOut) = value;

}
static PythonToCppFunc is_QSsl_AlertLevel_PythonToCpp_QSsl_AlertLevel_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSsl_AlertLevel_IDX])))
        return QSsl_AlertLevel_PythonToCpp_QSsl_AlertLevel;
    return {};
}
static PyObject *QSsl_AlertLevel_CppToPython_QSsl_AlertLevel(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QSsl::AlertLevel *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSsl_AlertLevel_IDX]), castCppIn);

}

static void QSsl_AlertType_PythonToCpp_QSsl_AlertType(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QSsl::AlertType>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QSsl::AlertType *>(cppOut) = value;

}
static PythonToCppFunc is_QSsl_AlertType_PythonToCpp_QSsl_AlertType_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSsl_AlertType_IDX])))
        return QSsl_AlertType_PythonToCpp_QSsl_AlertType;
    return {};
}
static PyObject *QSsl_AlertType_CppToPython_QSsl_AlertType(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QSsl::AlertType *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSsl_AlertType_IDX]), castCppIn);

}

static void QSsl_ImplementedClass_PythonToCpp_QSsl_ImplementedClass(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QSsl::ImplementedClass>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QSsl::ImplementedClass *>(cppOut) = value;

}
static PythonToCppFunc is_QSsl_ImplementedClass_PythonToCpp_QSsl_ImplementedClass_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSsl_ImplementedClass_IDX])))
        return QSsl_ImplementedClass_PythonToCpp_QSsl_ImplementedClass;
    return {};
}
static PyObject *QSsl_ImplementedClass_CppToPython_QSsl_ImplementedClass(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QSsl::ImplementedClass *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSsl_ImplementedClass_IDX]), castCppIn);

}

static void QSsl_SupportedFeature_PythonToCpp_QSsl_SupportedFeature(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QSsl::SupportedFeature>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QSsl::SupportedFeature *>(cppOut) = value;

}
static PythonToCppFunc is_QSsl_SupportedFeature_PythonToCpp_QSsl_SupportedFeature_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSsl_SupportedFeature_IDX])))
        return QSsl_SupportedFeature_PythonToCpp_QSsl_SupportedFeature;
    return {};
}
static PyObject *QSsl_SupportedFeature_CppToPython_QSsl_SupportedFeature(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QSsl::SupportedFeature *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSsl_SupportedFeature_IDX]), castCppIn);

}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QtNetworkQSsl_SignatureStrings[] = {
    nullptr}; // Sentinel

PyTypeObject *init_QtNetworkQSsl(PyObject *module)
{
    _Sbk_QSsl_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QSsl",
        "QSsl",
        &Sbk_QSsl_spec,
        nullptr,
        nullptr,
        0,
        0);
    auto *pyType = Sbk_QSsl_TypeF(); // references _Sbk_QSsl_Type
    InitSignatureStrings(pyType, QtNetworkQSsl_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QSsl_PropertyStrings);
    SbkPySide6_QtNetworkTypeStructs[SBK_QtNetworkQSsl_IDX].type = pyType;


    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QSsl_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'KeyType'.
    const char *KeyType_Initializer[] = {
        "PrivateKey",
        "PublicKey",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t KeyType_InitializerValues[] = {
        uint8_t(QSsl::KeyType::PrivateKey), //  0x00  0
        uint8_t(QSsl::KeyType::PublicKey)   //  0x01  1
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QSsl_TypeF(),
        "2:PySide6.QtNetwork.QSsl.KeyType",
        KeyType_Initializer, KeyType_InitializerValues);
    SbkPySide6_QtNetworkTypeStructs[SBK_QSsl_KeyType_IDX].type = EType;
    // Register converter for enum 'QSsl::KeyType'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QSsl_KeyType_CppToPython_QSsl_KeyType);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QSsl_KeyType_PythonToCpp_QSsl_KeyType,
            is_QSsl_KeyType_PythonToCpp_QSsl_KeyType_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QSsl::KeyType");
        Shiboken::Conversions::registerConverterName(converter, "KeyType");
    }
    // End of 'KeyType' enum.

    // Initialization of enum 'EncodingFormat'.
    const char *EncodingFormat_Initializer[] = {
        "Pem",
        "Der",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t EncodingFormat_InitializerValues[] = {
        uint8_t(QSsl::EncodingFormat::Pem), //  0x00  0
        uint8_t(QSsl::EncodingFormat::Der)  //  0x01  1
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QSsl_TypeF(),
        "2:PySide6.QtNetwork.QSsl.EncodingFormat",
        EncodingFormat_Initializer, EncodingFormat_InitializerValues);
    SbkPySide6_QtNetworkTypeStructs[SBK_QSsl_EncodingFormat_IDX].type = EType;
    // Register converter for enum 'QSsl::EncodingFormat'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QSsl_EncodingFormat_CppToPython_QSsl_EncodingFormat);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QSsl_EncodingFormat_PythonToCpp_QSsl_EncodingFormat,
            is_QSsl_EncodingFormat_PythonToCpp_QSsl_EncodingFormat_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QSsl::EncodingFormat");
        Shiboken::Conversions::registerConverterName(converter, "EncodingFormat");
    }
    // End of 'EncodingFormat' enum.

    // Initialization of enum 'KeyAlgorithm'.
    const char *KeyAlgorithm_Initializer[] = {
        "Opaque",
        "Rsa",
        "Dsa",
        "Ec",
        "Dh",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t KeyAlgorithm_InitializerValues[] = {
        uint8_t(QSsl::KeyAlgorithm::Opaque), //  0x00  0
        uint8_t(QSsl::KeyAlgorithm::Rsa),    //  0x01  1
        uint8_t(QSsl::KeyAlgorithm::Dsa),    //  0x02  2
        uint8_t(QSsl::KeyAlgorithm::Ec),     //  0x03  3
        uint8_t(QSsl::KeyAlgorithm::Dh)      //  0x04  4
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QSsl_TypeF(),
        "2:PySide6.QtNetwork.QSsl.KeyAlgorithm",
        KeyAlgorithm_Initializer, KeyAlgorithm_InitializerValues);
    SbkPySide6_QtNetworkTypeStructs[SBK_QSsl_KeyAlgorithm_IDX].type = EType;
    // Register converter for enum 'QSsl::KeyAlgorithm'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QSsl_KeyAlgorithm_CppToPython_QSsl_KeyAlgorithm);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QSsl_KeyAlgorithm_PythonToCpp_QSsl_KeyAlgorithm,
            is_QSsl_KeyAlgorithm_PythonToCpp_QSsl_KeyAlgorithm_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QSsl::KeyAlgorithm");
        Shiboken::Conversions::registerConverterName(converter, "KeyAlgorithm");
    }
    // End of 'KeyAlgorithm' enum.

    // Initialization of enum 'AlternativeNameEntryType'.
    const char *AlternativeNameEntryType_Initializer[] = {
        "EmailEntry",
        "DnsEntry",
        "IpAddressEntry",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t AlternativeNameEntryType_InitializerValues[] = {
        uint8_t(QSsl::AlternativeNameEntryType::EmailEntry),    //  0x00  0
        uint8_t(QSsl::AlternativeNameEntryType::DnsEntry),      //  0x01  1
        uint8_t(QSsl::AlternativeNameEntryType::IpAddressEntry) //  0x02  2
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QSsl_TypeF(),
        "2:PySide6.QtNetwork.QSsl.AlternativeNameEntryType",
        AlternativeNameEntryType_Initializer, AlternativeNameEntryType_InitializerValues);
    SbkPySide6_QtNetworkTypeStructs[SBK_QSsl_AlternativeNameEntryType_IDX].type = EType;
    // Register converter for enum 'QSsl::AlternativeNameEntryType'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QSsl_AlternativeNameEntryType_CppToPython_QSsl_AlternativeNameEntryType);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QSsl_AlternativeNameEntryType_PythonToCpp_QSsl_AlternativeNameEntryType,
            is_QSsl_AlternativeNameEntryType_PythonToCpp_QSsl_AlternativeNameEntryType_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QSsl::AlternativeNameEntryType");
        Shiboken::Conversions::registerConverterName(converter, "AlternativeNameEntryType");
    }
    // End of 'AlternativeNameEntryType' enum.

    // Initialization of enum 'SslProtocol'.
    const char *SslProtocol_Initializer[] = {
        "TlsV1_0",
        "TlsV1_1",
        "TlsV1_2",
        "AnyProtocol",
        "SecureProtocols",
        "TlsV1_0OrLater",
        "TlsV1_1OrLater",
        "TlsV1_2OrLater",
        "DtlsV1_0",
        "DtlsV1_0OrLater",
        "DtlsV1_2",
        "DtlsV1_2OrLater",
        "TlsV1_3",
        "TlsV1_3OrLater",
        "UnknownProtocol",
        nullptr};
    // "int8_t" used instead of "int"
    constexpr int8_t SslProtocol_InitializerValues[] = {
        int8_t(QSsl::SslProtocol::TlsV1_0),         //  0x00  0
        int8_t(QSsl::SslProtocol::TlsV1_1),         //  0x01  1
        int8_t(QSsl::SslProtocol::TlsV1_2),         //  0x02  2
        int8_t(QSsl::SslProtocol::AnyProtocol),     //  0x03  3
        int8_t(QSsl::SslProtocol::SecureProtocols), //  0x04  4
        int8_t(QSsl::SslProtocol::TlsV1_0OrLater),  //  0x05  5
        int8_t(QSsl::SslProtocol::TlsV1_1OrLater),  //  0x06  6
        int8_t(QSsl::SslProtocol::TlsV1_2OrLater),  //  0x07  7
        int8_t(QSsl::SslProtocol::DtlsV1_0),        //  0x08  8
        int8_t(QSsl::SslProtocol::DtlsV1_0OrLater), //  0x09  9
        int8_t(QSsl::SslProtocol::DtlsV1_2),        //  0x0a  10
        int8_t(QSsl::SslProtocol::DtlsV1_2OrLater), //  0x0b  11
        int8_t(QSsl::SslProtocol::TlsV1_3),         //  0x0c  12
        int8_t(QSsl::SslProtocol::TlsV1_3OrLater),  //  0x0d  13
        int8_t(QSsl::SslProtocol::UnknownProtocol)  // -0x01 -1
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QSsl_TypeF(),
        "2:PySide6.QtNetwork.QSsl.SslProtocol",
        SslProtocol_Initializer, SslProtocol_InitializerValues);
    SbkPySide6_QtNetworkTypeStructs[SBK_QSsl_SslProtocol_IDX].type = EType;
    // Register converter for enum 'QSsl::SslProtocol'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QSsl_SslProtocol_CppToPython_QSsl_SslProtocol);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QSsl_SslProtocol_PythonToCpp_QSsl_SslProtocol,
            is_QSsl_SslProtocol_PythonToCpp_QSsl_SslProtocol_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QSsl::SslProtocol");
        Shiboken::Conversions::registerConverterName(converter, "SslProtocol");
    }
    // End of 'SslProtocol' enum.

    // Initialization of enum 'SslOption'.
    const char *SslOption_Initializer[] = {
        "SslOptionDisableEmptyFragments",
        "SslOptionDisableSessionTickets",
        "SslOptionDisableCompression",
        "SslOptionDisableServerNameIndication",
        "SslOptionDisableLegacyRenegotiation",
        "SslOptionDisableSessionSharing",
        "SslOptionDisableSessionPersistence",
        "SslOptionDisableServerCipherPreference",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t SslOption_InitializerValues[] = {
        uint8_t(QSsl::SslOption::SslOptionDisableEmptyFragments),        //  0x01  1
        uint8_t(QSsl::SslOption::SslOptionDisableSessionTickets),        //  0x02  2
        uint8_t(QSsl::SslOption::SslOptionDisableCompression),           //  0x04  4
        uint8_t(QSsl::SslOption::SslOptionDisableServerNameIndication),  //  0x08  8
        uint8_t(QSsl::SslOption::SslOptionDisableLegacyRenegotiation),   //  0x10  16
        uint8_t(QSsl::SslOption::SslOptionDisableSessionSharing),        //  0x20  32
        uint8_t(QSsl::SslOption::SslOptionDisableSessionPersistence),    //  0x40  64
        uint8_t(QSsl::SslOption::SslOptionDisableServerCipherPreference) //  0x80  128
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QSsl_TypeF(),
        "2:PySide6.QtNetwork.QSsl.SslOption",
        SslOption_Initializer, SslOption_InitializerValues);
    SbkPySide6_QtNetworkTypeStructs[SBK_QSsl_SslOption_IDX].type = EType;
    // PYSIDE-1735: Mapping the flags class to the same enum class.
    SbkPySide6_QtNetworkTypeStructs[SBK_QFlags_QSsl_SslOption_IDX].type =
        EType;
    // Register converter for enum 'QSsl::SslOption'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QSsl_SslOption_CppToPython_QSsl_SslOption);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QSsl_SslOption_PythonToCpp_QSsl_SslOption,
            is_QSsl_SslOption_PythonToCpp_QSsl_SslOption_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QSsl::SslOption");
        Shiboken::Conversions::registerConverterName(converter, "SslOption");
        // Register converter for flag 'QFlags<QSsl::SslOption>'.
        Shiboken::Conversions::registerConverterName(converter, "QFlags<QSsl::SslOption>");
        Shiboken::Conversions::registerConverterName(converter, "QSsl::SslOptions");
    }
    // End of 'SslOption' enum/flags.

    // Initialization of enum 'AlertLevel'.
    const char *AlertLevel_Initializer[] = {
        "Warning",
        "Fatal",
        "Unknown",
        nullptr};
    // "int8_t" used instead of "int"
    constexpr int8_t AlertLevel_InitializerValues[] = {
        int8_t(QSsl::AlertLevel::Warning), //  0x00  0
        int8_t(QSsl::AlertLevel::Fatal),   //  0x01  1
        int8_t(QSsl::AlertLevel::Unknown)  //  0x02  2
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QSsl_TypeF(),
        "2:PySide6.QtNetwork.QSsl.AlertLevel",
        AlertLevel_Initializer, AlertLevel_InitializerValues);
    SbkPySide6_QtNetworkTypeStructs[SBK_QSsl_AlertLevel_IDX].type = EType;
    // Register converter for enum 'QSsl::AlertLevel'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QSsl_AlertLevel_CppToPython_QSsl_AlertLevel);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QSsl_AlertLevel_PythonToCpp_QSsl_AlertLevel,
            is_QSsl_AlertLevel_PythonToCpp_QSsl_AlertLevel_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QSsl::AlertLevel");
        Shiboken::Conversions::registerConverterName(converter, "AlertLevel");
    }
    // End of 'AlertLevel' enum.

    // Initialization of enum 'AlertType'.
    const char *AlertType_Initializer[] = {
        "CloseNotify",
        "UnexpectedMessage",
        "BadRecordMac",
        "RecordOverflow",
        "DecompressionFailure",
        "HandshakeFailure",
        "NoCertificate",
        "BadCertificate",
        "UnsupportedCertificate",
        "CertificateRevoked",
        "CertificateExpired",
        "CertificateUnknown",
        "IllegalParameter",
        "UnknownCa",
        "AccessDenied",
        "DecodeError",
        "DecryptError",
        "ExportRestriction",
        "ProtocolVersion",
        "InsufficientSecurity",
        "InternalError",
        "InappropriateFallback",
        "UserCancelled",
        "NoRenegotiation",
        "MissingExtension",
        "UnsupportedExtension",
        "CertificateUnobtainable",
        "UnrecognizedName",
        "BadCertificateStatusResponse",
        "BadCertificateHashValue",
        "UnknownPskIdentity",
        "CertificateRequired",
        "NoApplicationProtocol",
        "UnknownAlertMessage",
        nullptr};
    // "int16_t" used instead of "int"
    constexpr int16_t AlertType_InitializerValues[] = {
        int16_t(QSsl::AlertType::CloseNotify),                  //  0x0000  0
        int16_t(QSsl::AlertType::UnexpectedMessage),            //  0x000a  10
        int16_t(QSsl::AlertType::BadRecordMac),                 //  0x0014  20
        int16_t(QSsl::AlertType::RecordOverflow),               //  0x0016  22
        int16_t(QSsl::AlertType::DecompressionFailure),         //  0x001e  30
        int16_t(QSsl::AlertType::HandshakeFailure),             //  0x0028  40
        int16_t(QSsl::AlertType::NoCertificate),                //  0x0029  41
        int16_t(QSsl::AlertType::BadCertificate),               //  0x002a  42
        int16_t(QSsl::AlertType::UnsupportedCertificate),       //  0x002b  43
        int16_t(QSsl::AlertType::CertificateRevoked),           //  0x002c  44
        int16_t(QSsl::AlertType::CertificateExpired),           //  0x002d  45
        int16_t(QSsl::AlertType::CertificateUnknown),           //  0x002e  46
        int16_t(QSsl::AlertType::IllegalParameter),             //  0x002f  47
        int16_t(QSsl::AlertType::UnknownCa),                    //  0x0030  48
        int16_t(QSsl::AlertType::AccessDenied),                 //  0x0031  49
        int16_t(QSsl::AlertType::DecodeError),                  //  0x0032  50
        int16_t(QSsl::AlertType::DecryptError),                 //  0x0033  51
        int16_t(QSsl::AlertType::ExportRestriction),            //  0x003c  60
        int16_t(QSsl::AlertType::ProtocolVersion),              //  0x0046  70
        int16_t(QSsl::AlertType::InsufficientSecurity),         //  0x0047  71
        int16_t(QSsl::AlertType::InternalError),                //  0x0050  80
        int16_t(QSsl::AlertType::InappropriateFallback),        //  0x0056  86
        int16_t(QSsl::AlertType::UserCancelled),                //  0x005a  90
        int16_t(QSsl::AlertType::NoRenegotiation),              //  0x0064  100
        int16_t(QSsl::AlertType::MissingExtension),             //  0x006d  109
        int16_t(QSsl::AlertType::UnsupportedExtension),         //  0x006e  110
        int16_t(QSsl::AlertType::CertificateUnobtainable),      //  0x006f  111
        int16_t(QSsl::AlertType::UnrecognizedName),             //  0x0070  112
        int16_t(QSsl::AlertType::BadCertificateStatusResponse), //  0x0071  113
        int16_t(QSsl::AlertType::BadCertificateHashValue),      //  0x0072  114
        int16_t(QSsl::AlertType::UnknownPskIdentity),           //  0x0073  115
        int16_t(QSsl::AlertType::CertificateRequired),          //  0x0074  116
        int16_t(QSsl::AlertType::NoApplicationProtocol),        //  0x0078  120
        int16_t(QSsl::AlertType::UnknownAlertMessage)           //  0x00ff  255
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QSsl_TypeF(),
        "2:PySide6.QtNetwork.QSsl.AlertType",
        AlertType_Initializer, AlertType_InitializerValues);
    SbkPySide6_QtNetworkTypeStructs[SBK_QSsl_AlertType_IDX].type = EType;
    // Register converter for enum 'QSsl::AlertType'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QSsl_AlertType_CppToPython_QSsl_AlertType);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QSsl_AlertType_PythonToCpp_QSsl_AlertType,
            is_QSsl_AlertType_PythonToCpp_QSsl_AlertType_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QSsl::AlertType");
        Shiboken::Conversions::registerConverterName(converter, "AlertType");
    }
    // End of 'AlertType' enum.

    // Initialization of enum 'ImplementedClass'.
    const char *ImplementedClass_Initializer[] = {
        "Key",
        "Certificate",
        "Socket",
        "DiffieHellman",
        "EllipticCurve",
        "Dtls",
        "DtlsCookie",
        nullptr};
    // "int8_t" used instead of "int"
    constexpr int8_t ImplementedClass_InitializerValues[] = {
        int8_t(QSsl::ImplementedClass::Key),           //  0x00  0
        int8_t(QSsl::ImplementedClass::Certificate),   //  0x01  1
        int8_t(QSsl::ImplementedClass::Socket),        //  0x02  2
        int8_t(QSsl::ImplementedClass::DiffieHellman), //  0x03  3
        int8_t(QSsl::ImplementedClass::EllipticCurve), //  0x04  4
        int8_t(QSsl::ImplementedClass::Dtls),          //  0x05  5
        int8_t(QSsl::ImplementedClass::DtlsCookie)     //  0x06  6
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QSsl_TypeF(),
        "2:PySide6.QtNetwork.QSsl.ImplementedClass",
        ImplementedClass_Initializer, ImplementedClass_InitializerValues);
    SbkPySide6_QtNetworkTypeStructs[SBK_QSsl_ImplementedClass_IDX].type = EType;
    // Register converter for enum 'QSsl::ImplementedClass'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QSsl_ImplementedClass_CppToPython_QSsl_ImplementedClass);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QSsl_ImplementedClass_PythonToCpp_QSsl_ImplementedClass,
            is_QSsl_ImplementedClass_PythonToCpp_QSsl_ImplementedClass_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QSsl::ImplementedClass");
        Shiboken::Conversions::registerConverterName(converter, "ImplementedClass");
    }
    // End of 'ImplementedClass' enum.

    // Initialization of enum 'SupportedFeature'.
    const char *SupportedFeature_Initializer[] = {
        "CertificateVerification",
        "ClientSideAlpn",
        "ServerSideAlpn",
        "Ocsp",
        "Psk",
        "SessionTicket",
        "Alerts",
        nullptr};
    // "int8_t" used instead of "int"
    constexpr int8_t SupportedFeature_InitializerValues[] = {
        int8_t(QSsl::SupportedFeature::CertificateVerification), //  0x00  0
        int8_t(QSsl::SupportedFeature::ClientSideAlpn),          //  0x01  1
        int8_t(QSsl::SupportedFeature::ServerSideAlpn),          //  0x02  2
        int8_t(QSsl::SupportedFeature::Ocsp),                    //  0x03  3
        int8_t(QSsl::SupportedFeature::Psk),                     //  0x04  4
        int8_t(QSsl::SupportedFeature::SessionTicket),           //  0x05  5
        int8_t(QSsl::SupportedFeature::Alerts)                   //  0x06  6
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QSsl_TypeF(),
        "2:PySide6.QtNetwork.QSsl.SupportedFeature",
        SupportedFeature_Initializer, SupportedFeature_InitializerValues);
    SbkPySide6_QtNetworkTypeStructs[SBK_QSsl_SupportedFeature_IDX].type = EType;
    // Register converter for enum 'QSsl::SupportedFeature'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QSsl_SupportedFeature_CppToPython_QSsl_SupportedFeature);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QSsl_SupportedFeature_PythonToCpp_QSsl_SupportedFeature,
            is_QSsl_SupportedFeature_PythonToCpp_QSsl_SupportedFeature_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QSsl::SupportedFeature");
        Shiboken::Conversions::registerConverterName(converter, "SupportedFeature");
    }
    // End of 'SupportedFeature' enum.

    qRegisterMetaType< ::QSsl::KeyType >("QSsl::KeyType");
    qRegisterMetaType< ::QSsl::EncodingFormat >("QSsl::EncodingFormat");
    qRegisterMetaType< ::QSsl::KeyAlgorithm >("QSsl::KeyAlgorithm");
    qRegisterMetaType< ::QSsl::AlternativeNameEntryType >("QSsl::AlternativeNameEntryType");
    qRegisterMetaType< ::QSsl::SslProtocol >("QSsl::SslProtocol");
    qRegisterMetaType< ::QSsl::SslOption >("QSsl::SslOption");
    qRegisterMetaType< ::QSsl::AlertLevel >("QSsl::AlertLevel");
    qRegisterMetaType< ::QSsl::AlertType >("QSsl::AlertType");
    qRegisterMetaType< ::QSsl::ImplementedClass >("QSsl::ImplementedClass");
    qRegisterMetaType< ::QSsl::SupportedFeature >("QSsl::SupportedFeature");

    return pyType;
}
