// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtnetwork_python.h"

// main header
#include "qsslpresharedkeyauthenticator_wrapper.h"

// Argument includes
#include <QtNetwork/qsslpresharedkeyauthenticator.h>
#include <qbytearray.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QSslPreSharedKeyAuthenticator_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QSslPreSharedKeyAuthenticator >()))
        return -1;

    ::QSslPreSharedKeyAuthenticator *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtNetwork.QSslPreSharedKeyAuthenticator.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QSslPreSharedKeyAuthenticator", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QSslPreSharedKeyAuthenticator::QSslPreSharedKeyAuthenticator()
    // 1: QSslPreSharedKeyAuthenticator::QSslPreSharedKeyAuthenticator(QSslPreSharedKeyAuthenticator)
    if (numArgs == 0) {
        overloadId = 0; // QSslPreSharedKeyAuthenticator()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslPreSharedKeyAuthenticator_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QSslPreSharedKeyAuthenticator(QSslPreSharedKeyAuthenticator)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QSslPreSharedKeyAuthenticator()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QSslPreSharedKeyAuthenticator()
                cptr = new ::QSslPreSharedKeyAuthenticator();
            }
            break;
        }
        case 1: // QSslPreSharedKeyAuthenticator(const QSslPreSharedKeyAuthenticator & authenticator)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QSslPreSharedKeyAuthenticator cppArg0_local;
            ::QSslPreSharedKeyAuthenticator *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QSslPreSharedKeyAuthenticator(QSslPreSharedKeyAuthenticator)
                cptr = new ::QSslPreSharedKeyAuthenticator(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QSslPreSharedKeyAuthenticator >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QSslPreSharedKeyAuthenticatorFunc_identity(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSslPreSharedKeyAuthenticator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslPreSharedKeyAuthenticator_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtNetwork.QSslPreSharedKeyAuthenticator.identity";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // identity()const
            QByteArray cppResult = const_cast<const ::QSslPreSharedKeyAuthenticator *>(cppSelf)->identity();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSslPreSharedKeyAuthenticatorFunc_identityHint(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSslPreSharedKeyAuthenticator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslPreSharedKeyAuthenticator_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtNetwork.QSslPreSharedKeyAuthenticator.identityHint";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // identityHint()const
            QByteArray cppResult = const_cast<const ::QSslPreSharedKeyAuthenticator *>(cppSelf)->identityHint();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSslPreSharedKeyAuthenticatorFunc_maximumIdentityLength(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSslPreSharedKeyAuthenticator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslPreSharedKeyAuthenticator_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtNetwork.QSslPreSharedKeyAuthenticator.maximumIdentityLength";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // maximumIdentityLength()const
            int cppResult = const_cast<const ::QSslPreSharedKeyAuthenticator *>(cppSelf)->maximumIdentityLength();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSslPreSharedKeyAuthenticatorFunc_maximumPreSharedKeyLength(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSslPreSharedKeyAuthenticator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslPreSharedKeyAuthenticator_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtNetwork.QSslPreSharedKeyAuthenticator.maximumPreSharedKeyLength";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // maximumPreSharedKeyLength()const
            int cppResult = const_cast<const ::QSslPreSharedKeyAuthenticator *>(cppSelf)->maximumPreSharedKeyLength();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSslPreSharedKeyAuthenticatorFunc_preSharedKey(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSslPreSharedKeyAuthenticator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslPreSharedKeyAuthenticator_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtNetwork.QSslPreSharedKeyAuthenticator.preSharedKey";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // preSharedKey()const
            QByteArray cppResult = const_cast<const ::QSslPreSharedKeyAuthenticator *>(cppSelf)->preSharedKey();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSslPreSharedKeyAuthenticatorFunc_setIdentity(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSslPreSharedKeyAuthenticator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslPreSharedKeyAuthenticator_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtNetwork.QSslPreSharedKeyAuthenticator.setIdentity";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QSslPreSharedKeyAuthenticator::setIdentity(QByteArray)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), (pyArg)))) {
        overloadId = 0; // setIdentity(QByteArray)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QByteArray cppArg0_local;
        ::QByteArray *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // setIdentity(QByteArray)
            cppSelf->setIdentity(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QSslPreSharedKeyAuthenticatorFunc_setPreSharedKey(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSslPreSharedKeyAuthenticator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslPreSharedKeyAuthenticator_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtNetwork.QSslPreSharedKeyAuthenticator.setPreSharedKey";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QSslPreSharedKeyAuthenticator::setPreSharedKey(QByteArray)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), (pyArg)))) {
        overloadId = 0; // setPreSharedKey(QByteArray)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QByteArray cppArg0_local;
        ::QByteArray *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // setPreSharedKey(QByteArray)
            cppSelf->setPreSharedKey(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QSslPreSharedKeyAuthenticatorFunc_swap(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSslPreSharedKeyAuthenticator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslPreSharedKeyAuthenticator_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtNetwork.QSslPreSharedKeyAuthenticator.swap";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QSslPreSharedKeyAuthenticator::swap(QSslPreSharedKeyAuthenticator&)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslPreSharedKeyAuthenticator_IDX]), (pyArg)))) {
        overloadId = 0; // swap(QSslPreSharedKeyAuthenticator&)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QSslPreSharedKeyAuthenticator cppArg0_local;
        ::QSslPreSharedKeyAuthenticator *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // swap(QSslPreSharedKeyAuthenticator&)
            cppSelf->swap(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QSslPreSharedKeyAuthenticator__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QSslPreSharedKeyAuthenticator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslPreSharedKeyAuthenticator_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslPreSharedKeyAuthenticator_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QSslPreSharedKeyAuthenticator_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QSslPreSharedKeyAuthenticator_methods[] = {
    {"identity", reinterpret_cast<PyCFunction>(Sbk_QSslPreSharedKeyAuthenticatorFunc_identity), METH_NOARGS, nullptr},
    {"identityHint", reinterpret_cast<PyCFunction>(Sbk_QSslPreSharedKeyAuthenticatorFunc_identityHint), METH_NOARGS, nullptr},
    {"maximumIdentityLength", reinterpret_cast<PyCFunction>(Sbk_QSslPreSharedKeyAuthenticatorFunc_maximumIdentityLength), METH_NOARGS, nullptr},
    {"maximumPreSharedKeyLength", reinterpret_cast<PyCFunction>(Sbk_QSslPreSharedKeyAuthenticatorFunc_maximumPreSharedKeyLength), METH_NOARGS, nullptr},
    {"preSharedKey", reinterpret_cast<PyCFunction>(Sbk_QSslPreSharedKeyAuthenticatorFunc_preSharedKey), METH_NOARGS, nullptr},
    {"setIdentity", reinterpret_cast<PyCFunction>(Sbk_QSslPreSharedKeyAuthenticatorFunc_setIdentity), METH_O, nullptr},
    {"setPreSharedKey", reinterpret_cast<PyCFunction>(Sbk_QSslPreSharedKeyAuthenticatorFunc_setPreSharedKey), METH_O, nullptr},
    {"swap", reinterpret_cast<PyCFunction>(Sbk_QSslPreSharedKeyAuthenticatorFunc_swap), METH_O, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QSslPreSharedKeyAuthenticator__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QSslPreSharedKeyAuthenticator_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QSslPreSharedKeyAuthenticator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslPreSharedKeyAuthenticator_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslPreSharedKeyAuthenticator_IDX]), (pyArg)))) {
                // operator!=(const QSslPreSharedKeyAuthenticator & rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QSslPreSharedKeyAuthenticator cppArg0_local;
                ::QSslPreSharedKeyAuthenticator *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslPreSharedKeyAuthenticator_IDX]), (pyArg)))) {
                // operator==(const QSslPreSharedKeyAuthenticator & rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QSslPreSharedKeyAuthenticator cppArg0_local;
                ::QSslPreSharedKeyAuthenticator *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static int Sbk_QSslPreSharedKeyAuthenticator_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QSslPreSharedKeyAuthenticator_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QSslPreSharedKeyAuthenticator_Type = nullptr;
static PyTypeObject *Sbk_QSslPreSharedKeyAuthenticator_TypeF(void)
{
    return _Sbk_QSslPreSharedKeyAuthenticator_Type;
}

static PyType_Slot Sbk_QSslPreSharedKeyAuthenticator_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QSslPreSharedKeyAuthenticator_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QSslPreSharedKeyAuthenticator_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QSslPreSharedKeyAuthenticator_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QSslPreSharedKeyAuthenticator_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QSslPreSharedKeyAuthenticator_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QSslPreSharedKeyAuthenticator_spec = {
    "2:PySide6.QtNetwork.QSslPreSharedKeyAuthenticator",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QSslPreSharedKeyAuthenticator_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QSslPreSharedKeyAuthenticator_PythonToCpp_QSslPreSharedKeyAuthenticator_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QSslPreSharedKeyAuthenticator_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QSslPreSharedKeyAuthenticator_PythonToCpp_QSslPreSharedKeyAuthenticator_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QSslPreSharedKeyAuthenticator_TypeF()))
        return QSslPreSharedKeyAuthenticator_PythonToCpp_QSslPreSharedKeyAuthenticator_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QSslPreSharedKeyAuthenticator_PTR_CppToPython_QSslPreSharedKeyAuthenticator(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QSslPreSharedKeyAuthenticator *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QSslPreSharedKeyAuthenticator_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *QSslPreSharedKeyAuthenticator_COPY_CppToPython_QSslPreSharedKeyAuthenticator(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QSslPreSharedKeyAuthenticator *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QSslPreSharedKeyAuthenticator_TypeF(), new ::QSslPreSharedKeyAuthenticator(*source), true, true);
}

// Python to C++ copy conversion.
static void QSslPreSharedKeyAuthenticator_PythonToCpp_QSslPreSharedKeyAuthenticator_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QSslPreSharedKeyAuthenticator *>(cppOut) = *reinterpret_cast< ::QSslPreSharedKeyAuthenticator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslPreSharedKeyAuthenticator_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QSslPreSharedKeyAuthenticator_PythonToCpp_QSslPreSharedKeyAuthenticator_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QSslPreSharedKeyAuthenticator_TypeF()))
        return QSslPreSharedKeyAuthenticator_PythonToCpp_QSslPreSharedKeyAuthenticator_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QSslPreSharedKeyAuthenticator_SignatureStrings[] = {
    "1:PySide6.QtNetwork.QSslPreSharedKeyAuthenticator(self)",
    "0:PySide6.QtNetwork.QSslPreSharedKeyAuthenticator(self,authenticator:PySide6.QtNetwork.QSslPreSharedKeyAuthenticator)",
    "PySide6.QtNetwork.QSslPreSharedKeyAuthenticator.identity(self)->PySide6.QtCore.QByteArray",
    "PySide6.QtNetwork.QSslPreSharedKeyAuthenticator.identityHint(self)->PySide6.QtCore.QByteArray",
    "PySide6.QtNetwork.QSslPreSharedKeyAuthenticator.maximumIdentityLength(self)->int",
    "PySide6.QtNetwork.QSslPreSharedKeyAuthenticator.maximumPreSharedKeyLength(self)->int",
    "PySide6.QtNetwork.QSslPreSharedKeyAuthenticator.preSharedKey(self)->PySide6.QtCore.QByteArray",
    "PySide6.QtNetwork.QSslPreSharedKeyAuthenticator.setIdentity(self,identity:typing.Union[PySide6.QtCore.QByteArray, char*])",
    "PySide6.QtNetwork.QSslPreSharedKeyAuthenticator.setPreSharedKey(self,preSharedKey:typing.Union[PySide6.QtCore.QByteArray, char*])",
    "PySide6.QtNetwork.QSslPreSharedKeyAuthenticator.swap(self,other:PySide6.QtNetwork.QSslPreSharedKeyAuthenticator)",
    "PySide6.QtNetwork.QSslPreSharedKeyAuthenticator.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QSslPreSharedKeyAuthenticator(PyObject *module)
{
    _Sbk_QSslPreSharedKeyAuthenticator_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QSslPreSharedKeyAuthenticator",
        "QSslPreSharedKeyAuthenticator",
        &Sbk_QSslPreSharedKeyAuthenticator_spec,
        &Shiboken::callCppDestructor< ::QSslPreSharedKeyAuthenticator >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QSslPreSharedKeyAuthenticator_TypeF(); // references _Sbk_QSslPreSharedKeyAuthenticator_Type
    InitSignatureStrings(pyType, QSslPreSharedKeyAuthenticator_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QSslPreSharedKeyAuthenticator_PropertyStrings);
    SbkPySide6_QtNetworkTypeStructs[SBK_QSslPreSharedKeyAuthenticator_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QSslPreSharedKeyAuthenticator_PythonToCpp_QSslPreSharedKeyAuthenticator_PTR,
        is_QSslPreSharedKeyAuthenticator_PythonToCpp_QSslPreSharedKeyAuthenticator_PTR_Convertible,
        QSslPreSharedKeyAuthenticator_PTR_CppToPython_QSslPreSharedKeyAuthenticator,
        QSslPreSharedKeyAuthenticator_COPY_CppToPython_QSslPreSharedKeyAuthenticator);

    Shiboken::Conversions::registerConverterName(converter, "QSslPreSharedKeyAuthenticator");
    Shiboken::Conversions::registerConverterName(converter, "QSslPreSharedKeyAuthenticator*");
    Shiboken::Conversions::registerConverterName(converter, "QSslPreSharedKeyAuthenticator&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QSslPreSharedKeyAuthenticator).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QSslPreSharedKeyAuthenticator_PythonToCpp_QSslPreSharedKeyAuthenticator_COPY,
        is_QSslPreSharedKeyAuthenticator_PythonToCpp_QSslPreSharedKeyAuthenticator_COPY_Convertible);

    qRegisterMetaType< ::QSslPreSharedKeyAuthenticator >("QSslPreSharedKeyAuthenticator");

    return pyType;
}
