// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAbstractOAuth2Wrapper_H
#define SBK_QAbstractOAuth2Wrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtNetworkAuth/qabstractoauth2.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QAbstractOAuth2Wrapper : public QAbstractOAuth2
{
public:
    QAbstractOAuth2Wrapper(const QAbstractOAuth2Wrapper &) = delete;
    QAbstractOAuth2Wrapper& operator=(const QAbstractOAuth2Wrapper &) = delete;
    QAbstractOAuth2Wrapper(QAbstractOAuth2Wrapper &&) = delete;
    QAbstractOAuth2Wrapper& operator=(QAbstractOAuth2Wrapper &&) = delete;

    QAbstractOAuth2Wrapper(::QNetworkAccessManager * manager, ::QObject * parent = nullptr);
    QAbstractOAuth2Wrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    ::QUrl createAuthenticatedUrl(const ::QUrl & url, const ::QMap<QString,QVariant> & parameters = QVariantMap()) override;
    void customEvent(::QEvent * event) override;
    ::QNetworkReply * deleteResource(const ::QUrl & url, const ::QMap<QString,QVariant> & parameters = QVariantMap()) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QNetworkReply * get(const ::QUrl & url, const ::QMap<QString,QVariant> & parameters = QVariantMap()) override;
    void grant() override;
    ::QNetworkReply * head(const ::QUrl & url, const ::QMap<QString,QVariant> & parameters = QVariantMap()) override;
    ::QNetworkReply * post(const ::QUrl & url, ::QHttpMultiPart * multiPart) override;
    ::QNetworkReply * post(const ::QUrl & url, const ::QByteArray & data) override;
    ::QNetworkReply * post(const ::QUrl & url, const ::QMap<QString,QVariant> & parameters = QVariantMap()) override;
    void prepareRequest(::QNetworkRequest * request, const ::QByteArray & verb, const ::QByteArray & body = QByteArray()) override;
    ::QNetworkReply * put(const ::QUrl & url, ::QHttpMultiPart * multiPart) override;
    ::QNetworkReply * put(const ::QUrl & url, const ::QByteArray & data) override;
    ::QNetworkReply * put(const ::QUrl & url, const ::QMap<QString,QVariant> & parameters = QVariantMap()) override;
    void resourceOwnerAuthorization(const ::QUrl & url, const ::QMultiMap<QString,QVariant> & parameters) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QAbstractOAuth2Wrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[20];
};

#endif // SBK_QAbstractOAuth2Wrapper_H

