// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtnfc_python.h"

// main header
#include "qndefnfcsmartposterrecord_wrapper.h"

// Argument includes
#include <QList>
#include <QString>
#include <QtNfc/qndefnfcsmartposterrecord.h>
#include <QtNfc/qndefnfctextrecord.h>
#include <QtNfc/qndefnfcurirecord.h>
#include <QtNfc/qndefrecord.h>
#include <qbytearray.h>
#include <qurl.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QNdefNfcSmartPosterRecord_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QNdefNfcSmartPosterRecord >()))
        return -1;

    ::QNdefNfcSmartPosterRecord *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtNfc.QNdefNfcSmartPosterRecord.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QNdefNfcSmartPosterRecord", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QNdefNfcSmartPosterRecord::QNdefNfcSmartPosterRecord()
    // 1: QNdefNfcSmartPosterRecord::QNdefNfcSmartPosterRecord(QNdefNfcSmartPosterRecord)
    // 2: QNdefNfcSmartPosterRecord::QNdefNfcSmartPosterRecord(QNdefRecord)
    if (numArgs == 0) {
        overloadId = 0; // QNdefNfcSmartPosterRecord()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QNdefNfcSmartPosterRecord(QNdefNfcSmartPosterRecord)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefRecord_IDX]), (pyArgs[0])))) {
        overloadId = 2; // QNdefNfcSmartPosterRecord(QNdefRecord)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QNdefNfcSmartPosterRecord()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QNdefNfcSmartPosterRecord()
                cptr = new ::QNdefNfcSmartPosterRecord();
            }
            break;
        }
        case 1: // QNdefNfcSmartPosterRecord(const QNdefNfcSmartPosterRecord & other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QNdefNfcSmartPosterRecord cppArg0_local;
            ::QNdefNfcSmartPosterRecord *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QNdefNfcSmartPosterRecord(QNdefNfcSmartPosterRecord)
                cptr = new ::QNdefNfcSmartPosterRecord(*cppArg0);
            }
            break;
        }
        case 2: // QNdefNfcSmartPosterRecord(const QNdefRecord & other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QNdefRecord cppArg0_local;
            ::QNdefRecord *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QNdefNfcSmartPosterRecord(QNdefRecord)
                cptr = new ::QNdefNfcSmartPosterRecord(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QNdefNfcSmartPosterRecord >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QNdefNfcSmartPosterRecordFunc_action(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefNfcSmartPosterRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtNfc.QNdefNfcSmartPosterRecord.action";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // action()const
            QNdefNfcSmartPosterRecord::Action cppResult = const_cast<const ::QNdefNfcSmartPosterRecord *>(cppSelf)->action();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_Action_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QNdefNfcSmartPosterRecordFunc_addIcon(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefNfcSmartPosterRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtNfc.QNdefNfcSmartPosterRecord.addIcon";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "addIcon", 1, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QNdefNfcSmartPosterRecord::addIcon(QByteArray,QByteArray)
    // 1: QNdefNfcSmartPosterRecord::addIcon(QNdefNfcIconRecord)
    if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcIconRecord_IDX]), (pyArgs[0])))) {
        overloadId = 1; // addIcon(QNdefNfcIconRecord)
    } else if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), (pyArgs[1])))) {
        overloadId = 0; // addIcon(QByteArray,QByteArray)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    switch (overloadId) {
        case 0: // addIcon(const QByteArray & type, const QByteArray & data)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return {};
            ::QByteArray cppArg0_local;
            ::QByteArray *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);

            if (!Shiboken::Object::isValid(pyArgs[1]))
                return {};
            ::QByteArray cppArg1_local;
            ::QByteArray *cppArg1 = &cppArg1_local;
            if (pythonToCpp[1].isValue())
                pythonToCpp[1](pyArgs[1], &cppArg1_local);
            else
                pythonToCpp[1](pyArgs[1], &cppArg1);


            if (Shiboken::Errors::occurred() == nullptr) {
                // addIcon(QByteArray,QByteArray)
                cppSelf->addIcon(*cppArg0, *cppArg1);
            }
            break;
        }
        case 1: // addIcon(const QNdefNfcIconRecord & icon)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return {};
            ::QNdefNfcIconRecord cppArg0_local;
            ::QNdefNfcIconRecord *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // addIcon(QNdefNfcIconRecord)
                cppSelf->addIcon(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QNdefNfcSmartPosterRecordFunc_addTitle(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefNfcSmartPosterRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtNfc.QNdefNfcSmartPosterRecord.addTitle";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[3];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr};

    // invalid argument lengths
    if (numArgs == 2)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    if (PyArg_UnpackTuple(args, "addTitle", 1, 3, &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QNdefNfcSmartPosterRecord::addTitle(QNdefNfcTextRecord)->bool
    // 1: QNdefNfcSmartPosterRecord::addTitle(QString,QString,QNdefNfcTextRecord::Encoding)->bool
    if (numArgs == 3
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[1])))
        && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcTextRecord_Encoding_IDX])))->converter, (pyArgs[2])))) {
        overloadId = 1; // addTitle(QString,QString,QNdefNfcTextRecord::Encoding)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcTextRecord_IDX]), (pyArgs[0])))) {
        overloadId = 0; // addTitle(QNdefNfcTextRecord)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    switch (overloadId) {
        case 0: // addTitle(const QNdefNfcTextRecord & text)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return {};
            ::QNdefNfcTextRecord cppArg0_local;
            ::QNdefNfcTextRecord *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // addTitle(QNdefNfcTextRecord)
                bool cppResult = cppSelf->addTitle(*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            }
            break;
        }
        case 1: // addTitle(const QString & text, const QString & locale, QNdefNfcTextRecord::Encoding encoding)
        {
            ::QString cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            ::QString cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);
            ::QNdefNfcTextRecord::Encoding cppArg2{QNdefNfcTextRecord::Utf8};
            pythonToCpp[2](pyArgs[2], &cppArg2);

            if (Shiboken::Errors::occurred() == nullptr) {
                // addTitle(QString,QString,QNdefNfcTextRecord::Encoding)
                bool cppResult = cppSelf->addTitle(cppArg0, cppArg1, cppArg2);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QNdefNfcSmartPosterRecordFunc_hasAction(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefNfcSmartPosterRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtNfc.QNdefNfcSmartPosterRecord.hasAction";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // hasAction()const
            bool cppResult = const_cast<const ::QNdefNfcSmartPosterRecord *>(cppSelf)->hasAction();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QNdefNfcSmartPosterRecordFunc_hasIcon(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefNfcSmartPosterRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtNfc.QNdefNfcSmartPosterRecord.hasIcon";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 0, 1));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|O:hasIcon", &(pyArgs[0])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QNdefNfcSmartPosterRecord::hasIcon(const QByteArray&=)const->bool
    if (numArgs == 0) {
        overloadId = 0; // hasIcon(QByteArray)const
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), (pyArgs[0])))) {
        overloadId = 0; // hasIcon(QByteArray)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_mimetype = Shiboken::String::createStaticString("mimetype");
            if (PyDict_Contains(kwds, key_mimetype) != 0) {
                value = PyDict_GetItem(kwds, key_mimetype);
                if (value != nullptr && pyArgs[0] != nullptr ) {
                    errInfo.reset(key_mimetype);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                if (value != nullptr) {
                    pyArgs[0] = value;
                    if (!(pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), (pyArgs[0]))))
                        return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                PyDict_DelItem(kwds_dup, key_mimetype);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments(args, fullName, errInfo);
            }
        }
        if (!Shiboken::Object::isValid(pyArgs[0]))
            return {};
        ::QByteArray cppArg0_local = QByteArray();
        ::QByteArray *cppArg0 = &cppArg0_local;
        if (pythonToCpp[0]) {
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);
            }

        if (Shiboken::Errors::occurred() == nullptr) {
            // hasIcon(QByteArray)const
            bool cppResult = const_cast<const ::QNdefNfcSmartPosterRecord *>(cppSelf)->hasIcon(*cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QNdefNfcSmartPosterRecordFunc_hasSize(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefNfcSmartPosterRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtNfc.QNdefNfcSmartPosterRecord.hasSize";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // hasSize()const
            bool cppResult = const_cast<const ::QNdefNfcSmartPosterRecord *>(cppSelf)->hasSize();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QNdefNfcSmartPosterRecordFunc_hasTitle(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefNfcSmartPosterRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtNfc.QNdefNfcSmartPosterRecord.hasTitle";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 0, 1));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|O:hasTitle", &(pyArgs[0])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QNdefNfcSmartPosterRecord::hasTitle(const QString&=)const->bool
    if (numArgs == 0) {
        overloadId = 0; // hasTitle(QString)const
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))) {
        overloadId = 0; // hasTitle(QString)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_locale = Shiboken::String::createStaticString("locale");
            if (PyDict_Contains(kwds, key_locale) != 0) {
                value = PyDict_GetItem(kwds, key_locale);
                if (value != nullptr && pyArgs[0] != nullptr ) {
                    errInfo.reset(key_locale);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                if (value != nullptr) {
                    pyArgs[0] = value;
                    if (!(pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0]))))
                        return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                PyDict_DelItem(kwds_dup, key_locale);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments(args, fullName, errInfo);
            }
        }
        ::QString cppArg0 = QString();
        if (pythonToCpp[0])
            pythonToCpp[0](pyArgs[0], &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // hasTitle(QString)const
            bool cppResult = const_cast<const ::QNdefNfcSmartPosterRecord *>(cppSelf)->hasTitle(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QNdefNfcSmartPosterRecordFunc_hasTypeInfo(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefNfcSmartPosterRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtNfc.QNdefNfcSmartPosterRecord.hasTypeInfo";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // hasTypeInfo()const
            bool cppResult = const_cast<const ::QNdefNfcSmartPosterRecord *>(cppSelf)->hasTypeInfo();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QNdefNfcSmartPosterRecordFunc_icon(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefNfcSmartPosterRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtNfc.QNdefNfcSmartPosterRecord.icon";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 0, 1));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|O:icon", &(pyArgs[0])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QNdefNfcSmartPosterRecord::icon(const QByteArray&=)const->QByteArray
    if (numArgs == 0) {
        overloadId = 0; // icon(QByteArray)const
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), (pyArgs[0])))) {
        overloadId = 0; // icon(QByteArray)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_mimetype = Shiboken::String::createStaticString("mimetype");
            if (PyDict_Contains(kwds, key_mimetype) != 0) {
                value = PyDict_GetItem(kwds, key_mimetype);
                if (value != nullptr && pyArgs[0] != nullptr ) {
                    errInfo.reset(key_mimetype);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                if (value != nullptr) {
                    pyArgs[0] = value;
                    if (!(pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), (pyArgs[0]))))
                        return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                PyDict_DelItem(kwds_dup, key_mimetype);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments(args, fullName, errInfo);
            }
        }
        if (!Shiboken::Object::isValid(pyArgs[0]))
            return {};
        ::QByteArray cppArg0_local = QByteArray();
        ::QByteArray *cppArg0 = &cppArg0_local;
        if (pythonToCpp[0]) {
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);
            }

        if (Shiboken::Errors::occurred() == nullptr) {
            // icon(QByteArray)const
            QByteArray cppResult = const_cast<const ::QNdefNfcSmartPosterRecord *>(cppSelf)->icon(*cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QNdefNfcSmartPosterRecordFunc_iconCount(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefNfcSmartPosterRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtNfc.QNdefNfcSmartPosterRecord.iconCount";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // iconCount()const
            qsizetype cppResult = const_cast<const ::QNdefNfcSmartPosterRecord *>(cppSelf)->iconCount();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qsizetype>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QNdefNfcSmartPosterRecordFunc_iconRecord(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefNfcSmartPosterRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtNfc.QNdefNfcSmartPosterRecord.iconRecord";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QNdefNfcSmartPosterRecord::iconRecord(qsizetype)const->QNdefNfcIconRecord
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qsizetype>(), (pyArg)))) {
        overloadId = 0; // iconRecord(qsizetype)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        qsizetype cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // iconRecord(qsizetype)const
            QNdefNfcIconRecord cppResult = const_cast<const ::QNdefNfcSmartPosterRecord *>(cppSelf)->iconRecord(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcIconRecord_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QNdefNfcSmartPosterRecordFunc_iconRecords(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefNfcSmartPosterRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtNfc.QNdefNfcSmartPosterRecord.iconRecords";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // iconRecords()const
            QList<QNdefNfcIconRecord> cppResult = const_cast<const ::QNdefNfcSmartPosterRecord *>(cppSelf)->iconRecords();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtNfcTypeConverters[SBK_QtNfc_QList_QNdefNfcIconRecord_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QNdefNfcSmartPosterRecordFunc_removeIcon(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefNfcSmartPosterRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtNfc.QNdefNfcSmartPosterRecord.removeIcon";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QNdefNfcSmartPosterRecord::removeIcon(QByteArray)->bool
    // 1: QNdefNfcSmartPosterRecord::removeIcon(QNdefNfcIconRecord)->bool
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcIconRecord_IDX]), (pyArg)))) {
        overloadId = 1; // removeIcon(QNdefNfcIconRecord)
    } else if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), (pyArg)))) {
        overloadId = 0; // removeIcon(QByteArray)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    switch (overloadId) {
        case 0: // removeIcon(const QByteArray & type)
        {
            if (!Shiboken::Object::isValid(pyArg))
                return {};
            ::QByteArray cppArg0_local;
            ::QByteArray *cppArg0 = &cppArg0_local;
            if (pythonToCpp.isValue())
                pythonToCpp(pyArg, &cppArg0_local);
            else
                pythonToCpp(pyArg, &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // removeIcon(QByteArray)
                bool cppResult = cppSelf->removeIcon(*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            }
            break;
        }
        case 1: // removeIcon(const QNdefNfcIconRecord & icon)
        {
            if (!Shiboken::Object::isValid(pyArg))
                return {};
            ::QNdefNfcIconRecord cppArg0_local;
            ::QNdefNfcIconRecord *cppArg0 = &cppArg0_local;
            if (pythonToCpp.isValue())
                pythonToCpp(pyArg, &cppArg0_local);
            else
                pythonToCpp(pyArg, &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // removeIcon(QNdefNfcIconRecord)
                bool cppResult = cppSelf->removeIcon(*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QNdefNfcSmartPosterRecordFunc_removeTitle(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefNfcSmartPosterRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtNfc.QNdefNfcSmartPosterRecord.removeTitle";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QNdefNfcSmartPosterRecord::removeTitle(QNdefNfcTextRecord)->bool
    // 1: QNdefNfcSmartPosterRecord::removeTitle(QString)->bool
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArg)))) {
        overloadId = 1; // removeTitle(QString)
    } else if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcTextRecord_IDX]), (pyArg)))) {
        overloadId = 0; // removeTitle(QNdefNfcTextRecord)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    switch (overloadId) {
        case 0: // removeTitle(const QNdefNfcTextRecord & text)
        {
            if (!Shiboken::Object::isValid(pyArg))
                return {};
            ::QNdefNfcTextRecord cppArg0_local;
            ::QNdefNfcTextRecord *cppArg0 = &cppArg0_local;
            if (pythonToCpp.isValue())
                pythonToCpp(pyArg, &cppArg0_local);
            else
                pythonToCpp(pyArg, &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // removeTitle(QNdefNfcTextRecord)
                bool cppResult = cppSelf->removeTitle(*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            }
            break;
        }
        case 1: // removeTitle(const QString & locale)
        {
            ::QString cppArg0;
            pythonToCpp(pyArg, &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // removeTitle(QString)
                bool cppResult = cppSelf->removeTitle(cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QNdefNfcSmartPosterRecordFunc_setAction(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefNfcSmartPosterRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtNfc.QNdefNfcSmartPosterRecord.setAction";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QNdefNfcSmartPosterRecord::setAction(QNdefNfcSmartPosterRecord::Action)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_Action_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // setAction(QNdefNfcSmartPosterRecord::Action)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QNdefNfcSmartPosterRecord::Action cppArg0{QNdefNfcSmartPosterRecord::DoAction};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setAction(QNdefNfcSmartPosterRecord::Action)
            cppSelf->setAction(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QNdefNfcSmartPosterRecordFunc_setIcons(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefNfcSmartPosterRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtNfc.QNdefNfcSmartPosterRecord.setIcons";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QNdefNfcSmartPosterRecord::setIcons(QList<QNdefNfcIconRecord>)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtNfcTypeConverters[SBK_QtNfc_QList_QNdefNfcIconRecord_IDX], (pyArg)))) {
        overloadId = 0; // setIcons(QList<QNdefNfcIconRecord>)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QList<QNdefNfcIconRecord> cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setIcons(QList<QNdefNfcIconRecord>)
            cppSelf->setIcons(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QNdefNfcSmartPosterRecordFunc_setPayload(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefNfcSmartPosterRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtNfc.QNdefNfcSmartPosterRecord.setPayload";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QNdefRecord::setPayload(QByteArray)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), (pyArg)))) {
        overloadId = 0; // setPayload(QByteArray)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QByteArray cppArg0_local;
        ::QByteArray *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // setPayload(QByteArray)
            cppSelf->setPayload(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QNdefNfcSmartPosterRecordFunc_setSize(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefNfcSmartPosterRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtNfc.QNdefNfcSmartPosterRecord.setSize";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QNdefNfcSmartPosterRecord::setSize(quint32)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), (pyArg)))) {
        overloadId = 0; // setSize(quint32)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        quint32 cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setSize(quint32)
            cppSelf->setSize(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QNdefNfcSmartPosterRecordFunc_setTitles(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefNfcSmartPosterRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtNfc.QNdefNfcSmartPosterRecord.setTitles";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QNdefNfcSmartPosterRecord::setTitles(QList<QNdefNfcTextRecord>)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtNfcTypeConverters[SBK_QtNfc_QList_QNdefNfcTextRecord_IDX], (pyArg)))) {
        overloadId = 0; // setTitles(QList<QNdefNfcTextRecord>)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QList<QNdefNfcTextRecord> cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setTitles(QList<QNdefNfcTextRecord>)
            cppSelf->setTitles(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QNdefNfcSmartPosterRecordFunc_setTypeInfo(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefNfcSmartPosterRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtNfc.QNdefNfcSmartPosterRecord.setTypeInfo";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QNdefNfcSmartPosterRecord::setTypeInfo(QString)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArg)))) {
        overloadId = 0; // setTypeInfo(QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setTypeInfo(QString)
            cppSelf->setTypeInfo(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QNdefNfcSmartPosterRecordFunc_setUri(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefNfcSmartPosterRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtNfc.QNdefNfcSmartPosterRecord.setUri";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QNdefNfcSmartPosterRecord::setUri(QNdefNfcUriRecord)
    // 1: QNdefNfcSmartPosterRecord::setUri(QUrl)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QUrl_IDX]), (pyArg)))) {
        overloadId = 1; // setUri(QUrl)
    } else if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcUriRecord_IDX]), (pyArg)))) {
        overloadId = 0; // setUri(QNdefNfcUriRecord)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    switch (overloadId) {
        case 0: // setUri(const QNdefNfcUriRecord & url)
        {
            if (!Shiboken::Object::isValid(pyArg))
                return {};
            ::QNdefNfcUriRecord cppArg0_local;
            ::QNdefNfcUriRecord *cppArg0 = &cppArg0_local;
            if (pythonToCpp.isValue())
                pythonToCpp(pyArg, &cppArg0_local);
            else
                pythonToCpp(pyArg, &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // setUri(QNdefNfcUriRecord)
                cppSelf->setUri(*cppArg0);
            }
            break;
        }
        case 1: // setUri(const QUrl & url)
        {
            if (!Shiboken::Object::isValid(pyArg))
                return {};
            ::QUrl cppArg0_local;
            ::QUrl *cppArg0 = &cppArg0_local;
            if (pythonToCpp.isValue())
                pythonToCpp(pyArg, &cppArg0_local);
            else
                pythonToCpp(pyArg, &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // setUri(QUrl)
                cppSelf->setUri(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QNdefNfcSmartPosterRecordFunc_size(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefNfcSmartPosterRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtNfc.QNdefNfcSmartPosterRecord.size";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // size()const
            quint32 cppResult = const_cast<const ::QNdefNfcSmartPosterRecord *>(cppSelf)->size();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QNdefNfcSmartPosterRecordFunc_title(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefNfcSmartPosterRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtNfc.QNdefNfcSmartPosterRecord.title";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 0, 1));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|O:title", &(pyArgs[0])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QNdefNfcSmartPosterRecord::title(const QString&=)const->QString
    if (numArgs == 0) {
        overloadId = 0; // title(QString)const
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))) {
        overloadId = 0; // title(QString)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_locale = Shiboken::String::createStaticString("locale");
            if (PyDict_Contains(kwds, key_locale) != 0) {
                value = PyDict_GetItem(kwds, key_locale);
                if (value != nullptr && pyArgs[0] != nullptr ) {
                    errInfo.reset(key_locale);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                if (value != nullptr) {
                    pyArgs[0] = value;
                    if (!(pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0]))))
                        return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                PyDict_DelItem(kwds_dup, key_locale);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments(args, fullName, errInfo);
            }
        }
        ::QString cppArg0 = QString();
        if (pythonToCpp[0])
            pythonToCpp[0](pyArgs[0], &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // title(QString)const
            QString cppResult = const_cast<const ::QNdefNfcSmartPosterRecord *>(cppSelf)->title(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QNdefNfcSmartPosterRecordFunc_titleCount(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefNfcSmartPosterRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtNfc.QNdefNfcSmartPosterRecord.titleCount";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // titleCount()const
            qsizetype cppResult = const_cast<const ::QNdefNfcSmartPosterRecord *>(cppSelf)->titleCount();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qsizetype>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QNdefNfcSmartPosterRecordFunc_titleRecord(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefNfcSmartPosterRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtNfc.QNdefNfcSmartPosterRecord.titleRecord";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QNdefNfcSmartPosterRecord::titleRecord(qsizetype)const->QNdefNfcTextRecord
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qsizetype>(), (pyArg)))) {
        overloadId = 0; // titleRecord(qsizetype)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        qsizetype cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // titleRecord(qsizetype)const
            QNdefNfcTextRecord cppResult = const_cast<const ::QNdefNfcSmartPosterRecord *>(cppSelf)->titleRecord(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcTextRecord_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QNdefNfcSmartPosterRecordFunc_titleRecords(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefNfcSmartPosterRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtNfc.QNdefNfcSmartPosterRecord.titleRecords";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // titleRecords()const
            QList<QNdefNfcTextRecord> cppResult = const_cast<const ::QNdefNfcSmartPosterRecord *>(cppSelf)->titleRecords();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtNfcTypeConverters[SBK_QtNfc_QList_QNdefNfcTextRecord_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QNdefNfcSmartPosterRecordFunc_typeInfo(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefNfcSmartPosterRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtNfc.QNdefNfcSmartPosterRecord.typeInfo";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // typeInfo()const
            QString cppResult = const_cast<const ::QNdefNfcSmartPosterRecord *>(cppSelf)->typeInfo();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QNdefNfcSmartPosterRecordFunc_uri(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefNfcSmartPosterRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtNfc.QNdefNfcSmartPosterRecord.uri";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // uri()const
            QUrl cppResult = const_cast<const ::QNdefNfcSmartPosterRecord *>(cppSelf)->uri();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QUrl_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QNdefNfcSmartPosterRecordFunc_uriRecord(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefNfcSmartPosterRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtNfc.QNdefNfcSmartPosterRecord.uriRecord";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // uriRecord()const
            QNdefNfcUriRecord cppResult = const_cast<const ::QNdefNfcSmartPosterRecord *>(cppSelf)->uriRecord();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcUriRecord_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QNdefNfcSmartPosterRecord__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QNdefNfcSmartPosterRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QNdefNfcSmartPosterRecord_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QNdefNfcSmartPosterRecord_EnumFlagInfo[] = {
    "Action:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QNdefNfcSmartPosterRecord_methods[] = {
    {"action", reinterpret_cast<PyCFunction>(Sbk_QNdefNfcSmartPosterRecordFunc_action), METH_NOARGS, nullptr},
    {"addIcon", reinterpret_cast<PyCFunction>(Sbk_QNdefNfcSmartPosterRecordFunc_addIcon), METH_VARARGS, nullptr},
    {"addTitle", reinterpret_cast<PyCFunction>(Sbk_QNdefNfcSmartPosterRecordFunc_addTitle), METH_VARARGS, nullptr},
    {"hasAction", reinterpret_cast<PyCFunction>(Sbk_QNdefNfcSmartPosterRecordFunc_hasAction), METH_NOARGS, nullptr},
    {"hasIcon", reinterpret_cast<PyCFunction>(Sbk_QNdefNfcSmartPosterRecordFunc_hasIcon), METH_VARARGS|METH_KEYWORDS, nullptr},
    {"hasSize", reinterpret_cast<PyCFunction>(Sbk_QNdefNfcSmartPosterRecordFunc_hasSize), METH_NOARGS, nullptr},
    {"hasTitle", reinterpret_cast<PyCFunction>(Sbk_QNdefNfcSmartPosterRecordFunc_hasTitle), METH_VARARGS|METH_KEYWORDS, nullptr},
    {"hasTypeInfo", reinterpret_cast<PyCFunction>(Sbk_QNdefNfcSmartPosterRecordFunc_hasTypeInfo), METH_NOARGS, nullptr},
    {"icon", reinterpret_cast<PyCFunction>(Sbk_QNdefNfcSmartPosterRecordFunc_icon), METH_VARARGS|METH_KEYWORDS, nullptr},
    {"iconCount", reinterpret_cast<PyCFunction>(Sbk_QNdefNfcSmartPosterRecordFunc_iconCount), METH_NOARGS, nullptr},
    {"iconRecord", reinterpret_cast<PyCFunction>(Sbk_QNdefNfcSmartPosterRecordFunc_iconRecord), METH_O, nullptr},
    {"iconRecords", reinterpret_cast<PyCFunction>(Sbk_QNdefNfcSmartPosterRecordFunc_iconRecords), METH_NOARGS, nullptr},
    {"removeIcon", reinterpret_cast<PyCFunction>(Sbk_QNdefNfcSmartPosterRecordFunc_removeIcon), METH_O, nullptr},
    {"removeTitle", reinterpret_cast<PyCFunction>(Sbk_QNdefNfcSmartPosterRecordFunc_removeTitle), METH_O, nullptr},
    {"setAction", reinterpret_cast<PyCFunction>(Sbk_QNdefNfcSmartPosterRecordFunc_setAction), METH_O, nullptr},
    {"setIcons", reinterpret_cast<PyCFunction>(Sbk_QNdefNfcSmartPosterRecordFunc_setIcons), METH_O, nullptr},
    {"setPayload", reinterpret_cast<PyCFunction>(Sbk_QNdefNfcSmartPosterRecordFunc_setPayload), METH_O, nullptr},
    {"setSize", reinterpret_cast<PyCFunction>(Sbk_QNdefNfcSmartPosterRecordFunc_setSize), METH_O, nullptr},
    {"setTitles", reinterpret_cast<PyCFunction>(Sbk_QNdefNfcSmartPosterRecordFunc_setTitles), METH_O, nullptr},
    {"setTypeInfo", reinterpret_cast<PyCFunction>(Sbk_QNdefNfcSmartPosterRecordFunc_setTypeInfo), METH_O, nullptr},
    {"setUri", reinterpret_cast<PyCFunction>(Sbk_QNdefNfcSmartPosterRecordFunc_setUri), METH_O, nullptr},
    {"size", reinterpret_cast<PyCFunction>(Sbk_QNdefNfcSmartPosterRecordFunc_size), METH_NOARGS, nullptr},
    {"title", reinterpret_cast<PyCFunction>(Sbk_QNdefNfcSmartPosterRecordFunc_title), METH_VARARGS|METH_KEYWORDS, nullptr},
    {"titleCount", reinterpret_cast<PyCFunction>(Sbk_QNdefNfcSmartPosterRecordFunc_titleCount), METH_NOARGS, nullptr},
    {"titleRecord", reinterpret_cast<PyCFunction>(Sbk_QNdefNfcSmartPosterRecordFunc_titleRecord), METH_O, nullptr},
    {"titleRecords", reinterpret_cast<PyCFunction>(Sbk_QNdefNfcSmartPosterRecordFunc_titleRecords), METH_NOARGS, nullptr},
    {"typeInfo", reinterpret_cast<PyCFunction>(Sbk_QNdefNfcSmartPosterRecordFunc_typeInfo), METH_NOARGS, nullptr},
    {"uri", reinterpret_cast<PyCFunction>(Sbk_QNdefNfcSmartPosterRecordFunc_uri), METH_NOARGS, nullptr},
    {"uriRecord", reinterpret_cast<PyCFunction>(Sbk_QNdefNfcSmartPosterRecordFunc_uriRecord), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QNdefNfcSmartPosterRecord__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QNdefNfcSmartPosterRecord_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QNdefNfcSmartPosterRecord_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QNdefNfcSmartPosterRecord_Type = nullptr;
static PyTypeObject *Sbk_QNdefNfcSmartPosterRecord_TypeF(void)
{
    return _Sbk_QNdefNfcSmartPosterRecord_Type;
}

static PyType_Slot Sbk_QNdefNfcSmartPosterRecord_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QNdefNfcSmartPosterRecord_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QNdefNfcSmartPosterRecord_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QNdefNfcSmartPosterRecord_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QNdefNfcSmartPosterRecord_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QNdefNfcSmartPosterRecord_spec = {
    "2:PySide6.QtNfc.QNdefNfcSmartPosterRecord",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QNdefNfcSmartPosterRecord_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void QNdefNfcSmartPosterRecord_Action_PythonToCpp_QNdefNfcSmartPosterRecord_Action(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QNdefNfcSmartPosterRecord::Action>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QNdefNfcSmartPosterRecord::Action *>(cppOut) = value;

}
static PythonToCppFunc is_QNdefNfcSmartPosterRecord_Action_PythonToCpp_QNdefNfcSmartPosterRecord_Action_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_Action_IDX])))
        return QNdefNfcSmartPosterRecord_Action_PythonToCpp_QNdefNfcSmartPosterRecord_Action;
    return {};
}
static PyObject *QNdefNfcSmartPosterRecord_Action_CppToPython_QNdefNfcSmartPosterRecord_Action(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QNdefNfcSmartPosterRecord::Action *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_Action_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QNdefNfcSmartPosterRecord_PythonToCpp_QNdefNfcSmartPosterRecord_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QNdefNfcSmartPosterRecord_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QNdefNfcSmartPosterRecord_PythonToCpp_QNdefNfcSmartPosterRecord_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QNdefNfcSmartPosterRecord_TypeF()))
        return QNdefNfcSmartPosterRecord_PythonToCpp_QNdefNfcSmartPosterRecord_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QNdefNfcSmartPosterRecord_PTR_CppToPython_QNdefNfcSmartPosterRecord(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QNdefNfcSmartPosterRecord *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QNdefNfcSmartPosterRecord_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *QNdefNfcSmartPosterRecord_COPY_CppToPython_QNdefNfcSmartPosterRecord(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QNdefNfcSmartPosterRecord *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QNdefNfcSmartPosterRecord_TypeF(), new ::QNdefNfcSmartPosterRecord(*source), true, true);
}

// Python to C++ copy conversion.
static void QNdefNfcSmartPosterRecord_PythonToCpp_QNdefNfcSmartPosterRecord_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QNdefNfcSmartPosterRecord *>(cppOut) = *reinterpret_cast< ::QNdefNfcSmartPosterRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QNdefNfcSmartPosterRecord_PythonToCpp_QNdefNfcSmartPosterRecord_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QNdefNfcSmartPosterRecord_TypeF()))
        return QNdefNfcSmartPosterRecord_PythonToCpp_QNdefNfcSmartPosterRecord_COPY;
    return {};
}

// Implicit conversions.
static void constQNdefRecordREF_PythonToCpp_QNdefNfcSmartPosterRecord(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QNdefNfcSmartPosterRecord *>(cppOut) = ::QNdefNfcSmartPosterRecord( *reinterpret_cast< ::QNdefRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefRecord_IDX]), reinterpret_cast<SbkObject *>(pyIn))));
}
static PythonToCppFunc is_constQNdefRecordREF_PythonToCpp_QNdefNfcSmartPosterRecord_Convertible(PyObject *pyIn)
{
    if (SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefRecord_IDX]), pyIn))
        return constQNdefRecordREF_PythonToCpp_QNdefNfcSmartPosterRecord;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QNdefNfcSmartPosterRecord_SignatureStrings[] = {
    "2:PySide6.QtNfc.QNdefNfcSmartPosterRecord(self)",
    "1:PySide6.QtNfc.QNdefNfcSmartPosterRecord(self,other:typing.Union[PySide6.QtNfc.QNdefNfcSmartPosterRecord, PySide6.QtNfc.QNdefRecord])",
    "0:PySide6.QtNfc.QNdefNfcSmartPosterRecord(self,other:PySide6.QtNfc.QNdefRecord)",
    "PySide6.QtNfc.QNdefNfcSmartPosterRecord.action(self)->PySide6.QtNfc.QNdefNfcSmartPosterRecord.Action",
    "1:PySide6.QtNfc.QNdefNfcSmartPosterRecord.addIcon(self,type:typing.Union[PySide6.QtCore.QByteArray, char*],data:typing.Union[PySide6.QtCore.QByteArray, char*])",
    "0:PySide6.QtNfc.QNdefNfcSmartPosterRecord.addIcon(self,icon:typing.Union[PySide6.QtNfc.QNdefNfcIconRecord, PySide6.QtNfc.QNdefRecord])",
    "1:PySide6.QtNfc.QNdefNfcSmartPosterRecord.addTitle(self,text:typing.Union[PySide6.QtNfc.QNdefNfcTextRecord, PySide6.QtNfc.QNdefRecord])->bool",
    "0:PySide6.QtNfc.QNdefNfcSmartPosterRecord.addTitle(self,text:QString,locale:QString,encoding:PySide6.QtNfc.QNdefNfcTextRecord.Encoding)->bool",
    "PySide6.QtNfc.QNdefNfcSmartPosterRecord.hasAction(self)->bool",
    "PySide6.QtNfc.QNdefNfcSmartPosterRecord.hasIcon(self,mimetype:typing.Union[PySide6.QtCore.QByteArray, char*]=QByteArray())->bool",
    "PySide6.QtNfc.QNdefNfcSmartPosterRecord.hasSize(self)->bool",
    "PySide6.QtNfc.QNdefNfcSmartPosterRecord.hasTitle(self,locale:QString=QString())->bool",
    "PySide6.QtNfc.QNdefNfcSmartPosterRecord.hasTypeInfo(self)->bool",
    "PySide6.QtNfc.QNdefNfcSmartPosterRecord.icon(self,mimetype:typing.Union[PySide6.QtCore.QByteArray, char*]=QByteArray())->PySide6.QtCore.QByteArray",
    "PySide6.QtNfc.QNdefNfcSmartPosterRecord.iconCount(self)->qsizetype",
    "PySide6.QtNfc.QNdefNfcSmartPosterRecord.iconRecord(self,index:qsizetype)->PySide6.QtNfc.QNdefNfcIconRecord",
    "PySide6.QtNfc.QNdefNfcSmartPosterRecord.iconRecords(self)->QList[PySide6.QtNfc.QNdefNfcIconRecord]",
    "1:PySide6.QtNfc.QNdefNfcSmartPosterRecord.removeIcon(self,type:typing.Union[PySide6.QtCore.QByteArray, char*])->bool",
    "0:PySide6.QtNfc.QNdefNfcSmartPosterRecord.removeIcon(self,icon:typing.Union[PySide6.QtNfc.QNdefNfcIconRecord, PySide6.QtNfc.QNdefRecord])->bool",
    "1:PySide6.QtNfc.QNdefNfcSmartPosterRecord.removeTitle(self,text:typing.Union[PySide6.QtNfc.QNdefNfcTextRecord, PySide6.QtNfc.QNdefRecord])->bool",
    "0:PySide6.QtNfc.QNdefNfcSmartPosterRecord.removeTitle(self,locale:QString)->bool",
    "PySide6.QtNfc.QNdefNfcSmartPosterRecord.setAction(self,act:PySide6.QtNfc.QNdefNfcSmartPosterRecord.Action)",
    "PySide6.QtNfc.QNdefNfcSmartPosterRecord.setIcons(self,icons:QList[PySide6.QtNfc.QNdefNfcIconRecord])",
    "PySide6.QtNfc.QNdefNfcSmartPosterRecord.setPayload(self,payload:typing.Union[PySide6.QtCore.QByteArray, char*])",
    "PySide6.QtNfc.QNdefNfcSmartPosterRecord.setSize(self,size:quint32)",
    "PySide6.QtNfc.QNdefNfcSmartPosterRecord.setTitles(self,titles:QList[PySide6.QtNfc.QNdefNfcTextRecord])",
    "PySide6.QtNfc.QNdefNfcSmartPosterRecord.setTypeInfo(self,type:QString)",
    "1:PySide6.QtNfc.QNdefNfcSmartPosterRecord.setUri(self,url:typing.Union[PySide6.QtNfc.QNdefNfcUriRecord, PySide6.QtNfc.QNdefRecord])",
    "0:PySide6.QtNfc.QNdefNfcSmartPosterRecord.setUri(self,url:typing.Union[PySide6.QtCore.QUrl, QString])",
    "PySide6.QtNfc.QNdefNfcSmartPosterRecord.size(self)->quint32",
    "PySide6.QtNfc.QNdefNfcSmartPosterRecord.title(self,locale:QString=QString())->QString",
    "PySide6.QtNfc.QNdefNfcSmartPosterRecord.titleCount(self)->qsizetype",
    "PySide6.QtNfc.QNdefNfcSmartPosterRecord.titleRecord(self,index:qsizetype)->PySide6.QtNfc.QNdefNfcTextRecord",
    "PySide6.QtNfc.QNdefNfcSmartPosterRecord.titleRecords(self)->QList[PySide6.QtNfc.QNdefNfcTextRecord]",
    "PySide6.QtNfc.QNdefNfcSmartPosterRecord.typeInfo(self)->QString",
    "PySide6.QtNfc.QNdefNfcSmartPosterRecord.uri(self)->PySide6.QtCore.QUrl",
    "PySide6.QtNfc.QNdefNfcSmartPosterRecord.uriRecord(self)->PySide6.QtNfc.QNdefNfcUriRecord",
    "PySide6.QtNfc.QNdefNfcSmartPosterRecord.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QNdefNfcSmartPosterRecord(PyObject *module)
{
    _Sbk_QNdefNfcSmartPosterRecord_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QNdefNfcSmartPosterRecord",
        "QNdefNfcSmartPosterRecord",
        &Sbk_QNdefNfcSmartPosterRecord_spec,
        &Shiboken::callCppDestructor< ::QNdefNfcSmartPosterRecord >,
        Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefRecord_IDX]),
        0,
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QNdefNfcSmartPosterRecord_TypeF(); // references _Sbk_QNdefNfcSmartPosterRecord_Type
    InitSignatureStrings(pyType, QNdefNfcSmartPosterRecord_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QNdefNfcSmartPosterRecord_PropertyStrings);
    SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QNdefNfcSmartPosterRecord_PythonToCpp_QNdefNfcSmartPosterRecord_PTR,
        is_QNdefNfcSmartPosterRecord_PythonToCpp_QNdefNfcSmartPosterRecord_PTR_Convertible,
        QNdefNfcSmartPosterRecord_PTR_CppToPython_QNdefNfcSmartPosterRecord,
        QNdefNfcSmartPosterRecord_COPY_CppToPython_QNdefNfcSmartPosterRecord);

    Shiboken::Conversions::registerConverterName(converter, "QNdefNfcSmartPosterRecord");
    Shiboken::Conversions::registerConverterName(converter, "QNdefNfcSmartPosterRecord*");
    Shiboken::Conversions::registerConverterName(converter, "QNdefNfcSmartPosterRecord&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QNdefNfcSmartPosterRecord).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QNdefNfcSmartPosterRecord_PythonToCpp_QNdefNfcSmartPosterRecord_COPY,
        is_QNdefNfcSmartPosterRecord_PythonToCpp_QNdefNfcSmartPosterRecord_COPY_Convertible);
    // Add implicit conversions to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        constQNdefRecordREF_PythonToCpp_QNdefNfcSmartPosterRecord,
        is_constQNdefRecordREF_PythonToCpp_QNdefNfcSmartPosterRecord_Convertible);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QNdefNfcSmartPosterRecord_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'Action'.
    const char *Action_Initializer[] = {
        "UnspecifiedAction",
        "DoAction",
        "SaveAction",
        "EditAction",
        nullptr};
    // "int8_t" used instead of "int"
    constexpr int8_t Action_InitializerValues[] = {
        int8_t(QNdefNfcSmartPosterRecord::Action::UnspecifiedAction), // -0x01 -1
        int8_t(QNdefNfcSmartPosterRecord::Action::DoAction),          //  0x00  0
        int8_t(QNdefNfcSmartPosterRecord::Action::SaveAction),        //  0x01  1
        int8_t(QNdefNfcSmartPosterRecord::Action::EditAction)         //  0x02  2
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QNdefNfcSmartPosterRecord_TypeF(),
        "2:PySide6.QtNfc.QNdefNfcSmartPosterRecord.Action",
        Action_Initializer, Action_InitializerValues);
    SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcSmartPosterRecord_Action_IDX].type = EType;
    // Register converter for enum 'QNdefNfcSmartPosterRecord::Action'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QNdefNfcSmartPosterRecord_Action_CppToPython_QNdefNfcSmartPosterRecord_Action);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QNdefNfcSmartPosterRecord_Action_PythonToCpp_QNdefNfcSmartPosterRecord_Action,
            is_QNdefNfcSmartPosterRecord_Action_PythonToCpp_QNdefNfcSmartPosterRecord_Action_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QNdefNfcSmartPosterRecord::Action");
        Shiboken::Conversions::registerConverterName(converter, "Action");
    }
    // End of 'Action' enum.

    qRegisterMetaType< ::QNdefNfcSmartPosterRecord >("QNdefNfcSmartPosterRecord");
    qRegisterMetaType< ::QNdefNfcSmartPosterRecord::Action >("QNdefNfcSmartPosterRecord::Action");

    return pyType;
}
