// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAbstractOpenGLFunctionsWrapper_H
#define SBK_QAbstractOpenGLFunctionsWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtOpenGL/qopenglversionfunctions.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QAbstractOpenGLFunctionsWrapper : public QAbstractOpenGLFunctions
{
public:
    QAbstractOpenGLFunctionsWrapper(const QAbstractOpenGLFunctionsWrapper &) = delete;
    QAbstractOpenGLFunctionsWrapper& operator=(const QAbstractOpenGLFunctionsWrapper &) = delete;
    QAbstractOpenGLFunctionsWrapper(QAbstractOpenGLFunctionsWrapper &&) = delete;
    QAbstractOpenGLFunctionsWrapper& operator=(QAbstractOpenGLFunctionsWrapper &&) = delete;

    QAbstractOpenGLFunctionsWrapper();
    bool initializeOpenGLFunctions() override;
    ~QAbstractOpenGLFunctionsWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1];
};

#endif // SBK_QAbstractOpenGLFunctionsWrapper_H

