// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGeoPositionInfoSourceWrapper_H
#define SBK_QGeoPositionInfoSourceWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtPositioning/qgeopositioninfosource.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QGeoPositionInfoSourceWrapper : public QGeoPositionInfoSource
{
public:
    QGeoPositionInfoSourceWrapper(const QGeoPositionInfoSourceWrapper &) = delete;
    QGeoPositionInfoSourceWrapper& operator=(const QGeoPositionInfoSourceWrapper &) = delete;
    QGeoPositionInfoSourceWrapper(QGeoPositionInfoSourceWrapper &&) = delete;
    QGeoPositionInfoSourceWrapper& operator=(QGeoPositionInfoSourceWrapper &&) = delete;

    QGeoPositionInfoSourceWrapper(::QObject * parent);
    ::QVariant backendProperty(const ::QString & name) const override;
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    ::QGeoPositionInfoSource::Error error() const override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QGeoPositionInfo lastKnownPosition(bool fromSatellitePositioningMethodsOnly = false) const override;
    int minimumUpdateInterval() const override;
    void requestUpdate(int timeout = 0) override;
    bool setBackendProperty(const ::QString & name, const ::QVariant & value) override;
    void setPreferredPositioningMethods(::QFlags<QGeoPositionInfoSource::PositioningMethod> methods) override;
    void setUpdateInterval(int msec) override;
    void startUpdates() override;
    void stopUpdates() override;
    ::QFlags<QGeoPositionInfoSource::PositioningMethod> supportedPositioningMethods() const override;
    void timerEvent(::QTimerEvent * event) override;
    ~QGeoPositionInfoSourceWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[18];
};

#endif // SBK_QGeoPositionInfoSourceWrapper_H

