// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <QtCore/QBuffer>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtpositioning_python.h"

// main header
#include "qgeosatelliteinfo_wrapper.h"

// Argument includes
#include <QtPositioning/qgeosatelliteinfo.h>
#include <qdatastream.h>
#include <qobject.h>
#include <qobjectdefs.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QGeoSatelliteInfo_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QGeoSatelliteInfo >()))
        return -1;

    ::QGeoSatelliteInfo *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtPositioning.QGeoSatelliteInfo.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QGeoSatelliteInfo", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QGeoSatelliteInfo::QGeoSatelliteInfo()
    // 1: QGeoSatelliteInfo::QGeoSatelliteInfo(QGeoSatelliteInfo)
    if (numArgs == 0) {
        overloadId = 0; // QGeoSatelliteInfo()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QGeoSatelliteInfo(QGeoSatelliteInfo)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QGeoSatelliteInfo()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QGeoSatelliteInfo()
                cptr = new ::QGeoSatelliteInfo();
            }
            break;
        }
        case 1: // QGeoSatelliteInfo(const QGeoSatelliteInfo & other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QGeoSatelliteInfo cppArg0_local;
            ::QGeoSatelliteInfo *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QGeoSatelliteInfo(QGeoSatelliteInfo)
                cptr = new ::QGeoSatelliteInfo(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QGeoSatelliteInfo >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QGeoSatelliteInfoFunc_attribute(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGeoSatelliteInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtPositioning.QGeoSatelliteInfo.attribute";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QGeoSatelliteInfo::attribute(QGeoSatelliteInfo::Attribute)const->qreal
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_Attribute_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // attribute(QGeoSatelliteInfo::Attribute)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QGeoSatelliteInfo::Attribute cppArg0{QGeoSatelliteInfo::Elevation};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // attribute(QGeoSatelliteInfo::Attribute)const
            qreal cppResult = const_cast<const ::QGeoSatelliteInfo *>(cppSelf)->attribute(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QGeoSatelliteInfoFunc_hasAttribute(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGeoSatelliteInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtPositioning.QGeoSatelliteInfo.hasAttribute";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QGeoSatelliteInfo::hasAttribute(QGeoSatelliteInfo::Attribute)const->bool
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_Attribute_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // hasAttribute(QGeoSatelliteInfo::Attribute)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QGeoSatelliteInfo::Attribute cppArg0{QGeoSatelliteInfo::Elevation};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // hasAttribute(QGeoSatelliteInfo::Attribute)const
            bool cppResult = const_cast<const ::QGeoSatelliteInfo *>(cppSelf)->hasAttribute(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QGeoSatelliteInfoFunc_removeAttribute(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGeoSatelliteInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtPositioning.QGeoSatelliteInfo.removeAttribute";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QGeoSatelliteInfo::removeAttribute(QGeoSatelliteInfo::Attribute)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_Attribute_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // removeAttribute(QGeoSatelliteInfo::Attribute)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QGeoSatelliteInfo::Attribute cppArg0{QGeoSatelliteInfo::Elevation};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // removeAttribute(QGeoSatelliteInfo::Attribute)
            cppSelf->removeAttribute(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QGeoSatelliteInfoFunc_satelliteIdentifier(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGeoSatelliteInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtPositioning.QGeoSatelliteInfo.satelliteIdentifier";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // satelliteIdentifier()const
            int cppResult = const_cast<const ::QGeoSatelliteInfo *>(cppSelf)->satelliteIdentifier();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QGeoSatelliteInfoFunc_satelliteSystem(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGeoSatelliteInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtPositioning.QGeoSatelliteInfo.satelliteSystem";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // satelliteSystem()const
            QGeoSatelliteInfo::SatelliteSystem cppResult = const_cast<const ::QGeoSatelliteInfo *>(cppSelf)->satelliteSystem();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_SatelliteSystem_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QGeoSatelliteInfoFunc_setAttribute(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGeoSatelliteInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtPositioning.QGeoSatelliteInfo.setAttribute";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "setAttribute", 2, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QGeoSatelliteInfo::setAttribute(QGeoSatelliteInfo::Attribute,qreal)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_Attribute_IDX])))->converter, (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), (pyArgs[1])))) {
        overloadId = 0; // setAttribute(QGeoSatelliteInfo::Attribute,qreal)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        ::QGeoSatelliteInfo::Attribute cppArg0{QGeoSatelliteInfo::Elevation};
        pythonToCpp[0](pyArgs[0], &cppArg0);
        qreal cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setAttribute(QGeoSatelliteInfo::Attribute,qreal)
            cppSelf->setAttribute(cppArg0, cppArg1);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QGeoSatelliteInfoFunc_setSatelliteIdentifier(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGeoSatelliteInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtPositioning.QGeoSatelliteInfo.setSatelliteIdentifier";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QGeoSatelliteInfo::setSatelliteIdentifier(int)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // setSatelliteIdentifier(int)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setSatelliteIdentifier(int)
            cppSelf->setSatelliteIdentifier(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QGeoSatelliteInfoFunc_setSatelliteSystem(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGeoSatelliteInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtPositioning.QGeoSatelliteInfo.setSatelliteSystem";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QGeoSatelliteInfo::setSatelliteSystem(QGeoSatelliteInfo::SatelliteSystem)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_SatelliteSystem_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // setSatelliteSystem(QGeoSatelliteInfo::SatelliteSystem)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QGeoSatelliteInfo::SatelliteSystem cppArg0{QGeoSatelliteInfo::Undefined};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setSatelliteSystem(QGeoSatelliteInfo::SatelliteSystem)
            cppSelf->setSatelliteSystem(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QGeoSatelliteInfoFunc_setSignalStrength(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGeoSatelliteInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtPositioning.QGeoSatelliteInfo.setSignalStrength";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QGeoSatelliteInfo::setSignalStrength(int)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // setSignalStrength(int)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setSignalStrength(int)
            cppSelf->setSignalStrength(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QGeoSatelliteInfoFunc_signalStrength(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGeoSatelliteInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtPositioning.QGeoSatelliteInfo.signalStrength";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // signalStrength()const
            int cppResult = const_cast<const ::QGeoSatelliteInfo *>(cppSelf)->signalStrength();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QGeoSatelliteInfoFunc_swap(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGeoSatelliteInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtPositioning.QGeoSatelliteInfo.swap";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QGeoSatelliteInfo::swap(QGeoSatelliteInfo&)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_IDX]), (pyArg)))) {
        overloadId = 0; // swap(QGeoSatelliteInfo&)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QGeoSatelliteInfo cppArg0_local;
        ::QGeoSatelliteInfo *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // swap(QGeoSatelliteInfo&)
            cppSelf->swap(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QGeoSatelliteInfo__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QGeoSatelliteInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QGeoSatelliteInfo_PropertyStrings[] = {
    "satelliteIdentifier:",
    "satelliteSystem:",
    "signalStrength:",
    nullptr // Sentinel
};

static const char *Sbk_QGeoSatelliteInfo_EnumFlagInfo[] = {
    "Attribute:Enum",
    "SatelliteSystem:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QGeoSatelliteInfo_methods[] = {
    {"attribute", reinterpret_cast<PyCFunction>(Sbk_QGeoSatelliteInfoFunc_attribute), METH_O, nullptr},
    {"hasAttribute", reinterpret_cast<PyCFunction>(Sbk_QGeoSatelliteInfoFunc_hasAttribute), METH_O, nullptr},
    {"removeAttribute", reinterpret_cast<PyCFunction>(Sbk_QGeoSatelliteInfoFunc_removeAttribute), METH_O, nullptr},
    {"satelliteIdentifier", reinterpret_cast<PyCFunction>(Sbk_QGeoSatelliteInfoFunc_satelliteIdentifier), METH_NOARGS, nullptr},
    {"satelliteSystem", reinterpret_cast<PyCFunction>(Sbk_QGeoSatelliteInfoFunc_satelliteSystem), METH_NOARGS, nullptr},
    {"setAttribute", reinterpret_cast<PyCFunction>(Sbk_QGeoSatelliteInfoFunc_setAttribute), METH_VARARGS, nullptr},
    {"setSatelliteIdentifier", reinterpret_cast<PyCFunction>(Sbk_QGeoSatelliteInfoFunc_setSatelliteIdentifier), METH_O, nullptr},
    {"setSatelliteSystem", reinterpret_cast<PyCFunction>(Sbk_QGeoSatelliteInfoFunc_setSatelliteSystem), METH_O, nullptr},
    {"setSignalStrength", reinterpret_cast<PyCFunction>(Sbk_QGeoSatelliteInfoFunc_setSignalStrength), METH_O, nullptr},
    {"signalStrength", reinterpret_cast<PyCFunction>(Sbk_QGeoSatelliteInfoFunc_signalStrength), METH_NOARGS, nullptr},
    {"swap", reinterpret_cast<PyCFunction>(Sbk_QGeoSatelliteInfoFunc_swap), METH_O, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QGeoSatelliteInfo__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QGeoSatelliteInfoFunc___lshift__(PyObject *self, PyObject *pyArg)
{
    bool isReverse = SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_IDX]), pyArg)
                    && !SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_IDX]), self);
    if (isReverse)
        std::swap(self, pyArg);
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGeoSatelliteInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtPositioning.QGeoSatelliteInfo.__lshift__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    static PyObject *attrName = Shiboken::PyMagicName::rlshift();
    if (!isReverse
        && Shiboken::Object::checkType(pyArg)
        && !PyObject_TypeCheck(pyArg, self->ob_type)
        && PyObject_HasAttr(pyArg, attrName)) {
        PyObject *revOpMethod = PyObject_GetAttr(pyArg, attrName);
        if (revOpMethod && PyCallable_Check(revOpMethod)) {
            pyResult = PyObject_CallFunction(revOpMethod, "O", self);
            if (Shiboken::Errors::occurred() != nullptr && (PyErr_ExceptionMatches(PyExc_NotImplementedError) || PyErr_ExceptionMatches(PyExc_AttributeError))) {
                PyErr_Clear();
                Py_XDECREF(pyResult);
                pyResult = nullptr;
            }
        }
        Py_XDECREF(revOpMethod);

    }

    // Do not enter here if other object has implemented a reverse operator.
    if (pyResult == nullptr) {
        // Overloaded function decisor
        // 0: QGeoSatelliteInfo::operator<<(QDataStream&)->QDataStream&
        if (isReverse
            && (pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QDataStream_IDX]), (pyArg)))) {
            overloadId = 0; // operator<<(QDataStream&,QGeoSatelliteInfo)
        }

        if (isReverse && overloadId == -1) {
            Shiboken::Errors::setReverseOperatorNotImplemented();
            return {};
        }

        // Function signature not found.
        if (overloadId == -1)
            return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

        // Call function/method
        {
            if (!Shiboken::Object::isValid(pyArg))
                return {};
            ::QDataStream *cppArg0;
            pythonToCpp(pyArg, &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // operator<<(QDataStream&,QGeoSatelliteInfo) [reverse operator]
                QDataStream & cppResult = (*cppArg0) << (*cppSelf);
                pyResult = Shiboken::Conversions::referenceToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QDataStream_IDX]), &cppResult);
            }
        }

    } // End of "if (!pyResult)"

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QGeoSatelliteInfoFunc___rshift__(PyObject *self, PyObject *pyArg)
{
    bool isReverse = SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_IDX]), pyArg)
                    && !SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_IDX]), self);
    if (isReverse)
        std::swap(self, pyArg);
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGeoSatelliteInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtPositioning.QGeoSatelliteInfo.__rshift__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    static PyObject *attrName = Shiboken::PyMagicName::rrshift();
    if (!isReverse
        && Shiboken::Object::checkType(pyArg)
        && !PyObject_TypeCheck(pyArg, self->ob_type)
        && PyObject_HasAttr(pyArg, attrName)) {
        PyObject *revOpMethod = PyObject_GetAttr(pyArg, attrName);
        if (revOpMethod && PyCallable_Check(revOpMethod)) {
            pyResult = PyObject_CallFunction(revOpMethod, "O", self);
            if (Shiboken::Errors::occurred() != nullptr && (PyErr_ExceptionMatches(PyExc_NotImplementedError) || PyErr_ExceptionMatches(PyExc_AttributeError))) {
                PyErr_Clear();
                Py_XDECREF(pyResult);
                pyResult = nullptr;
            }
        }
        Py_XDECREF(revOpMethod);

    }

    // Do not enter here if other object has implemented a reverse operator.
    if (pyResult == nullptr) {
        // Overloaded function decisor
        // 0: QGeoSatelliteInfo::operator>>(QDataStream&)->QDataStream&
        if (isReverse
            && (pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QDataStream_IDX]), (pyArg)))) {
            overloadId = 0; // operator>>(QDataStream&,QGeoSatelliteInfo&)
        }

        if (isReverse && overloadId == -1) {
            Shiboken::Errors::setReverseOperatorNotImplemented();
            return {};
        }

        // Function signature not found.
        if (overloadId == -1)
            return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

        // Call function/method
        {
            if (!Shiboken::Object::isValid(pyArg))
                return {};
            ::QDataStream *cppArg0;
            pythonToCpp(pyArg, &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // operator>>(QDataStream&,QGeoSatelliteInfo&) [reverse operator]
                QDataStream & cppResult = (*cppArg0) >> (*cppSelf);
                pyResult = Shiboken::Conversions::referenceToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QDataStream_IDX]), &cppResult);
            }
        }

    } // End of "if (!pyResult)"

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

// Rich comparison
static PyObject * Sbk_QGeoSatelliteInfo_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QGeoSatelliteInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_IDX]), (pyArg)))) {
                // operator!=(const QGeoSatelliteInfo & rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QGeoSatelliteInfo cppArg0_local;
                ::QGeoSatelliteInfo *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_IDX]), (pyArg)))) {
                // operator==(const QGeoSatelliteInfo & rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QGeoSatelliteInfo cppArg0_local;
                ::QGeoSatelliteInfo *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static Py_hash_t Sbk_QGeoSatelliteInfo_HashFunc(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGeoSatelliteInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    return Py_hash_t(qHash(*cppSelf));
}

static int Sbk_QGeoSatelliteInfo_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QGeoSatelliteInfo_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
extern "C"
{
static PyObject *Sbk_QGeoSatelliteInfo__repr__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGeoSatelliteInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    QBuffer buffer;
    buffer.open(QBuffer::ReadWrite);
    QDebug dbg(&buffer);
    dbg << *cppSelf;
    buffer.close();
    QByteArray str = buffer.data();
    const auto idx = str.indexOf('(');
    auto *typeName = Py_TYPE(self)->tp_name;
    if (idx >= 0)
        str.replace(0, idx, typeName);
    str = str.trimmed();
    Shiboken::AutoDecRef tpDict(PepType_GetDict(Py_TYPE(self)));
    PyObject *mod = PyDict_GetItem(tpDict.object(), Shiboken::PyMagicName::module());
    if (mod != nullptr && std::strchr(typeName, '.') == nullptr)
        return Shiboken::String::fromFormat("<%s.%s at %p>", Shiboken::String::toCString(mod), str.constData(), self);
    return Shiboken::String::fromFormat("<%s at %p>", str.constData(), self);
}
} // extern C

// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QGeoSatelliteInfo_Type = nullptr;
static PyTypeObject *Sbk_QGeoSatelliteInfo_TypeF(void)
{
    return _Sbk_QGeoSatelliteInfo_Type;
}

static PyType_Slot Sbk_QGeoSatelliteInfo_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_repr,        reinterpret_cast<void *>(Sbk_QGeoSatelliteInfo__repr__)},
    {Py_tp_hash,        reinterpret_cast<void *>(&Sbk_QGeoSatelliteInfo_HashFunc)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QGeoSatelliteInfo_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QGeoSatelliteInfo_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QGeoSatelliteInfo_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QGeoSatelliteInfo_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QGeoSatelliteInfo_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    // type supports number protocol
    {Py_nb_lshift,      reinterpret_cast<void *>(Sbk_QGeoSatelliteInfoFunc___lshift__)},
    {Py_nb_rshift,      reinterpret_cast<void *>(Sbk_QGeoSatelliteInfoFunc___rshift__)},
    {0, nullptr}
};
static PyType_Spec Sbk_QGeoSatelliteInfo_spec = {
    "2:PySide6.QtPositioning.QGeoSatelliteInfo",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QGeoSatelliteInfo_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void QGeoSatelliteInfo_Attribute_PythonToCpp_QGeoSatelliteInfo_Attribute(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QGeoSatelliteInfo::Attribute>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QGeoSatelliteInfo::Attribute *>(cppOut) = value;

}
static PythonToCppFunc is_QGeoSatelliteInfo_Attribute_PythonToCpp_QGeoSatelliteInfo_Attribute_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_Attribute_IDX])))
        return QGeoSatelliteInfo_Attribute_PythonToCpp_QGeoSatelliteInfo_Attribute;
    return {};
}
static PyObject *QGeoSatelliteInfo_Attribute_CppToPython_QGeoSatelliteInfo_Attribute(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QGeoSatelliteInfo::Attribute *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_Attribute_IDX]), castCppIn);

}

static void QGeoSatelliteInfo_SatelliteSystem_PythonToCpp_QGeoSatelliteInfo_SatelliteSystem(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QGeoSatelliteInfo::SatelliteSystem>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QGeoSatelliteInfo::SatelliteSystem *>(cppOut) = value;

}
static PythonToCppFunc is_QGeoSatelliteInfo_SatelliteSystem_PythonToCpp_QGeoSatelliteInfo_SatelliteSystem_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_SatelliteSystem_IDX])))
        return QGeoSatelliteInfo_SatelliteSystem_PythonToCpp_QGeoSatelliteInfo_SatelliteSystem;
    return {};
}
static PyObject *QGeoSatelliteInfo_SatelliteSystem_CppToPython_QGeoSatelliteInfo_SatelliteSystem(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QGeoSatelliteInfo::SatelliteSystem *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_SatelliteSystem_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QGeoSatelliteInfo_PythonToCpp_QGeoSatelliteInfo_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QGeoSatelliteInfo_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QGeoSatelliteInfo_PythonToCpp_QGeoSatelliteInfo_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QGeoSatelliteInfo_TypeF()))
        return QGeoSatelliteInfo_PythonToCpp_QGeoSatelliteInfo_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QGeoSatelliteInfo_PTR_CppToPython_QGeoSatelliteInfo(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QGeoSatelliteInfo *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QGeoSatelliteInfo_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *QGeoSatelliteInfo_COPY_CppToPython_QGeoSatelliteInfo(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QGeoSatelliteInfo *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QGeoSatelliteInfo_TypeF(), new ::QGeoSatelliteInfo(*source), true, true);
}

// Python to C++ copy conversion.
static void QGeoSatelliteInfo_PythonToCpp_QGeoSatelliteInfo_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QGeoSatelliteInfo *>(cppOut) = *reinterpret_cast< ::QGeoSatelliteInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QGeoSatelliteInfo_PythonToCpp_QGeoSatelliteInfo_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QGeoSatelliteInfo_TypeF()))
        return QGeoSatelliteInfo_PythonToCpp_QGeoSatelliteInfo_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QGeoSatelliteInfo_SignatureStrings[] = {
    "1:PySide6.QtPositioning.QGeoSatelliteInfo(self)",
    "0:PySide6.QtPositioning.QGeoSatelliteInfo(self,other:PySide6.QtPositioning.QGeoSatelliteInfo)",
    "PySide6.QtPositioning.QGeoSatelliteInfo.attribute(self,attribute:PySide6.QtPositioning.QGeoSatelliteInfo.Attribute)->qreal",
    "PySide6.QtPositioning.QGeoSatelliteInfo.hasAttribute(self,attribute:PySide6.QtPositioning.QGeoSatelliteInfo.Attribute)->bool",
    "PySide6.QtPositioning.QGeoSatelliteInfo.removeAttribute(self,attribute:PySide6.QtPositioning.QGeoSatelliteInfo.Attribute)",
    "PySide6.QtPositioning.QGeoSatelliteInfo.satelliteIdentifier(self)->int",
    "PySide6.QtPositioning.QGeoSatelliteInfo.satelliteSystem(self)->PySide6.QtPositioning.QGeoSatelliteInfo.SatelliteSystem",
    "PySide6.QtPositioning.QGeoSatelliteInfo.setAttribute(self,attribute:PySide6.QtPositioning.QGeoSatelliteInfo.Attribute,value:qreal)",
    "PySide6.QtPositioning.QGeoSatelliteInfo.setSatelliteIdentifier(self,satId:int)",
    "PySide6.QtPositioning.QGeoSatelliteInfo.setSatelliteSystem(self,system:PySide6.QtPositioning.QGeoSatelliteInfo.SatelliteSystem)",
    "PySide6.QtPositioning.QGeoSatelliteInfo.setSignalStrength(self,signalStrength:int)",
    "PySide6.QtPositioning.QGeoSatelliteInfo.signalStrength(self)->int",
    "PySide6.QtPositioning.QGeoSatelliteInfo.swap(self,other:PySide6.QtPositioning.QGeoSatelliteInfo)",
    "PySide6.QtPositioning.QGeoSatelliteInfo.__copy__()",
    "PySide6.QtPositioning.QGeoSatelliteInfo.__lshift__(self,stream:PySide6.QtCore.QDataStream)->PySide6.QtCore.QDataStream",
    "PySide6.QtPositioning.QGeoSatelliteInfo.__rshift__(self,stream:PySide6.QtCore.QDataStream)->PySide6.QtCore.QDataStream",
    nullptr}; // Sentinel

PyTypeObject *init_QGeoSatelliteInfo(PyObject *module)
{
    _Sbk_QGeoSatelliteInfo_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QGeoSatelliteInfo",
        "QGeoSatelliteInfo",
        &Sbk_QGeoSatelliteInfo_spec,
        &Shiboken::callCppDestructor< ::QGeoSatelliteInfo >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QGeoSatelliteInfo_TypeF(); // references _Sbk_QGeoSatelliteInfo_Type
    InitSignatureStrings(pyType, QGeoSatelliteInfo_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QGeoSatelliteInfo_PropertyStrings);
    SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QGeoSatelliteInfo_PythonToCpp_QGeoSatelliteInfo_PTR,
        is_QGeoSatelliteInfo_PythonToCpp_QGeoSatelliteInfo_PTR_Convertible,
        QGeoSatelliteInfo_PTR_CppToPython_QGeoSatelliteInfo,
        QGeoSatelliteInfo_COPY_CppToPython_QGeoSatelliteInfo);

    Shiboken::Conversions::registerConverterName(converter, "QGeoSatelliteInfo");
    Shiboken::Conversions::registerConverterName(converter, "QGeoSatelliteInfo*");
    Shiboken::Conversions::registerConverterName(converter, "QGeoSatelliteInfo&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QGeoSatelliteInfo).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QGeoSatelliteInfo_PythonToCpp_QGeoSatelliteInfo_COPY,
        is_QGeoSatelliteInfo_PythonToCpp_QGeoSatelliteInfo_COPY_Convertible);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QGeoSatelliteInfo_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'Attribute'.
    const char *Attribute_Initializer[] = {
        "Elevation",
        "Azimuth",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t Attribute_InitializerValues[] = {
        uint8_t(QGeoSatelliteInfo::Attribute::Elevation), //  0x00  0
        uint8_t(QGeoSatelliteInfo::Attribute::Azimuth)    //  0x01  1
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QGeoSatelliteInfo_TypeF(),
        "2:PySide6.QtPositioning.QGeoSatelliteInfo.Attribute",
        Attribute_Initializer, Attribute_InitializerValues);
    SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_Attribute_IDX].type = EType;
    // Register converter for enum 'QGeoSatelliteInfo::Attribute'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QGeoSatelliteInfo_Attribute_CppToPython_QGeoSatelliteInfo_Attribute);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QGeoSatelliteInfo_Attribute_PythonToCpp_QGeoSatelliteInfo_Attribute,
            is_QGeoSatelliteInfo_Attribute_PythonToCpp_QGeoSatelliteInfo_Attribute_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QGeoSatelliteInfo::Attribute");
        Shiboken::Conversions::registerConverterName(converter, "Attribute");
    }
    // End of 'Attribute' enum.

    // Initialization of enum 'SatelliteSystem'.
    const char *SatelliteSystem_Initializer[] = {
        "Undefined",
        "GPS",
        "GLONASS",
        "GALILEO",
        "BEIDOU",
        "QZSS",
        "Multiple",
        "CustomType",
        nullptr};
    // "uint16_t" used instead of "unsigned int"
    constexpr uint16_t SatelliteSystem_InitializerValues[] = {
        uint16_t(QGeoSatelliteInfo::SatelliteSystem::Undefined), //  0x0000  0
        uint16_t(QGeoSatelliteInfo::SatelliteSystem::GPS),       //  0x0001  1
        uint16_t(QGeoSatelliteInfo::SatelliteSystem::GLONASS),   //  0x0002  2
        uint16_t(QGeoSatelliteInfo::SatelliteSystem::GALILEO),   //  0x0003  3
        uint16_t(QGeoSatelliteInfo::SatelliteSystem::BEIDOU),    //  0x0004  4
        uint16_t(QGeoSatelliteInfo::SatelliteSystem::QZSS),      //  0x0005  5
        uint16_t(QGeoSatelliteInfo::SatelliteSystem::Multiple),  //  0x00ff  255
        uint16_t(QGeoSatelliteInfo::SatelliteSystem::CustomType) //  0x0100  256
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QGeoSatelliteInfo_TypeF(),
        "2:PySide6.QtPositioning.QGeoSatelliteInfo.SatelliteSystem",
        SatelliteSystem_Initializer, SatelliteSystem_InitializerValues);
    SbkPySide6_QtPositioningTypeStructs[SBK_QGeoSatelliteInfo_SatelliteSystem_IDX].type = EType;
    // Register converter for enum 'QGeoSatelliteInfo::SatelliteSystem'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QGeoSatelliteInfo_SatelliteSystem_CppToPython_QGeoSatelliteInfo_SatelliteSystem);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QGeoSatelliteInfo_SatelliteSystem_PythonToCpp_QGeoSatelliteInfo_SatelliteSystem,
            is_QGeoSatelliteInfo_SatelliteSystem_PythonToCpp_QGeoSatelliteInfo_SatelliteSystem_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QGeoSatelliteInfo::SatelliteSystem");
        Shiboken::Conversions::registerConverterName(converter, "SatelliteSystem");
    }
    // End of 'SatelliteSystem' enum.

    qRegisterMetaType< ::QGeoSatelliteInfo >("QGeoSatelliteInfo");
    qRegisterMetaType< ::QGeoSatelliteInfo::Attribute >("QGeoSatelliteInfo::Attribute");
    qRegisterMetaType< ::QGeoSatelliteInfo::SatelliteSystem >("QGeoSatelliteInfo::SatelliteSystem");

    return pyType;
}
