// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtqml_python.h"

// main header
#include "qjsprimitivevalue_wrapper.h"

// Argument includes
#include <QString>
#include <QtQml/qjsprimitivevalue.h>
#include <qmetatype.h>
#include <qvariant.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QJSPrimitiveValue_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QJSPrimitiveValue >()))
        return -1;

    ::QJSPrimitiveValue *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtQml.QJSPrimitiveValue.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QJSPrimitiveValue", 0, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QJSPrimitiveValue::QJSPrimitiveValue()
    // 1: QJSPrimitiveValue::QJSPrimitiveValue(QMetaType)
    // 2: QJSPrimitiveValue::QJSPrimitiveValue(QString)
    // 3: QJSPrimitiveValue::QJSPrimitiveValue(bool)
    // 4: QJSPrimitiveValue::QJSPrimitiveValue(QMetaType,const void*)
    // 5: QJSPrimitiveValue::QJSPrimitiveValue(QVariant)
    // 6: QJSPrimitiveValue::QJSPrimitiveValue(double)
    // 7: QJSPrimitiveValue::QJSPrimitiveValue(int)
    if (numArgs == 0) {
        overloadId = 0; // QJSPrimitiveValue()
    } else if (numArgs == 1
        && PyFloat_Check(pyArgs[0]) && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<double>(), (pyArgs[0])))) {
        overloadId = 6; // QJSPrimitiveValue(double)
    } else if (numArgs == 1
        && PyBool_Check(pyArgs[0]) && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArgs[0])))) {
        overloadId = 3; // QJSPrimitiveValue(bool)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0])))) {
        overloadId = 7; // QJSPrimitiveValue(int)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))) {
        overloadId = 2; // QJSPrimitiveValue(QString)
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QMetaType_IDX]), (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 1; // QJSPrimitiveValue(QMetaType)
        } else if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<void *>(), (pyArgs[1])))) {
            overloadId = 4; // QJSPrimitiveValue(QMetaType,const void*)
        }
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QVariant_IDX], (pyArgs[0])))) {
        overloadId = 5; // QJSPrimitiveValue(QVariant)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QJSPrimitiveValue()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QJSPrimitiveValue()
                cptr = new ::QJSPrimitiveValue();
            }
            break;
        }
        case 1: // QJSPrimitiveValue(QMetaType type)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QMetaType cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QJSPrimitiveValue(QMetaType)
                cptr = new ::QJSPrimitiveValue(cppArg0);
            }
            break;
        }
        case 2: // QJSPrimitiveValue(QString string)
        {
            ::QString cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QJSPrimitiveValue(QString)
                cptr = new ::QJSPrimitiveValue(cppArg0);
            }
            break;
        }
        case 3: // QJSPrimitiveValue(bool value)
        {
            bool cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QJSPrimitiveValue(bool)
                cptr = new ::QJSPrimitiveValue(cppArg0);
            }
            break;
        }
        case 4: // QJSPrimitiveValue(const QMetaType type, const void * value)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QMetaType cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            void* cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QJSPrimitiveValue(QMetaType,const void*)
                cptr = new ::QJSPrimitiveValue(cppArg0, cppArg1);
            }
            break;
        }
        case 5: // QJSPrimitiveValue(const QVariant & variant)
        {
            ::QVariant cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QJSPrimitiveValue(QVariant)
                cptr = new ::QJSPrimitiveValue(cppArg0);
            }
            break;
        }
        case 6: // QJSPrimitiveValue(double value)
        {
            double cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QJSPrimitiveValue(double)
                cptr = new ::QJSPrimitiveValue(cppArg0);
            }
            break;
        }
        case 7: // QJSPrimitiveValue(int value)
        {
            int cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QJSPrimitiveValue(int)
                cptr = new ::QJSPrimitiveValue(cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QJSPrimitiveValue >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QJSPrimitiveValueFunc_constData(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QJSPrimitiveValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQml.QJSPrimitiveValue.constData";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // constData()const
            const void * cppResult = const_cast<const ::QJSPrimitiveValue *>(cppSelf)->constData();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<void *>(), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QJSPrimitiveValueFunc_data(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QJSPrimitiveValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQml.QJSPrimitiveValue.data";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // data()
            void * cppResult = cppSelf->data();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<void *>(), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QJSPrimitiveValueFunc_equals(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QJSPrimitiveValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtQml.QJSPrimitiveValue.equals";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QJSPrimitiveValue::equals(QJSPrimitiveValue)const->bool
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), (pyArg)))) {
        overloadId = 0; // equals(QJSPrimitiveValue)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QJSPrimitiveValue cppArg0_local;
        ::QJSPrimitiveValue *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // equals(QJSPrimitiveValue)const
            bool cppResult = const_cast<const ::QJSPrimitiveValue *>(cppSelf)->equals(*cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QJSPrimitiveValueFunc_metaType(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QJSPrimitiveValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQml.QJSPrimitiveValue.metaType";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // metaType()const
            QMetaType cppResult = const_cast<const ::QJSPrimitiveValue *>(cppSelf)->metaType();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QMetaType_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QJSPrimitiveValueFunc_strictlyEquals(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QJSPrimitiveValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtQml.QJSPrimitiveValue.strictlyEquals";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QJSPrimitiveValue::strictlyEquals(QJSPrimitiveValue)const->bool
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), (pyArg)))) {
        overloadId = 0; // strictlyEquals(QJSPrimitiveValue)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QJSPrimitiveValue cppArg0_local;
        ::QJSPrimitiveValue *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // strictlyEquals(QJSPrimitiveValue)const
            bool cppResult = const_cast<const ::QJSPrimitiveValue *>(cppSelf)->strictlyEquals(*cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QJSPrimitiveValueFunc_toBoolean(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QJSPrimitiveValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQml.QJSPrimitiveValue.toBoolean";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // toBoolean()const
            bool cppResult = const_cast<const ::QJSPrimitiveValue *>(cppSelf)->toBoolean();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QJSPrimitiveValueFunc_toDouble(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QJSPrimitiveValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQml.QJSPrimitiveValue.toDouble";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // toDouble()const
            double cppResult = const_cast<const ::QJSPrimitiveValue *>(cppSelf)->toDouble();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<double>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QJSPrimitiveValueFunc_toInteger(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QJSPrimitiveValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQml.QJSPrimitiveValue.toInteger";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // toInteger()const
            int cppResult = const_cast<const ::QJSPrimitiveValue *>(cppSelf)->toInteger();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QJSPrimitiveValueFunc_toString(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QJSPrimitiveValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQml.QJSPrimitiveValue.toString";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // toString()const
            QString cppResult = const_cast<const ::QJSPrimitiveValue *>(cppSelf)->toString();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QJSPrimitiveValueFunc_toVariant(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QJSPrimitiveValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQml.QJSPrimitiveValue.toVariant";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // toVariant()const
            QVariant cppResult = const_cast<const ::QJSPrimitiveValue *>(cppSelf)->toVariant();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QVariant_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QJSPrimitiveValueFunc_type(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QJSPrimitiveValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQml.QJSPrimitiveValue.type";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // type()const
            QJSPrimitiveValue::Type cppResult = const_cast<const ::QJSPrimitiveValue *>(cppSelf)->type();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_Type_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QJSPrimitiveValue__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QJSPrimitiveValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QJSPrimitiveValue_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QJSPrimitiveValue_EnumFlagInfo[] = {
    "Type:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QJSPrimitiveValue_methods[] = {
    {"constData", reinterpret_cast<PyCFunction>(Sbk_QJSPrimitiveValueFunc_constData), METH_NOARGS, nullptr},
    {"data", reinterpret_cast<PyCFunction>(Sbk_QJSPrimitiveValueFunc_data), METH_NOARGS, nullptr},
    {"equals", reinterpret_cast<PyCFunction>(Sbk_QJSPrimitiveValueFunc_equals), METH_O, nullptr},
    {"metaType", reinterpret_cast<PyCFunction>(Sbk_QJSPrimitiveValueFunc_metaType), METH_NOARGS, nullptr},
    {"strictlyEquals", reinterpret_cast<PyCFunction>(Sbk_QJSPrimitiveValueFunc_strictlyEquals), METH_O, nullptr},
    {"toBoolean", reinterpret_cast<PyCFunction>(Sbk_QJSPrimitiveValueFunc_toBoolean), METH_NOARGS, nullptr},
    {"toDouble", reinterpret_cast<PyCFunction>(Sbk_QJSPrimitiveValueFunc_toDouble), METH_NOARGS, nullptr},
    {"toInteger", reinterpret_cast<PyCFunction>(Sbk_QJSPrimitiveValueFunc_toInteger), METH_NOARGS, nullptr},
    {"toString", reinterpret_cast<PyCFunction>(Sbk_QJSPrimitiveValueFunc_toString), METH_NOARGS, nullptr},
    {"toVariant", reinterpret_cast<PyCFunction>(Sbk_QJSPrimitiveValueFunc_toVariant), METH_NOARGS, nullptr},
    {"type", reinterpret_cast<PyCFunction>(Sbk_QJSPrimitiveValueFunc_type), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QJSPrimitiveValue__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QJSPrimitiveValueFunc___mod__(PyObject *self, PyObject *pyArg)
{
    bool isReverse = SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), pyArg)
                    && !SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), self);
    if (isReverse)
        std::swap(self, pyArg);
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QJSPrimitiveValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtQml.QJSPrimitiveValue.__mod__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QJSPrimitiveValue::operator%(QJSPrimitiveValue)->QJSPrimitiveValue
    if (!isReverse
        && (pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), (pyArg)))) {
        overloadId = 0; // operator%(QJSPrimitiveValue,QJSPrimitiveValue)
    }

    if (isReverse && overloadId == -1) {
        Shiboken::Errors::setReverseOperatorNotImplemented();
        return {};
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QJSPrimitiveValue cppArg0_local;
        ::QJSPrimitiveValue *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // operator%(QJSPrimitiveValue,QJSPrimitiveValue)
            QJSPrimitiveValue cppResult = (*cppSelf) % (*cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QJSPrimitiveValueFunc___mul__(PyObject *self, PyObject *pyArg)
{
    bool isReverse = SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), pyArg)
                    && !SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), self);
    if (isReverse)
        std::swap(self, pyArg);
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QJSPrimitiveValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtQml.QJSPrimitiveValue.__mul__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QJSPrimitiveValue::operator*(QJSPrimitiveValue)->QJSPrimitiveValue
    if (!isReverse
        && (pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), (pyArg)))) {
        overloadId = 0; // operator*(QJSPrimitiveValue,QJSPrimitiveValue)
    }

    if (isReverse && overloadId == -1) {
        Shiboken::Errors::setReverseOperatorNotImplemented();
        return {};
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QJSPrimitiveValue cppArg0_local;
        ::QJSPrimitiveValue *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // operator*(QJSPrimitiveValue,QJSPrimitiveValue)
            QJSPrimitiveValue cppResult = (*cppSelf) * (*cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QJSPrimitiveValueFunc___pos__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QJSPrimitiveValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQml.QJSPrimitiveValue.__pos__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // operator+()
            QJSPrimitiveValue cppResult = + (*cppSelf);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QJSPrimitiveValueFunc___add__(PyObject *self, PyObject *pyArg)
{
    bool isReverse = SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), pyArg)
                    && !SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), self);
    if (isReverse)
        std::swap(self, pyArg);
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QJSPrimitiveValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtQml.QJSPrimitiveValue.__add__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QJSPrimitiveValue::operator+(QJSPrimitiveValue)->QJSPrimitiveValue
    if (!isReverse
        && (pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), (pyArg)))) {
        overloadId = 0; // operator+(QJSPrimitiveValue,QJSPrimitiveValue)
    }

    if (isReverse && overloadId == -1) {
        Shiboken::Errors::setReverseOperatorNotImplemented();
        return {};
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QJSPrimitiveValue cppArg0_local;
        ::QJSPrimitiveValue *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // operator+(QJSPrimitiveValue,QJSPrimitiveValue)
            QJSPrimitiveValue cppResult = (*cppSelf) + (*cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QJSPrimitiveValueFunc___iadd__(PyObject *self, PyObject *pyArg)
{
    bool isReverse = SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), pyArg)
                    && !SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), self);
    if (isReverse)
        std::swap(self, pyArg);
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QJSPrimitiveValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtQml.QJSPrimitiveValue.__iadd__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QJSPrimitiveValue::operator++(int)->QJSPrimitiveValue
    if (!isReverse
        && (pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // operator++(int)
    }

    if (isReverse && overloadId == -1) {
        Shiboken::Errors::setReverseOperatorNotImplemented();
        return {};
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // operator++(int)

            for (int i = 0; i < cppArg0; ++i, ++(*cppSelf));
            QJSPrimitiveValue cppResult = (*cppSelf);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QJSPrimitiveValueFunc___neg__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QJSPrimitiveValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQml.QJSPrimitiveValue.__neg__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // operator-()
            QJSPrimitiveValue cppResult = - (*cppSelf);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QJSPrimitiveValueFunc___sub__(PyObject *self, PyObject *pyArg)
{
    bool isReverse = SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), pyArg)
                    && !SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), self);
    if (isReverse)
        std::swap(self, pyArg);
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QJSPrimitiveValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtQml.QJSPrimitiveValue.__sub__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QJSPrimitiveValue::operator-(QJSPrimitiveValue)->QJSPrimitiveValue
    if (!isReverse
        && (pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), (pyArg)))) {
        overloadId = 0; // operator-(QJSPrimitiveValue,QJSPrimitiveValue)
    }

    if (isReverse && overloadId == -1) {
        Shiboken::Errors::setReverseOperatorNotImplemented();
        return {};
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QJSPrimitiveValue cppArg0_local;
        ::QJSPrimitiveValue *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // operator-(QJSPrimitiveValue,QJSPrimitiveValue)
            QJSPrimitiveValue cppResult = (*cppSelf) - (*cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QJSPrimitiveValueFunc___isub__(PyObject *self, PyObject *pyArg)
{
    bool isReverse = SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), pyArg)
                    && !SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), self);
    if (isReverse)
        std::swap(self, pyArg);
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QJSPrimitiveValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtQml.QJSPrimitiveValue.__isub__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QJSPrimitiveValue::operator--(int)->QJSPrimitiveValue
    if (!isReverse
        && (pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // operator--(int)
    }

    if (isReverse && overloadId == -1) {
        Shiboken::Errors::setReverseOperatorNotImplemented();
        return {};
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // operator--(int)

            for (int i = 0; i < cppArg0; ++i, --(*cppSelf));
            QJSPrimitiveValue cppResult = (*cppSelf);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QJSPrimitiveValueFunc___div__(PyObject *self, PyObject *pyArg)
{
    bool isReverse = SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), pyArg)
                    && !SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), self);
    if (isReverse)
        std::swap(self, pyArg);
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QJSPrimitiveValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtQml.QJSPrimitiveValue.__div__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QJSPrimitiveValue::operator/(QJSPrimitiveValue)->QJSPrimitiveValue
    if (!isReverse
        && (pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), (pyArg)))) {
        overloadId = 0; // operator/(QJSPrimitiveValue,QJSPrimitiveValue)
    }

    if (isReverse && overloadId == -1) {
        Shiboken::Errors::setReverseOperatorNotImplemented();
        return {};
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QJSPrimitiveValue cppArg0_local;
        ::QJSPrimitiveValue *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // operator/(QJSPrimitiveValue,QJSPrimitiveValue)
            QJSPrimitiveValue cppResult = (*cppSelf) / (*cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

// Rich comparison
static PyObject * Sbk_QJSPrimitiveValue_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QJSPrimitiveValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), (pyArg)))) {
                // operator!=(const QJSPrimitiveValue & rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QJSPrimitiveValue cppArg0_local;
                ::QJSPrimitiveValue *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_LT:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), (pyArg)))) {
                // operator<(const QJSPrimitiveValue & rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QJSPrimitiveValue cppArg0_local;
                ::QJSPrimitiveValue *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf < (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                return Shiboken::returnFromRichCompare(pyResult);
            }

            break;
        case Py_LE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), (pyArg)))) {
                // operator<=(const QJSPrimitiveValue & rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QJSPrimitiveValue cppArg0_local;
                ::QJSPrimitiveValue *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf <= (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                return Shiboken::returnFromRichCompare(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), (pyArg)))) {
                // operator==(const QJSPrimitiveValue & rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QJSPrimitiveValue cppArg0_local;
                ::QJSPrimitiveValue *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        case Py_GT:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), (pyArg)))) {
                // operator>(const QJSPrimitiveValue & rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QJSPrimitiveValue cppArg0_local;
                ::QJSPrimitiveValue *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf > (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                return Shiboken::returnFromRichCompare(pyResult);
            }

            break;
        case Py_GE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), (pyArg)))) {
                // operator>=(const QJSPrimitiveValue & rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QJSPrimitiveValue cppArg0_local;
                ::QJSPrimitiveValue *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf >= (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                return Shiboken::returnFromRichCompare(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static int Sbk_QJSPrimitiveValue_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QJSPrimitiveValue_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QJSPrimitiveValue_Type = nullptr;
static PyTypeObject *Sbk_QJSPrimitiveValue_TypeF(void)
{
    return _Sbk_QJSPrimitiveValue_Type;
}

static PyType_Slot Sbk_QJSPrimitiveValue_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QJSPrimitiveValue_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QJSPrimitiveValue_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QJSPrimitiveValue_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QJSPrimitiveValue_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QJSPrimitiveValue_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    // type supports number protocol
    {Py_nb_inplace_add, reinterpret_cast<void *>(Sbk_QJSPrimitiveValueFunc___iadd__)},
    {Py_nb_subtract,    reinterpret_cast<void *>(Sbk_QJSPrimitiveValueFunc___sub__)},
    {Py_nb_positive,    reinterpret_cast<void *>(Sbk_QJSPrimitiveValueFunc___pos__)},
    {Py_nb_multiply,    reinterpret_cast<void *>(Sbk_QJSPrimitiveValueFunc___mul__)},
    {Py_nb_negative,    reinterpret_cast<void *>(Sbk_QJSPrimitiveValueFunc___neg__)},
    {Py_nb_inplace_subtract,reinterpret_cast<void *>(Sbk_QJSPrimitiveValueFunc___isub__)},
    {Py_nb_remainder,   reinterpret_cast<void *>(Sbk_QJSPrimitiveValueFunc___mod__)},
    {Py_nb_true_divide, reinterpret_cast<void *>(Sbk_QJSPrimitiveValueFunc___div__)},
    {Py_nb_add,         reinterpret_cast<void *>(Sbk_QJSPrimitiveValueFunc___add__)},
    {0, nullptr}
};
static PyType_Spec Sbk_QJSPrimitiveValue_spec = {
    "2:PySide6.QtQml.QJSPrimitiveValue",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QJSPrimitiveValue_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void QJSPrimitiveValue_Type_PythonToCpp_QJSPrimitiveValue_Type(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QJSPrimitiveValue::Type>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QJSPrimitiveValue::Type *>(cppOut) = value;

}
static PythonToCppFunc is_QJSPrimitiveValue_Type_PythonToCpp_QJSPrimitiveValue_Type_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_Type_IDX])))
        return QJSPrimitiveValue_Type_PythonToCpp_QJSPrimitiveValue_Type;
    return {};
}
static PyObject *QJSPrimitiveValue_Type_CppToPython_QJSPrimitiveValue_Type(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QJSPrimitiveValue::Type *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_Type_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QJSPrimitiveValue_PythonToCpp_QJSPrimitiveValue_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QJSPrimitiveValue_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QJSPrimitiveValue_PythonToCpp_QJSPrimitiveValue_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QJSPrimitiveValue_TypeF()))
        return QJSPrimitiveValue_PythonToCpp_QJSPrimitiveValue_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QJSPrimitiveValue_PTR_CppToPython_QJSPrimitiveValue(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QJSPrimitiveValue *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QJSPrimitiveValue_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *QJSPrimitiveValue_COPY_CppToPython_QJSPrimitiveValue(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QJSPrimitiveValue *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QJSPrimitiveValue_TypeF(), new ::QJSPrimitiveValue(*source), true, true);
}

// Python to C++ copy conversion.
static void QJSPrimitiveValue_PythonToCpp_QJSPrimitiveValue_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QJSPrimitiveValue *>(cppOut) = *reinterpret_cast< ::QJSPrimitiveValue *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QJSPrimitiveValue_PythonToCpp_QJSPrimitiveValue_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QJSPrimitiveValue_TypeF()))
        return QJSPrimitiveValue_PythonToCpp_QJSPrimitiveValue_COPY;
    return {};
}

// Implicit conversions.
static void PySide6_QtCore_QString_PythonToCpp_QJSPrimitiveValue(PyObject *pyIn, void *cppOut)
{
    ::QString cppIn;
    Shiboken::Conversions::pythonToCppCopy(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], pyIn, &cppIn);
    *reinterpret_cast<::QJSPrimitiveValue *>(cppOut) = ::QJSPrimitiveValue(cppIn);
}
static PythonToCppFunc is_PySide6_QtCore_QString_PythonToCpp_QJSPrimitiveValue_Convertible(PyObject *pyIn)
{
    if (PyUnicode_Check(pyIn))
        return PySide6_QtCore_QString_PythonToCpp_QJSPrimitiveValue;
    return {};
}

static void bool_PythonToCpp_QJSPrimitiveValue(PyObject *pyIn, void *cppOut)
{
    bool cppIn;
    Shiboken::Conversions::pythonToCppCopy(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), pyIn, &cppIn);
    *reinterpret_cast<::QJSPrimitiveValue *>(cppOut) = ::QJSPrimitiveValue(cppIn);
}
static PythonToCppFunc is_bool_PythonToCpp_QJSPrimitiveValue_Convertible(PyObject *pyIn)
{
    if (PyBool_Check(pyIn))
        return bool_PythonToCpp_QJSPrimitiveValue;
    return {};
}

static void double_PythonToCpp_QJSPrimitiveValue(PyObject *pyIn, void *cppOut)
{
    double cppIn;
    Shiboken::Conversions::pythonToCppCopy(Shiboken::Conversions::PrimitiveTypeConverter<double>(), pyIn, &cppIn);
    *reinterpret_cast<::QJSPrimitiveValue *>(cppOut) = ::QJSPrimitiveValue(cppIn);
}
static PythonToCppFunc is_double_PythonToCpp_QJSPrimitiveValue_Convertible(PyObject *pyIn)
{
    if (PyFloat_Check(pyIn))
        return double_PythonToCpp_QJSPrimitiveValue;
    return {};
}

static void int_PythonToCpp_QJSPrimitiveValue(PyObject *pyIn, void *cppOut)
{
    int cppIn;
    Shiboken::Conversions::pythonToCppCopy(Shiboken::Conversions::PrimitiveTypeConverter<int>(), pyIn, &cppIn);
    *reinterpret_cast<::QJSPrimitiveValue *>(cppOut) = ::QJSPrimitiveValue(cppIn);
}
static PythonToCppFunc is_int_PythonToCpp_QJSPrimitiveValue_Convertible(PyObject *pyIn)
{
    if (PyLong_Check(pyIn))
        return int_PythonToCpp_QJSPrimitiveValue;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QJSPrimitiveValue_SignatureStrings[] = {
    "7:PySide6.QtQml.QJSPrimitiveValue(self)",
    "6:PySide6.QtQml.QJSPrimitiveValue(self,type:typing.Union[PySide6.QtCore.QMetaType, PySide6.QtCore.QMetaType.Type])",
    "5:PySide6.QtQml.QJSPrimitiveValue(self,string:QString)",
    "4:PySide6.QtQml.QJSPrimitiveValue(self,value:bool)",
    "3:PySide6.QtQml.QJSPrimitiveValue(self,type:typing.Union[PySide6.QtCore.QMetaType, PySide6.QtCore.QMetaType.Type],value:void)",
    "2:PySide6.QtQml.QJSPrimitiveValue(self,variant:QVariant)",
    "1:PySide6.QtQml.QJSPrimitiveValue(self,value:double)",
    "0:PySide6.QtQml.QJSPrimitiveValue(self,value:int)",
    "PySide6.QtQml.QJSPrimitiveValue.constData(self)->void",
    "PySide6.QtQml.QJSPrimitiveValue.data(self)->void",
    "PySide6.QtQml.QJSPrimitiveValue.equals(self,other:typing.Union[PySide6.QtQml.QJSPrimitiveValue, QString, bool, double, int])->bool",
    "PySide6.QtQml.QJSPrimitiveValue.metaType(self)->PySide6.QtCore.QMetaType",
    "PySide6.QtQml.QJSPrimitiveValue.strictlyEquals(self,other:typing.Union[PySide6.QtQml.QJSPrimitiveValue, QString, bool, double, int])->bool",
    "PySide6.QtQml.QJSPrimitiveValue.toBoolean(self)->bool",
    "PySide6.QtQml.QJSPrimitiveValue.toDouble(self)->double",
    "PySide6.QtQml.QJSPrimitiveValue.toInteger(self)->int",
    "PySide6.QtQml.QJSPrimitiveValue.toString(self)->QString",
    "PySide6.QtQml.QJSPrimitiveValue.toVariant(self)->QVariant",
    "PySide6.QtQml.QJSPrimitiveValue.type(self)->PySide6.QtQml.QJSPrimitiveValue.Type",
    "PySide6.QtQml.QJSPrimitiveValue.__copy__()",
    "PySide6.QtQml.QJSPrimitiveValue.__mod__(self,rhs:typing.Union[PySide6.QtQml.QJSPrimitiveValue, QString, bool, double, int])->PySide6.QtQml.QJSPrimitiveValue",
    "PySide6.QtQml.QJSPrimitiveValue.__mul__(self,rhs:typing.Union[PySide6.QtQml.QJSPrimitiveValue, QString, bool, double, int])->PySide6.QtQml.QJSPrimitiveValue",
    "PySide6.QtQml.QJSPrimitiveValue.__pos__(self)->PySide6.QtQml.QJSPrimitiveValue",
    "PySide6.QtQml.QJSPrimitiveValue.__add__(self,rhs:typing.Union[PySide6.QtQml.QJSPrimitiveValue, QString, bool, double, int])->PySide6.QtQml.QJSPrimitiveValue",
    "PySide6.QtQml.QJSPrimitiveValue.__iadd__(self,arg__1:int)->PySide6.QtQml.QJSPrimitiveValue",
    "PySide6.QtQml.QJSPrimitiveValue.__neg__(self)->PySide6.QtQml.QJSPrimitiveValue",
    "PySide6.QtQml.QJSPrimitiveValue.__sub__(self,rhs:typing.Union[PySide6.QtQml.QJSPrimitiveValue, QString, bool, double, int])->PySide6.QtQml.QJSPrimitiveValue",
    "PySide6.QtQml.QJSPrimitiveValue.__isub__(self,arg__1:int)->PySide6.QtQml.QJSPrimitiveValue",
    "PySide6.QtQml.QJSPrimitiveValue.__div__(self,rhs:typing.Union[PySide6.QtQml.QJSPrimitiveValue, QString, bool, double, int])->PySide6.QtQml.QJSPrimitiveValue",
    nullptr}; // Sentinel

PyTypeObject *init_QJSPrimitiveValue(PyObject *module)
{
    _Sbk_QJSPrimitiveValue_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QJSPrimitiveValue",
        "QJSPrimitiveValue",
        &Sbk_QJSPrimitiveValue_spec,
        &Shiboken::callCppDestructor< ::QJSPrimitiveValue >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QJSPrimitiveValue_TypeF(); // references _Sbk_QJSPrimitiveValue_Type
    InitSignatureStrings(pyType, QJSPrimitiveValue_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QJSPrimitiveValue_PropertyStrings);
    SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QJSPrimitiveValue_PythonToCpp_QJSPrimitiveValue_PTR,
        is_QJSPrimitiveValue_PythonToCpp_QJSPrimitiveValue_PTR_Convertible,
        QJSPrimitiveValue_PTR_CppToPython_QJSPrimitiveValue,
        QJSPrimitiveValue_COPY_CppToPython_QJSPrimitiveValue);

    Shiboken::Conversions::registerConverterName(converter, "QJSPrimitiveValue");
    Shiboken::Conversions::registerConverterName(converter, "QJSPrimitiveValue*");
    Shiboken::Conversions::registerConverterName(converter, "QJSPrimitiveValue&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QJSPrimitiveValue).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QJSPrimitiveValue_PythonToCpp_QJSPrimitiveValue_COPY,
        is_QJSPrimitiveValue_PythonToCpp_QJSPrimitiveValue_COPY_Convertible);
    // Add implicit conversions to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        PySide6_QtCore_QString_PythonToCpp_QJSPrimitiveValue,
        is_PySide6_QtCore_QString_PythonToCpp_QJSPrimitiveValue_Convertible);
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        bool_PythonToCpp_QJSPrimitiveValue,
        is_bool_PythonToCpp_QJSPrimitiveValue_Convertible);
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        double_PythonToCpp_QJSPrimitiveValue,
        is_double_PythonToCpp_QJSPrimitiveValue_Convertible);
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        int_PythonToCpp_QJSPrimitiveValue,
        is_int_PythonToCpp_QJSPrimitiveValue_Convertible);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QJSPrimitiveValue_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'Type'.
    const char *Type_Initializer[] = {
        "Undefined",
        "Null",
        "Boolean",
        "Integer",
        "Double",
        "String",
        nullptr};
    // "uint8_t" used instead of "unsigned char"
    constexpr uint8_t Type_InitializerValues[] = {
        uint8_t(QJSPrimitiveValue::Type::Undefined), //  0x00  0
        uint8_t(QJSPrimitiveValue::Type::Null),      //  0x01  1
        uint8_t(QJSPrimitiveValue::Type::Boolean),   //  0x02  2
        uint8_t(QJSPrimitiveValue::Type::Integer),   //  0x03  3
        uint8_t(QJSPrimitiveValue::Type::Double),    //  0x04  4
        uint8_t(QJSPrimitiveValue::Type::String)     //  0x05  5
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QJSPrimitiveValue_TypeF(),
        "2:PySide6.QtQml.QJSPrimitiveValue.Type",
        Type_Initializer, Type_InitializerValues);
    SbkPySide6_QtQmlTypeStructs[SBK_QJSPrimitiveValue_Type_IDX].type = EType;
    // Register converter for enum 'QJSPrimitiveValue::Type'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QJSPrimitiveValue_Type_CppToPython_QJSPrimitiveValue_Type);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QJSPrimitiveValue_Type_PythonToCpp_QJSPrimitiveValue_Type,
            is_QJSPrimitiveValue_Type_PythonToCpp_QJSPrimitiveValue_Type_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QJSPrimitiveValue::Type");
        Shiboken::Conversions::registerConverterName(converter, "Type");
    }
    // End of 'Type' enum.

    qRegisterMetaType< ::QJSPrimitiveValue >("QJSPrimitiveValue");
    qRegisterMetaType< ::QJSPrimitiveValue::Type >("QJSPrimitiveValue::Type");

    return pyType;
}
