// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtqml_python.h"

// main header
#include "qqmldebuggingenabler_wrapper.h"

// Argument includes
#include <QHash>
#include <QString>
#include <QStringList>
#include <QtQml/qqmldebug.h>
#include <qvariant.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QQmlDebuggingEnabler_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QQmlDebuggingEnabler >()))
        return -1;

    ::QQmlDebuggingEnabler *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtQml.QQmlDebuggingEnabler.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 0, 1));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|O:QQmlDebuggingEnabler", &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QQmlDebuggingEnabler::QQmlDebuggingEnabler(bool=)
    if (numArgs == 0) {
        overloadId = 0; // QQmlDebuggingEnabler(bool)
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArgs[0])))) {
        overloadId = 0; // QQmlDebuggingEnabler(bool)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    {
        Shiboken::Warnings::warnDeprecated("QQmlDebuggingEnabler", "QQmlDebuggingEnabler(bool printWarning)");
        if (Shiboken::Errors::occurred() != nullptr)
            return -1;
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_printWarning = Shiboken::String::createStaticString("printWarning");
            if (PyDict_Contains(kwds, key_printWarning) != 0) {
                value = PyDict_GetItem(kwds, key_printWarning);
                if (value != nullptr && pyArgs[0] != nullptr ) {
                    errInfo.reset(key_printWarning);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                }
                if (value != nullptr) {
                    pyArgs[0] = value;
                    if (!(pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArgs[0]))))
                        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                }
                PyDict_DelItem(kwds_dup, key_printWarning);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
            }
        }
        bool cppArg0 = true;
        if (pythonToCpp[0])
            pythonToCpp[0](pyArgs[0], &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // QQmlDebuggingEnabler(bool)
            cptr = new ::QQmlDebuggingEnabler(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QQmlDebuggingEnabler >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QQmlDebuggingEnablerFunc_connectToLocalDebugger(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(self)
    SBK_UNUSED(kwds)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtQml.QQmlDebuggingEnabler.connectToLocalDebugger";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 1, 2));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|OO:connectToLocalDebugger", &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: static QQmlDebuggingEnabler::connectToLocalDebugger(QString,QQmlDebuggingEnabler::StartMode=)->bool
    if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 0; // connectToLocalDebugger(QString,QQmlDebuggingEnabler::StartMode)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_StartMode_IDX])))->converter, (pyArgs[1])))) {
            overloadId = 0; // connectToLocalDebugger(QString,QQmlDebuggingEnabler::StartMode)
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_mode = Shiboken::String::createStaticString("mode");
            if (PyDict_Contains(kwds, key_mode) != 0) {
                value = PyDict_GetItem(kwds, key_mode);
                if (value != nullptr && pyArgs[1] != nullptr ) {
                    errInfo.reset(key_mode);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                if (value != nullptr) {
                    pyArgs[1] = value;
                    if (!(pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_StartMode_IDX])))->converter, (pyArgs[1]))))
                        return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                PyDict_DelItem(kwds_dup, key_mode);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments(args, fullName, errInfo);
            }
        }
        ::QString cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QQmlDebuggingEnabler::StartMode cppArg1(QQmlDebuggingEnabler::StartMode::DoNotWaitForClient);
        if (pythonToCpp[1])
            pythonToCpp[1](pyArgs[1], &cppArg1);

        if (Shiboken::Errors::occurred() == nullptr) {
            // connectToLocalDebugger(QString,QQmlDebuggingEnabler::StartMode)
            bool cppResult = ::QQmlDebuggingEnabler::connectToLocalDebugger(cppArg0, cppArg1);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlDebuggingEnablerFunc_debuggerServices(PyObject *self)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQml.QQmlDebuggingEnabler.debuggerServices";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // debuggerServices()
            QStringList cppResult = ::QQmlDebuggingEnabler::debuggerServices();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QStringList_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlDebuggingEnablerFunc_enableDebugging(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtQml.QQmlDebuggingEnabler.enableDebugging";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static QQmlDebuggingEnabler::enableDebugging(bool)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArg)))) {
        overloadId = 0; // enableDebugging(bool)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        bool cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // enableDebugging(bool)
            ::QQmlDebuggingEnabler::enableDebugging(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QQmlDebuggingEnablerFunc_inspectorServices(PyObject *self)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQml.QQmlDebuggingEnabler.inspectorServices";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // inspectorServices()
            QStringList cppResult = ::QQmlDebuggingEnabler::inspectorServices();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QStringList_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlDebuggingEnablerFunc_nativeDebuggerServices(PyObject *self)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQml.QQmlDebuggingEnabler.nativeDebuggerServices";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // nativeDebuggerServices()
            QStringList cppResult = ::QQmlDebuggingEnabler::nativeDebuggerServices();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QStringList_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlDebuggingEnablerFunc_profilerServices(PyObject *self)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQml.QQmlDebuggingEnabler.profilerServices";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // profilerServices()
            QStringList cppResult = ::QQmlDebuggingEnabler::profilerServices();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QStringList_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlDebuggingEnablerFunc_setServices(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtQml.QQmlDebuggingEnabler.setServices";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static QQmlDebuggingEnabler::setServices(QStringList)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QStringList_IDX], (pyArg)))) {
        overloadId = 0; // setServices(QStringList)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QStringList cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setServices(QStringList)
            ::QQmlDebuggingEnabler::setServices(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QQmlDebuggingEnablerFunc_startDebugConnector(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(self)
    SBK_UNUSED(kwds)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtQml.QQmlDebuggingEnabler.startDebugConnector";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 1, 2));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|OO:startDebugConnector", &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: static QQmlDebuggingEnabler::startDebugConnector(QString,const QHash<QString,QVariant>&=)->bool
    if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 0; // startDebugConnector(QString,QHash<QString,QVariant>)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtQmlTypeConverters[SBK_QtQml_QHash_QString_QVariant_IDX], (pyArgs[1])))) {
            overloadId = 0; // startDebugConnector(QString,QHash<QString,QVariant>)
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_configuration = Shiboken::String::createStaticString("configuration");
            if (PyDict_Contains(kwds, key_configuration) != 0) {
                value = PyDict_GetItem(kwds, key_configuration);
                if (value != nullptr && pyArgs[1] != nullptr ) {
                    errInfo.reset(key_configuration);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                if (value != nullptr) {
                    pyArgs[1] = value;
                    if (!(pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtQmlTypeConverters[SBK_QtQml_QHash_QString_QVariant_IDX], (pyArgs[1]))))
                        return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                PyDict_DelItem(kwds_dup, key_configuration);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments(args, fullName, errInfo);
            }
        }
        ::QString cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QHash<QString,QVariant> cppArg1 = QVariantHash();
        if (pythonToCpp[1])
            pythonToCpp[1](pyArgs[1], &cppArg1);

        if (Shiboken::Errors::occurred() == nullptr) {
            // startDebugConnector(QString,QHash<QString,QVariant>)
            bool cppResult = ::QQmlDebuggingEnabler::startDebugConnector(cppArg0, cppArg1);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlDebuggingEnablerFunc_startTcpDebugServer(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(self)
    SBK_UNUSED(kwds)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtQml.QQmlDebuggingEnabler.startTcpDebugServer";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[3];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 1, 3));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|OOO:startTcpDebugServer", &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2])) == 0)
        return {};


    // Overloaded function decisor
    // 0: static QQmlDebuggingEnabler::startTcpDebugServer(int,QQmlDebuggingEnabler::StartMode=,const QString&=)->bool
    if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 0; // startTcpDebugServer(int,QQmlDebuggingEnabler::StartMode,QString)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_StartMode_IDX])))->converter, (pyArgs[1])))) {
            if (numArgs == 2) {
                overloadId = 0; // startTcpDebugServer(int,QQmlDebuggingEnabler::StartMode,QString)
            } else if (numArgs >= 3
                && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[2])))) {
                overloadId = 0; // startTcpDebugServer(int,QQmlDebuggingEnabler::StartMode,QString)
            }
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_mode = Shiboken::String::createStaticString("mode");
            if (PyDict_Contains(kwds, key_mode) != 0) {
                value = PyDict_GetItem(kwds, key_mode);
                if (value != nullptr && pyArgs[1] != nullptr ) {
                    errInfo.reset(key_mode);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                if (value != nullptr) {
                    pyArgs[1] = value;
                    if (!(pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_StartMode_IDX])))->converter, (pyArgs[1]))))
                        return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                PyDict_DelItem(kwds_dup, key_mode);
            }
            static PyObject *const key_hostName = Shiboken::String::createStaticString("hostName");
            if (PyDict_Contains(kwds, key_hostName) != 0) {
                value = PyDict_GetItem(kwds, key_hostName);
                if (value != nullptr && pyArgs[2] != nullptr ) {
                    errInfo.reset(key_hostName);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                if (value != nullptr) {
                    pyArgs[2] = value;
                    if (!(pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[2]))))
                        return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                PyDict_DelItem(kwds_dup, key_hostName);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments(args, fullName, errInfo);
            }
        }
        int cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QQmlDebuggingEnabler::StartMode cppArg1(QQmlDebuggingEnabler::StartMode::DoNotWaitForClient);
        if (pythonToCpp[1])
            pythonToCpp[1](pyArgs[1], &cppArg1);
        ::QString cppArg2 = QString();
        if (pythonToCpp[2])
            pythonToCpp[2](pyArgs[2], &cppArg2);

        if (Shiboken::Errors::occurred() == nullptr) {
            // startTcpDebugServer(int,QQmlDebuggingEnabler::StartMode,QString)
            bool cppResult = ::QQmlDebuggingEnabler::startTcpDebugServer(cppArg0, cppArg1, cppArg2);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QQmlDebuggingEnabler_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QQmlDebuggingEnabler_EnumFlagInfo[] = {
    "StartMode:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QQmlDebuggingEnabler_methods[] = {
    {"connectToLocalDebugger", reinterpret_cast<PyCFunction>(Sbk_QQmlDebuggingEnablerFunc_connectToLocalDebugger), METH_VARARGS|METH_KEYWORDS|METH_STATIC, nullptr},
    {"debuggerServices", reinterpret_cast<PyCFunction>(Sbk_QQmlDebuggingEnablerFunc_debuggerServices), METH_NOARGS|METH_STATIC, nullptr},
    {"enableDebugging", reinterpret_cast<PyCFunction>(Sbk_QQmlDebuggingEnablerFunc_enableDebugging), METH_O|METH_STATIC, nullptr},
    {"inspectorServices", reinterpret_cast<PyCFunction>(Sbk_QQmlDebuggingEnablerFunc_inspectorServices), METH_NOARGS|METH_STATIC, nullptr},
    {"nativeDebuggerServices", reinterpret_cast<PyCFunction>(Sbk_QQmlDebuggingEnablerFunc_nativeDebuggerServices), METH_NOARGS|METH_STATIC, nullptr},
    {"profilerServices", reinterpret_cast<PyCFunction>(Sbk_QQmlDebuggingEnablerFunc_profilerServices), METH_NOARGS|METH_STATIC, nullptr},
    {"setServices", reinterpret_cast<PyCFunction>(Sbk_QQmlDebuggingEnablerFunc_setServices), METH_O|METH_STATIC, nullptr},
    {"startDebugConnector", reinterpret_cast<PyCFunction>(Sbk_QQmlDebuggingEnablerFunc_startDebugConnector), METH_VARARGS|METH_KEYWORDS|METH_STATIC, nullptr},
    {"startTcpDebugServer", reinterpret_cast<PyCFunction>(Sbk_QQmlDebuggingEnablerFunc_startTcpDebugServer), METH_VARARGS|METH_KEYWORDS|METH_STATIC, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QQmlDebuggingEnabler_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QQmlDebuggingEnabler_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QQmlDebuggingEnabler_Type = nullptr;
static PyTypeObject *Sbk_QQmlDebuggingEnabler_TypeF(void)
{
    return _Sbk_QQmlDebuggingEnabler_Type;
}

static PyType_Slot Sbk_QQmlDebuggingEnabler_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QQmlDebuggingEnabler_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QQmlDebuggingEnabler_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QQmlDebuggingEnabler_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QQmlDebuggingEnabler_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QQmlDebuggingEnabler_spec = {
    "2:PySide6.QtQml.QQmlDebuggingEnabler",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QQmlDebuggingEnabler_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void QQmlDebuggingEnabler_StartMode_PythonToCpp_QQmlDebuggingEnabler_StartMode(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QQmlDebuggingEnabler::StartMode>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QQmlDebuggingEnabler::StartMode *>(cppOut) = value;

}
static PythonToCppFunc is_QQmlDebuggingEnabler_StartMode_PythonToCpp_QQmlDebuggingEnabler_StartMode_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_StartMode_IDX])))
        return QQmlDebuggingEnabler_StartMode_PythonToCpp_QQmlDebuggingEnabler_StartMode;
    return {};
}
static PyObject *QQmlDebuggingEnabler_StartMode_CppToPython_QQmlDebuggingEnabler_StartMode(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QQmlDebuggingEnabler::StartMode *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_StartMode_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QQmlDebuggingEnabler_PythonToCpp_QQmlDebuggingEnabler_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QQmlDebuggingEnabler_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QQmlDebuggingEnabler_PythonToCpp_QQmlDebuggingEnabler_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QQmlDebuggingEnabler_TypeF()))
        return QQmlDebuggingEnabler_PythonToCpp_QQmlDebuggingEnabler_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QQmlDebuggingEnabler_PTR_CppToPython_QQmlDebuggingEnabler(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QQmlDebuggingEnabler *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QQmlDebuggingEnabler_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QQmlDebuggingEnabler_SignatureStrings[] = {
    "PySide6.QtQml.QQmlDebuggingEnabler(self,printWarning:bool=true)",
    "PySide6.QtQml.QQmlDebuggingEnabler.connectToLocalDebugger(socketFileName:QString,mode:PySide6.QtQml.QQmlDebuggingEnabler.StartMode=QQmlDebuggingEnabler.StartMode.DoNotWaitForClient)->bool",
    "PySide6.QtQml.QQmlDebuggingEnabler.debuggerServices()->QStringList",
    "PySide6.QtQml.QQmlDebuggingEnabler.enableDebugging(printWarning:bool)",
    "PySide6.QtQml.QQmlDebuggingEnabler.inspectorServices()->QStringList",
    "PySide6.QtQml.QQmlDebuggingEnabler.nativeDebuggerServices()->QStringList",
    "PySide6.QtQml.QQmlDebuggingEnabler.profilerServices()->QStringList",
    "PySide6.QtQml.QQmlDebuggingEnabler.setServices(services:QStringList)",
    "PySide6.QtQml.QQmlDebuggingEnabler.startDebugConnector(pluginName:QString,configuration:QHash[QString, QVariant]=QVariantHash())->bool",
    "PySide6.QtQml.QQmlDebuggingEnabler.startTcpDebugServer(port:int,mode:PySide6.QtQml.QQmlDebuggingEnabler.StartMode=QQmlDebuggingEnabler.StartMode.DoNotWaitForClient,hostName:QString=QString())->bool",
    nullptr}; // Sentinel

PyTypeObject *init_QQmlDebuggingEnabler(PyObject *module)
{
    _Sbk_QQmlDebuggingEnabler_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QQmlDebuggingEnabler",
        "QQmlDebuggingEnabler*",
        &Sbk_QQmlDebuggingEnabler_spec,
        &Shiboken::callCppDestructor< ::QQmlDebuggingEnabler >,
        nullptr,
        0,
        0);
    auto *pyType = Sbk_QQmlDebuggingEnabler_TypeF(); // references _Sbk_QQmlDebuggingEnabler_Type
    InitSignatureStrings(pyType, QQmlDebuggingEnabler_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QQmlDebuggingEnabler_PropertyStrings);
    SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QQmlDebuggingEnabler_PythonToCpp_QQmlDebuggingEnabler_PTR,
        is_QQmlDebuggingEnabler_PythonToCpp_QQmlDebuggingEnabler_PTR_Convertible,
        QQmlDebuggingEnabler_PTR_CppToPython_QQmlDebuggingEnabler);

    Shiboken::Conversions::registerConverterName(converter, "QQmlDebuggingEnabler");
    Shiboken::Conversions::registerConverterName(converter, "QQmlDebuggingEnabler*");
    Shiboken::Conversions::registerConverterName(converter, "QQmlDebuggingEnabler&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QQmlDebuggingEnabler).name());

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QQmlDebuggingEnabler_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'StartMode'.
    const char *StartMode_Initializer[] = {
        "DoNotWaitForClient",
        "WaitForClient",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t StartMode_InitializerValues[] = {
        uint8_t(QQmlDebuggingEnabler::StartMode::DoNotWaitForClient), //  0x00  0
        uint8_t(QQmlDebuggingEnabler::StartMode::WaitForClient)       //  0x01  1
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QQmlDebuggingEnabler_TypeF(),
        "2:PySide6.QtQml.QQmlDebuggingEnabler.StartMode",
        StartMode_Initializer, StartMode_InitializerValues);
    SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_StartMode_IDX].type = EType;
    // Register converter for enum 'QQmlDebuggingEnabler::StartMode'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QQmlDebuggingEnabler_StartMode_CppToPython_QQmlDebuggingEnabler_StartMode);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QQmlDebuggingEnabler_StartMode_PythonToCpp_QQmlDebuggingEnabler_StartMode,
            is_QQmlDebuggingEnabler_StartMode_PythonToCpp_QQmlDebuggingEnabler_StartMode_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QQmlDebuggingEnabler::StartMode");
        Shiboken::Conversions::registerConverterName(converter, "StartMode");
    }
    // End of 'StartMode' enum.

    qRegisterMetaType< ::QQmlDebuggingEnabler *>();
    qRegisterMetaType< ::QQmlDebuggingEnabler::StartMode >("QQmlDebuggingEnabler::StartMode");

    return pyType;
}
