// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtqml_python.h"

// main header
#include "qqmlproperty_wrapper.h"

// Argument includes
#include <QString>
#include <QtQml/qqmlcontext.h>
#include <QtQml/qqmlengine.h>
#include <QtQml/qqmlproperty.h>
#include <qmetaobject.h>
#include <qmetatype.h>
#include <qobject.h>
#include <qobjectdefs.h>
#include <qvariant.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QQmlProperty_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QQmlProperty >()))
        return -1;

    ::QQmlProperty *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtQml.QQmlProperty.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[3];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QQmlProperty", 0, 3, &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QQmlProperty::QQmlProperty()
    // 1: QQmlProperty::QQmlProperty(QObject*)
    // 2: QQmlProperty::QQmlProperty(QObject*,QQmlContext*)
    // 3: QQmlProperty::QQmlProperty(QObject*,QQmlEngine*)
    // 4: QQmlProperty::QQmlProperty(QObject*,QString)
    // 5: QQmlProperty::QQmlProperty(QObject*,QString,QQmlContext*)
    // 6: QQmlProperty::QQmlProperty(QObject*,QString,QQmlEngine*)
    // 7: QQmlProperty::QQmlProperty(QQmlProperty)
    if (numArgs == 0) {
        overloadId = 0; // QQmlProperty()
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QObject_IDX]), (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 1; // QQmlProperty(QObject*)
        } else if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlEngine_IDX]), (pyArgs[1])))) {
            overloadId = 3; // QQmlProperty(QObject*,QQmlEngine*)
        } else if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlContext_IDX]), (pyArgs[1])))) {
            overloadId = 2; // QQmlProperty(QObject*,QQmlContext*)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[1])))) {
            if (numArgs == 2) {
                overloadId = 4; // QQmlProperty(QObject*,QString)
            } else if (numArgs == 3
                && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlEngine_IDX]), (pyArgs[2])))) {
                overloadId = 6; // QQmlProperty(QObject*,QString,QQmlEngine*)
            } else if (numArgs == 3
                && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlContext_IDX]), (pyArgs[2])))) {
                overloadId = 5; // QQmlProperty(QObject*,QString,QQmlContext*)
            }
        }
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_IDX]), (pyArgs[0])))) {
        overloadId = 7; // QQmlProperty(QQmlProperty)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QQmlProperty()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QQmlProperty()
                cptr = new ::QQmlProperty();
            }
            break;
        }
        case 1: // QQmlProperty(QObject * arg__1)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QObject *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QQmlProperty(QObject*)
                cptr = new ::QQmlProperty(cppArg0);
            }
            break;
        }
        case 2: // QQmlProperty(QObject * arg__1, QQmlContext * arg__2)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QObject *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            if (!Shiboken::Object::isValid(pyArgs[1]))
                return -1;
            ::QQmlContext *cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QQmlProperty(QObject*,QQmlContext*)
                cptr = new ::QQmlProperty(cppArg0, cppArg1);
            }
            break;
        }
        case 3: // QQmlProperty(QObject * arg__1, QQmlEngine * arg__2)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QObject *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            if (!Shiboken::Object::isValid(pyArgs[1]))
                return -1;
            ::QQmlEngine *cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QQmlProperty(QObject*,QQmlEngine*)
                cptr = new ::QQmlProperty(cppArg0, cppArg1);
            }
            break;
        }
        case 4: // QQmlProperty(QObject * arg__1, const QString & arg__2)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QObject *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            ::QString cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QQmlProperty(QObject*,QString)
                cptr = new ::QQmlProperty(cppArg0, cppArg1);
            }
            break;
        }
        case 5: // QQmlProperty(QObject * arg__1, const QString & arg__2, QQmlContext * arg__3)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QObject *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            ::QString cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);
            if (!Shiboken::Object::isValid(pyArgs[2]))
                return -1;
            ::QQmlContext *cppArg2;
            pythonToCpp[2](pyArgs[2], &cppArg2);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QQmlProperty(QObject*,QString,QQmlContext*)
                cptr = new ::QQmlProperty(cppArg0, cppArg1, cppArg2);
            }
            break;
        }
        case 6: // QQmlProperty(QObject * arg__1, const QString & arg__2, QQmlEngine * arg__3)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QObject *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            ::QString cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);
            if (!Shiboken::Object::isValid(pyArgs[2]))
                return -1;
            ::QQmlEngine *cppArg2;
            pythonToCpp[2](pyArgs[2], &cppArg2);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QQmlProperty(QObject*,QString,QQmlEngine*)
                cptr = new ::QQmlProperty(cppArg0, cppArg1, cppArg2);
            }
            break;
        }
        case 7: // QQmlProperty(const QQmlProperty & arg__1)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QQmlProperty cppArg0_local;
            ::QQmlProperty *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QQmlProperty(QQmlProperty)
                cptr = new ::QQmlProperty(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QQmlProperty >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QQmlPropertyFunc_connectNotifySignal(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlProperty *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtQml.QQmlProperty.connectNotifySignal";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "connectNotifySignal", 2, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QQmlProperty::connectNotifySignal(QObject*,const char*)const->bool
    // 1: QQmlProperty::connectNotifySignal(QObject*,int)const->bool
    if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QObject_IDX]), (pyArgs[0])))) {
        if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1])))) {
            overloadId = 1; // connectNotifySignal(QObject*,int)const
        } else if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<const char *>(), (pyArgs[1])))) {
            overloadId = 0; // connectNotifySignal(QObject*,const char*)const
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    switch (overloadId) {
        case 0: // connectNotifySignal(QObject * dest, const char * slot) const
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return {};
            ::QObject *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            const char* cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // connectNotifySignal(QObject*,const char*)const
                bool cppResult = const_cast<const ::QQmlProperty *>(cppSelf)->connectNotifySignal(cppArg0, cppArg1);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            }
            break;
        }
        case 1: // connectNotifySignal(QObject * dest, int method) const
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return {};
            ::QObject *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            int cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // connectNotifySignal(QObject*,int)const
                bool cppResult = const_cast<const ::QQmlProperty *>(cppSelf)->connectNotifySignal(cppArg0, cppArg1);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlPropertyFunc_hasNotifySignal(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlProperty *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQml.QQmlProperty.hasNotifySignal";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // hasNotifySignal()const
            bool cppResult = const_cast<const ::QQmlProperty *>(cppSelf)->hasNotifySignal();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlPropertyFunc_index(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlProperty *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQml.QQmlProperty.index";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // index()const
            int cppResult = const_cast<const ::QQmlProperty *>(cppSelf)->index();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlPropertyFunc_isBindable(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlProperty *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQml.QQmlProperty.isBindable";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isBindable()const
            bool cppResult = const_cast<const ::QQmlProperty *>(cppSelf)->isBindable();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlPropertyFunc_isDesignable(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlProperty *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQml.QQmlProperty.isDesignable";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isDesignable()const
            bool cppResult = const_cast<const ::QQmlProperty *>(cppSelf)->isDesignable();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlPropertyFunc_isProperty(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlProperty *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQml.QQmlProperty.isProperty";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isProperty()const
            bool cppResult = const_cast<const ::QQmlProperty *>(cppSelf)->isProperty();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlPropertyFunc_isResettable(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlProperty *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQml.QQmlProperty.isResettable";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isResettable()const
            bool cppResult = const_cast<const ::QQmlProperty *>(cppSelf)->isResettable();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlPropertyFunc_isSignalProperty(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlProperty *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQml.QQmlProperty.isSignalProperty";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isSignalProperty()const
            bool cppResult = const_cast<const ::QQmlProperty *>(cppSelf)->isSignalProperty();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlPropertyFunc_isValid(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlProperty *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQml.QQmlProperty.isValid";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isValid()const
            bool cppResult = const_cast<const ::QQmlProperty *>(cppSelf)->isValid();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlPropertyFunc_isWritable(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlProperty *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQml.QQmlProperty.isWritable";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isWritable()const
            bool cppResult = const_cast<const ::QQmlProperty *>(cppSelf)->isWritable();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlPropertyFunc_method(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlProperty *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQml.QQmlProperty.method";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // method()const
            QMetaMethod cppResult = const_cast<const ::QQmlProperty *>(cppSelf)->method();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QMetaMethod_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlPropertyFunc_name(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlProperty *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQml.QQmlProperty.name";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // name()const
            QString cppResult = const_cast<const ::QQmlProperty *>(cppSelf)->name();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlPropertyFunc_needsNotifySignal(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlProperty *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQml.QQmlProperty.needsNotifySignal";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // needsNotifySignal()const
            bool cppResult = const_cast<const ::QQmlProperty *>(cppSelf)->needsNotifySignal();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlPropertyFunc_object(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlProperty *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQml.QQmlProperty.object";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // object()const
            QObject * cppResult = const_cast<const ::QQmlProperty *>(cppSelf)->object();
            pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QObject_IDX]), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlPropertyFunc_property(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlProperty *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQml.QQmlProperty.property";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // property()const
            QMetaProperty cppResult = const_cast<const ::QQmlProperty *>(cppSelf)->property();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QMetaProperty_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlPropertyFunc_propertyMetaType(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlProperty *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQml.QQmlProperty.propertyMetaType";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // propertyMetaType()const
            QMetaType cppResult = const_cast<const ::QQmlProperty *>(cppSelf)->propertyMetaType();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QMetaType_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlPropertyFunc_propertyType(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlProperty *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQml.QQmlProperty.propertyType";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // propertyType()const
            int cppResult = const_cast<const ::QQmlProperty *>(cppSelf)->propertyType();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlPropertyFunc_propertyTypeCategory(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlProperty *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQml.QQmlProperty.propertyTypeCategory";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // propertyTypeCategory()const
            QQmlProperty::PropertyTypeCategory cppResult = const_cast<const ::QQmlProperty *>(cppSelf)->propertyTypeCategory();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_PropertyTypeCategory_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlPropertyFunc_propertyTypeName(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlProperty *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQml.QQmlProperty.propertyTypeName";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // propertyTypeName()const
            const char * cppResult = const_cast<const ::QQmlProperty *>(cppSelf)->propertyTypeName();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<const char *>(), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlPropertyFunc_read(PyObject *self, PyObject *args)
{
    SBK_UNUSED(self)
    if (!Shiboken::Object::isValid(self))
        return {};
    ::QQmlProperty *cppSelf = nullptr;
    SBK_UNUSED(cppSelf)
    if (self)
        cppSelf = reinterpret_cast< ::QQmlProperty *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtQml.QQmlProperty.read";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[3];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr};

    // invalid argument lengths
    if (numArgs == 1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    if (PyArg_UnpackTuple(args, "read", 0, 3, &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QQmlProperty::read()const->QVariant
    // 1: static QQmlProperty::read(const QObject*,QString)->QVariant
    // 2: static QQmlProperty::read(const QObject*,QString,QQmlContext*)->QVariant
    // 3: static QQmlProperty::read(const QObject*,QString,QQmlEngine*)->QVariant
    if (numArgs == 0) {
        overloadId = 0; // read()const
    } else if (numArgs >= 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QObject_IDX]), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[1])))) {
        if (numArgs == 2) {
            overloadId = 1; // read(const QObject*,QString)
        } else if (numArgs == 3
            && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlEngine_IDX]), (pyArgs[2])))) {
            overloadId = 3; // read(const QObject*,QString,QQmlEngine*)
        } else if (numArgs == 3
            && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlContext_IDX]), (pyArgs[2])))) {
            overloadId = 2; // read(const QObject*,QString,QQmlContext*)
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    switch (overloadId) {
        case 0: // read() const
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // read()const
                QVariant cppResult = const_cast<const ::QQmlProperty *>(cppSelf)->read();
                pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QVariant_IDX], &cppResult);
            }
            break;
        }
        case 1: // read(const QObject * arg__1, const QString & arg__2)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return {};
            ::QObject *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            ::QString cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // read(const QObject*,QString)
                QVariant cppResult = ::QQmlProperty::read(cppArg0, cppArg1);
                pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QVariant_IDX], &cppResult);
            }
            break;
        }
        case 2: // read(const QObject * arg__1, const QString & arg__2, QQmlContext * arg__3)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return {};
            ::QObject *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            ::QString cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);
            if (!Shiboken::Object::isValid(pyArgs[2]))
                return {};
            ::QQmlContext *cppArg2;
            pythonToCpp[2](pyArgs[2], &cppArg2);

            if (Shiboken::Errors::occurred() == nullptr) {
                // read(const QObject*,QString,QQmlContext*)
                QVariant cppResult = ::QQmlProperty::read(cppArg0, cppArg1, cppArg2);
                pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QVariant_IDX], &cppResult);
            }
            break;
        }
        case 3: // read(const QObject * arg__1, const QString & arg__2, QQmlEngine * arg__3)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return {};
            ::QObject *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            ::QString cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);
            if (!Shiboken::Object::isValid(pyArgs[2]))
                return {};
            ::QQmlEngine *cppArg2;
            pythonToCpp[2](pyArgs[2], &cppArg2);

            if (Shiboken::Errors::occurred() == nullptr) {
                // read(const QObject*,QString,QQmlEngine*)
                QVariant cppResult = ::QQmlProperty::read(cppArg0, cppArg1, cppArg2);
                pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QVariant_IDX], &cppResult);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlPropertyFunc_reset(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlProperty *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQml.QQmlProperty.reset";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // reset()const
            bool cppResult = const_cast<const ::QQmlProperty *>(cppSelf)->reset();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlPropertyFunc_swap(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlProperty *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtQml.QQmlProperty.swap";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QQmlProperty::swap(QQmlProperty&)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_IDX]), (pyArg)))) {
        overloadId = 0; // swap(QQmlProperty&)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QQmlProperty cppArg0_local;
        ::QQmlProperty *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // swap(QQmlProperty&)
            cppSelf->swap(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QQmlPropertyFunc_type(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlProperty *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQml.QQmlProperty.type";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // type()const
            QQmlProperty::Type cppResult = const_cast<const ::QQmlProperty *>(cppSelf)->type();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_Type_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlPropertyFunc_write(PyObject *self, PyObject *args)
{
    SBK_UNUSED(self)
    if (!Shiboken::Object::isValid(self))
        return {};
    ::QQmlProperty *cppSelf = nullptr;
    SBK_UNUSED(cppSelf)
    if (self)
        cppSelf = reinterpret_cast< ::QQmlProperty *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtQml.QQmlProperty.write";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[4];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr, nullptr};

    // invalid argument lengths
    if (numArgs == 2)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    if (PyArg_UnpackTuple(args, "write", 1, 4, &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2]), &(pyArgs[3])) == 0)
        return {};


    // Overloaded function decisor
    // 0: static QQmlProperty::write(QObject*,QString,QVariant)->bool
    // 1: static QQmlProperty::write(QObject*,QString,QVariant,QQmlContext*)->bool
    // 2: static QQmlProperty::write(QObject*,QString,QVariant,QQmlEngine*)->bool
    // 3: QQmlProperty::write(QVariant)const->bool
    if (numArgs >= 3
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QObject_IDX]), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[1])))
        && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QVariant_IDX], (pyArgs[2])))) {
        if (numArgs == 3) {
            overloadId = 0; // write(QObject*,QString,QVariant)
        } else if (numArgs == 4
            && (pythonToCpp[3] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlEngine_IDX]), (pyArgs[3])))) {
            overloadId = 2; // write(QObject*,QString,QVariant,QQmlEngine*)
        } else if (numArgs == 4
            && (pythonToCpp[3] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlContext_IDX]), (pyArgs[3])))) {
            overloadId = 1; // write(QObject*,QString,QVariant,QQmlContext*)
        }
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QVariant_IDX], (pyArgs[0])))) {
        overloadId = 3; // write(QVariant)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    switch (overloadId) {
        case 0: // write(QObject * arg__1, const QString & arg__2, const QVariant & arg__3)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return {};
            ::QObject *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            ::QString cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);
            ::QVariant cppArg2;
            pythonToCpp[2](pyArgs[2], &cppArg2);

            if (Shiboken::Errors::occurred() == nullptr) {
                // write(QObject*,QString,QVariant)
                bool cppResult = ::QQmlProperty::write(cppArg0, cppArg1, cppArg2);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            }
            break;
        }
        case 1: // write(QObject * arg__1, const QString & arg__2, const QVariant & arg__3, QQmlContext * arg__4)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return {};
            ::QObject *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            ::QString cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);
            ::QVariant cppArg2;
            pythonToCpp[2](pyArgs[2], &cppArg2);
            if (!Shiboken::Object::isValid(pyArgs[3]))
                return {};
            ::QQmlContext *cppArg3;
            pythonToCpp[3](pyArgs[3], &cppArg3);

            if (Shiboken::Errors::occurred() == nullptr) {
                // write(QObject*,QString,QVariant,QQmlContext*)
                bool cppResult = ::QQmlProperty::write(cppArg0, cppArg1, cppArg2, cppArg3);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            }
            break;
        }
        case 2: // write(QObject * arg__1, const QString & arg__2, const QVariant & arg__3, QQmlEngine * arg__4)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return {};
            ::QObject *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            ::QString cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);
            ::QVariant cppArg2;
            pythonToCpp[2](pyArgs[2], &cppArg2);
            if (!Shiboken::Object::isValid(pyArgs[3]))
                return {};
            ::QQmlEngine *cppArg3;
            pythonToCpp[3](pyArgs[3], &cppArg3);

            if (Shiboken::Errors::occurred() == nullptr) {
                // write(QObject*,QString,QVariant,QQmlEngine*)
                bool cppResult = ::QQmlProperty::write(cppArg0, cppArg1, cppArg2, cppArg3);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            }
            break;
        }
        case 3: // write(const QVariant & arg__1) const
        {
            ::QVariant cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // write(QVariant)const
                bool cppResult = const_cast<const ::QQmlProperty *>(cppSelf)->write(cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlProperty__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QQmlProperty *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyMethodDef Sbk_QQmlPropertyMethod_read = {"read", reinterpret_cast<PyCFunction>(Sbk_QQmlPropertyFunc_read), METH_VARARGS|METH_STATIC, nullptr};

static PyMethodDef Sbk_QQmlPropertyMethod_write = {"write", reinterpret_cast<PyCFunction>(Sbk_QQmlPropertyFunc_write), METH_VARARGS|METH_STATIC, nullptr};


static const char *Sbk_QQmlProperty_PropertyStrings[] = {
    "name:",
    "object:",
    nullptr // Sentinel
};

static const char *Sbk_QQmlProperty_EnumFlagInfo[] = {
    "PropertyTypeCategory:Enum",
    "QmlIsAnonymous:IntEnum",
    "Type:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QQmlProperty_methods[] = {
    {"connectNotifySignal", reinterpret_cast<PyCFunction>(Sbk_QQmlPropertyFunc_connectNotifySignal), METH_VARARGS, nullptr},
    {"hasNotifySignal", reinterpret_cast<PyCFunction>(Sbk_QQmlPropertyFunc_hasNotifySignal), METH_NOARGS, nullptr},
    {"index", reinterpret_cast<PyCFunction>(Sbk_QQmlPropertyFunc_index), METH_NOARGS, nullptr},
    {"isBindable", reinterpret_cast<PyCFunction>(Sbk_QQmlPropertyFunc_isBindable), METH_NOARGS, nullptr},
    {"isDesignable", reinterpret_cast<PyCFunction>(Sbk_QQmlPropertyFunc_isDesignable), METH_NOARGS, nullptr},
    {"isProperty", reinterpret_cast<PyCFunction>(Sbk_QQmlPropertyFunc_isProperty), METH_NOARGS, nullptr},
    {"isResettable", reinterpret_cast<PyCFunction>(Sbk_QQmlPropertyFunc_isResettable), METH_NOARGS, nullptr},
    {"isSignalProperty", reinterpret_cast<PyCFunction>(Sbk_QQmlPropertyFunc_isSignalProperty), METH_NOARGS, nullptr},
    {"isValid", reinterpret_cast<PyCFunction>(Sbk_QQmlPropertyFunc_isValid), METH_NOARGS, nullptr},
    {"isWritable", reinterpret_cast<PyCFunction>(Sbk_QQmlPropertyFunc_isWritable), METH_NOARGS, nullptr},
    {"method", reinterpret_cast<PyCFunction>(Sbk_QQmlPropertyFunc_method), METH_NOARGS, nullptr},
    {"name", reinterpret_cast<PyCFunction>(Sbk_QQmlPropertyFunc_name), METH_NOARGS, nullptr},
    {"needsNotifySignal", reinterpret_cast<PyCFunction>(Sbk_QQmlPropertyFunc_needsNotifySignal), METH_NOARGS, nullptr},
    {"object", reinterpret_cast<PyCFunction>(Sbk_QQmlPropertyFunc_object), METH_NOARGS, nullptr},
    {"property", reinterpret_cast<PyCFunction>(Sbk_QQmlPropertyFunc_property), METH_NOARGS, nullptr},
    {"propertyMetaType", reinterpret_cast<PyCFunction>(Sbk_QQmlPropertyFunc_propertyMetaType), METH_NOARGS, nullptr},
    {"propertyType", reinterpret_cast<PyCFunction>(Sbk_QQmlPropertyFunc_propertyType), METH_NOARGS, nullptr},
    {"propertyTypeCategory", reinterpret_cast<PyCFunction>(Sbk_QQmlPropertyFunc_propertyTypeCategory), METH_NOARGS, nullptr},
    {"propertyTypeName", reinterpret_cast<PyCFunction>(Sbk_QQmlPropertyFunc_propertyTypeName), METH_NOARGS, nullptr},
    {"read", reinterpret_cast<PyCFunction>(Sbk_QQmlPropertyFunc_read), METH_VARARGS|METH_STATIC, nullptr},
    {"reset", reinterpret_cast<PyCFunction>(Sbk_QQmlPropertyFunc_reset), METH_NOARGS, nullptr},
    {"swap", reinterpret_cast<PyCFunction>(Sbk_QQmlPropertyFunc_swap), METH_O, nullptr},
    {"type", reinterpret_cast<PyCFunction>(Sbk_QQmlPropertyFunc_type), METH_NOARGS, nullptr},
    {"write", reinterpret_cast<PyCFunction>(Sbk_QQmlPropertyFunc_write), METH_VARARGS|METH_STATIC, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QQmlProperty__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QQmlProperty_getattro(PyObject *self, PyObject *name)
{
    PySide::Feature::Select(self);
    // Search the method in the instance dict
    auto *ob_dict = SbkObject_GetDict_NoRef(self);
    if (auto *meth = PyDict_GetItem(ob_dict, name)) {
        Py_INCREF(meth);
        return meth;
    }
    // Search the method in the type dict
    if (Shiboken::Object::isUserType(self)) {
        Shiboken::AutoDecRef tmp(_Pep_PrivateMangle(self, name));
        Shiboken::AutoDecRef tpDict(PepType_GetDict(Py_TYPE(self)));
        if (auto *meth = PyDict_GetItem(tpDict.object(), tmp)) {
            if (std::strcmp(Py_TYPE(meth)->tp_name, "compiled_function") == 0) {
                auto descrGetFunc = reinterpret_cast<descrgetfunc>(PepType_GetSlot(Py_TYPE(meth), Py_tp_descr_get));
                ;
                return descrGetFunc(meth, self, nullptr);
            }
            return PyFunction_Check(meth) ? PyMethod_New(meth, self)
                                          : PyObject_GenericGetAttr(self, name);
        }
    }
    static PyMethodDef non_static_Sbk_QQmlPropertyMethod_read = {
        Sbk_QQmlPropertyMethod_read.ml_name,
        Sbk_QQmlPropertyMethod_read.ml_meth,
        Sbk_QQmlPropertyMethod_read.ml_flags & (~METH_STATIC),
        Sbk_QQmlPropertyMethod_read.ml_doc,
    };
    if (Shiboken::String::compare(name, "read") == 0)
        return PyCFunction_NewEx(&non_static_Sbk_QQmlPropertyMethod_read, self, 0);
    static PyMethodDef non_static_Sbk_QQmlPropertyMethod_write = {
        Sbk_QQmlPropertyMethod_write.ml_name,
        Sbk_QQmlPropertyMethod_write.ml_meth,
        Sbk_QQmlPropertyMethod_write.ml_flags & (~METH_STATIC),
        Sbk_QQmlPropertyMethod_write.ml_doc,
    };
    if (Shiboken::String::compare(name, "write") == 0)
        return PyCFunction_NewEx(&non_static_Sbk_QQmlPropertyMethod_write, self, 0);
    return PyObject_GenericGetAttr(self, name);
}

// Rich comparison
static PyObject * Sbk_QQmlProperty_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QQmlProperty *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_IDX]), (pyArg)))) {
                // operator==(const QQmlProperty & arg__1) const
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QQmlProperty cppArg0_local;
                ::QQmlProperty *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static Py_hash_t Sbk_QQmlProperty_HashFunc(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlProperty *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    return Py_hash_t(qHash(*cppSelf));
}

static int Sbk_QQmlProperty_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QQmlProperty_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QQmlProperty_Type = nullptr;
static PyTypeObject *Sbk_QQmlProperty_TypeF(void)
{
    return _Sbk_QQmlProperty_Type;
}

static PyType_Slot Sbk_QQmlProperty_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_hash,        reinterpret_cast<void *>(&Sbk_QQmlProperty_HashFunc)},
    {Py_tp_getattro,    reinterpret_cast<void *>(Sbk_QQmlProperty_getattro)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QQmlProperty_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QQmlProperty_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QQmlProperty_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QQmlProperty_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QQmlProperty_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QQmlProperty_spec = {
    "2:PySide6.QtQml.QQmlProperty",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QQmlProperty_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void QQmlProperty_PropertyTypeCategory_PythonToCpp_QQmlProperty_PropertyTypeCategory(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QQmlProperty::PropertyTypeCategory>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QQmlProperty::PropertyTypeCategory *>(cppOut) = value;

}
static PythonToCppFunc is_QQmlProperty_PropertyTypeCategory_PythonToCpp_QQmlProperty_PropertyTypeCategory_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_PropertyTypeCategory_IDX])))
        return QQmlProperty_PropertyTypeCategory_PythonToCpp_QQmlProperty_PropertyTypeCategory;
    return {};
}
static PyObject *QQmlProperty_PropertyTypeCategory_CppToPython_QQmlProperty_PropertyTypeCategory(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QQmlProperty::PropertyTypeCategory *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_PropertyTypeCategory_IDX]), castCppIn);

}

static void QQmlProperty_Type_PythonToCpp_QQmlProperty_Type(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QQmlProperty::Type>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QQmlProperty::Type *>(cppOut) = value;

}
static PythonToCppFunc is_QQmlProperty_Type_PythonToCpp_QQmlProperty_Type_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_Type_IDX])))
        return QQmlProperty_Type_PythonToCpp_QQmlProperty_Type;
    return {};
}
static PyObject *QQmlProperty_Type_CppToPython_QQmlProperty_Type(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QQmlProperty::Type *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_Type_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QQmlProperty_PythonToCpp_QQmlProperty_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QQmlProperty_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QQmlProperty_PythonToCpp_QQmlProperty_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QQmlProperty_TypeF()))
        return QQmlProperty_PythonToCpp_QQmlProperty_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QQmlProperty_PTR_CppToPython_QQmlProperty(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QQmlProperty *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QQmlProperty_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *QQmlProperty_COPY_CppToPython_QQmlProperty(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QQmlProperty *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QQmlProperty_TypeF(), new ::QQmlProperty(*source), true, true);
}

// Python to C++ copy conversion.
static void QQmlProperty_PythonToCpp_QQmlProperty_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QQmlProperty *>(cppOut) = *reinterpret_cast< ::QQmlProperty *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QQmlProperty_PythonToCpp_QQmlProperty_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QQmlProperty_TypeF()))
        return QQmlProperty_PythonToCpp_QQmlProperty_COPY;
    return {};
}

// Implicit conversions.
static void PySide6_QtCore_QObjectPTR_PythonToCpp_QQmlProperty(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QQmlProperty *>(cppOut) = ::QQmlProperty(reinterpret_cast< ::QObject *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QObject_IDX]), reinterpret_cast<SbkObject *>(pyIn))));
}
static PythonToCppFunc is_PySide6_QtCore_QObjectPTR_PythonToCpp_QQmlProperty_Convertible(PyObject *pyIn)
{
    if (SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QObject_IDX]), pyIn))
        return PySide6_QtCore_QObjectPTR_PythonToCpp_QQmlProperty;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QQmlProperty_SignatureStrings[] = {
    "7:PySide6.QtQml.QQmlProperty(self)",
    "6:PySide6.QtQml.QQmlProperty(self,arg__1:PySide6.QtCore.QObject)",
    "5:PySide6.QtQml.QQmlProperty(self,arg__1:PySide6.QtCore.QObject,arg__2:PySide6.QtQml.QQmlContext)",
    "4:PySide6.QtQml.QQmlProperty(self,arg__1:PySide6.QtCore.QObject,arg__2:PySide6.QtQml.QQmlEngine)",
    "3:PySide6.QtQml.QQmlProperty(self,arg__1:PySide6.QtCore.QObject,arg__2:QString)",
    "2:PySide6.QtQml.QQmlProperty(self,arg__1:PySide6.QtCore.QObject,arg__2:QString,arg__3:PySide6.QtQml.QQmlContext)",
    "1:PySide6.QtQml.QQmlProperty(self,arg__1:PySide6.QtCore.QObject,arg__2:QString,arg__3:PySide6.QtQml.QQmlEngine)",
    "0:PySide6.QtQml.QQmlProperty(self,arg__1:typing.Union[PySide6.QtQml.QQmlProperty, PySide6.QtCore.QObject])",
    "1:PySide6.QtQml.QQmlProperty.connectNotifySignal(self,dest:PySide6.QtCore.QObject,slot:char*)->bool",
    "0:PySide6.QtQml.QQmlProperty.connectNotifySignal(self,dest:PySide6.QtCore.QObject,method:int)->bool",
    "PySide6.QtQml.QQmlProperty.hasNotifySignal(self)->bool",
    "PySide6.QtQml.QQmlProperty.index(self)->int",
    "PySide6.QtQml.QQmlProperty.isBindable(self)->bool",
    "PySide6.QtQml.QQmlProperty.isDesignable(self)->bool",
    "PySide6.QtQml.QQmlProperty.isProperty(self)->bool",
    "PySide6.QtQml.QQmlProperty.isResettable(self)->bool",
    "PySide6.QtQml.QQmlProperty.isSignalProperty(self)->bool",
    "PySide6.QtQml.QQmlProperty.isValid(self)->bool",
    "PySide6.QtQml.QQmlProperty.isWritable(self)->bool",
    "PySide6.QtQml.QQmlProperty.method(self)->PySide6.QtCore.QMetaMethod",
    "PySide6.QtQml.QQmlProperty.name(self)->QString",
    "PySide6.QtQml.QQmlProperty.needsNotifySignal(self)->bool",
    "PySide6.QtQml.QQmlProperty.object(self)->PySide6.QtCore.QObject",
    "PySide6.QtQml.QQmlProperty.property(self)->PySide6.QtCore.QMetaProperty",
    "PySide6.QtQml.QQmlProperty.propertyMetaType(self)->PySide6.QtCore.QMetaType",
    "PySide6.QtQml.QQmlProperty.propertyType(self)->int",
    "PySide6.QtQml.QQmlProperty.propertyTypeCategory(self)->PySide6.QtQml.QQmlProperty.PropertyTypeCategory",
    "PySide6.QtQml.QQmlProperty.propertyTypeName(self)->char*",
    "3:PySide6.QtQml.QQmlProperty.read(self)->QVariant",
    "2:PySide6.QtQml.QQmlProperty.read(arg__1:PySide6.QtCore.QObject,arg__2:QString)->QVariant",
    "1:PySide6.QtQml.QQmlProperty.read(arg__1:PySide6.QtCore.QObject,arg__2:QString,arg__3:PySide6.QtQml.QQmlContext)->QVariant",
    "0:PySide6.QtQml.QQmlProperty.read(arg__1:PySide6.QtCore.QObject,arg__2:QString,arg__3:PySide6.QtQml.QQmlEngine)->QVariant",
    "PySide6.QtQml.QQmlProperty.reset(self)->bool",
    "PySide6.QtQml.QQmlProperty.swap(self,other:typing.Union[PySide6.QtQml.QQmlProperty, PySide6.QtCore.QObject])",
    "PySide6.QtQml.QQmlProperty.type(self)->PySide6.QtQml.QQmlProperty.Type",
    "3:PySide6.QtQml.QQmlProperty.write(arg__1:PySide6.QtCore.QObject,arg__2:QString,arg__3:QVariant)->bool",
    "2:PySide6.QtQml.QQmlProperty.write(arg__1:PySide6.QtCore.QObject,arg__2:QString,arg__3:QVariant,arg__4:PySide6.QtQml.QQmlContext)->bool",
    "1:PySide6.QtQml.QQmlProperty.write(arg__1:PySide6.QtCore.QObject,arg__2:QString,arg__3:QVariant,arg__4:PySide6.QtQml.QQmlEngine)->bool",
    "0:PySide6.QtQml.QQmlProperty.write(self,arg__1:QVariant)->bool",
    "PySide6.QtQml.QQmlProperty.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QQmlProperty(PyObject *module)
{
    _Sbk_QQmlProperty_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QQmlProperty",
        "QQmlProperty",
        &Sbk_QQmlProperty_spec,
        &Shiboken::callCppDestructor< ::QQmlProperty >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QQmlProperty_TypeF(); // references _Sbk_QQmlProperty_Type
    InitSignatureStrings(pyType, QQmlProperty_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QQmlProperty_PropertyStrings);
    SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QQmlProperty_PythonToCpp_QQmlProperty_PTR,
        is_QQmlProperty_PythonToCpp_QQmlProperty_PTR_Convertible,
        QQmlProperty_PTR_CppToPython_QQmlProperty,
        QQmlProperty_COPY_CppToPython_QQmlProperty);

    Shiboken::Conversions::registerConverterName(converter, "QQmlProperty");
    Shiboken::Conversions::registerConverterName(converter, "QQmlProperty*");
    Shiboken::Conversions::registerConverterName(converter, "QQmlProperty&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QQmlProperty).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QQmlProperty_PythonToCpp_QQmlProperty_COPY,
        is_QQmlProperty_PythonToCpp_QQmlProperty_COPY_Convertible);
    // Add implicit conversions to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        PySide6_QtCore_QObjectPTR_PythonToCpp_QQmlProperty,
        is_PySide6_QtCore_QObjectPTR_PythonToCpp_QQmlProperty_Convertible);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QQmlProperty_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'PropertyTypeCategory'.
    const char *PropertyTypeCategory_Initializer[] = {
        "InvalidCategory",
        "List",
        "Object",
        "Normal",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t PropertyTypeCategory_InitializerValues[] = {
        uint8_t(QQmlProperty::PropertyTypeCategory::InvalidCategory), //  0x00  0
        uint8_t(QQmlProperty::PropertyTypeCategory::List),            //  0x01  1
        uint8_t(QQmlProperty::PropertyTypeCategory::Object),          //  0x02  2
        uint8_t(QQmlProperty::PropertyTypeCategory::Normal)           //  0x03  3
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QQmlProperty_TypeF(),
        "2:PySide6.QtQml.QQmlProperty.PropertyTypeCategory",
        PropertyTypeCategory_Initializer, PropertyTypeCategory_InitializerValues);
    SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_PropertyTypeCategory_IDX].type = EType;
    // Register converter for enum 'QQmlProperty::PropertyTypeCategory'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QQmlProperty_PropertyTypeCategory_CppToPython_QQmlProperty_PropertyTypeCategory);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QQmlProperty_PropertyTypeCategory_PythonToCpp_QQmlProperty_PropertyTypeCategory,
            is_QQmlProperty_PropertyTypeCategory_PythonToCpp_QQmlProperty_PropertyTypeCategory_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QQmlProperty::PropertyTypeCategory");
        Shiboken::Conversions::registerConverterName(converter, "PropertyTypeCategory");
    }
    // End of 'PropertyTypeCategory' enum.

    // Initialization of enum 'Type'.
    const char *Type_Initializer[] = {
        "Invalid",
        "Property",
        "SignalProperty",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t Type_InitializerValues[] = {
        uint8_t(QQmlProperty::Type::Invalid),       //  0x00  0
        uint8_t(QQmlProperty::Type::Property),      //  0x01  1
        uint8_t(QQmlProperty::Type::SignalProperty) //  0x02  2
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QQmlProperty_TypeF(),
        "2:PySide6.QtQml.QQmlProperty.Type",
        Type_Initializer, Type_InitializerValues);
    SbkPySide6_QtQmlTypeStructs[SBK_QQmlProperty_Type_IDX].type = EType;
    // Register converter for enum 'QQmlProperty::Type'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QQmlProperty_Type_CppToPython_QQmlProperty_Type);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QQmlProperty_Type_PythonToCpp_QQmlProperty_Type,
            is_QQmlProperty_Type_PythonToCpp_QQmlProperty_Type_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QQmlProperty::Type");
        Shiboken::Conversions::registerConverterName(converter, "Type");
    }
    // End of 'Type' enum.

    qRegisterMetaType< ::QQmlProperty >("QQmlProperty");
    qRegisterMetaType< ::QQmlProperty::PropertyTypeCategory >("QQmlProperty::PropertyTypeCategory");
    qRegisterMetaType< ::QQmlProperty::Type >("QQmlProperty::Type");

    return pyType;
}
