// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QQuickRhiItemRendererWrapper_H
#define SBK_QQuickRhiItemRendererWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qquickrhiitem.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QQuickRhiItemRendererWrapper : public QQuickRhiItemRenderer
{
public:
    QQuickRhiItemRendererWrapper(const QQuickRhiItemRendererWrapper &) = delete;
    QQuickRhiItemRendererWrapper& operator=(const QQuickRhiItemRendererWrapper &) = delete;
    QQuickRhiItemRendererWrapper(QQuickRhiItemRendererWrapper &&) = delete;
    QQuickRhiItemRendererWrapper& operator=(QQuickRhiItemRendererWrapper &&) = delete;

    QQuickRhiItemRendererWrapper();
    void initialize(::QRhiCommandBuffer * cb) override;
    void render(::QRhiCommandBuffer * cb) override;
    void synchronize(::QQuickRhiItem * item) override;
    ~QQuickRhiItemRendererWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[3];
};

#endif // SBK_QQuickRhiItemRendererWrapper_H

