// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSGFlatColorMaterialWrapper_H
#define SBK_QSGFlatColorMaterialWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qsgflatcolormaterial.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QSGFlatColorMaterialWrapper : public QSGFlatColorMaterial
{
public:
    QSGFlatColorMaterialWrapper(const QSGFlatColorMaterialWrapper &) = delete;
    QSGFlatColorMaterialWrapper& operator=(const QSGFlatColorMaterialWrapper &) = delete;
    QSGFlatColorMaterialWrapper(QSGFlatColorMaterialWrapper &&) = delete;
    QSGFlatColorMaterialWrapper& operator=(QSGFlatColorMaterialWrapper &&) = delete;

    QSGFlatColorMaterialWrapper();
    int compare(const ::QSGMaterial * other) const override;
    ::QSGMaterialShader * createShader(::QSGRendererInterface::RenderMode renderMode) const override;
    ::QSGMaterialType * type() const override;
    ~QSGFlatColorMaterialWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[3];
};

#endif // SBK_QSGFlatColorMaterialWrapper_H

