// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtquick_python.h"

// main header
#include "qsgmaterialtype_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QSGMaterialType_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(args)
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QSGMaterialType >()))
        return -1;

    ::QSGMaterialType *cptr{};
    static const char fullName[] = "PySide6.QtQuick.QSGMaterialType.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // QSGMaterialType()
            cptr = new ::QSGMaterialType();
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QSGMaterialType >(), cptr)) {
        delete cptr;
        return -1;
    }
    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}


static const char *Sbk_QSGMaterialType_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QSGMaterialType_methods[] = {
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QSGMaterialType_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QSGMaterialType_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QSGMaterialType_Type = nullptr;
static PyTypeObject *Sbk_QSGMaterialType_TypeF(void)
{
    return _Sbk_QSGMaterialType_Type;
}

static PyType_Slot Sbk_QSGMaterialType_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QSGMaterialType_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QSGMaterialType_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QSGMaterialType_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QSGMaterialType_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QSGMaterialType_spec = {
    "2:PySide6.QtQuick.QSGMaterialType",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QSGMaterialType_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QSGMaterialType_PythonToCpp_QSGMaterialType_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QSGMaterialType_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QSGMaterialType_PythonToCpp_QSGMaterialType_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QSGMaterialType_TypeF()))
        return QSGMaterialType_PythonToCpp_QSGMaterialType_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QSGMaterialType_PTR_CppToPython_QSGMaterialType(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QSGMaterialType *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QSGMaterialType_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QSGMaterialType_SignatureStrings[] = {
    "PySide6.QtQuick.QSGMaterialType(self)",
    nullptr}; // Sentinel

PyTypeObject *init_QSGMaterialType(PyObject *module)
{
    _Sbk_QSGMaterialType_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QSGMaterialType",
        "QSGMaterialType*",
        &Sbk_QSGMaterialType_spec,
        &Shiboken::callCppDestructor< ::QSGMaterialType >,
        nullptr,
        0,
        0);
    auto *pyType = Sbk_QSGMaterialType_TypeF(); // references _Sbk_QSGMaterialType_Type
    InitSignatureStrings(pyType, QSGMaterialType_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QSGMaterialType_PropertyStrings);
    SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialType_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QSGMaterialType_PythonToCpp_QSGMaterialType_PTR,
        is_QSGMaterialType_PythonToCpp_QSGMaterialType_PTR_Convertible,
        QSGMaterialType_PTR_CppToPython_QSGMaterialType);

    Shiboken::Conversions::registerConverterName(converter, "QSGMaterialType");
    Shiboken::Conversions::registerConverterName(converter, "QSGMaterialType*");
    Shiboken::Conversions::registerConverterName(converter, "QSGMaterialType&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QSGMaterialType).name());

    qRegisterMetaType< ::QSGMaterialType *>();

    return pyType;
}
