// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSGTextureWrapper_H
#define SBK_QSGTextureWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qsgtexture.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QSGTextureWrapper : public QSGTexture
{
public:
    QSGTextureWrapper(const QSGTextureWrapper &) = delete;
    QSGTextureWrapper& operator=(const QSGTextureWrapper &) = delete;
    QSGTextureWrapper(QSGTextureWrapper &&) = delete;
    QSGTextureWrapper& operator=(QSGTextureWrapper &&) = delete;

    QSGTextureWrapper();
    void childEvent(::QChildEvent * event) override;
    void commitTextureOperations(::QRhi * rhi, ::QRhiResourceUpdateBatch * resourceUpdates) override;
    qint64 comparisonKey() const override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    bool hasAlphaChannel() const override;
    bool hasMipmaps() const override;
    bool isAtlasTexture() const override;
    ::QRectF normalizedTextureSubRect() const override;
    ::QSGTexture * removedFromAtlas(::QRhiResourceUpdateBatch * resourceUpdates = nullptr) const override;
    ::QRhiTexture * rhiTexture() const override;
    ::QSize textureSize() const override;
    void timerEvent(::QTimerEvent * event) override;
    ~QSGTextureWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[16];
};

#endif // SBK_QSGTextureWrapper_H

