// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtquick3d_python.h"

// main header
#include "qquick3dgeometry_targetattribute_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QQuick3DGeometry_TargetAttribute_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QQuick3DGeometry::TargetAttribute >()))
        return -1;

    ::QQuick3DGeometry::TargetAttribute *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtQuick3D.QQuick3DGeometry.TargetAttribute.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "TargetAttribute", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: TargetAttribute::TargetAttribute()
    // 1: TargetAttribute::TargetAttribute(QQuick3DGeometry::TargetAttribute)
    if (numArgs == 0) {
        overloadId = 0; // TargetAttribute()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtQuick3DTypeStructs[SBK_QQuick3DGeometry_TargetAttribute_IDX]), (pyArgs[0])))) {
        overloadId = 1; // TargetAttribute(QQuick3DGeometry::TargetAttribute)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // TargetAttribute()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // TargetAttribute()
                cptr = new ::QQuick3DGeometry::TargetAttribute();
            }
            break;
        }
        case 1: // TargetAttribute(const QQuick3DGeometry::TargetAttribute & TargetAttribute)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QQuick3DGeometry::TargetAttribute cppArg0_local;
            ::QQuick3DGeometry::TargetAttribute *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // TargetAttribute(QQuick3DGeometry::TargetAttribute)
                cptr = new ::QQuick3DGeometry::TargetAttribute(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QQuick3DGeometry::TargetAttribute >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QQuick3DGeometry_TargetAttribute__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QQuick3DGeometry::TargetAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuick3DTypeStructs[SBK_QQuick3DGeometry_TargetAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtQuick3DTypeStructs[SBK_QQuick3DGeometry_TargetAttribute_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QQuick3DGeometry_TargetAttribute_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QQuick3DGeometry_TargetAttribute_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QQuick3DGeometry_TargetAttribute__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QQuick3DGeometry_TargetAttribute_get_targetId(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQuick3DGeometry::TargetAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuick3DTypeStructs[SBK_QQuick3DGeometry_TargetAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    quint32 cppOut_local = cppSelf->targetId;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QQuick3DGeometry_TargetAttribute_set_targetId(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QQuick3DGeometry::TargetAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuick3DTypeStructs[SBK_QQuick3DGeometry_TargetAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("targetId");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("targetId", "quint32");
        return -1;
    }

    auto cppOut_local = cppSelf->targetId;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->targetId = cppOut_local;

    return 0;
}

static PyObject *Sbk_QQuick3DGeometry_TargetAttribute_get_attr(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQuick3DGeometry::TargetAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuick3DTypeStructs[SBK_QQuick3DGeometry_TargetAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->attr)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), Shiboken::Module::get(SbkPySide6_QtQuick3DTypeStructs[SBK_QQuick3DGeometry_Attribute_IDX])));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->attr))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->attr)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(Shiboken::Module::get(SbkPySide6_QtQuick3DTypeStructs[SBK_QQuick3DGeometry_Attribute_IDX]), &(cppSelf->attr), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_QQuick3DGeometry_TargetAttribute_set_attr(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QQuick3DGeometry::TargetAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuick3DTypeStructs[SBK_QQuick3DGeometry_TargetAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("attr");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtQuick3DTypeStructs[SBK_QQuick3DGeometry_Attribute_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("attr", "Attribute");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->attr;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QQuick3DGeometry_TargetAttribute_get_stride(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQuick3DGeometry::TargetAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuick3DTypeStructs[SBK_QQuick3DGeometry_TargetAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->stride;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QQuick3DGeometry_TargetAttribute_set_stride(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QQuick3DGeometry::TargetAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuick3DTypeStructs[SBK_QQuick3DGeometry_TargetAttribute_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("stride");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("stride", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->stride;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->stride = cppOut_local;

    return 0;
}

// Getters and Setters for TargetAttribute
static PyGetSetDef Sbk_QQuick3DGeometry_TargetAttribute_getsetlist[] = {
    {const_cast<char *>("targetId"), Sbk_QQuick3DGeometry_TargetAttribute_get_targetId, Sbk_QQuick3DGeometry_TargetAttribute_set_targetId, nullptr, nullptr},
    {const_cast<char *>("attr"), Sbk_QQuick3DGeometry_TargetAttribute_get_attr, Sbk_QQuick3DGeometry_TargetAttribute_set_attr, nullptr, nullptr},
    {const_cast<char *>("stride"), Sbk_QQuick3DGeometry_TargetAttribute_get_stride, Sbk_QQuick3DGeometry_TargetAttribute_set_stride, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QQuick3DGeometry_TargetAttribute_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QQuick3DGeometry_TargetAttribute_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QQuick3DGeometry_TargetAttribute_Type = nullptr;
static PyTypeObject *Sbk_QQuick3DGeometry_TargetAttribute_TypeF(void)
{
    return _Sbk_QQuick3DGeometry_TargetAttribute_Type;
}

static PyType_Slot Sbk_QQuick3DGeometry_TargetAttribute_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QQuick3DGeometry_TargetAttribute_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QQuick3DGeometry_TargetAttribute_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QQuick3DGeometry_TargetAttribute_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QQuick3DGeometry_TargetAttribute_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QQuick3DGeometry_TargetAttribute_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QQuick3DGeometry_TargetAttribute_spec = {
    "2:PySide6.QtQuick3D.QQuick3DGeometry.TargetAttribute",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QQuick3DGeometry_TargetAttribute_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void TargetAttribute_PythonToCpp_TargetAttribute_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QQuick3DGeometry_TargetAttribute_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_TargetAttribute_PythonToCpp_TargetAttribute_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QQuick3DGeometry_TargetAttribute_TypeF()))
        return TargetAttribute_PythonToCpp_TargetAttribute_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *TargetAttribute_PTR_CppToPython_TargetAttribute(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QQuick3DGeometry::TargetAttribute *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QQuick3DGeometry_TargetAttribute_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *TargetAttribute_COPY_CppToPython_TargetAttribute(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QQuick3DGeometry::TargetAttribute *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QQuick3DGeometry_TargetAttribute_TypeF(), new ::QQuick3DGeometry::TargetAttribute(*source), true, true);
}

// Python to C++ copy conversion.
static void TargetAttribute_PythonToCpp_TargetAttribute_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QQuick3DGeometry::TargetAttribute *>(cppOut) = *reinterpret_cast< ::QQuick3DGeometry::TargetAttribute *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuick3DTypeStructs[SBK_QQuick3DGeometry_TargetAttribute_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_TargetAttribute_PythonToCpp_TargetAttribute_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QQuick3DGeometry_TargetAttribute_TypeF()))
        return TargetAttribute_PythonToCpp_TargetAttribute_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QQuick3DGeometry_TargetAttribute_SignatureStrings[] = {
    "1:PySide6.QtQuick3D.QQuick3DGeometry.TargetAttribute(self)",
    "0:PySide6.QtQuick3D.QQuick3DGeometry.TargetAttribute(self,TargetAttribute:PySide6.QtQuick3D.QQuick3DGeometry.TargetAttribute)",
    "PySide6.QtQuick3D.QQuick3DGeometry.TargetAttribute.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QQuick3DGeometry_TargetAttribute(PyObject *enclosingClass)
{
    _Sbk_QQuick3DGeometry_TargetAttribute_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "TargetAttribute",
        "QQuick3DGeometry::TargetAttribute",
        &Sbk_QQuick3DGeometry_TargetAttribute_spec,
        &Shiboken::callCppDestructor< ::QQuick3DGeometry::TargetAttribute >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QQuick3DGeometry_TargetAttribute_TypeF(); // references _Sbk_QQuick3DGeometry_TargetAttribute_Type
    InitSignatureStrings(pyType, QQuick3DGeometry_TargetAttribute_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QQuick3DGeometry_TargetAttribute_PropertyStrings);
    SbkPySide6_QtQuick3DTypeStructs[SBK_QQuick3DGeometry_TargetAttribute_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        TargetAttribute_PythonToCpp_TargetAttribute_PTR,
        is_TargetAttribute_PythonToCpp_TargetAttribute_PTR_Convertible,
        TargetAttribute_PTR_CppToPython_TargetAttribute,
        TargetAttribute_COPY_CppToPython_TargetAttribute);

    Shiboken::Conversions::registerConverterName(converter, "QQuick3DGeometry::TargetAttribute");
    Shiboken::Conversions::registerConverterName(converter, "QQuick3DGeometry::TargetAttribute*");
    Shiboken::Conversions::registerConverterName(converter, "QQuick3DGeometry::TargetAttribute&");
    Shiboken::Conversions::registerConverterName(converter, "TargetAttribute");
    Shiboken::Conversions::registerConverterName(converter, "TargetAttribute*");
    Shiboken::Conversions::registerConverterName(converter, "TargetAttribute&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QQuick3DGeometry::TargetAttribute).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        TargetAttribute_PythonToCpp_TargetAttribute_COPY,
        is_TargetAttribute_PythonToCpp_TargetAttribute_COPY_Convertible);

    qRegisterMetaType< ::QQuick3DGeometry::TargetAttribute >("TargetAttribute");
    qRegisterMetaType< ::QQuick3DGeometry::TargetAttribute >("QQuick3DGeometry::TargetAttribute");

    return pyType;
}
