// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtscxml_python.h"

// main header
#include "qscxmlexecutablecontent_evaluatorinfo_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>

using namespace QScxmlExecutableContent;


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QScxmlExecutableContent_EvaluatorInfo_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QScxmlExecutableContent::EvaluatorInfo >()))
        return -1;

    ::QScxmlExecutableContent::EvaluatorInfo *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtScxml.QScxmlExecutableContent.EvaluatorInfo.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "EvaluatorInfo", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: EvaluatorInfo::EvaluatorInfo()
    // 1: EvaluatorInfo::EvaluatorInfo(QScxmlExecutableContent::EvaluatorInfo)
    if (numArgs == 0) {
        overloadId = 0; // EvaluatorInfo()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_EvaluatorInfo_IDX]), (pyArgs[0])))) {
        overloadId = 1; // EvaluatorInfo(QScxmlExecutableContent::EvaluatorInfo)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // EvaluatorInfo()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // EvaluatorInfo()
                cptr = new ::QScxmlExecutableContent::EvaluatorInfo();
            }
            break;
        }
        case 1: // EvaluatorInfo(const QScxmlExecutableContent::EvaluatorInfo & EvaluatorInfo)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QScxmlExecutableContent::EvaluatorInfo cppArg0_local;
            ::QScxmlExecutableContent::EvaluatorInfo *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // EvaluatorInfo(QScxmlExecutableContent::EvaluatorInfo)
                cptr = new ::QScxmlExecutableContent::EvaluatorInfo(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QScxmlExecutableContent::EvaluatorInfo >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QScxmlExecutableContent_EvaluatorInfo__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QScxmlExecutableContent::EvaluatorInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_EvaluatorInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_EvaluatorInfo_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QScxmlExecutableContent_EvaluatorInfo_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QScxmlExecutableContent_EvaluatorInfo_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QScxmlExecutableContent_EvaluatorInfo__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QScxmlExecutableContent_EvaluatorInfo_get_expr(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::EvaluatorInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_EvaluatorInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->expr;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QScxmlExecutableContent_EvaluatorInfo_set_expr(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::EvaluatorInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_EvaluatorInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("expr");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("expr", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->expr;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->expr = cppOut_local;

    return 0;
}

static PyObject *Sbk_QScxmlExecutableContent_EvaluatorInfo_get_context(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::EvaluatorInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_EvaluatorInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->context;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QScxmlExecutableContent_EvaluatorInfo_set_context(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::EvaluatorInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_EvaluatorInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("context");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("context", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->context;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->context = cppOut_local;

    return 0;
}

// Getters and Setters for EvaluatorInfo
static PyGetSetDef Sbk_QScxmlExecutableContent_EvaluatorInfo_getsetlist[] = {
    {const_cast<char *>("expr"), Sbk_QScxmlExecutableContent_EvaluatorInfo_get_expr, Sbk_QScxmlExecutableContent_EvaluatorInfo_set_expr, nullptr, nullptr},
    {const_cast<char *>("context"), Sbk_QScxmlExecutableContent_EvaluatorInfo_get_context, Sbk_QScxmlExecutableContent_EvaluatorInfo_set_context, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QScxmlExecutableContent_EvaluatorInfo_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QScxmlExecutableContent_EvaluatorInfo_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QScxmlExecutableContent_EvaluatorInfo_Type = nullptr;
static PyTypeObject *Sbk_QScxmlExecutableContent_EvaluatorInfo_TypeF(void)
{
    return _Sbk_QScxmlExecutableContent_EvaluatorInfo_Type;
}

static PyType_Slot Sbk_QScxmlExecutableContent_EvaluatorInfo_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QScxmlExecutableContent_EvaluatorInfo_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QScxmlExecutableContent_EvaluatorInfo_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QScxmlExecutableContent_EvaluatorInfo_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QScxmlExecutableContent_EvaluatorInfo_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QScxmlExecutableContent_EvaluatorInfo_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QScxmlExecutableContent_EvaluatorInfo_spec = {
    "2:PySide6.QtScxml.QScxmlExecutableContent.EvaluatorInfo",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QScxmlExecutableContent_EvaluatorInfo_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void EvaluatorInfo_PythonToCpp_EvaluatorInfo_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QScxmlExecutableContent_EvaluatorInfo_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_EvaluatorInfo_PythonToCpp_EvaluatorInfo_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QScxmlExecutableContent_EvaluatorInfo_TypeF()))
        return EvaluatorInfo_PythonToCpp_EvaluatorInfo_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *EvaluatorInfo_PTR_CppToPython_EvaluatorInfo(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QScxmlExecutableContent::EvaluatorInfo *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QScxmlExecutableContent_EvaluatorInfo_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *EvaluatorInfo_COPY_CppToPython_EvaluatorInfo(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QScxmlExecutableContent::EvaluatorInfo *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QScxmlExecutableContent_EvaluatorInfo_TypeF(), new ::QScxmlExecutableContent::EvaluatorInfo(*source), true, true);
}

// Python to C++ copy conversion.
static void EvaluatorInfo_PythonToCpp_EvaluatorInfo_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QScxmlExecutableContent::EvaluatorInfo *>(cppOut) = *reinterpret_cast< ::QScxmlExecutableContent::EvaluatorInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_EvaluatorInfo_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_EvaluatorInfo_PythonToCpp_EvaluatorInfo_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QScxmlExecutableContent_EvaluatorInfo_TypeF()))
        return EvaluatorInfo_PythonToCpp_EvaluatorInfo_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QScxmlExecutableContent_EvaluatorInfo_SignatureStrings[] = {
    "1:PySide6.QtScxml.QScxmlExecutableContent.EvaluatorInfo(self)",
    "0:PySide6.QtScxml.QScxmlExecutableContent.EvaluatorInfo(self,EvaluatorInfo:PySide6.QtScxml.QScxmlExecutableContent.EvaluatorInfo)",
    "PySide6.QtScxml.QScxmlExecutableContent.EvaluatorInfo.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QScxmlExecutableContent_EvaluatorInfo(PyObject *enclosingClass)
{
    _Sbk_QScxmlExecutableContent_EvaluatorInfo_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "EvaluatorInfo",
        "QScxmlExecutableContent::EvaluatorInfo",
        &Sbk_QScxmlExecutableContent_EvaluatorInfo_spec,
        &Shiboken::callCppDestructor< ::QScxmlExecutableContent::EvaluatorInfo >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QScxmlExecutableContent_EvaluatorInfo_TypeF(); // references _Sbk_QScxmlExecutableContent_EvaluatorInfo_Type
    InitSignatureStrings(pyType, QScxmlExecutableContent_EvaluatorInfo_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QScxmlExecutableContent_EvaluatorInfo_PropertyStrings);
    SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_EvaluatorInfo_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        EvaluatorInfo_PythonToCpp_EvaluatorInfo_PTR,
        is_EvaluatorInfo_PythonToCpp_EvaluatorInfo_PTR_Convertible,
        EvaluatorInfo_PTR_CppToPython_EvaluatorInfo,
        EvaluatorInfo_COPY_CppToPython_EvaluatorInfo);

    Shiboken::Conversions::registerConverterName(converter, "QScxmlExecutableContent::EvaluatorInfo");
    Shiboken::Conversions::registerConverterName(converter, "QScxmlExecutableContent::EvaluatorInfo*");
    Shiboken::Conversions::registerConverterName(converter, "QScxmlExecutableContent::EvaluatorInfo&");
    Shiboken::Conversions::registerConverterName(converter, "EvaluatorInfo");
    Shiboken::Conversions::registerConverterName(converter, "EvaluatorInfo*");
    Shiboken::Conversions::registerConverterName(converter, "EvaluatorInfo&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QScxmlExecutableContent::EvaluatorInfo).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        EvaluatorInfo_PythonToCpp_EvaluatorInfo_COPY,
        is_EvaluatorInfo_PythonToCpp_EvaluatorInfo_COPY_Convertible);

    qRegisterMetaType< ::QScxmlExecutableContent::EvaluatorInfo >("EvaluatorInfo");
    qRegisterMetaType< ::QScxmlExecutableContent::EvaluatorInfo >("QScxmlExecutableContent::EvaluatorInfo");

    return pyType;
}
