// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QScxmlInvokableServiceWrapper_H
#define SBK_QScxmlInvokableServiceWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtScxml/qscxmlinvokableservice.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QScxmlInvokableServiceWrapper : public QScxmlInvokableService
{
public:
    QScxmlInvokableServiceWrapper(const QScxmlInvokableServiceWrapper &) = delete;
    QScxmlInvokableServiceWrapper& operator=(const QScxmlInvokableServiceWrapper &) = delete;
    QScxmlInvokableServiceWrapper(QScxmlInvokableServiceWrapper &&) = delete;
    QScxmlInvokableServiceWrapper& operator=(QScxmlInvokableServiceWrapper &&) = delete;

    QScxmlInvokableServiceWrapper(::QScxmlStateMachine * parentStateMachine, ::QScxmlInvokableServiceFactory * parent);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QString id() const override;
    ::QString name() const override;
    void postEvent(::QScxmlEvent * event) override;
    bool start() override;
    void timerEvent(::QTimerEvent * event) override;
    ~QScxmlInvokableServiceWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[11];
};

#endif // SBK_QScxmlInvokableServiceWrapper_H

