// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QCompassFilterWrapper_H
#define SBK_QCompassFilterWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qcompass.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QCompassFilterWrapper : public QCompassFilter
{
public:
    QCompassFilterWrapper(const QCompassFilterWrapper &) = delete;
    QCompassFilterWrapper& operator=(const QCompassFilterWrapper &) = delete;
    QCompassFilterWrapper(QCompassFilterWrapper &&) = delete;
    QCompassFilterWrapper& operator=(QCompassFilterWrapper &&) = delete;

    bool filter(::QCompassReading * reading) override;
    void setSensor(::QSensor * sensor) override;
    ~QCompassFilterWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QCompassFilterWrapper_H

