// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGyroscopeFilterWrapper_H
#define SBK_QGyroscopeFilterWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qgyroscope.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QGyroscopeFilterWrapper : public QGyroscopeFilter
{
public:
    QGyroscopeFilterWrapper(const QGyroscopeFilterWrapper &) = delete;
    QGyroscopeFilterWrapper& operator=(const QGyroscopeFilterWrapper &) = delete;
    QGyroscopeFilterWrapper(QGyroscopeFilterWrapper &&) = delete;
    QGyroscopeFilterWrapper& operator=(QGyroscopeFilterWrapper &&) = delete;

    bool filter(::QGyroscopeReading * reading) override;
    void setSensor(::QSensor * sensor) override;
    ~QGyroscopeFilterWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QGyroscopeFilterWrapper_H

