// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QLightFilterWrapper_H
#define SBK_QLightFilterWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qlightsensor.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QLightFilterWrapper : public QLightFilter
{
public:
    QLightFilterWrapper(const QLightFilterWrapper &) = delete;
    QLightFilterWrapper& operator=(const QLightFilterWrapper &) = delete;
    QLightFilterWrapper(QLightFilterWrapper &&) = delete;
    QLightFilterWrapper& operator=(QLightFilterWrapper &&) = delete;

    bool filter(::QLightReading * reading) override;
    void setSensor(::QSensor * sensor) override;
    ~QLightFilterWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QLightFilterWrapper_H

