// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QPressureFilterWrapper_H
#define SBK_QPressureFilterWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qpressuresensor.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QPressureFilterWrapper : public QPressureFilter
{
public:
    QPressureFilterWrapper(const QPressureFilterWrapper &) = delete;
    QPressureFilterWrapper& operator=(const QPressureFilterWrapper &) = delete;
    QPressureFilterWrapper(QPressureFilterWrapper &&) = delete;
    QPressureFilterWrapper& operator=(QPressureFilterWrapper &&) = delete;

    bool filter(::QPressureReading * reading) override;
    void setSensor(::QSensor * sensor) override;
    ~QPressureFilterWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QPressureFilterWrapper_H

