// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSensorPluginInterfaceWrapper_H
#define SBK_QSensorPluginInterfaceWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qsensorplugin.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QSensorPluginInterfaceWrapper : public QSensorPluginInterface
{
public:
    QSensorPluginInterfaceWrapper(const QSensorPluginInterfaceWrapper &) = delete;
    QSensorPluginInterfaceWrapper& operator=(const QSensorPluginInterfaceWrapper &) = delete;
    QSensorPluginInterfaceWrapper(QSensorPluginInterfaceWrapper &&) = delete;
    QSensorPluginInterfaceWrapper& operator=(QSensorPluginInterfaceWrapper &&) = delete;

    QSensorPluginInterfaceWrapper();
    void registerSensors() override;
    ~QSensorPluginInterfaceWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1];
};

#endif // SBK_QSensorPluginInterfaceWrapper_H

