// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QCanBusDeviceWrapper_H
#define SBK_QCanBusDeviceWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSerialBus/qcanbusdevice.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QCanBusDeviceWrapper : public QCanBusDevice
{
public:
    QCanBusDeviceWrapper(const QCanBusDeviceWrapper &) = delete;
    QCanBusDeviceWrapper& operator=(const QCanBusDeviceWrapper &) = delete;
    QCanBusDeviceWrapper(QCanBusDeviceWrapper &&) = delete;
    QCanBusDeviceWrapper& operator=(QCanBusDeviceWrapper &&) = delete;

    QCanBusDeviceWrapper(::QObject * parent = nullptr);
    ::QCanBusDevice::CanBusStatus busStatus() override;
    void childEvent(::QChildEvent * event) override;
    void close() override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    bool hasBusStatus() const override;
    ::QString interpretErrorFrame(const ::QCanBusFrame & errorFrame) override;
    bool open() override;
    void resetController() override;
    void setConfigurationParameter(::QCanBusDevice::ConfigurationKey key, const ::QVariant & value) override;
    void timerEvent(::QTimerEvent * event) override;
    bool waitForFramesReceived(int msecs) override;
    bool waitForFramesWritten(int msecs) override;
    bool writeFrame(const ::QCanBusFrame & frame) override;
    ~QCanBusDeviceWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[17];
};

#endif // SBK_QCanBusDeviceWrapper_H

