// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtserialbus_python.h"

// main header
#include "qcanbusdeviceinfo_wrapper.h"

// Argument includes
#include <QString>
#include <QtSerialBus/qcanbusdeviceinfo.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QCanBusDeviceInfo_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QCanBusDeviceInfo >()))
        return -1;

    ::QCanBusDeviceInfo *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusDeviceInfo.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QCanBusDeviceInfo", 1, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QCanBusDeviceInfo::QCanBusDeviceInfo(QCanBusDeviceInfo)
    if (numArgs == 1
        && (pyArgs[0] != Py_None && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusDeviceInfo_IDX]), (pyArgs[0]))))) {
        overloadId = 0; // QCanBusDeviceInfo(QCanBusDeviceInfo)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArgs[0]))
            return -1;
        ::QCanBusDeviceInfo *cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // QCanBusDeviceInfo(QCanBusDeviceInfo)
            cptr = new ::QCanBusDeviceInfo(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QCanBusDeviceInfo >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QCanBusDeviceInfoFunc_alias(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanBusDeviceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusDeviceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusDeviceInfo.alias";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // alias()const
            QString cppResult = const_cast<const ::QCanBusDeviceInfo *>(cppSelf)->alias();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCanBusDeviceInfoFunc_channel(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanBusDeviceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusDeviceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusDeviceInfo.channel";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // channel()const
            int cppResult = const_cast<const ::QCanBusDeviceInfo *>(cppSelf)->channel();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCanBusDeviceInfoFunc_description(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanBusDeviceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusDeviceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusDeviceInfo.description";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // description()const
            QString cppResult = const_cast<const ::QCanBusDeviceInfo *>(cppSelf)->description();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCanBusDeviceInfoFunc_hasFlexibleDataRate(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanBusDeviceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusDeviceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusDeviceInfo.hasFlexibleDataRate";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // hasFlexibleDataRate()const
            bool cppResult = const_cast<const ::QCanBusDeviceInfo *>(cppSelf)->hasFlexibleDataRate();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCanBusDeviceInfoFunc_isVirtual(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanBusDeviceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusDeviceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusDeviceInfo.isVirtual";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isVirtual()const
            bool cppResult = const_cast<const ::QCanBusDeviceInfo *>(cppSelf)->isVirtual();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCanBusDeviceInfoFunc_name(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanBusDeviceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusDeviceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusDeviceInfo.name";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // name()const
            QString cppResult = const_cast<const ::QCanBusDeviceInfo *>(cppSelf)->name();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCanBusDeviceInfoFunc_plugin(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanBusDeviceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusDeviceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusDeviceInfo.plugin";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // plugin()const
            QString cppResult = const_cast<const ::QCanBusDeviceInfo *>(cppSelf)->plugin();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCanBusDeviceInfoFunc_serialNumber(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanBusDeviceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusDeviceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusDeviceInfo.serialNumber";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // serialNumber()const
            QString cppResult = const_cast<const ::QCanBusDeviceInfo *>(cppSelf)->serialNumber();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCanBusDeviceInfo__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QCanBusDeviceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusDeviceInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusDeviceInfo_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QCanBusDeviceInfo_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QCanBusDeviceInfo_methods[] = {
    {"alias", reinterpret_cast<PyCFunction>(Sbk_QCanBusDeviceInfoFunc_alias), METH_NOARGS, nullptr},
    {"channel", reinterpret_cast<PyCFunction>(Sbk_QCanBusDeviceInfoFunc_channel), METH_NOARGS, nullptr},
    {"description", reinterpret_cast<PyCFunction>(Sbk_QCanBusDeviceInfoFunc_description), METH_NOARGS, nullptr},
    {"hasFlexibleDataRate", reinterpret_cast<PyCFunction>(Sbk_QCanBusDeviceInfoFunc_hasFlexibleDataRate), METH_NOARGS, nullptr},
    {"isVirtual", reinterpret_cast<PyCFunction>(Sbk_QCanBusDeviceInfoFunc_isVirtual), METH_NOARGS, nullptr},
    {"name", reinterpret_cast<PyCFunction>(Sbk_QCanBusDeviceInfoFunc_name), METH_NOARGS, nullptr},
    {"plugin", reinterpret_cast<PyCFunction>(Sbk_QCanBusDeviceInfoFunc_plugin), METH_NOARGS, nullptr},
    {"serialNumber", reinterpret_cast<PyCFunction>(Sbk_QCanBusDeviceInfoFunc_serialNumber), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QCanBusDeviceInfo__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QCanBusDeviceInfo_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QCanBusDeviceInfo_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QCanBusDeviceInfo_Type = nullptr;
static PyTypeObject *Sbk_QCanBusDeviceInfo_TypeF(void)
{
    return _Sbk_QCanBusDeviceInfo_Type;
}

static PyType_Slot Sbk_QCanBusDeviceInfo_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QCanBusDeviceInfo_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QCanBusDeviceInfo_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QCanBusDeviceInfo_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QCanBusDeviceInfo_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QCanBusDeviceInfo_spec = {
    "2:PySide6.QtSerialBus.QCanBusDeviceInfo",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QCanBusDeviceInfo_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QCanBusDeviceInfo_PythonToCpp_QCanBusDeviceInfo_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QCanBusDeviceInfo_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QCanBusDeviceInfo_PythonToCpp_QCanBusDeviceInfo_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QCanBusDeviceInfo_TypeF()))
        return QCanBusDeviceInfo_PythonToCpp_QCanBusDeviceInfo_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QCanBusDeviceInfo_PTR_CppToPython_QCanBusDeviceInfo(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QCanBusDeviceInfo *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QCanBusDeviceInfo_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *QCanBusDeviceInfo_COPY_CppToPython_QCanBusDeviceInfo(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QCanBusDeviceInfo *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QCanBusDeviceInfo_TypeF(), new ::QCanBusDeviceInfo(*source), true, true);
}

// Python to C++ copy conversion.
static void QCanBusDeviceInfo_PythonToCpp_QCanBusDeviceInfo_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QCanBusDeviceInfo *>(cppOut) = *reinterpret_cast< ::QCanBusDeviceInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusDeviceInfo_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QCanBusDeviceInfo_PythonToCpp_QCanBusDeviceInfo_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QCanBusDeviceInfo_TypeF()))
        return QCanBusDeviceInfo_PythonToCpp_QCanBusDeviceInfo_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QCanBusDeviceInfo_SignatureStrings[] = {
    "PySide6.QtSerialBus.QCanBusDeviceInfo(self,other:PySide6.QtSerialBus.QCanBusDeviceInfo)",
    "PySide6.QtSerialBus.QCanBusDeviceInfo.alias(self)->QString",
    "PySide6.QtSerialBus.QCanBusDeviceInfo.channel(self)->int",
    "PySide6.QtSerialBus.QCanBusDeviceInfo.description(self)->QString",
    "PySide6.QtSerialBus.QCanBusDeviceInfo.hasFlexibleDataRate(self)->bool",
    "PySide6.QtSerialBus.QCanBusDeviceInfo.isVirtual(self)->bool",
    "PySide6.QtSerialBus.QCanBusDeviceInfo.name(self)->QString",
    "PySide6.QtSerialBus.QCanBusDeviceInfo.plugin(self)->QString",
    "PySide6.QtSerialBus.QCanBusDeviceInfo.serialNumber(self)->QString",
    "PySide6.QtSerialBus.QCanBusDeviceInfo.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QCanBusDeviceInfo(PyObject *module)
{
    _Sbk_QCanBusDeviceInfo_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QCanBusDeviceInfo",
        "QCanBusDeviceInfo",
        &Sbk_QCanBusDeviceInfo_spec,
        &Shiboken::callCppDestructor< ::QCanBusDeviceInfo >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QCanBusDeviceInfo_TypeF(); // references _Sbk_QCanBusDeviceInfo_Type
    InitSignatureStrings(pyType, QCanBusDeviceInfo_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QCanBusDeviceInfo_PropertyStrings);
    SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusDeviceInfo_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QCanBusDeviceInfo_PythonToCpp_QCanBusDeviceInfo_PTR,
        is_QCanBusDeviceInfo_PythonToCpp_QCanBusDeviceInfo_PTR_Convertible,
        QCanBusDeviceInfo_PTR_CppToPython_QCanBusDeviceInfo,
        QCanBusDeviceInfo_COPY_CppToPython_QCanBusDeviceInfo);

    Shiboken::Conversions::registerConverterName(converter, "QCanBusDeviceInfo");
    Shiboken::Conversions::registerConverterName(converter, "QCanBusDeviceInfo*");
    Shiboken::Conversions::registerConverterName(converter, "QCanBusDeviceInfo&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QCanBusDeviceInfo).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QCanBusDeviceInfo_PythonToCpp_QCanBusDeviceInfo_COPY,
        is_QCanBusDeviceInfo_PythonToCpp_QCanBusDeviceInfo_COPY_Convertible);


    return pyType;
}
