// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtserialbus_python.h"

// main header
#include "qcanbusframe_wrapper.h"

// inner classes
#include "qcanbusframe_timestamp_wrapper.h"

// Argument includes
#include <QString>
#include <QtSerialBus/qcanbusframe.h>
#include <qbytearray.h>
#include <qdatastream.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QCanBusFrame_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QCanBusFrame >()))
        return -1;

    ::QCanBusFrame *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusFrame.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 0, 2));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|OO:QCanBusFrame", &(pyArgs[0]), &(pyArgs[1])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QCanBusFrame::QCanBusFrame(QCanBusFrame::FrameType=)
    // 1: QCanBusFrame::QCanBusFrame(QCanBusFrame)
    // 2: QCanBusFrame::QCanBusFrame(uint,QByteArray)
    if (numArgs == 0) {
        overloadId = 0; // QCanBusFrame(QCanBusFrame::FrameType)
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_FrameType_IDX])))->converter, (pyArgs[0])))) {
        overloadId = 0; // QCanBusFrame(QCanBusFrame::FrameType)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QCanBusFrame(QCanBusFrame)
    } else if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<unsigned int>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), (pyArgs[1])))) {
        overloadId = 2; // QCanBusFrame(uint,QByteArray)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QCanBusFrame(QCanBusFrame::FrameType type)
        {
            if (kwds && PyDict_Size(kwds) > 0) {
                PyObject *value{};
                Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
                static PyObject *const key_type = Shiboken::String::createStaticString("type");
                if (PyDict_Contains(kwds, key_type) != 0) {
                    value = PyDict_GetItem(kwds, key_type);
                    if (value != nullptr && pyArgs[0] != nullptr ) {
                        errInfo.reset(key_type);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    if (value != nullptr) {
                        pyArgs[0] = value;
                        if (!(pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_FrameType_IDX])))->converter, (pyArgs[0]))))
                            return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    PyDict_DelItem(kwds_dup, key_type);
                }
                if (PyDict_Size(kwds_dup) > 0) {
                    errInfo.reset(kwds_dup.release());
                    return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                }
            }
            ::QCanBusFrame::FrameType cppArg0(QCanBusFrame::FrameType::DataFrame);
            if (pythonToCpp[0])
                pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QCanBusFrame(QCanBusFrame::FrameType)
                cptr = new ::QCanBusFrame(cppArg0);
            }
            break;
        }
        case 1: // QCanBusFrame(const QCanBusFrame & QCanBusFrame)
        {
            if (kwds != nullptr && PyDict_Size(kwds) > 0) {
                errInfo.reset(kwds);
                Py_INCREF(errInfo.object());
                return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
            }
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QCanBusFrame cppArg0_local;
            ::QCanBusFrame *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QCanBusFrame(QCanBusFrame)
                cptr = new ::QCanBusFrame(*cppArg0);
            }
            break;
        }
        case 2: // QCanBusFrame(unsigned int identifier, const QByteArray & data)
        {
            if (kwds != nullptr && PyDict_Size(kwds) > 0) {
                errInfo.reset(kwds);
                Py_INCREF(errInfo.object());
                return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
            }
            unsigned int cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            if (!Shiboken::Object::isValid(pyArgs[1]))
                return -1;
            ::QByteArray cppArg1_local;
            ::QByteArray *cppArg1 = &cppArg1_local;
            if (pythonToCpp[1].isValue())
                pythonToCpp[1](pyArgs[1], &cppArg1_local);
            else
                pythonToCpp[1](pyArgs[1], &cppArg1);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QCanBusFrame(uint,QByteArray)
                cptr = new ::QCanBusFrame(cppArg0, *cppArg1);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QCanBusFrame >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QCanBusFrameFunc_error(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanBusFrame *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusFrame.error";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // error()const
            QFlags<QCanBusFrame::FrameError> cppResult = const_cast<const ::QCanBusFrame *>(cppSelf)->error();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QFlags_QCanBusFrame_FrameError_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCanBusFrameFunc_frameId(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanBusFrame *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusFrame.frameId";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // frameId()const
            unsigned int cppResult = const_cast<const ::QCanBusFrame *>(cppSelf)->frameId();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<unsigned int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCanBusFrameFunc_frameType(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanBusFrame *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusFrame.frameType";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // frameType()const
            QCanBusFrame::FrameType cppResult = const_cast<const ::QCanBusFrame *>(cppSelf)->frameType();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_FrameType_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCanBusFrameFunc_hasBitrateSwitch(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanBusFrame *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusFrame.hasBitrateSwitch";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // hasBitrateSwitch()const
            bool cppResult = const_cast<const ::QCanBusFrame *>(cppSelf)->hasBitrateSwitch();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCanBusFrameFunc_hasErrorStateIndicator(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanBusFrame *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusFrame.hasErrorStateIndicator";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // hasErrorStateIndicator()const
            bool cppResult = const_cast<const ::QCanBusFrame *>(cppSelf)->hasErrorStateIndicator();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCanBusFrameFunc_hasExtendedFrameFormat(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanBusFrame *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusFrame.hasExtendedFrameFormat";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // hasExtendedFrameFormat()const
            bool cppResult = const_cast<const ::QCanBusFrame *>(cppSelf)->hasExtendedFrameFormat();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCanBusFrameFunc_hasFlexibleDataRateFormat(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanBusFrame *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusFrame.hasFlexibleDataRateFormat";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // hasFlexibleDataRateFormat()const
            bool cppResult = const_cast<const ::QCanBusFrame *>(cppSelf)->hasFlexibleDataRateFormat();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCanBusFrameFunc_hasLocalEcho(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanBusFrame *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusFrame.hasLocalEcho";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // hasLocalEcho()const
            bool cppResult = const_cast<const ::QCanBusFrame *>(cppSelf)->hasLocalEcho();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCanBusFrameFunc_isValid(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanBusFrame *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusFrame.isValid";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isValid()const
            bool cppResult = const_cast<const ::QCanBusFrame *>(cppSelf)->isValid();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCanBusFrameFunc_payload(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanBusFrame *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusFrame.payload";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // payload()const
            QByteArray cppResult = const_cast<const ::QCanBusFrame *>(cppSelf)->payload();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCanBusFrameFunc_setBitrateSwitch(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanBusFrame *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusFrame.setBitrateSwitch";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QCanBusFrame::setBitrateSwitch(bool)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArg)))) {
        overloadId = 0; // setBitrateSwitch(bool)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        bool cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setBitrateSwitch(bool)
            cppSelf->setBitrateSwitch(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QCanBusFrameFunc_setError(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanBusFrame *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusFrame.setError";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QCanBusFrame::setError(QFlags<QCanBusFrame::FrameError>)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QFlags_QCanBusFrame_FrameError_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // setError(QFlags<QCanBusFrame::FrameError>)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QFlags<QCanBusFrame::FrameError> cppArg0 = QFlags<QCanBusFrame::FrameError>(0);
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setError(QFlags<QCanBusFrame::FrameError>)
            cppSelf->setError(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QCanBusFrameFunc_setErrorStateIndicator(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanBusFrame *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusFrame.setErrorStateIndicator";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QCanBusFrame::setErrorStateIndicator(bool)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArg)))) {
        overloadId = 0; // setErrorStateIndicator(bool)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        bool cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setErrorStateIndicator(bool)
            cppSelf->setErrorStateIndicator(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QCanBusFrameFunc_setExtendedFrameFormat(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanBusFrame *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusFrame.setExtendedFrameFormat";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QCanBusFrame::setExtendedFrameFormat(bool)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArg)))) {
        overloadId = 0; // setExtendedFrameFormat(bool)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        bool cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setExtendedFrameFormat(bool)
            cppSelf->setExtendedFrameFormat(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QCanBusFrameFunc_setFlexibleDataRateFormat(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanBusFrame *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusFrame.setFlexibleDataRateFormat";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QCanBusFrame::setFlexibleDataRateFormat(bool)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArg)))) {
        overloadId = 0; // setFlexibleDataRateFormat(bool)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        bool cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setFlexibleDataRateFormat(bool)
            cppSelf->setFlexibleDataRateFormat(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QCanBusFrameFunc_setFrameId(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanBusFrame *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusFrame.setFrameId";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QCanBusFrame::setFrameId(uint)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<unsigned int>(), (pyArg)))) {
        overloadId = 0; // setFrameId(uint)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        unsigned int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setFrameId(uint)
            cppSelf->setFrameId(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QCanBusFrameFunc_setFrameType(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanBusFrame *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusFrame.setFrameType";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QCanBusFrame::setFrameType(QCanBusFrame::FrameType)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_FrameType_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // setFrameType(QCanBusFrame::FrameType)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QCanBusFrame::FrameType cppArg0{QCanBusFrame::UnknownFrame};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setFrameType(QCanBusFrame::FrameType)
            cppSelf->setFrameType(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QCanBusFrameFunc_setLocalEcho(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanBusFrame *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusFrame.setLocalEcho";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QCanBusFrame::setLocalEcho(bool)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArg)))) {
        overloadId = 0; // setLocalEcho(bool)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        bool cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setLocalEcho(bool)
            cppSelf->setLocalEcho(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QCanBusFrameFunc_setPayload(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanBusFrame *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusFrame.setPayload";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QCanBusFrame::setPayload(QByteArray)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), (pyArg)))) {
        overloadId = 0; // setPayload(QByteArray)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QByteArray cppArg0_local;
        ::QByteArray *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // setPayload(QByteArray)
            cppSelf->setPayload(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QCanBusFrameFunc_setTimeStamp(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanBusFrame *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusFrame.setTimeStamp";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QCanBusFrame::setTimeStamp(QCanBusFrame::TimeStamp)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_TimeStamp_IDX]), (pyArg)))) {
        overloadId = 0; // setTimeStamp(QCanBusFrame::TimeStamp)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QCanBusFrame::TimeStamp cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setTimeStamp(QCanBusFrame::TimeStamp)
            cppSelf->setTimeStamp(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QCanBusFrameFunc_timeStamp(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanBusFrame *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusFrame.timeStamp";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // timeStamp()const
            QCanBusFrame::TimeStamp cppResult = const_cast<const ::QCanBusFrame *>(cppSelf)->timeStamp();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_TimeStamp_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCanBusFrameFunc_toString(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanBusFrame *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusFrame.toString";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // toString()const
            QString cppResult = const_cast<const ::QCanBusFrame *>(cppSelf)->toString();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCanBusFrame__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QCanBusFrame *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QCanBusFrame_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QCanBusFrame_EnumFlagInfo[] = {
    "FrameError:Flag:FrameErrors",
    "FrameType:Enum",
    "Version:IntEnum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QCanBusFrame_methods[] = {
    {"error", reinterpret_cast<PyCFunction>(Sbk_QCanBusFrameFunc_error), METH_NOARGS, nullptr},
    {"frameId", reinterpret_cast<PyCFunction>(Sbk_QCanBusFrameFunc_frameId), METH_NOARGS, nullptr},
    {"frameType", reinterpret_cast<PyCFunction>(Sbk_QCanBusFrameFunc_frameType), METH_NOARGS, nullptr},
    {"hasBitrateSwitch", reinterpret_cast<PyCFunction>(Sbk_QCanBusFrameFunc_hasBitrateSwitch), METH_NOARGS, nullptr},
    {"hasErrorStateIndicator", reinterpret_cast<PyCFunction>(Sbk_QCanBusFrameFunc_hasErrorStateIndicator), METH_NOARGS, nullptr},
    {"hasExtendedFrameFormat", reinterpret_cast<PyCFunction>(Sbk_QCanBusFrameFunc_hasExtendedFrameFormat), METH_NOARGS, nullptr},
    {"hasFlexibleDataRateFormat", reinterpret_cast<PyCFunction>(Sbk_QCanBusFrameFunc_hasFlexibleDataRateFormat), METH_NOARGS, nullptr},
    {"hasLocalEcho", reinterpret_cast<PyCFunction>(Sbk_QCanBusFrameFunc_hasLocalEcho), METH_NOARGS, nullptr},
    {"isValid", reinterpret_cast<PyCFunction>(Sbk_QCanBusFrameFunc_isValid), METH_NOARGS, nullptr},
    {"payload", reinterpret_cast<PyCFunction>(Sbk_QCanBusFrameFunc_payload), METH_NOARGS, nullptr},
    {"setBitrateSwitch", reinterpret_cast<PyCFunction>(Sbk_QCanBusFrameFunc_setBitrateSwitch), METH_O, nullptr},
    {"setError", reinterpret_cast<PyCFunction>(Sbk_QCanBusFrameFunc_setError), METH_O, nullptr},
    {"setErrorStateIndicator", reinterpret_cast<PyCFunction>(Sbk_QCanBusFrameFunc_setErrorStateIndicator), METH_O, nullptr},
    {"setExtendedFrameFormat", reinterpret_cast<PyCFunction>(Sbk_QCanBusFrameFunc_setExtendedFrameFormat), METH_O, nullptr},
    {"setFlexibleDataRateFormat", reinterpret_cast<PyCFunction>(Sbk_QCanBusFrameFunc_setFlexibleDataRateFormat), METH_O, nullptr},
    {"setFrameId", reinterpret_cast<PyCFunction>(Sbk_QCanBusFrameFunc_setFrameId), METH_O, nullptr},
    {"setFrameType", reinterpret_cast<PyCFunction>(Sbk_QCanBusFrameFunc_setFrameType), METH_O, nullptr},
    {"setLocalEcho", reinterpret_cast<PyCFunction>(Sbk_QCanBusFrameFunc_setLocalEcho), METH_O, nullptr},
    {"setPayload", reinterpret_cast<PyCFunction>(Sbk_QCanBusFrameFunc_setPayload), METH_O, nullptr},
    {"setTimeStamp", reinterpret_cast<PyCFunction>(Sbk_QCanBusFrameFunc_setTimeStamp), METH_O, nullptr},
    {"timeStamp", reinterpret_cast<PyCFunction>(Sbk_QCanBusFrameFunc_timeStamp), METH_NOARGS, nullptr},
    {"toString", reinterpret_cast<PyCFunction>(Sbk_QCanBusFrameFunc_toString), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QCanBusFrame__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QCanBusFrameFunc___lshift__(PyObject *self, PyObject *pyArg)
{
    bool isReverse = SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_IDX]), pyArg)
                    && !SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_IDX]), self);
    if (isReverse)
        std::swap(self, pyArg);
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanBusFrame *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusFrame.__lshift__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    static PyObject *attrName = Shiboken::PyMagicName::rlshift();
    if (!isReverse
        && Shiboken::Object::checkType(pyArg)
        && !PyObject_TypeCheck(pyArg, self->ob_type)
        && PyObject_HasAttr(pyArg, attrName)) {
        PyObject *revOpMethod = PyObject_GetAttr(pyArg, attrName);
        if (revOpMethod && PyCallable_Check(revOpMethod)) {
            pyResult = PyObject_CallFunction(revOpMethod, "O", self);
            if (Shiboken::Errors::occurred() != nullptr && (PyErr_ExceptionMatches(PyExc_NotImplementedError) || PyErr_ExceptionMatches(PyExc_AttributeError))) {
                PyErr_Clear();
                Py_XDECREF(pyResult);
                pyResult = nullptr;
            }
        }
        Py_XDECREF(revOpMethod);

    }

    // Do not enter here if other object has implemented a reverse operator.
    if (pyResult == nullptr) {
        // Overloaded function decisor
        // 0: QCanBusFrame::operator<<(QDataStream&)->QDataStream&
        if (isReverse
            && (pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QDataStream_IDX]), (pyArg)))) {
            overloadId = 0; // operator<<(QDataStream&,QCanBusFrame)
        }

        if (isReverse && overloadId == -1) {
            Shiboken::Errors::setReverseOperatorNotImplemented();
            return {};
        }

        // Function signature not found.
        if (overloadId == -1)
            return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

        // Call function/method
        {
            if (!Shiboken::Object::isValid(pyArg))
                return {};
            ::QDataStream *cppArg0;
            pythonToCpp(pyArg, &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // operator<<(QDataStream&,QCanBusFrame) [reverse operator]
                QDataStream & cppResult = (*cppArg0) << (*cppSelf);
                pyResult = Shiboken::Conversions::referenceToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QDataStream_IDX]), &cppResult);
            }
        }

    } // End of "if (!pyResult)"

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCanBusFrameFunc___rshift__(PyObject *self, PyObject *pyArg)
{
    bool isReverse = SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_IDX]), pyArg)
                    && !SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_IDX]), self);
    if (isReverse)
        std::swap(self, pyArg);
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanBusFrame *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanBusFrame.__rshift__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    static PyObject *attrName = Shiboken::PyMagicName::rrshift();
    if (!isReverse
        && Shiboken::Object::checkType(pyArg)
        && !PyObject_TypeCheck(pyArg, self->ob_type)
        && PyObject_HasAttr(pyArg, attrName)) {
        PyObject *revOpMethod = PyObject_GetAttr(pyArg, attrName);
        if (revOpMethod && PyCallable_Check(revOpMethod)) {
            pyResult = PyObject_CallFunction(revOpMethod, "O", self);
            if (Shiboken::Errors::occurred() != nullptr && (PyErr_ExceptionMatches(PyExc_NotImplementedError) || PyErr_ExceptionMatches(PyExc_AttributeError))) {
                PyErr_Clear();
                Py_XDECREF(pyResult);
                pyResult = nullptr;
            }
        }
        Py_XDECREF(revOpMethod);

    }

    // Do not enter here if other object has implemented a reverse operator.
    if (pyResult == nullptr) {
        // Overloaded function decisor
        // 0: QCanBusFrame::operator>>(QDataStream&)->QDataStream&
        if (isReverse
            && (pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QDataStream_IDX]), (pyArg)))) {
            overloadId = 0; // operator>>(QDataStream&,QCanBusFrame&)
        }

        if (isReverse && overloadId == -1) {
            Shiboken::Errors::setReverseOperatorNotImplemented();
            return {};
        }

        // Function signature not found.
        if (overloadId == -1)
            return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

        // Call function/method
        {
            if (!Shiboken::Object::isValid(pyArg))
                return {};
            ::QDataStream *cppArg0;
            pythonToCpp(pyArg, &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // operator>>(QDataStream&,QCanBusFrame&) [reverse operator]
                QDataStream & cppResult = (*cppArg0) >> (*cppSelf);
                pyResult = Shiboken::Conversions::referenceToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QDataStream_IDX]), &cppResult);
            }
        }

    } // End of "if (!pyResult)"

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

} // extern "C"

static int Sbk_QCanBusFrame_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QCanBusFrame_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QCanBusFrame_Type = nullptr;
static PyTypeObject *Sbk_QCanBusFrame_TypeF(void)
{
    return _Sbk_QCanBusFrame_Type;
}

static PyType_Slot Sbk_QCanBusFrame_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QCanBusFrame_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QCanBusFrame_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QCanBusFrame_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QCanBusFrame_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    // type supports number protocol
    {Py_nb_lshift,      reinterpret_cast<void *>(Sbk_QCanBusFrameFunc___lshift__)},
    {Py_nb_rshift,      reinterpret_cast<void *>(Sbk_QCanBusFrameFunc___rshift__)},
    {0, nullptr}
};
static PyType_Spec Sbk_QCanBusFrame_spec = {
    "2:PySide6.QtSerialBus.QCanBusFrame",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QCanBusFrame_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void QCanBusFrame_FrameType_PythonToCpp_QCanBusFrame_FrameType(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QCanBusFrame::FrameType>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QCanBusFrame::FrameType *>(cppOut) = value;

}
static PythonToCppFunc is_QCanBusFrame_FrameType_PythonToCpp_QCanBusFrame_FrameType_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_FrameType_IDX])))
        return QCanBusFrame_FrameType_PythonToCpp_QCanBusFrame_FrameType;
    return {};
}
static PyObject *QCanBusFrame_FrameType_CppToPython_QCanBusFrame_FrameType(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QCanBusFrame::FrameType *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_FrameType_IDX]), castCppIn);

}

static void QCanBusFrame_FrameError_PythonToCpp_QCanBusFrame_FrameError(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QCanBusFrame::FrameError>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QCanBusFrame::FrameError *>(cppOut) = value;

}
static PythonToCppFunc is_QCanBusFrame_FrameError_PythonToCpp_QCanBusFrame_FrameError_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_FrameError_IDX])))
        return QCanBusFrame_FrameError_PythonToCpp_QCanBusFrame_FrameError;
    return {};
}
static PyObject *QCanBusFrame_FrameError_CppToPython_QCanBusFrame_FrameError(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QCanBusFrame::FrameError *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_FrameError_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QCanBusFrame_PythonToCpp_QCanBusFrame_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QCanBusFrame_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QCanBusFrame_PythonToCpp_QCanBusFrame_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QCanBusFrame_TypeF()))
        return QCanBusFrame_PythonToCpp_QCanBusFrame_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QCanBusFrame_PTR_CppToPython_QCanBusFrame(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QCanBusFrame *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QCanBusFrame_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *QCanBusFrame_COPY_CppToPython_QCanBusFrame(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QCanBusFrame *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QCanBusFrame_TypeF(), new ::QCanBusFrame(*source), true, true);
}

// Python to C++ copy conversion.
static void QCanBusFrame_PythonToCpp_QCanBusFrame_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QCanBusFrame *>(cppOut) = *reinterpret_cast< ::QCanBusFrame *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QCanBusFrame_PythonToCpp_QCanBusFrame_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QCanBusFrame_TypeF()))
        return QCanBusFrame_PythonToCpp_QCanBusFrame_COPY;
    return {};
}

// Implicit conversions.
static void QCanBusFrame_FrameType_PythonToCpp_QCanBusFrame(PyObject *pyIn, void *cppOut)
{
    ::QCanBusFrame::FrameType cppIn{QCanBusFrame::UnknownFrame};
    Shiboken::Conversions::pythonToCppCopy(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_FrameType_IDX])))->converter, pyIn, &cppIn);
    *reinterpret_cast<::QCanBusFrame *>(cppOut) = ::QCanBusFrame(cppIn);
}
static PythonToCppFunc is_QCanBusFrame_FrameType_PythonToCpp_QCanBusFrame_Convertible(PyObject *pyIn)
{
    if (SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_FrameType_IDX]), pyIn))
        return QCanBusFrame_FrameType_PythonToCpp_QCanBusFrame;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QCanBusFrame_SignatureStrings[] = {
    "2:PySide6.QtSerialBus.QCanBusFrame(self,type:PySide6.QtSerialBus.QCanBusFrame.FrameType=QCanBusFrame.FrameType.DataFrame)",
    "1:PySide6.QtSerialBus.QCanBusFrame(self,QCanBusFrame:typing.Union[PySide6.QtSerialBus.QCanBusFrame, PySide6.QtSerialBus.QCanBusFrame.FrameType])",
    "0:PySide6.QtSerialBus.QCanBusFrame(self,identifier:unsigned int,data:typing.Union[PySide6.QtCore.QByteArray, char*])",
    "PySide6.QtSerialBus.QCanBusFrame.error(self)->PySide6.QtSerialBus.QCanBusFrame.FrameError",
    "PySide6.QtSerialBus.QCanBusFrame.frameId(self)->unsigned int",
    "PySide6.QtSerialBus.QCanBusFrame.frameType(self)->PySide6.QtSerialBus.QCanBusFrame.FrameType",
    "PySide6.QtSerialBus.QCanBusFrame.hasBitrateSwitch(self)->bool",
    "PySide6.QtSerialBus.QCanBusFrame.hasErrorStateIndicator(self)->bool",
    "PySide6.QtSerialBus.QCanBusFrame.hasExtendedFrameFormat(self)->bool",
    "PySide6.QtSerialBus.QCanBusFrame.hasFlexibleDataRateFormat(self)->bool",
    "PySide6.QtSerialBus.QCanBusFrame.hasLocalEcho(self)->bool",
    "PySide6.QtSerialBus.QCanBusFrame.isValid(self)->bool",
    "PySide6.QtSerialBus.QCanBusFrame.payload(self)->PySide6.QtCore.QByteArray",
    "PySide6.QtSerialBus.QCanBusFrame.setBitrateSwitch(self,bitrateSwitch:bool)",
    "PySide6.QtSerialBus.QCanBusFrame.setError(self,e:PySide6.QtSerialBus.QCanBusFrame.FrameError)",
    "PySide6.QtSerialBus.QCanBusFrame.setErrorStateIndicator(self,errorStateIndicator:bool)",
    "PySide6.QtSerialBus.QCanBusFrame.setExtendedFrameFormat(self,isExtended:bool)",
    "PySide6.QtSerialBus.QCanBusFrame.setFlexibleDataRateFormat(self,isFlexibleData:bool)",
    "PySide6.QtSerialBus.QCanBusFrame.setFrameId(self,newFrameId:unsigned int)",
    "PySide6.QtSerialBus.QCanBusFrame.setFrameType(self,newFormat:PySide6.QtSerialBus.QCanBusFrame.FrameType)",
    "PySide6.QtSerialBus.QCanBusFrame.setLocalEcho(self,localEcho:bool)",
    "PySide6.QtSerialBus.QCanBusFrame.setPayload(self,data:typing.Union[PySide6.QtCore.QByteArray, char*])",
    "PySide6.QtSerialBus.QCanBusFrame.setTimeStamp(self,ts:PySide6.QtSerialBus.QCanBusFrame.TimeStamp)",
    "PySide6.QtSerialBus.QCanBusFrame.timeStamp(self)->PySide6.QtSerialBus.QCanBusFrame.TimeStamp",
    "PySide6.QtSerialBus.QCanBusFrame.toString(self)->QString",
    "PySide6.QtSerialBus.QCanBusFrame.__copy__()",
    "PySide6.QtSerialBus.QCanBusFrame.__lshift__(self,arg__1:PySide6.QtCore.QDataStream)->PySide6.QtCore.QDataStream",
    "PySide6.QtSerialBus.QCanBusFrame.__rshift__(self,arg__1:PySide6.QtCore.QDataStream)->PySide6.QtCore.QDataStream",
    nullptr}; // Sentinel

PyTypeObject *init_QCanBusFrame(PyObject *module)
{
    _Sbk_QCanBusFrame_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QCanBusFrame",
        "QCanBusFrame",
        &Sbk_QCanBusFrame_spec,
        &Shiboken::callCppDestructor< ::QCanBusFrame >,
        nullptr,
        0,
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QCanBusFrame_TypeF(); // references _Sbk_QCanBusFrame_Type
    InitSignatureStrings(pyType, QCanBusFrame_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QCanBusFrame_PropertyStrings);
    SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QCanBusFrame_PythonToCpp_QCanBusFrame_PTR,
        is_QCanBusFrame_PythonToCpp_QCanBusFrame_PTR_Convertible,
        QCanBusFrame_PTR_CppToPython_QCanBusFrame,
        QCanBusFrame_COPY_CppToPython_QCanBusFrame);

    Shiboken::Conversions::registerConverterName(converter, "QCanBusFrame");
    Shiboken::Conversions::registerConverterName(converter, "QCanBusFrame*");
    Shiboken::Conversions::registerConverterName(converter, "QCanBusFrame&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QCanBusFrame).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QCanBusFrame_PythonToCpp_QCanBusFrame_COPY,
        is_QCanBusFrame_PythonToCpp_QCanBusFrame_COPY_Convertible);
    // Add implicit conversions to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QCanBusFrame_FrameType_PythonToCpp_QCanBusFrame,
        is_QCanBusFrame_FrameType_PythonToCpp_QCanBusFrame_Convertible);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QCanBusFrame_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'FrameType'.
    const char *FrameType_Initializer[] = {
        "UnknownFrame",
        "DataFrame",
        "ErrorFrame",
        "RemoteRequestFrame",
        "InvalidFrame",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t FrameType_InitializerValues[] = {
        uint8_t(QCanBusFrame::FrameType::UnknownFrame),       //  0x00  0
        uint8_t(QCanBusFrame::FrameType::DataFrame),          //  0x01  1
        uint8_t(QCanBusFrame::FrameType::ErrorFrame),         //  0x02  2
        uint8_t(QCanBusFrame::FrameType::RemoteRequestFrame), //  0x03  3
        uint8_t(QCanBusFrame::FrameType::InvalidFrame)        //  0x04  4
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QCanBusFrame_TypeF(),
        "2:PySide6.QtSerialBus.QCanBusFrame.FrameType",
        FrameType_Initializer, FrameType_InitializerValues);
    SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_FrameType_IDX].type = EType;
    // Register converter for enum 'QCanBusFrame::FrameType'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QCanBusFrame_FrameType_CppToPython_QCanBusFrame_FrameType);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QCanBusFrame_FrameType_PythonToCpp_QCanBusFrame_FrameType,
            is_QCanBusFrame_FrameType_PythonToCpp_QCanBusFrame_FrameType_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QCanBusFrame::FrameType");
        Shiboken::Conversions::registerConverterName(converter, "FrameType");
    }
    // End of 'FrameType' enum.

    // Initialization of enum 'FrameError'.
    const char *FrameError_Initializer[] = {
        "NoError",
        "TransmissionTimeoutError",
        "LostArbitrationError",
        "ControllerError",
        "ProtocolViolationError",
        "TransceiverError",
        "MissingAcknowledgmentError",
        "BusOffError",
        "BusError",
        "ControllerRestartError",
        "UnknownError",
        "AnyError",
        nullptr};
    // "uint32_t" used instead of "unsigned int"
    constexpr uint32_t FrameError_InitializerValues[] = {
        uint32_t(QCanBusFrame::FrameError::NoError),                    //  0x00000000  0
        uint32_t(QCanBusFrame::FrameError::TransmissionTimeoutError),   //  0x00000001  1
        uint32_t(QCanBusFrame::FrameError::LostArbitrationError),       //  0x00000002  2
        uint32_t(QCanBusFrame::FrameError::ControllerError),            //  0x00000004  4
        uint32_t(QCanBusFrame::FrameError::ProtocolViolationError),     //  0x00000008  8
        uint32_t(QCanBusFrame::FrameError::TransceiverError),           //  0x00000010  16
        uint32_t(QCanBusFrame::FrameError::MissingAcknowledgmentError), //  0x00000020  32
        uint32_t(QCanBusFrame::FrameError::BusOffError),                //  0x00000040  64
        uint32_t(QCanBusFrame::FrameError::BusError),                   //  0x00000080  128
        uint32_t(QCanBusFrame::FrameError::ControllerRestartError),     //  0x00000100  256
        uint32_t(QCanBusFrame::FrameError::UnknownError),               //  0x00000200  512
        uint32_t(QCanBusFrame::FrameError::AnyError)                    //  0x1fffffff  536870911
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QCanBusFrame_TypeF(),
        "2:PySide6.QtSerialBus.QCanBusFrame.FrameError",
        FrameError_Initializer, FrameError_InitializerValues);
    SbkPySide6_QtSerialBusTypeStructs[SBK_QCanBusFrame_FrameError_IDX].type = EType;
    // PYSIDE-1735: Mapping the flags class to the same enum class.
    SbkPySide6_QtSerialBusTypeStructs[SBK_QFlags_QCanBusFrame_FrameError_IDX].type =
        EType;
    // Register converter for enum 'QCanBusFrame::FrameError'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QCanBusFrame_FrameError_CppToPython_QCanBusFrame_FrameError);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QCanBusFrame_FrameError_PythonToCpp_QCanBusFrame_FrameError,
            is_QCanBusFrame_FrameError_PythonToCpp_QCanBusFrame_FrameError_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QCanBusFrame::FrameError");
        Shiboken::Conversions::registerConverterName(converter, "FrameError");
        // Register converter for flag 'QFlags<QCanBusFrame::FrameError>'.
        Shiboken::Conversions::registerConverterName(converter, "QFlags<QCanBusFrame::FrameError>");
        Shiboken::Conversions::registerConverterName(converter, "QCanBusFrame::FrameErrors");
    }
    // End of 'FrameError' enum/flags.

    qRegisterMetaType< ::QCanBusFrame >("QCanBusFrame");
    qRegisterMetaType< ::QCanBusFrame::FrameType >("QCanBusFrame::FrameType");
    qRegisterMetaType< ::QCanBusFrame::FrameError >("QCanBusFrame::FrameError");

    return pyType;
}
