// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QModbusServerWrapper_H
#define SBK_QModbusServerWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSerialBus/qmodbusserver.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QModbusServerWrapper : public QModbusServer
{
public:
    QModbusServerWrapper(const QModbusServerWrapper &) = delete;
    QModbusServerWrapper& operator=(const QModbusServerWrapper &) = delete;
    QModbusServerWrapper(QModbusServerWrapper &&) = delete;
    QModbusServerWrapper& operator=(QModbusServerWrapper &&) = delete;

    QModbusServerWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void close() override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    bool open() override;
    bool processesBroadcast() const override;
    bool readData(::QModbusDataUnit * newData) const override;
    bool setMap(const ::QMap<QModbusDataUnit::RegisterType,QModbusDataUnit> & map) override;
    bool setValue(int option, const ::QVariant & value) override;
    void timerEvent(::QTimerEvent * event) override;
    ::QVariant value(int option) const override;
    bool writeData(const ::QModbusDataUnit & unit) override;
    ~QModbusServerWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[15];
};

#endif // SBK_QModbusServerWrapper_H

