// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QModbusTcpClientWrapper_H
#define SBK_QModbusTcpClientWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSerialBus/qmodbustcpclient.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QModbusTcpClientWrapper : public QModbusTcpClient
{
public:
    QModbusTcpClientWrapper(const QModbusTcpClientWrapper &) = delete;
    QModbusTcpClientWrapper& operator=(const QModbusTcpClientWrapper &) = delete;
    QModbusTcpClientWrapper(QModbusTcpClientWrapper &&) = delete;
    QModbusTcpClientWrapper& operator=(QModbusTcpClientWrapper &&) = delete;

    QModbusTcpClientWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void close() override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    bool open() override;
    void timerEvent(::QTimerEvent * event) override;
    ~QModbusTcpClientWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[9];
};

#endif // SBK_QModbusTcpClientWrapper_H

