// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QKeyEventTransitionWrapper_H
#define SBK_QKeyEventTransitionWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtStateMachine/qkeyeventtransition.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QKeyEventTransitionWrapper : public QKeyEventTransition
{
public:
    QKeyEventTransitionWrapper(const QKeyEventTransitionWrapper &) = delete;
    QKeyEventTransitionWrapper& operator=(const QKeyEventTransitionWrapper &) = delete;
    QKeyEventTransitionWrapper(QKeyEventTransitionWrapper &&) = delete;
    QKeyEventTransitionWrapper& operator=(QKeyEventTransitionWrapper &&) = delete;

    QKeyEventTransitionWrapper(::QObject * object, ::QEvent::Type type, int key, ::QState * sourceState = nullptr);
    QKeyEventTransitionWrapper(::QState * sourceState = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * e) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    bool eventTest(::QEvent * event) override;
    void onTransition(::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QKeyEventTransitionWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[9];
};

#endif // SBK_QKeyEventTransitionWrapper_H

