// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_WrappedEventWrapper_H
#define SBK_WrappedEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtStateMachine/qstatemachine.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class WrappedEventWrapper : public QStateMachine::WrappedEvent
{
public:
    WrappedEventWrapper(const WrappedEventWrapper &) = delete;
    WrappedEventWrapper& operator=(const WrappedEventWrapper &) = delete;
    WrappedEventWrapper(WrappedEventWrapper &&) = delete;
    WrappedEventWrapper& operator=(WrappedEventWrapper &&) = delete;

    WrappedEventWrapper(::QObject * object, ::QEvent * event);
    ::QEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~WrappedEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_WrappedEventWrapper_H

