// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QUiLoaderWrapper_H
#define SBK_QUiLoaderWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtUiTools/quiloader.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QUiLoaderWrapper : public QUiLoader
{
public:
    QUiLoaderWrapper(const QUiLoaderWrapper &) = delete;
    QUiLoaderWrapper& operator=(const QUiLoaderWrapper &) = delete;
    QUiLoaderWrapper(QUiLoaderWrapper &&) = delete;
    QUiLoaderWrapper& operator=(QUiLoaderWrapper &&) = delete;

    QUiLoaderWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    ::QAction * createAction(::QObject * parent = nullptr, const ::QString & name = QString()) override;
    ::QActionGroup * createActionGroup(::QObject * parent = nullptr, const ::QString & name = QString()) override;
    ::QLayout * createLayout(const ::QString & className, ::QObject * parent = nullptr, const ::QString & name = QString()) override;
    ::QWidget * createWidget(const ::QString & className, ::QWidget * parent = nullptr, const ::QString & name = QString()) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QUiLoaderWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[11];
};

#endif // SBK_QUiLoaderWrapper_H

