// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtwebsockets_python.h"

// main header
#include "qwebsocketprotocol_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {

static const char *Sbk_QWebSocketProtocol_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QWebSocketProtocol_EnumFlagInfo[] = {
    "CloseCode:Enum",
    "Version:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QWebSocketProtocol_methods[] = {
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QWebSocketProtocol_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QWebSocketProtocol_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QWebSocketProtocol_Type = nullptr;
static PyTypeObject *Sbk_QWebSocketProtocol_TypeF(void)
{
    return _Sbk_QWebSocketProtocol_Type;
}

static PyType_Slot Sbk_QWebSocketProtocol_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(Sbk_object_dealloc /* PYSIDE-832: Prevent replacement of "0" with subtype_dealloc. */)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QWebSocketProtocol_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QWebSocketProtocol_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QWebSocketProtocol_methods)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QWebSocketProtocol_spec = {
    "2:PySide6.QtWebSockets.QWebSocketProtocol",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QWebSocketProtocol_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void QWebSocketProtocol_Version_PythonToCpp_QWebSocketProtocol_Version(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QWebSocketProtocol::Version>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QWebSocketProtocol::Version *>(cppOut) = value;

}
static PythonToCppFunc is_QWebSocketProtocol_Version_PythonToCpp_QWebSocketProtocol_Version_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWebSocketsTypeStructs[SBK_QWebSocketProtocol_Version_IDX])))
        return QWebSocketProtocol_Version_PythonToCpp_QWebSocketProtocol_Version;
    return {};
}
static PyObject *QWebSocketProtocol_Version_CppToPython_QWebSocketProtocol_Version(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QWebSocketProtocol::Version *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWebSocketsTypeStructs[SBK_QWebSocketProtocol_Version_IDX]), castCppIn);

}

static void QWebSocketProtocol_CloseCode_PythonToCpp_QWebSocketProtocol_CloseCode(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QWebSocketProtocol::CloseCode>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QWebSocketProtocol::CloseCode *>(cppOut) = value;

}
static PythonToCppFunc is_QWebSocketProtocol_CloseCode_PythonToCpp_QWebSocketProtocol_CloseCode_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWebSocketsTypeStructs[SBK_QWebSocketProtocol_CloseCode_IDX])))
        return QWebSocketProtocol_CloseCode_PythonToCpp_QWebSocketProtocol_CloseCode;
    return {};
}
static PyObject *QWebSocketProtocol_CloseCode_CppToPython_QWebSocketProtocol_CloseCode(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QWebSocketProtocol::CloseCode *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWebSocketsTypeStructs[SBK_QWebSocketProtocol_CloseCode_IDX]), castCppIn);

}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QtWebSocketsQWebSocketProtocol_SignatureStrings[] = {
    nullptr}; // Sentinel

PyTypeObject *init_QtWebSocketsQWebSocketProtocol(PyObject *module)
{
    _Sbk_QWebSocketProtocol_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QWebSocketProtocol",
        "QWebSocketProtocol",
        &Sbk_QWebSocketProtocol_spec,
        nullptr,
        nullptr,
        0,
        0);
    auto *pyType = Sbk_QWebSocketProtocol_TypeF(); // references _Sbk_QWebSocketProtocol_Type
    InitSignatureStrings(pyType, QtWebSocketsQWebSocketProtocol_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QWebSocketProtocol_PropertyStrings);
    SbkPySide6_QtWebSocketsTypeStructs[SBK_QtWebSocketsQWebSocketProtocol_IDX].type = pyType;


    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QWebSocketProtocol_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'Version'.
    const char *Version_Initializer[] = {
        "VersionUnknown",
        "Version0",
        "Version4",
        "Version5",
        "Version6",
        "Version7",
        "Version8",
        "Version13",
        "VersionLatest",
        nullptr};
    // "int8_t" used instead of "int"
    constexpr int8_t Version_InitializerValues[] = {
        int8_t(QWebSocketProtocol::Version::VersionUnknown), // -0x01 -1
        int8_t(QWebSocketProtocol::Version::Version0),       //  0x00  0
        int8_t(QWebSocketProtocol::Version::Version4),       //  0x04  4
        int8_t(QWebSocketProtocol::Version::Version5),       //  0x05  5
        int8_t(QWebSocketProtocol::Version::Version6),       //  0x06  6
        int8_t(QWebSocketProtocol::Version::Version7),       //  0x07  7
        int8_t(QWebSocketProtocol::Version::Version8),       //  0x08  8
        int8_t(QWebSocketProtocol::Version::Version13),      //  0x0d  13
        int8_t(QWebSocketProtocol::Version::VersionLatest)   //  0x0d  13
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QWebSocketProtocol_TypeF(),
        "2:PySide6.QtWebSockets.QWebSocketProtocol.Version",
        Version_Initializer, Version_InitializerValues);
    SbkPySide6_QtWebSocketsTypeStructs[SBK_QWebSocketProtocol_Version_IDX].type = EType;
    // Register converter for enum 'QWebSocketProtocol::Version'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QWebSocketProtocol_Version_CppToPython_QWebSocketProtocol_Version);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QWebSocketProtocol_Version_PythonToCpp_QWebSocketProtocol_Version,
            is_QWebSocketProtocol_Version_PythonToCpp_QWebSocketProtocol_Version_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QWebSocketProtocol::Version");
        Shiboken::Conversions::registerConverterName(converter, "Version");
    }
    // End of 'Version' enum.

    // Initialization of enum 'CloseCode'.
    const char *CloseCode_Initializer[] = {
        "CloseCodeNormal",
        "CloseCodeGoingAway",
        "CloseCodeProtocolError",
        "CloseCodeDatatypeNotSupported",
        "CloseCodeReserved1004",
        "CloseCodeMissingStatusCode",
        "CloseCodeAbnormalDisconnection",
        "CloseCodeWrongDatatype",
        "CloseCodePolicyViolated",
        "CloseCodeTooMuchData",
        "CloseCodeMissingExtension",
        "CloseCodeBadOperation",
        "CloseCodeTlsHandshakeFailed",
        nullptr};
    // "uint16_t" used instead of "unsigned int"
    constexpr uint16_t CloseCode_InitializerValues[] = {
        uint16_t(QWebSocketProtocol::CloseCode::CloseCodeNormal),                //  0x03e8  1000
        uint16_t(QWebSocketProtocol::CloseCode::CloseCodeGoingAway),             //  0x03e9  1001
        uint16_t(QWebSocketProtocol::CloseCode::CloseCodeProtocolError),         //  0x03ea  1002
        uint16_t(QWebSocketProtocol::CloseCode::CloseCodeDatatypeNotSupported),  //  0x03eb  1003
        uint16_t(QWebSocketProtocol::CloseCode::CloseCodeReserved1004),          //  0x03ec  1004
        uint16_t(QWebSocketProtocol::CloseCode::CloseCodeMissingStatusCode),     //  0x03ed  1005
        uint16_t(QWebSocketProtocol::CloseCode::CloseCodeAbnormalDisconnection), //  0x03ee  1006
        uint16_t(QWebSocketProtocol::CloseCode::CloseCodeWrongDatatype),         //  0x03ef  1007
        uint16_t(QWebSocketProtocol::CloseCode::CloseCodePolicyViolated),        //  0x03f0  1008
        uint16_t(QWebSocketProtocol::CloseCode::CloseCodeTooMuchData),           //  0x03f1  1009
        uint16_t(QWebSocketProtocol::CloseCode::CloseCodeMissingExtension),      //  0x03f2  1010
        uint16_t(QWebSocketProtocol::CloseCode::CloseCodeBadOperation),          //  0x03f3  1011
        uint16_t(QWebSocketProtocol::CloseCode::CloseCodeTlsHandshakeFailed)     //  0x03f7  1015
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QWebSocketProtocol_TypeF(),
        "2:PySide6.QtWebSockets.QWebSocketProtocol.CloseCode",
        CloseCode_Initializer, CloseCode_InitializerValues);
    SbkPySide6_QtWebSocketsTypeStructs[SBK_QWebSocketProtocol_CloseCode_IDX].type = EType;
    // Register converter for enum 'QWebSocketProtocol::CloseCode'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QWebSocketProtocol_CloseCode_CppToPython_QWebSocketProtocol_CloseCode);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QWebSocketProtocol_CloseCode_PythonToCpp_QWebSocketProtocol_CloseCode,
            is_QWebSocketProtocol_CloseCode_PythonToCpp_QWebSocketProtocol_CloseCode_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QWebSocketProtocol::CloseCode");
        Shiboken::Conversions::registerConverterName(converter, "CloseCode");
    }
    // End of 'CloseCode' enum.

    qRegisterMetaType< ::QWebSocketProtocol::Version >("QWebSocketProtocol::Version");
    qRegisterMetaType< ::QWebSocketProtocol::CloseCode >("QWebSocketProtocol::CloseCode");

    return pyType;
}
