// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QFileIconProviderWrapper_H
#define SBK_QFileIconProviderWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qfileiconprovider.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QFileIconProviderWrapper : public QFileIconProvider
{
public:
    QFileIconProviderWrapper(const QFileIconProviderWrapper &) = delete;
    QFileIconProviderWrapper& operator=(const QFileIconProviderWrapper &) = delete;
    QFileIconProviderWrapper(QFileIconProviderWrapper &&) = delete;
    QFileIconProviderWrapper& operator=(QFileIconProviderWrapper &&) = delete;

    QFileIconProviderWrapper();
    ::QIcon icon(::QAbstractFileIconProvider::IconType type) const override;
    ::QIcon icon(const ::QFileInfo & info) const override;
    ::QFlags<QAbstractFileIconProvider::Option> options() const override;
    void setOptions(::QFlags<QAbstractFileIconProvider::Option> arg__1) override;
    ::QString type(const ::QFileInfo & arg__1) const override;
    ~QFileIconProviderWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[5];
};

#endif // SBK_QFileIconProviderWrapper_H

