// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGraphicsSceneContextMenuEventWrapper_H
#define SBK_QGraphicsSceneContextMenuEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qgraphicssceneevent.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QGraphicsSceneContextMenuEventWrapper : public QGraphicsSceneContextMenuEvent
{
public:
    QGraphicsSceneContextMenuEventWrapper(const QGraphicsSceneContextMenuEventWrapper &) = delete;
    QGraphicsSceneContextMenuEventWrapper& operator=(const QGraphicsSceneContextMenuEventWrapper &) = delete;
    QGraphicsSceneContextMenuEventWrapper(QGraphicsSceneContextMenuEventWrapper &&) = delete;
    QGraphicsSceneContextMenuEventWrapper& operator=(QGraphicsSceneContextMenuEventWrapper &&) = delete;

    QGraphicsSceneContextMenuEventWrapper(::QEvent::Type type = QEvent::Type::None);
    ::QEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QGraphicsSceneContextMenuEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QGraphicsSceneContextMenuEventWrapper_H

