// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGraphicsSceneHoverEventWrapper_H
#define SBK_QGraphicsSceneHoverEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qgraphicssceneevent.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QGraphicsSceneHoverEventWrapper : public QGraphicsSceneHoverEvent
{
public:
    QGraphicsSceneHoverEventWrapper(const QGraphicsSceneHoverEventWrapper &) = delete;
    QGraphicsSceneHoverEventWrapper& operator=(const QGraphicsSceneHoverEventWrapper &) = delete;
    QGraphicsSceneHoverEventWrapper(QGraphicsSceneHoverEventWrapper &&) = delete;
    QGraphicsSceneHoverEventWrapper& operator=(QGraphicsSceneHoverEventWrapper &&) = delete;

    QGraphicsSceneHoverEventWrapper(::QEvent::Type type = QEvent::Type::None);
    ::QEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QGraphicsSceneHoverEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QGraphicsSceneHoverEventWrapper_H

