// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGraphicsSceneWheelEventWrapper_H
#define SBK_QGraphicsSceneWheelEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qgraphicssceneevent.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QGraphicsSceneWheelEventWrapper : public QGraphicsSceneWheelEvent
{
public:
    QGraphicsSceneWheelEventWrapper(const QGraphicsSceneWheelEventWrapper &) = delete;
    QGraphicsSceneWheelEventWrapper& operator=(const QGraphicsSceneWheelEventWrapper &) = delete;
    QGraphicsSceneWheelEventWrapper(QGraphicsSceneWheelEventWrapper &&) = delete;
    QGraphicsSceneWheelEventWrapper& operator=(QGraphicsSceneWheelEventWrapper &&) = delete;

    QGraphicsSceneWheelEventWrapper(::QEvent::Type type = QEvent::Type::None);
    ::QEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QGraphicsSceneWheelEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QGraphicsSceneWheelEventWrapper_H

