// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QLayoutItemWrapper_H
#define SBK_QLayoutItemWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qlayoutitem.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QLayoutItemWrapper : public QLayoutItem
{
public:
    QLayoutItemWrapper(const QLayoutItemWrapper &) = delete;
    QLayoutItemWrapper& operator=(const QLayoutItemWrapper &) = delete;
    QLayoutItemWrapper(QLayoutItemWrapper &&) = delete;
    QLayoutItemWrapper& operator=(QLayoutItemWrapper &&) = delete;

    QLayoutItemWrapper(::QFlags<Qt::AlignmentFlag> alignment = Qt::Alignment());
    ::QFlags<QSizePolicy::ControlType> controlTypes() const override;
    ::QFlags<Qt::Orientation> expandingDirections() const override;
    ::QRect geometry() const override;
    bool hasHeightForWidth() const override;
    int heightForWidth(int arg__1) const override;
    void invalidate() override;
    bool isEmpty() const override;
    ::QLayout * layout() override;
    ::QSize maximumSize() const override;
    int minimumHeightForWidth(int arg__1) const override;
    ::QSize minimumSize() const override;
    void setGeometry(const ::QRect & arg__1) override;
    ::QSize sizeHint() const override;
    ::QSpacerItem * spacerItem() override;
    ::QWidget * widget() const override;
    ~QLayoutItemWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[15];
};

#endif // SBK_QLayoutItemWrapper_H

