// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QStyledItemDelegateWrapper_H
#define SBK_QStyledItemDelegateWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qstyleditemdelegate.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QStyledItemDelegateWrapper : public QStyledItemDelegate
{
public:
    QStyledItemDelegateWrapper(const QStyledItemDelegateWrapper &) = delete;
    QStyledItemDelegateWrapper& operator=(const QStyledItemDelegateWrapper &) = delete;
    QStyledItemDelegateWrapper(QStyledItemDelegateWrapper &&) = delete;
    QStyledItemDelegateWrapper& operator=(QStyledItemDelegateWrapper &&) = delete;

    QStyledItemDelegateWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    ::QWidget * createEditor(::QWidget * parent, const ::QStyleOptionViewItem & option, const ::QModelIndex & index) const override;
    void customEvent(::QEvent * event) override;
    void destroyEditor(::QWidget * editor, const ::QModelIndex & index) const override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    ::QString displayText(const ::QVariant & value, const ::QLocale & locale) const override;
    bool editorEvent(::QEvent * event, ::QAbstractItemModel * model, const ::QStyleOptionViewItem & option, const ::QModelIndex & index) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * object, ::QEvent * event) override;
    bool helpEvent(::QHelpEvent * event, ::QAbstractItemView * view, const ::QStyleOptionViewItem & option, const ::QModelIndex & index) override;
    void initStyleOption(::QStyleOptionViewItem * option, const ::QModelIndex & index) const override;
    void paint(::QPainter * painter, const ::QStyleOptionViewItem & option, const ::QModelIndex & index) const override;
    ::QList<int> paintingRoles() const override;
    void setEditorData(::QWidget * editor, const ::QModelIndex & index) const override;
    void setModelData(::QWidget * editor, ::QAbstractItemModel * model, const ::QModelIndex & index) const override;
    ::QSize sizeHint(const ::QStyleOptionViewItem & option, const ::QModelIndex & index) const override;
    void timerEvent(::QTimerEvent * event) override;
    void updateEditorGeometry(::QWidget * editor, const ::QStyleOptionViewItem & option, const ::QModelIndex & index) const override;
    ~QStyledItemDelegateWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[19];
};

#endif // SBK_QStyledItemDelegateWrapper_H

