// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtwidgets_python.h"

// main header
#include "qstylehintreturnmask_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QStyleHintReturnMask_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(args)
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QStyleHintReturnMask >()))
        return -1;

    ::QStyleHintReturnMask *cptr{};
    static const char fullName[] = "PySide6.QtWidgets.QStyleHintReturnMask.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // QStyleHintReturnMask()
            cptr = new ::QStyleHintReturnMask();
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QStyleHintReturnMask >(), cptr)) {
        delete cptr;
        return -1;
    }
    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}


static const char *Sbk_QStyleHintReturnMask_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QStyleHintReturnMask_EnumFlagInfo[] = {
    "StyleOptionType:Enum",
    "StyleOptionVersion:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QStyleHintReturnMask_methods[] = {
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QStyleHintReturnMask_get_region(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleHintReturnMask *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleHintReturnMask_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->region)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRegion_IDX])));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->region))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->region)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRegion_IDX]), &(cppSelf->region), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_QStyleHintReturnMask_set_region(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleHintReturnMask *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleHintReturnMask_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("region");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRegion_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("region", "QRegion");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->region;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

// Getters and Setters for QStyleHintReturnMask
static PyGetSetDef Sbk_QStyleHintReturnMask_getsetlist[] = {
    {const_cast<char *>("region"), Sbk_QStyleHintReturnMask_get_region, Sbk_QStyleHintReturnMask_set_region, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QStyleHintReturnMask_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QStyleHintReturnMask_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QStyleHintReturnMask_Type = nullptr;
static PyTypeObject *Sbk_QStyleHintReturnMask_TypeF(void)
{
    return _Sbk_QStyleHintReturnMask_Type;
}

static PyType_Slot Sbk_QStyleHintReturnMask_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QStyleHintReturnMask_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QStyleHintReturnMask_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QStyleHintReturnMask_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QStyleHintReturnMask_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QStyleHintReturnMask_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QStyleHintReturnMask_spec = {
    "2:PySide6.QtWidgets.QStyleHintReturnMask",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QStyleHintReturnMask_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void QStyleHintReturnMask_StyleOptionType_PythonToCpp_QStyleHintReturnMask_StyleOptionType(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QStyleHintReturnMask::StyleOptionType>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QStyleHintReturnMask::StyleOptionType *>(cppOut) = value;

}
static PythonToCppFunc is_QStyleHintReturnMask_StyleOptionType_PythonToCpp_QStyleHintReturnMask_StyleOptionType_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleHintReturnMask_StyleOptionType_IDX])))
        return QStyleHintReturnMask_StyleOptionType_PythonToCpp_QStyleHintReturnMask_StyleOptionType;
    return {};
}
static PyObject *QStyleHintReturnMask_StyleOptionType_CppToPython_QStyleHintReturnMask_StyleOptionType(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QStyleHintReturnMask::StyleOptionType *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleHintReturnMask_StyleOptionType_IDX]), castCppIn);

}

static void QStyleHintReturnMask_StyleOptionVersion_PythonToCpp_QStyleHintReturnMask_StyleOptionVersion(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QStyleHintReturnMask::StyleOptionVersion>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QStyleHintReturnMask::StyleOptionVersion *>(cppOut) = value;

}
static PythonToCppFunc is_QStyleHintReturnMask_StyleOptionVersion_PythonToCpp_QStyleHintReturnMask_StyleOptionVersion_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleHintReturnMask_StyleOptionVersion_IDX])))
        return QStyleHintReturnMask_StyleOptionVersion_PythonToCpp_QStyleHintReturnMask_StyleOptionVersion;
    return {};
}
static PyObject *QStyleHintReturnMask_StyleOptionVersion_CppToPython_QStyleHintReturnMask_StyleOptionVersion(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QStyleHintReturnMask::StyleOptionVersion *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleHintReturnMask_StyleOptionVersion_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QStyleHintReturnMask_PythonToCpp_QStyleHintReturnMask_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QStyleHintReturnMask_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QStyleHintReturnMask_PythonToCpp_QStyleHintReturnMask_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QStyleHintReturnMask_TypeF()))
        return QStyleHintReturnMask_PythonToCpp_QStyleHintReturnMask_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QStyleHintReturnMask_PTR_CppToPython_QStyleHintReturnMask(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QStyleHintReturnMask *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QStyleHintReturnMask_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QStyleHintReturnMask_SignatureStrings[] = {
    "PySide6.QtWidgets.QStyleHintReturnMask(self)",
    nullptr}; // Sentinel

PyTypeObject *init_QStyleHintReturnMask(PyObject *module)
{
    _Sbk_QStyleHintReturnMask_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QStyleHintReturnMask",
        "QStyleHintReturnMask*",
        &Sbk_QStyleHintReturnMask_spec,
        &Shiboken::callCppDestructor< ::QStyleHintReturnMask >,
        Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleHintReturn_IDX]),
        0,
        0);
    auto *pyType = Sbk_QStyleHintReturnMask_TypeF(); // references _Sbk_QStyleHintReturnMask_Type
    InitSignatureStrings(pyType, QStyleHintReturnMask_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QStyleHintReturnMask_PropertyStrings);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleHintReturnMask_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QStyleHintReturnMask_PythonToCpp_QStyleHintReturnMask_PTR,
        is_QStyleHintReturnMask_PythonToCpp_QStyleHintReturnMask_PTR_Convertible,
        QStyleHintReturnMask_PTR_CppToPython_QStyleHintReturnMask);

    Shiboken::Conversions::registerConverterName(converter, "QStyleHintReturnMask");
    Shiboken::Conversions::registerConverterName(converter, "QStyleHintReturnMask*");
    Shiboken::Conversions::registerConverterName(converter, "QStyleHintReturnMask&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QStyleHintReturnMask).name());

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QStyleHintReturnMask_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'StyleOptionType'.
    const char *StyleOptionType_Initializer[] = {
        "Type",
        nullptr};
    // "uint16_t" used instead of "unsigned int"
    constexpr uint16_t StyleOptionType_InitializerValues[] = {
        uint16_t(QStyleHintReturnMask::StyleOptionType::Type) //  0xf001  61441
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QStyleHintReturnMask_TypeF(),
        "2:PySide6.QtWidgets.QStyleHintReturnMask.StyleOptionType",
        StyleOptionType_Initializer, StyleOptionType_InitializerValues);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleHintReturnMask_StyleOptionType_IDX].type = EType;
    // Register converter for enum 'QStyleHintReturnMask::StyleOptionType'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QStyleHintReturnMask_StyleOptionType_CppToPython_QStyleHintReturnMask_StyleOptionType);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QStyleHintReturnMask_StyleOptionType_PythonToCpp_QStyleHintReturnMask_StyleOptionType,
            is_QStyleHintReturnMask_StyleOptionType_PythonToCpp_QStyleHintReturnMask_StyleOptionType_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QStyleHintReturnMask::StyleOptionType");
        Shiboken::Conversions::registerConverterName(converter, "StyleOptionType");
    }
    // End of 'StyleOptionType' enum.

    // Initialization of enum 'StyleOptionVersion'.
    const char *StyleOptionVersion_Initializer[] = {
        "Version",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t StyleOptionVersion_InitializerValues[] = {
        uint8_t(QStyleHintReturnMask::StyleOptionVersion::Version) //  0x01  1
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QStyleHintReturnMask_TypeF(),
        "2:PySide6.QtWidgets.QStyleHintReturnMask.StyleOptionVersion",
        StyleOptionVersion_Initializer, StyleOptionVersion_InitializerValues);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleHintReturnMask_StyleOptionVersion_IDX].type = EType;
    // Register converter for enum 'QStyleHintReturnMask::StyleOptionVersion'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QStyleHintReturnMask_StyleOptionVersion_CppToPython_QStyleHintReturnMask_StyleOptionVersion);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QStyleHintReturnMask_StyleOptionVersion_PythonToCpp_QStyleHintReturnMask_StyleOptionVersion,
            is_QStyleHintReturnMask_StyleOptionVersion_PythonToCpp_QStyleHintReturnMask_StyleOptionVersion_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QStyleHintReturnMask::StyleOptionVersion");
        Shiboken::Conversions::registerConverterName(converter, "StyleOptionVersion");
    }
    // End of 'StyleOptionVersion' enum.

    qRegisterMetaType< ::QStyleHintReturnMask *>();
    qRegisterMetaType< ::QStyleHintReturnMask::StyleOptionType >("QStyleHintReturnMask::StyleOptionType");
    qRegisterMetaType< ::QStyleHintReturnMask::StyleOptionVersion >("QStyleHintReturnMask::StyleOptionVersion");

    return pyType;
}
