// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtxml_python.h"

// main header
#include "qdomprocessinginstruction_wrapper.h"

// Argument includes
#include <QString>
#include <QtXml/qdom.h>
#include <qtextstream.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QDomProcessingInstruction_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QDomProcessingInstruction >()))
        return -1;

    ::QDomProcessingInstruction *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtXml.QDomProcessingInstruction.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QDomProcessingInstruction", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QDomProcessingInstruction::QDomProcessingInstruction()
    // 1: QDomProcessingInstruction::QDomProcessingInstruction(QDomProcessingInstruction)
    if (numArgs == 0) {
        overloadId = 0; // QDomProcessingInstruction()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtXmlTypeStructs[SBK_QDomProcessingInstruction_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QDomProcessingInstruction(QDomProcessingInstruction)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QDomProcessingInstruction()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QDomProcessingInstruction()
                cptr = new ::QDomProcessingInstruction();
            }
            break;
        }
        case 1: // QDomProcessingInstruction(const QDomProcessingInstruction & x)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QDomProcessingInstruction cppArg0_local;
            ::QDomProcessingInstruction *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QDomProcessingInstruction(QDomProcessingInstruction)
                cptr = new ::QDomProcessingInstruction(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QDomProcessingInstruction >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QDomProcessingInstructionFunc_data(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDomProcessingInstruction *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtXmlTypeStructs[SBK_QDomProcessingInstruction_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtXml.QDomProcessingInstruction.data";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // data()const
            QString cppResult = const_cast<const ::QDomProcessingInstruction *>(cppSelf)->data();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDomProcessingInstructionFunc_nodeType(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDomProcessingInstruction *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtXmlTypeStructs[SBK_QDomProcessingInstruction_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtXml.QDomProcessingInstruction.nodeType";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // nodeType()const
            QDomNode::NodeType cppResult = const_cast<const ::QDomProcessingInstruction *>(cppSelf)->nodeType();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtXmlTypeStructs[SBK_QDomNode_NodeType_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDomProcessingInstructionFunc_setData(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDomProcessingInstruction *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtXmlTypeStructs[SBK_QDomProcessingInstruction_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtXml.QDomProcessingInstruction.setData";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QDomProcessingInstruction::setData(QString)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArg)))) {
        overloadId = 0; // setData(QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setData(QString)
            cppSelf->setData(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QDomProcessingInstructionFunc_target(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDomProcessingInstruction *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtXmlTypeStructs[SBK_QDomProcessingInstruction_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtXml.QDomProcessingInstruction.target";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // target()const
            QString cppResult = const_cast<const ::QDomProcessingInstruction *>(cppSelf)->target();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDomProcessingInstruction__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QDomProcessingInstruction *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtXmlTypeStructs[SBK_QDomProcessingInstruction_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtXmlTypeStructs[SBK_QDomProcessingInstruction_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QDomProcessingInstruction_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QDomProcessingInstruction_methods[] = {
    {"data", reinterpret_cast<PyCFunction>(Sbk_QDomProcessingInstructionFunc_data), METH_NOARGS, nullptr},
    {"nodeType", reinterpret_cast<PyCFunction>(Sbk_QDomProcessingInstructionFunc_nodeType), METH_NOARGS, nullptr},
    {"setData", reinterpret_cast<PyCFunction>(Sbk_QDomProcessingInstructionFunc_setData), METH_O, nullptr},
    {"target", reinterpret_cast<PyCFunction>(Sbk_QDomProcessingInstructionFunc_target), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QDomProcessingInstruction__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static int Sbk_QDomProcessingInstruction___nb_bool(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return -1;
    auto *cppSelf = reinterpret_cast< ::QDomProcessingInstruction *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtXmlTypeStructs[SBK_QDomProcessingInstruction_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    return !cppSelf->isNull() ? 1 : 0;
}

} // extern "C"

static int Sbk_QDomProcessingInstruction_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QDomProcessingInstruction_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QDomProcessingInstruction_Type = nullptr;
static PyTypeObject *Sbk_QDomProcessingInstruction_TypeF(void)
{
    return _Sbk_QDomProcessingInstruction_Type;
}

static PyType_Slot Sbk_QDomProcessingInstruction_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QDomProcessingInstruction_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QDomProcessingInstruction_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QDomProcessingInstruction_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QDomProcessingInstruction_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    // type supports number protocol
    {Py_nb_bool,        reinterpret_cast<void *>(Sbk_QDomProcessingInstruction___nb_bool)},
    {0, nullptr}
};
static PyType_Spec Sbk_QDomProcessingInstruction_spec = {
    "2:PySide6.QtXml.QDomProcessingInstruction",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QDomProcessingInstruction_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QDomProcessingInstruction_PythonToCpp_QDomProcessingInstruction_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QDomProcessingInstruction_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QDomProcessingInstruction_PythonToCpp_QDomProcessingInstruction_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QDomProcessingInstruction_TypeF()))
        return QDomProcessingInstruction_PythonToCpp_QDomProcessingInstruction_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QDomProcessingInstruction_PTR_CppToPython_QDomProcessingInstruction(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QDomProcessingInstruction *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QDomProcessingInstruction_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *QDomProcessingInstruction_COPY_CppToPython_QDomProcessingInstruction(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QDomProcessingInstruction *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QDomProcessingInstruction_TypeF(), new ::QDomProcessingInstruction(*source), true, true);
}

// Python to C++ copy conversion.
static void QDomProcessingInstruction_PythonToCpp_QDomProcessingInstruction_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QDomProcessingInstruction *>(cppOut) = *reinterpret_cast< ::QDomProcessingInstruction *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtXmlTypeStructs[SBK_QDomProcessingInstruction_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QDomProcessingInstruction_PythonToCpp_QDomProcessingInstruction_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QDomProcessingInstruction_TypeF()))
        return QDomProcessingInstruction_PythonToCpp_QDomProcessingInstruction_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QDomProcessingInstruction_SignatureStrings[] = {
    "1:PySide6.QtXml.QDomProcessingInstruction(self)",
    "0:PySide6.QtXml.QDomProcessingInstruction(self,x:PySide6.QtXml.QDomProcessingInstruction)",
    "PySide6.QtXml.QDomProcessingInstruction.data(self)->QString",
    "PySide6.QtXml.QDomProcessingInstruction.nodeType(self)->PySide6.QtXml.QDomNode.NodeType",
    "PySide6.QtXml.QDomProcessingInstruction.setData(self,d:QString)",
    "PySide6.QtXml.QDomProcessingInstruction.target(self)->QString",
    "PySide6.QtXml.QDomProcessingInstruction.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QDomProcessingInstruction(PyObject *module)
{
    _Sbk_QDomProcessingInstruction_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QDomProcessingInstruction",
        "QDomProcessingInstruction",
        &Sbk_QDomProcessingInstruction_spec,
        &Shiboken::callCppDestructor< ::QDomProcessingInstruction >,
        Shiboken::Module::get(SbkPySide6_QtXmlTypeStructs[SBK_QDomNode_IDX]),
        0,
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QDomProcessingInstruction_TypeF(); // references _Sbk_QDomProcessingInstruction_Type
    InitSignatureStrings(pyType, QDomProcessingInstruction_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QDomProcessingInstruction_PropertyStrings);
    SbkPySide6_QtXmlTypeStructs[SBK_QDomProcessingInstruction_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QDomProcessingInstruction_PythonToCpp_QDomProcessingInstruction_PTR,
        is_QDomProcessingInstruction_PythonToCpp_QDomProcessingInstruction_PTR_Convertible,
        QDomProcessingInstruction_PTR_CppToPython_QDomProcessingInstruction,
        QDomProcessingInstruction_COPY_CppToPython_QDomProcessingInstruction);

    Shiboken::Conversions::registerConverterName(converter, "QDomProcessingInstruction");
    Shiboken::Conversions::registerConverterName(converter, "QDomProcessingInstruction*");
    Shiboken::Conversions::registerConverterName(converter, "QDomProcessingInstruction&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QDomProcessingInstruction).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QDomProcessingInstruction_PythonToCpp_QDomProcessingInstruction_COPY,
        is_QDomProcessingInstruction_PythonToCpp_QDomProcessingInstruction_COPY_Convertible);

    qRegisterMetaType< ::QDomProcessingInstruction >("QDomProcessingInstruction");

    return pyType;
}
